/*******************************************************************************
*Copyright (c) 2014 PMC-Sierra, Inc.  All rights reserved. 
*
*Redistribution and use in source and binary forms, with or without modification, are permitted provided 
*that the following conditions are met: 
*1. Redistributions of source code must retain the above copyright notice, this list of conditions and the
*following disclaimer. 
*2. Redistributions in binary form must reproduce the above copyright notice, 
*this list of conditions and the following disclaimer in the documentation and/or other materials provided
*with the distribution. 
*
*THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND ANY EXPRESS OR IMPLIED 
*WARRANTIES,INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
*FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
*FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT 
*NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 
*BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
*LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
*SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE
*
* $FreeBSD$
*
********************************************************************************/
/*******************************************************************************/
/** \file
 *
 * This file contains wcs code 
 *
 */

/* wcsImage */
bit32 oldwcsImage[] = 
{
  0x011, // 00000 = 0 - PHY_RESET_START
  0x0ca, // 0x001 = 1 - JUMP_IF_PHY_READY
  0x009, // 0x002 = 2 - 
  0x0ba, // 0x003 = 3 - JUMP_IF_HARD_RESET_PRIMITIVE
  0x010, // 0x004 = 4 - 
  0x0bb, // 0x005 = 5 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
  0x01e, // 0x006 = 6 - 
  0x0ff, // 0x007 = 7 - JUMP
  0x001, // 0x008 = 8 - 
  0x010, // 0x009 = 9 - SEND_ID_FRAME
  0x0ba, // 0x00a = 10 - JUMP_IF_HARD_RESET_PRIMITIVE
  0x010, // 0x00b = 11 - 
  0x0bb, // 0x00c = 12 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
  0x023, // 0x00d = 13 - 
  0x0ff, // 0x00e = 14 - JUMP
  0x00a, // 0x00f = 15 - 
  0x033, // 0x010 = 16 - SOFT_RESET
  0x011, // 0x011 = 17 - PHY_RESET_START
  0x0ca, // 0x012 = 18 - JUMP_IF_PHY_READY
  0x016, // 0x013 = 19 - 
  0x0bb, // 0x014 = 20 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
  0x01b, // 0x015 = 21 - 
  0x010, // 0x016 = 22 - SEND_ID_FRAME
  0x0bb, // 0x017 = 23 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
  0x023, // 0x018 = 24 - 
  0x0ff, // 0x019 = 25 - JUMP
  0x017, // 0x01a = 26 - 
  0x010, // 0x01b = 27 - SEND_ID_FRAME
  0x0ff, // 0x01c = 28 - JUMP
  0x023, // 0x01d = 29 - 
  0x0ca, // 0x01e = 30 - JUMP_IF_PHY_READY
  0x022, // 0x01f = 31 - 
  0x0ff, // 0x020 = 32 - JUMP
  0x01e, // 0x021 = 33 - 
  0x010, // 0x022 = 34 - SEND_ID_FRAME
  0x000, // 0x023 = 35 - NO_OP
  0x000, // 0x024 = 36 - NO_OP
  0x000, // 0x025 = 37 - NO_OP
  0x000, // 0x026 = 38 - NO_OP
  0x000, // 0x027 = 39 - NO_OP
  0x000, // 0x028 = 40 - NO_OP
  0x0ff, // 0x029 = 41 - JUMP
  0x0ff, // 0x02a = 42 - 
  0x01b, // 0x02b = 43 - START_IT_NEXUS_LOSS_TIMER_SFO
  0x017, // 0x02c = 44 - PATHWAY_BLOCKED_CNT_SFO_RESET
  0x013, // 0x02d = 45 - START_ARB_WAIT_TIMER_SFO
  0x001, // 0x02e = 46 - OPEN_REQUEST_SFO
  0x000, // 0x02f = 47 - NO_OP
  0x000, // 0x030 = 48 - NO_OP
  0x000, // 0x031 = 49 - NO_OP
  0x000, // 0x032 = 50 - NO_OP
  0x000, // 0x033 = 51 - NO_OP
  0x091, // 0x034 = 52 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_ACCEPT
  0x056, // 0x035 = 53 - 
  0x097, // 0x036 = 54 - JUMP_IF_OPEN_STATUS_EQUAL_RATE_NOT_SUPPORTED
  0x059, // 0x037 = 55 - 
  0x09b, // 0x038 = 56 - JUMP_IF_OPEN_STATUS_EQUAL_PROTOCOL_NOT_SUPPORTED
  0x05c, // 0x039 = 57 - 
  0x09d, // 0x03a = 58 - JUMP_IF_OPEN_STATUS_EQUAL_WRONG_DESTINATION
  0x05f, // 0x03b = 59 - 
  0x096, // 0x03c = 60 - JUMP_IF_OPEN_STATUS_EQUAL_BREAK_RECEIVED
  0x062, // 0x03d = 61 - 
  0x095, // 0x03e = 62 - JUMP_IF_OPEN_STATUS_EQUAL_BAD_DESTINATION
  0x065, // 0x03f = 63 - 
  0x0a1, // 0x040 = 64 - JUMP_IF_IT_NEXUS_LOSS_TIMEOUT_SFO
  0x068, // 0x041 = 65 - 
  0x09c, // 0x042 = 66 - JUMP_IF_OPEN_STATUS_EQUAL_STP_RESOURCE_BUSY
  0x02b, // 0x043 = 67 - 
  0x098, // 0x044 = 68 - JUMP_IF_OPEN_STATUS_EQUAL_NO_DESTINATION
  0x0ff, // 0x045 = 69 - 
  0x099, // 0x046 = 70 - JUMP_IF_OPEN_STATUS_EQUAL_PATHWAY_BLOCKED
  0x06b, // 0x047 = 71 - 
  0x09a, // 0x048 = 72 - JUMP_IF_OPEN_STATUS_EQUAL_RETRY
  0x02e, // 0x049 = 73 - 
  0x094, // 0x04a = 74 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_TIMEOUT
  0x02e, // 0x04b = 75 - 
  0x0a7, // 0x04c = 76 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
  0x114, // 0x04d = 77 - 
  0x092, // 0x04e = 78 - JUMP_IF_OPEN_STATUS_EQUAL_OCSM_BUSY
  0x02e, // 0x04f = 79 - 
  0x0ca, // 0x050 = 80 - JUMP_IF_PHY_READY
  0x034, // 0x051 = 81 - 
  0x031, // 0x052 = 82 - SET_OPEN_STATUS_PHY_NOT_RDY_SFO
  0x033, // 0x053 = 83 - SOFT_RESET
  0x0ff, // 0x054 = 84 - JUMP
  0x001, // 0x055 = 85 - 
  0x021, // 0x056 = 86 - SET_OPEN_STATUS_NORMAL_SFO
  0x0ff, // 0x057 = 87 - JUMP
  0x06e, // 0x058 = 88 - 
  0x025, // 0x059 = 89 - SET_OPEN_STATUS_BAD_RATE_SFO
  0x0ff, // 0x05a = 90 - JUMP
  0x0ff, // 0x05b = 91 - 
  0x026, // 0x05c = 92 - SET_OPEN_STATUS_BAD_PROTOCOL_SFO
  0x0ff, // 0x05d = 93 - JUMP
  0x0ff, // 0x05e = 94 - 
  0x028, // 0x05f = 95 - SET_OPEN_STATUS_WRONG_DEST_SFO
  0x0ff, // 0x060 = 96 - JUMP
  0x0ff, // 0x061 = 97 - 
  0x024, // 0x062 = 98 - SET_OPEN_STATUS_BREAK_SFO
  0x0ff, // 0x063 = 99 - JUMP
  0x0ff, // 0x064 = 100 - 
  0x023, // 0x065 = 101 - SET_OPEN_STATUS_BAD_DEST_SFO
  0x0ff, // 0x066 = 102 - JUMP
  0x0ff, // 0x067 = 103 - 
  0x022, // 0x068 = 104 - SET_OPEN_STATUS_IT_NEXUS_LOSS_SFO
  0x0ff, // 0x069 = 105 - JUMP
  0x0ff, // 0x06a = 106 - 
  0x019, // 0x06b = 107 - PATHWAY_BLOCKED_CNT_SFO_INC
  0x0ff, // 0x06c = 108 - JUMP
  0x02e, // 0x06d = 109 - 
  0x000, // 0x06e = 110 - NO_OP
  0x0aa, // 0x06f = 111 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_GOOD
  0x08e, // 0x070 = 112 - 
  0x0ab, // 0x071 = 113 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_NAK
  0x080, // 0x072 = 114 - 
  0x0ac, // 0x073 = 115 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_ACK_NAK_TIMEOUT
  0x083, // 0x074 = 116 - 
  0x0ad, // 0x075 = 117 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_BREAK
  0x083, // 0x076 = 118 - 
  0x0af, // 0x077 = 119 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_CREDIT_TIMEOUT
  0x087, // 0x078 = 120 - 
  0x0ae, // 0x079 = 121 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_UNEXPECTED_CLOSE
  0x080, // 0x07a = 122 - 
  0x0ca, // 0x07b = 123 - JUMP_IF_PHY_READY
  0x06f, // 0x07c = 124 - 
  0x033, // 0x07d = 125 - SOFT_RESET
  0x0ff, // 0x07e = 126 - JUMP
  0x001, // 0x07f = 127 - 
  0x006, // 0x080 = 128 - CLOSE_NORMAL
  0x0ff, // 0x081 = 129 - JUMP
  0x08b, // 0x082 = 130 - 
  0x009, // 0x083 = 131 - CLOSE_BREAK
  0x034, // 0x084 = 132 - ADVANCE_SFO
  0x0ff, // 0x085 = 133 - JUMP
  0x0ff, // 0x086 = 134 - 
  0x009, // 0x087 = 135 - CLOSE_BREAK
  0x034, // 0x088 = 136 - ADVANCE_SFO
  0x0ff, // 0x089 = 137 - JUMP
  0x0ff, // 0x08a = 138 - 
  0x034, // 0x08b = 139 - ADVANCE_SFO
  0x0ff, // 0x08c = 140 - JUMP
  0x12d, // 0x08d = 141 - 
  0x034, // 0x08e = 142 - ADVANCE_SFO
  0x0ff, // 0x08f = 143 - JUMP
  0x0ff, // 0x090 = 144 - 
  0x01c, // 0x091 = 145 - START_IT_NEXUS_LOSS_TIMER_DOC
  0x018, // 0x092 = 146 - PATHWAY_BLOCKED_CNT_DOC_RESET
  0x014, // 0x093 = 147 - START_ARB_WAIT_TIMER_DOC
  0x002, // 0x094 = 148 - OPEN_REQUEST_DOC
  0x000, // 0x095 = 149 - NO_OP
  0x000, // 0x096 = 150 - NO_OP
  0x000, // 0x097 = 151 - NO_OP
  0x000, // 0x098 = 152 - NO_OP
  0x000, // 0x099 = 153 - NO_OP
  0x091, // 0x09a = 154 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_ACCEPT
  0x0bc, // 0x09b = 155 - 
  0x097, // 0x09c = 156 - JUMP_IF_OPEN_STATUS_EQUAL_RATE_NOT_SUPPORTED
  0x0bf, // 0x09d = 157 - 
  0x09b, // 0x09e = 158 - JUMP_IF_OPEN_STATUS_EQUAL_PROTOCOL_NOT_SUPPORTED
  0x0c2, // 0x09f = 159 - 
  0x09d, // 0x0a0 = 160 - JUMP_IF_OPEN_STATUS_EQUAL_WRONG_DESTINATION
  0x0c5, // 0x0a1 = 161 - 
  0x096, // 0x0a2 = 162 - JUMP_IF_OPEN_STATUS_EQUAL_BREAK_RECEIVED
  0x0c8, // 0x0a3 = 163 - 
  0x095, // 0x0a4 = 164 - JUMP_IF_OPEN_STATUS_EQUAL_BAD_DESTINATION
  0x0cb, // 0x0a5 = 165 - 
  0x0a2, // 0x0a6 = 166 - JUMP_IF_IT_NEXUS_LOSS_TIMEOUT_DOC
  0x0ce, // 0x0a7 = 167 - 
  0x09c, // 0x0a8 = 168 - JUMP_IF_OPEN_STATUS_EQUAL_STP_RESOURCE_BUSY
  0x091, // 0x0a9 = 169 - 
  0x098, // 0x0aa = 170 - JUMP_IF_OPEN_STATUS_EQUAL_NO_DESTINATION
  0x0ff, // 0x0ab = 171 - 
  0x099, // 0x0ac = 172 - JUMP_IF_OPEN_STATUS_EQUAL_PATHWAY_BLOCKED
  0x0d1, // 0x0ad = 173 - 
  0x09a, // 0x0ae = 174 - JUMP_IF_OPEN_STATUS_EQUAL_RETRY
  0x094, // 0x0af = 175 - 
  0x094, // 0x0b0 = 176 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_TIMEOUT
  0x094, // 0x0b1 = 177 - 
  0x0a7, // 0x0b2 = 178 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
  0x122, // 0x0b3 = 179 - 
  0x092, // 0x0b4 = 180 - JUMP_IF_OPEN_STATUS_EQUAL_OCSM_BUSY
  0x094, // 0x0b5 = 181 - 
  0x0ca, // 0x0b6 = 182 - JUMP_IF_PHY_READY
  0x09a, // 0x0b7 = 183 - 
  0x032, // 0x0b8 = 184 - SET_OPEN_STATUS_PHY_NOT_RDY_DOC
  0x033, // 0x0b9 = 185 - SOFT_RESET
  0x0ff, // 0x0ba = 186 - JUMP
  0x001, // 0x0bb = 187 - 
  0x029, // 0x0bc = 188 - SET_OPEN_STATUS_NORMAL_DOC
  0x0ff, // 0x0bd = 189 - JUMP
  0x0d4, // 0x0be = 190 - 
  0x02d, // 0x0bf = 191 - SET_OPEN_STATUS_BAD_RATE_DOC
  0x0ff, // 0x0c0 = 192 - JUMP
  0x0ff, // 0x0c1 = 193 - 
  0x02e, // 0x0c2 = 194 - SET_OPEN_STATUS_BAD_PROTOCOL_DOC
  0x0ff, // 0x0c3 = 195 - JUMP
  0x0ff, // 0x0c4 = 196 - 
  0x030, // 0x0c5 = 197 - SET_OPEN_STATUS_WRONG_DEST_DOC
  0x0ff, // 0x0c6 = 198 - JUMP
  0x0ff, // 0x0c7 = 199 - 
  0x02c, // 0x0c8 = 200 - SET_OPEN_STATUS_BREAK_DOC
  0x0ff, // 0x0c9 = 201 - JUMP
  0x0ff, // 0x0ca = 202 - 
  0x02b, // 0x0cb = 203 - SET_OPEN_STATUS_BAD_DEST_DOC
  0x0ff, // 0x0cc = 204 - JUMP
  0x0ff, // 0x0cd = 205 - 
  0x02a, // 0x0ce = 206 - SET_OPEN_STATUS_IT_NEXUS_LOSS_DOC
  0x0ff, // 0x0cf = 207 - JUMP
  0x0ff, // 0x0d0 = 208 - 
  0x01a, // 0x0d1 = 209 - PATHWAY_BLOCKED_CNT_DOC_INC
  0x0ff, // 0x0d2 = 210 - JUMP
  0x094, // 0x0d3 = 211 - 
  0x000, // 0x0d4 = 212 - NO_OP
  0x0b1, // 0x0d5 = 213 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_GOOD
  0x0fc, // 0x0d6 = 214 - 
  0x0b2, // 0x0d7 = 215 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_NAK
  0x0ee, // 0x0d8 = 216 - 
  0x0b3, // 0x0d9 = 217 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_ACK_NAK_TIMEOUT
  0x0f1, // 0x0da = 218 - 
  0x0b4, // 0x0db = 219 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_BREAK
  0x0f1, // 0x0dc = 220 - 
  0x0b6, // 0x0dd = 221 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_CREDIT_TIMEOUT
  0x0f5, // 0x0de = 222 - 
  0x0b5, // 0x0df = 223 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_UNEXPECTED_CLOSE
  0x0ee, // 0x0e0 = 224 - 
  0x0ca, // 0x0e1 = 225 - JUMP_IF_PHY_READY
  0x0e6, // 0x0e2 = 226 - 
  0x033, // 0x0e3 = 227 - SOFT_RESET
  0x0ff, // 0x0e4 = 228 - JUMP
  0x001, // 0x0e5 = 229 - 
  0x0b7, // 0x0e6 = 230 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_CREDIT_BLOCKED
  0x0ee, // 0x0e7 = 231 - 
  0x0b8, // 0x0e8 = 232 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_MAX_BURST_SIZE
  0x0ee, // 0x0e9 = 233 - 
  0x0b9, // 0x0ea = 234 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_MAX_CONNECTION_TIME
  0x0ee, // 0x0eb = 235 - 
  0x0ff, // 0x0ec = 236 - JUMP
  0x0d5, // 0x0ed = 237 - 
  0x006, // 0x0ee = 238 - CLOSE_NORMAL
  0x0ff, // 0x0ef = 239 - JUMP
  0x0f9, // 0x0f0 = 240 - 
  0x009, // 0x0f1 = 241 - CLOSE_BREAK
  0x035, // 0x0f2 = 242 - ADVANCE_DOC
  0x0ff, // 0x0f3 = 243 - JUMP
  0x0ff, // 0x0f4 = 244 - 
  0x009, // 0x0f5 = 245 - CLOSE_BREAK
  0x035, // 0x0f6 = 246 - ADVANCE_DOC
  0x0ff, // 0x0f7 = 247 - JUMP
  0x0ff, // 0x0f8 = 248 - 
  0x035, // 0x0f9 = 249 - ADVANCE_DOC
  0x0ff, // 0x0fa = 250 - JUMP
  0x12d, // 0x0fb = 251 - 
  0x035, // 0x0fc = 252 - ADVANCE_DOC
  0x0ff, // 0x0fd = 253 - JUMP
  0x0ff, // 0x0fe = 254 - 
  0x0a9, // 0x0ff = 255 - JUMP_IF_SFO_REQ
  0x10a, // 0x100 = 256 - 
  0x0b0, // 0x101 = 257 - JUMP_IF_DOC_REQ
  0x118, // 0x102 = 258 - 
  0x0a8, // 0x103 = 259 - JUMP_IF_CONNECTION_ACTIVE_SET
  0x126, // 0x104 = 260 - 
  0x0ca, // 0x105 = 261 - JUMP_IF_PHY_READY
  0x0ff, // 0x106 = 262 - 
  0x033, // 0x107 = 263 - SOFT_RESET
  0x0ff, // 0x108 = 264 - JUMP
  0x001, // 0x109 = 265 - 
  0x0ca, // 0x10a = 266 - JUMP_IF_PHY_READY
  0x110, // 0x10b = 267 - 
  0x031, // 0x10c = 268 - SET_OPEN_STATUS_PHY_NOT_RDY_SFO
  0x033, // 0x10d = 269 - SOFT_RESET
  0x0ff, // 0x10e = 270 - JUMP
  0x001, // 0x10f = 271 - 
  0x0a8, // 0x110 = 272 - JUMP_IF_CONNECTION_ACTIVE_SET
  0x114, // 0x111 = 273 - 
  0x0ff, // 0x112 = 274 - JUMP
  0x02b, // 0x113 = 275 - 
  0x0a3, // 0x114 = 276 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL_SFO
  0x056, // 0x115 = 277 - 
  0x0ff, // 0x116 = 278 - JUMP
  0x101, // 0x117 = 279 - 
  0x0ca, // 0x118 = 280 - JUMP_IF_PHY_READY
  0x11e, // 0x119 = 281 - 
  0x032, // 0x11a = 282 - SET_OPEN_STATUS_PHY_NOT_RDY_DOC
  0x033, // 0x11b = 283 - SOFT_RESET
  0x0ff, // 0x11c = 284 - JUMP
  0x001, // 0x11d = 285 - 
  0x0a8, // 0x11e = 286 - JUMP_IF_CONNECTION_ACTIVE_SET
  0x122, // 0x11f = 287 - 
  0x0ff, // 0x120 = 288 - JUMP
  0x091, // 0x121 = 289 - 
  0x0a4, // 0x122 = 290 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL_DOC
  0x0bc, // 0x123 = 291 - 
  0x0ff, // 0x124 = 292 - JUMP
  0x103, // 0x125 = 293 - 
  0x0a6, // 0x126 = 294 - JUMP_IF_CONNECTION_OPEN_MASTER_FLAG_SET
  0x12a, // 0x127 = 295 - 
  0x0ff, // 0x128 = 296 - JUMP
  0x143, // 0x129 = 297 - 
  0x006, // 0x12a = 298 - CLOSE_NORMAL
  0x0ff, // 0x12b = 299 - JUMP
  0x12d, // 0x12c = 300 - 
  0x000, // 0x12d = 301 - NO_OP
  0x000, // 0x12e = 302 - NO_OP
  0x000, // 0x12f = 303 - NO_OP
  0x000, // 0x130 = 304 - NO_OP
  0x000, // 0x131 = 305 - NO_OP
  0x09e, // 0x132 = 306 - JUMP_IF_CLOSE_STATUS_EQUAL_NORMAL
  0x0ff, // 0x133 = 307 - 
  0x0c8, // 0x134 = 308 - JUMP_IF_BREAK_RECEIVED
  0x13b, // 0x135 = 309 - 
  0x0ca, // 0x136 = 310 - JUMP_IF_PHY_READY
  0x12d, // 0x137 = 311 - 
  0x033, // 0x138 = 312 - SOFT_RESET
  0x0ff, // 0x139 = 313 - JUMP
  0x001, // 0x13a = 314 - 
  0x009, // 0x13b = 315 - CLOSE_BREAK
  0x0c8, // 0x13c = 316 - JUMP_IF_BREAK_RECEIVED
  0x0ff, // 0x13d = 317 - 
  0x0ca, // 0x13e = 318 - JUMP_IF_PHY_READY
  0x13c, // 0x13f = 319 - 
  0x033, // 0x140 = 320 - SOFT_RESET
  0x0ff, // 0x141 = 321 - JUMP
  0x001, // 0x142 = 322 - 
  0x0c8, // 0x143 = 323 - JUMP_IF_BREAK_RECEIVED
  0x14c, // 0x144 = 324 - 
  0x0c9, // 0x145 = 325 - JUMP_IF_DONE_NORMAL_RECEIVED
  0x154, // 0x146 = 326 - 
  0x0ca, // 0x147 = 327 - JUMP_IF_PHY_READY
  0x0ff, // 0x148 = 328 - 
  0x033, // 0x149 = 329 - SOFT_RESET
  0x0ff, // 0x14a = 330 - JUMP
  0x0ff, // 0x14b = 331 - 
  0x009, // 0x14c = 332 - CLOSE_BREAK
  0x0c8, // 0x14d = 333 - JUMP_IF_BREAK_RECEIVED
  0x0ff, // 0x14e = 334 - 
  0x0ca, // 0x14f = 335 - JUMP_IF_PHY_READY
  0x14d, // 0x150 = 336 - 
  0x033, // 0x151 = 337 - SOFT_RESET
  0x0ff, // 0x152 = 338 - JUMP
  0x001, // 0x153 = 339 - 
  0x006, // 0x154 = 340 - CLOSE_NORMAL
  0x000, // 0x155 = 341 - NO_OP
  0x000, // 0x156 = 342 - NO_OP
  0x000, // 0x157 = 343 - NO_OP
  0x000, // 0x158 = 344 - NO_OP
  0x000, // 0x159 = 345 - NO_OP
  0x09e, // 0x15a = 346 - JUMP_IF_CLOSE_STATUS_EQUAL_NORMAL
  0x0ff, // 0x15b = 347 - 
  0x0ca, // 0x15c = 348 - JUMP_IF_PHY_READY
  0x15a, // 0x15d = 349 - 
  0x033, // 0x15e = 350 - SOFT_RESET
  0x0ff, // 0x15f = 351 - JUMP
  0x001, // 0x160 = 352 - 
  0x000, // 0x161 = 353 - NO_OP
  0x000, // 0x162 = 354 - NO_OP
  0x000, // 0x163 = 355 - NO_OP
  0x000, // 0x164 = 356 - NO_OP
  0x000, // 0x165 = 357 - NO_OP
  0x000, // 0x166 = 358 - NO_OP
  0x000, // 0x167 = 359 - NO_OP
  0x000, // 0x168 = 360 - NO_OP
  0x000, // 0x169 = 361 - NO_OP
  0x000, // 0x16a = 362 - NO_OP
  0x000, // 0x16b = 363 - NO_OP
  0x000, // 0x16c = 364 - NO_OP
  0x000, // 0x16d = 365 - NO_OP
  0x000, // 0x16e = 366 - NO_OP
  0x000, // 0x16f = 367 - NO_OP
  0x000, // 0x170 = 368 - NO_OP
  0x000, // 0x171 = 369 - NO_OP
  0x000, // 0x172 = 370 - NO_OP
  0x000, // 0x173 = 371 - NO_OP
  0x000, // 0x174 = 372 - NO_OP
  0x000, // 0x175 = 373 - NO_OP
  0x000, // 0x176 = 374 - NO_OP
  0x000, // 0x177 = 375 - NO_OP
  0x000, // 0x178 = 376 - NO_OP
  0x000, // 0x179 = 377 - NO_OP
  0x000, // 0x17a = 378 - NO_OP
  0x000, // 0x17b = 379 - NO_OP
  0x000, // 0x17c = 380 - NO_OP
  0x000, // 0x17d = 381 - NO_OP
  0x000, // 0x17e = 382 - NO_OP
  0x000, // 0x17f = 383 - NO_OP
  0x000, // 0x180 = 384 - NO_OP
  0x000, // 0x181 = 385 - NO_OP
  0x000, // 0x182 = 386 - NO_OP
  0x000, // 0x183 = 387 - NO_OP
  0x000, // 0x184 = 388 - NO_OP
  0x000, // 0x185 = 389 - NO_OP
  0x000, // 0x186 = 390 - NO_OP
  0x000, // 0x187 = 391 - NO_OP
  0x000, // 0x188 = 392 - NO_OP
  0x000, // 0x189 = 393 - NO_OP
  0x000, // 0x18a = 394 - NO_OP
  0x000, // 0x18b = 395 - NO_OP
  0x000, // 0x18c = 396 - NO_OP
  0x000, // 0x18d = 397 - NO_OP
  0x000, // 0x18e = 398 - NO_OP
  0x000, // 0x18f = 399 - NO_OP
  0x000, // 0x190 = 400 - NO_OP
  0x000, // 0x191 = 401 - NO_OP
  0x000, // 0x192 = 402 - NO_OP
  0x000, // 0x193 = 403 - NO_OP
  0x000, // 0x194 = 404 - NO_OP
  0x000, // 0x195 = 405 - NO_OP
  0x000, // 0x196 = 406 - NO_OP
  0x000, // 0x197 = 407 - NO_OP
  0x000, // 0x198 = 408 - NO_OP
  0x000, // 0x199 = 409 - NO_OP
  0x000, // 0x19a = 410 - NO_OP
  0x000, // 0x19b = 411 - NO_OP
  0x000, // 0x19c = 412 - NO_OP
  0x000, // 0x19d = 413 - NO_OP
  0x000, // 0x19e = 414 - NO_OP
  0x000, // 0x19f = 415 - NO_OP
  0x000, // 0x1a0 = 416 - NO_OP
  0x000, // 0x1a1 = 417 - NO_OP
  0x000, // 0x1a2 = 418 - NO_OP
  0x000, // 0x1a3 = 419 - NO_OP
  0x000, // 0x1a4 = 420 - NO_OP
  0x000, // 0x1a5 = 421 - NO_OP
  0x000, // 0x1a6 = 422 - NO_OP
  0x000, // 0x1a7 = 423 - NO_OP
  0x000, // 0x1a8 = 424 - NO_OP
  0x000, // 0x1a9 = 425 - NO_OP
  0x000, // 0x1aa = 426 - NO_OP
  0x000, // 0x1ab = 427 - NO_OP
  0x000, // 0x1ac = 428 - NO_OP
  0x000, // 0x1ad = 429 - NO_OP
  0x000, // 0x1ae = 430 - NO_OP
  0x000, // 0x1af = 431 - NO_OP
  0x000, // 0x1b0 = 432 - NO_OP
  0x000, // 0x1b1 = 433 - NO_OP
  0x000, // 0x1b2 = 434 - NO_OP
  0x000, // 0x1b3 = 435 - NO_OP
  0x000, // 0x1b4 = 436 - NO_OP
  0x000, // 0x1b5 = 437 - NO_OP
  0x000, // 0x1b6 = 438 - NO_OP
  0x000, // 0x1b7 = 439 - NO_OP
  0x000, // 0x1b8 = 440 - NO_OP
  0x000, // 0x1b9 = 441 - NO_OP
  0x000, // 0x1ba = 442 - NO_OP
  0x000, // 0x1bb = 443 - NO_OP
  0x000, // 0x1bc = 444 - NO_OP
  0x000, // 0x1bd = 445 - NO_OP
  0x000, // 0x1be = 446 - NO_OP
  0x000, // 0x1bf = 447 - NO_OP
  0x000, // 0x1c0 = 448 - NO_OP
  0x000, // 0x1c1 = 449 - NO_OP
  0x000, // 0x1c2 = 450 - NO_OP
  0x000, // 0x1c3 = 451 - NO_OP
  0x000, // 0x1c4 = 452 - NO_OP
  0x000, // 0x1c5 = 453 - NO_OP
  0x000, // 0x1c6 = 454 - NO_OP
  0x000, // 0x1c7 = 455 - NO_OP
  0x000, // 0x1c8 = 456 - NO_OP
  0x000, // 0x1c9 = 457 - NO_OP
  0x000, // 0x1ca = 458 - NO_OP
  0x000, // 0x1cb = 459 - NO_OP
  0x000, // 0x1cc = 460 - NO_OP
  0x000, // 0x1cd = 461 - NO_OP
  0x000, // 0x1ce = 462 - NO_OP
  0x000, // 0x1cf = 463 - NO_OP
  0x000, // 0x1d0 = 464 - NO_OP
  0x000, // 0x1d1 = 465 - NO_OP
  0x000, // 0x1d2 = 466 - NO_OP
  0x000, // 0x1d3 = 467 - NO_OP
  0x000, // 0x1d4 = 468 - NO_OP
  0x000, // 0x1d5 = 469 - NO_OP
  0x000, // 0x1d6 = 470 - NO_OP
  0x000, // 0x1d7 = 471 - NO_OP
  0x000, // 0x1d8 = 472 - NO_OP
  0x000, // 0x1d9 = 473 - NO_OP
  0x000, // 0x1da = 474 - NO_OP
  0x000, // 0x1db = 475 - NO_OP
  0x000, // 0x1dc = 476 - NO_OP
  0x000, // 0x1dd = 477 - NO_OP
  0x000, // 0x1de = 478 - NO_OP
  0x000, // 0x1df = 479 - NO_OP
  0x000, // 0x1e0 = 480 - NO_OP
  0x000, // 0x1e1 = 481 - NO_OP
  0x000, // 0x1e2 = 482 - NO_OP
  0x000, // 0x1e3 = 483 - NO_OP
  0x000, // 0x1e4 = 484 - NO_OP
  0x000, // 0x1e5 = 485 - NO_OP
  0x000, // 0x1e6 = 486 - NO_OP
  0x000, // 0x1e7 = 487 - NO_OP
  0x000, // 0x1e8 = 488 - NO_OP
  0x000, // 0x1e9 = 489 - NO_OP
  0x000, // 0x1ea = 490 - NO_OP
  0x000, // 0x1eb = 491 - NO_OP
  0x000, // 0x1ec = 492 - NO_OP
  0x000, // 0x1ed = 493 - NO_OP
  0x000, // 0x1ee = 494 - NO_OP
  0x000, // 0x1ef = 495 - NO_OP
  0x000, // 0x1f0 = 496 - NO_OP
  0x000, // 0x1f1 = 497 - NO_OP
  0x000, // 0x1f2 = 498 - NO_OP
  0x000, // 0x1f3 = 499 - NO_OP
  0x000, // 0x1f4 = 500 - NO_OP
  0x000, // 0x1f5 = 501 - NO_OP
  0x000, // 0x1f6 = 502 - NO_OP
  0x000, // 0x1f7 = 503 - NO_OP
  0x000, // 0x1f8 = 504 - NO_OP
  0x000, // 0x1f9 = 505 - NO_OP
  0x000, // 0x1fa = 506 - NO_OP
  0x000, // 0x1fb = 507 - NO_OP
  0x000, // 0x1fc = 508 - NO_OP
  0x000, // 0x1fd = 509 - NO_OP
  0x000, // 0x1fe = 510 - NO_OP
  0x000, // 0x1ff = 511 - NO_OP
};

/* as of 6/27 */
bit32 wcsImage0627[] = 
{
  0x011,  // 00000 = 0 - PHY_RESET_START
  0x0ca,  // 0x001 = 1 - JUMP_IF_PHY_READY
  0x009,  // 0x002 = 2 - 
  0x0ba,  // 0x003 = 3 - JUMP_IF_HARD_RESET_PRIMITIVE
  0x010,  // 0x004 = 4 - 
  0x0bb,  // 0x005 = 5 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
  0x01e,  // 0x006 = 6 - 
  0x0ff,  // 0x007 = 7 - JUMP
  0x001,  // 0x008 = 8 - 
  0x010,  // 0x009 = 9 - SEND_ID_FRAME
  0x0ba,  // 0x00a = 10 - JUMP_IF_HARD_RESET_PRIMITIVE
  0x010,  // 0x00b = 11 - 
  0x0bb,  // 0x00c = 12 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
  0x023,  // 0x00d = 13 - 
  0x0ff,  // 0x00e = 14 - JUMP
  0x00a,  // 0x00f = 15 - 
  0x033,  // 0x010 = 16 - SOFT_RESET
  0x011,  // 0x011 = 17 - PHY_RESET_START
  0x0ca,  // 0x012 = 18 - JUMP_IF_PHY_READY
  0x016,  // 0x013 = 19 - 
  0x0bb,  // 0x014 = 20 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
  0x01b,  // 0x015 = 21 - 
  0x010,  // 0x016 = 22 - SEND_ID_FRAME
  0x0bb,  // 0x017 = 23 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
  0x023,  // 0x018 = 24 - 
  0x0ff,  // 0x019 = 25 - JUMP
  0x017,  // 0x01a = 26 - 
  0x010,  // 0x01b = 27 - SEND_ID_FRAME
  0x0ff,  // 0x01c = 28 - JUMP
  0x023,  // 0x01d = 29 - 
  0x0ca,  // 0x01e = 30 - JUMP_IF_PHY_READY
  0x022,  // 0x01f = 31 - 
  0x0ff,  // 0x020 = 32 - JUMP
  0x01e,  // 0x021 = 33 - 
  0x010,  // 0x022 = 34 - SEND_ID_FRAME
  0x000,  // 0x023 = 35 - NO_OP
  0x000,  // 0x024 = 36 - NO_OP
  0x000,  // 0x025 = 37 - NO_OP
  0x000,  // 0x026 = 38 - NO_OP
  0x000,  // 0x027 = 39 - NO_OP
  0x000,  // 0x028 = 40 - NO_OP
  0x0ff,  // 0x029 = 41 - JUMP
  0x10d,  // 0x02a = 42 - 
  0x01b,  // 0x02b = 43 - START_IT_NEXUS_LOSS_TIMER_SFO
  0x017,  // 0x02c = 44 - PATHWAY_BLOCKED_CNT_SFO_RESET
  0x013,  // 0x02d = 45 - START_ARB_WAIT_TIMER_SFO
  0x001,  // 0x02e = 46 - OPEN_REQUEST_SFO
  0x000,  // 0x02f = 47 - NO_OP
  0x000,  // 0x030 = 48 - NO_OP
  0x000,  // 0x031 = 49 - NO_OP
  0x000,  // 0x032 = 50 - NO_OP
  0x000,  // 0x033 = 51 - NO_OP
  0x091,  // 0x034 = 52 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_ACCEPT
  0x056,  // 0x035 = 53 - 
  0x097,  // 0x036 = 54 - JUMP_IF_OPEN_STATUS_EQUAL_RATE_NOT_SUPPORTED
  0x059,  // 0x037 = 55 - 
  0x09b,  // 0x038 = 56 - JUMP_IF_OPEN_STATUS_EQUAL_PROTOCOL_NOT_SUPPORTED
  0x05c,  // 0x039 = 57 - 
  0x09d,  // 0x03a = 58 - JUMP_IF_OPEN_STATUS_EQUAL_WRONG_DESTINATION
  0x05f,  // 0x03b = 59 - 
  0x096,  // 0x03c = 60 - JUMP_IF_OPEN_STATUS_EQUAL_BREAK_RECEIVED
  0x062,  // 0x03d = 61 - 
  0x095,  // 0x03e = 62 - JUMP_IF_OPEN_STATUS_EQUAL_BAD_DESTINATION
  0x065,  // 0x03f = 63 - 
  0x0a1,  // 0x040 = 64 - JUMP_IF_IT_NEXUS_LOSS_TIMEOUT_SFO
  0x068,  // 0x041 = 65 - 
  0x09c,  // 0x042 = 66 - JUMP_IF_OPEN_STATUS_EQUAL_STP_RESOURCE_BUSY
  0x02b,  // 0x043 = 67 - 
  0x098,  // 0x044 = 68 - JUMP_IF_OPEN_STATUS_EQUAL_NO_DESTINATION
  0x10d,  // 0x045 = 69 - 
  0x099,  // 0x046 = 70 - JUMP_IF_OPEN_STATUS_EQUAL_PATHWAY_BLOCKED
  0x06b,  // 0x047 = 71 - 
  0x09a,  // 0x048 = 72 - JUMP_IF_OPEN_STATUS_EQUAL_RETRY
  0x02e,  // 0x049 = 73 - 
  0x094,  // 0x04a = 74 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_TIMEOUT
  0x02e,  // 0x04b = 75 - 
  0x0a7,  // 0x04c = 76 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
  0x122,  // 0x04d = 77 - 
  0x092,  // 0x04e = 78 - JUMP_IF_OPEN_STATUS_EQUAL_OCSM_BUSY
  0x02e,  // 0x04f = 79 - 
  0x0ca,  // 0x050 = 80 - JUMP_IF_PHY_READY
  0x034,  // 0x051 = 81 - 
  0x031,  // 0x052 = 82 - SET_OPEN_STATUS_PHY_NOT_RDY_SFO
  0x033,  // 0x053 = 83 - SOFT_RESET
  0x0ff,  // 0x054 = 84 - JUMP
  0x001,  // 0x055 = 85 - 
  0x021,  // 0x056 = 86 - SET_OPEN_STATUS_NORMAL_SFO
  0x0ff,  // 0x057 = 87 - JUMP
  0x06e,  // 0x058 = 88 - 
  0x025,  // 0x059 = 89 - SET_OPEN_STATUS_BAD_RATE_SFO
  0x0ff,  // 0x05a = 90 - JUMP
  0x10d,  // 0x05b = 91 - 
  0x026,  // 0x05c = 92 - SET_OPEN_STATUS_BAD_PROTOCOL_SFO
  0x0ff,  // 0x05d = 93 - JUMP
  0x10d,  // 0x05e = 94 - 
  0x028,  // 0x05f = 95 - SET_OPEN_STATUS_WRONG_DEST_SFO
  0x0ff,  // 0x060 = 96 - JUMP
  0x10d,  // 0x061 = 97 - 
  0x024,  // 0x062 = 98 - SET_OPEN_STATUS_BREAK_SFO
  0x0ff,  // 0x063 = 99 - JUMP
  0x10d,  // 0x064 = 100 - 
  0x023,  // 0x065 = 101 - SET_OPEN_STATUS_BAD_DEST_SFO
  0x0ff,  // 0x066 = 102 - JUMP
  0x10d,  // 0x067 = 103 - 
  0x022,  // 0x068 = 104 - SET_OPEN_STATUS_IT_NEXUS_LOSS_SFO
  0x0ff,  // 0x069 = 105 - JUMP
  0x10d,  // 0x06a = 106 - 
  0x019,  // 0x06b = 107 - PATHWAY_BLOCKED_CNT_SFO_INC
  0x0ff,  // 0x06c = 108 - JUMP
  0x02e,  // 0x06d = 109 - 
  0x000,  // 0x06e = 110 - NO_OP
  0x0aa,  // 0x06f = 111 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_GOOD
  0x082,  // 0x070 = 112 - 
  0x0ab,  // 0x071 = 113 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_NAK
  0x086,  // 0x072 = 114 - 
  0x0ac,  // 0x073 = 115 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_ACK_NAK_TIMEOUT
  0x089,  // 0x074 = 116 - 
  0x0ad,  // 0x075 = 117 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_BREAK
  0x08f,  // 0x076 = 118 - 
  0x0af,  // 0x077 = 119 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_CREDIT_TIMEOUT
  0x08c,  // 0x078 = 120 - 
  0x0ae,  // 0x079 = 121 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_UNEXPECTED_CLOSE
  0x086,  // 0x07a = 122 - 
  0x0d2,  // 0x07b = 123 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_SMP_ERR
  0x095,  // 0x07c = 124 - 
  0x0ca,  // 0x07d = 125 - JUMP_IF_PHY_READY
  0x06f,  // 0x07e = 126 - 
  0x033,  // 0x07f = 127 - SOFT_RESET
  0x0ff,  // 0x080 = 128 - JUMP
  0x001,  // 0x081 = 129 - 
  0x0d0,  // 0x082 = 130 - JUMP_IF_SMP_PROTOCOL
  0x086,  // 0x083 = 131 - 
  0x0ff,  // 0x084 = 132 - JUMP
  0x092,  // 0x085 = 133 - 
  0x006,  // 0x086 = 134 - CLOSE_NORMAL
  0x0ff,  // 0x087 = 135 - JUMP
  0x08f,  // 0x088 = 136 - 
  0x007,  // 0x089 = 137 - CLOSE_ACK_NAK_TIMEOUT
  0x0ff,  // 0x08a = 138 - JUMP
  0x08f,  // 0x08b = 139 - 
  0x008,  // 0x08c = 140 - CLOSE_CREDIT_TIMEOUT
  0x0ff,  // 0x08d = 141 - JUMP
  0x08f,  // 0x08e = 142 - 
  0x034,  // 0x08f = 143 - ADVANCE_SFO
  0x0ff,  // 0x090 = 144 - JUMP
  0x141,  // 0x091 = 145 - 
  0x034,  // 0x092 = 146 - ADVANCE_SFO
  0x0ff,  // 0x093 = 147 - JUMP
  0x10d,  // 0x094 = 148 - 
  0x034,  // 0x095 = 149 - ADVANCE_SFO
  0x0ff,  // 0x096 = 150 - JUMP
  0x14f,  // 0x097 = 151 - 
  0x01c,  // 0x098 = 152 - START_IT_NEXUS_LOSS_TIMER_DOC
  0x018,  // 0x099 = 153 - PATHWAY_BLOCKED_CNT_DOC_RESET
  0x014,  // 0x09a = 154 - START_ARB_WAIT_TIMER_DOC
  0x002,  // 0x09b = 155 - OPEN_REQUEST_DOC
  0x000,  // 0x09c = 156 - NO_OP
  0x000,  // 0x09d = 157 - NO_OP
  0x000,  // 0x09e = 158 - NO_OP
  0x000,  // 0x09f = 159 - NO_OP
  0x000,  // 0x0a0 = 160 - NO_OP
  0x091,  // 0x0a1 = 161 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_ACCEPT
  0x0c3,  // 0x0a2 = 162 - 
  0x097,  // 0x0a3 = 163 - JUMP_IF_OPEN_STATUS_EQUAL_RATE_NOT_SUPPORTED
  0x0c6,  // 0x0a4 = 164 - 
  0x09b,  // 0x0a5 = 165 - JUMP_IF_OPEN_STATUS_EQUAL_PROTOCOL_NOT_SUPPORTED
  0x0c9,  // 0x0a6 = 166 - 
  0x09d,  // 0x0a7 = 167 - JUMP_IF_OPEN_STATUS_EQUAL_WRONG_DESTINATION
  0x0cc,  // 0x0a8 = 168 - 
  0x096,  // 0x0a9 = 169 - JUMP_IF_OPEN_STATUS_EQUAL_BREAK_RECEIVED
  0x0cf,  // 0x0aa = 170 - 
  0x095,  // 0x0ab = 171 - JUMP_IF_OPEN_STATUS_EQUAL_BAD_DESTINATION
  0x0d2,  // 0x0ac = 172 - 
  0x0a2,  // 0x0ad = 173 - JUMP_IF_IT_NEXUS_LOSS_TIMEOUT_DOC
  0x0d5,  // 0x0ae = 174 - 
  0x09c,  // 0x0af = 175 - JUMP_IF_OPEN_STATUS_EQUAL_STP_RESOURCE_BUSY
  0x098,  // 0x0b0 = 176 - 
  0x098,  // 0x0b1 = 177 - JUMP_IF_OPEN_STATUS_EQUAL_NO_DESTINATION
  0x10d,  // 0x0b2 = 178 - 
  0x099,  // 0x0b3 = 179 - JUMP_IF_OPEN_STATUS_EQUAL_PATHWAY_BLOCKED
  0x0d8,  // 0x0b4 = 180 - 
  0x09a,  // 0x0b5 = 181 - JUMP_IF_OPEN_STATUS_EQUAL_RETRY
  0x09b,  // 0x0b6 = 182 - 
  0x094,  // 0x0b7 = 183 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_TIMEOUT
  0x09b,  // 0x0b8 = 184 - 
  0x0a7,  // 0x0b9 = 185 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
  0x130,  // 0x0ba = 186 - 
  0x092,  // 0x0bb = 187 - JUMP_IF_OPEN_STATUS_EQUAL_OCSM_BUSY
  0x09b,  // 0x0bc = 188 - 
  0x0ca,  // 0x0bd = 189 - JUMP_IF_PHY_READY
  0x0a1,  // 0x0be = 190 - 
  0x032,  // 0x0bf = 191 - SET_OPEN_STATUS_PHY_NOT_RDY_DOC
  0x033,  // 0x0c0 = 192 - SOFT_RESET
  0x0ff,  // 0x0c1 = 193 - JUMP
  0x001,  // 0x0c2 = 194 - 
  0x029,  // 0x0c3 = 195 - SET_OPEN_STATUS_NORMAL_DOC
  0x0ff,  // 0x0c4 = 196 - JUMP
  0x0db,  // 0x0c5 = 197 - 
  0x02d,  // 0x0c6 = 198 - SET_OPEN_STATUS_BAD_RATE_DOC
  0x0ff,  // 0x0c7 = 199 - JUMP
  0x10d,  // 0x0c8 = 200 - 
  0x02e,  // 0x0c9 = 201 - SET_OPEN_STATUS_BAD_PROTOCOL_DOC
  0x0ff,  // 0x0ca = 202 - JUMP
  0x10d,  // 0x0cb = 203 - 
  0x030,  // 0x0cc = 204 - SET_OPEN_STATUS_WRONG_DEST_DOC
  0x0ff,  // 0x0cd = 205 - JUMP
  0x10d,  // 0x0ce = 206 - 
  0x02c,  // 0x0cf = 207 - SET_OPEN_STATUS_BREAK_DOC
  0x0ff,  // 0x0d0 = 208 - JUMP
  0x10d,  // 0x0d1 = 209 - 
  0x02b,  // 0x0d2 = 210 - SET_OPEN_STATUS_BAD_DEST_DOC
  0x0ff,  // 0x0d3 = 211 - JUMP
  0x10d,  // 0x0d4 = 212 - 
  0x02a,  // 0x0d5 = 213 - SET_OPEN_STATUS_IT_NEXUS_LOSS_DOC
  0x0ff,  // 0x0d6 = 214 - JUMP
  0x10d,  // 0x0d7 = 215 - 
  0x01a,  // 0x0d8 = 216 - PATHWAY_BLOCKED_CNT_DOC_INC
  0x0ff,  // 0x0d9 = 217 - JUMP
  0x09b,  // 0x0da = 218 - 
  0x000,  // 0x0db = 219 - NO_OP
  0x0b1,  // 0x0dc = 220 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_GOOD
  0x0ef,  // 0x0dd = 221 - 
  0x0b2,  // 0x0de = 222 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_NAK
  0x0fb,  // 0x0df = 223 - 
  0x0b3,  // 0x0e0 = 224 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_ACK_NAK_TIMEOUT
  0x0fe,  // 0x0e1 = 225 - 
  0x0b4,  // 0x0e2 = 226 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_BREAK
  0x104,  // 0x0e3 = 227 - 
  0x0b6,  // 0x0e4 = 228 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_CREDIT_TIMEOUT
  0x101,  // 0x0e5 = 229 - 
  0x0b5,  // 0x0e6 = 230 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_UNEXPECTED_CLOSE
  0x0fb,  // 0x0e7 = 231 - 
  0x0d3,  // 0x0e8 = 232 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_SMP_ERR
  0x10a,  // 0x0e9 = 233 - 
  0x0ca,  // 0x0ea = 234 - JUMP_IF_PHY_READY
  0x0f3,  // 0x0eb = 235 - 
  0x033,  // 0x0ec = 236 - SOFT_RESET
  0x0ff,  // 0x0ed = 237 - JUMP
  0x001,  // 0x0ee = 238 - 
  0x0d0,  // 0x0ef = 239 - JUMP_IF_SMP_PROTOCOL
  0x0fb,  // 0x0f0 = 240 - 
  0x0ff,  // 0x0f1 = 241 - JUMP
  0x107,  // 0x0f2 = 242 - 
  0x0b7,  // 0x0f3 = 243 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_CREDIT_BLOCKED
  0x0fb,  // 0x0f4 = 244 - 
  0x0b8,  // 0x0f5 = 245 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_MAX_BURST_SIZE
  0x0fb,  // 0x0f6 = 246 - 
  0x0b9,  // 0x0f7 = 247 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_MAX_CONNECTION_TIME
  0x0fb,  // 0x0f8 = 248 - 
  0x0ff,  // 0x0f9 = 249 - JUMP
  0x0dc,  // 0x0fa = 250 - 
  0x006,  // 0x0fb = 251 - CLOSE_NORMAL
  0x0ff,  // 0x0fc = 252 - JUMP
  0x104,  // 0x0fd = 253 - 
  0x007,  // 0x0fe = 254 - CLOSE_ACK_NAK_TIMEOUT
  0x0ff,  // 0x0ff = 255 - JUMP
  0x104,  // 0x100 = 256 - 
  0x008,  // 0x101 = 257 - CLOSE_CREDIT_TIMEOUT
  0x0ff,  // 0x102 = 258 - JUMP
  0x104,  // 0x103 = 259 - 
  0x035,  // 0x104 = 260 - ADVANCE_DOC
  0x0ff,  // 0x105 = 261 - JUMP
  0x141,  // 0x106 = 262 - 
  0x035,  // 0x107 = 263 - ADVANCE_DOC
  0x0ff,  // 0x108 = 264 - JUMP
  0x10d,  // 0x109 = 265 - 
  0x035,  // 0x10a = 266 - ADVANCE_DOC
  0x0ff,  // 0x10b = 267 - JUMP
  0x14f,  // 0x10c = 268 - 
  0x0a9,  // 0x10d = 269 - JUMP_IF_SFO_REQ
  0x118,  // 0x10e = 270 - 
  0x0b0,  // 0x10f = 271 - JUMP_IF_DOC_REQ
  0x126,  // 0x110 = 272 - 
  0x0a8,  // 0x111 = 273 - JUMP_IF_CONNECTION_ACTIVE_SET
  0x134,  // 0x112 = 274 - 
  0x0ca,  // 0x113 = 275 - JUMP_IF_PHY_READY
  0x10d,  // 0x114 = 276 - 
  0x033,  // 0x115 = 277 - SOFT_RESET
  0x0ff,  // 0x116 = 278 - JUMP
  0x001,  // 0x117 = 279 - 
  0x0ca,  // 0x118 = 280 - JUMP_IF_PHY_READY
  0x11e,  // 0x119 = 281 - 
  0x031,  // 0x11a = 282 - SET_OPEN_STATUS_PHY_NOT_RDY_SFO
  0x033,  // 0x11b = 283 - SOFT_RESET
  0x0ff,  // 0x11c = 284 - JUMP
  0x001,  // 0x11d = 285 - 
  0x0a8,  // 0x11e = 286 - JUMP_IF_CONNECTION_ACTIVE_SET
  0x122,  // 0x11f = 287 - 
  0x0ff,  // 0x120 = 288 - JUMP
  0x02b,  // 0x121 = 289 - 
  0x0a3,  // 0x122 = 290 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL_SFO
  0x056,  // 0x123 = 291 - 
  0x0ff,  // 0x124 = 292 - JUMP
  0x10f,  // 0x125 = 293 - 
  0x0ca,  // 0x126 = 294 - JUMP_IF_PHY_READY
  0x12c,  // 0x127 = 295 - 
  0x032,  // 0x128 = 296 - SET_OPEN_STATUS_PHY_NOT_RDY_DOC
  0x033,  // 0x129 = 297 - SOFT_RESET
  0x0ff,  // 0x12a = 298 - JUMP
  0x001,  // 0x12b = 299 - 
  0x0a8,  // 0x12c = 300 - JUMP_IF_CONNECTION_ACTIVE_SET
  0x130,  // 0x12d = 301 - 
  0x0ff,  // 0x12e = 302 - JUMP
  0x098,  // 0x12f = 303 - 
  0x0a4,  // 0x130 = 304 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL_DOC
  0x0c3,  // 0x131 = 305 - 
  0x0ff,  // 0x132 = 306 - JUMP
  0x111,  // 0x133 = 307 - 
  0x0d0,  // 0x134 = 308 - JUMP_IF_SMP_PROTOCOL
  0x13d,  // 0x135 = 309 - 
  0x0a6,  // 0x136 = 310 - JUMP_IF_CONNECTION_OPEN_MASTER_FLAG_SET
  0x13a,  // 0x137 = 311 - 
  0x0ff,  // 0x138 = 312 - JUMP
  0x157,  // 0x139 = 313 - 
  0x006,  // 0x13a = 314 - CLOSE_NORMAL
  0x0ff,  // 0x13b = 315 - JUMP
  0x141,  // 0x13c = 316 - 
  0x0d1,  // 0x13d = 317 - JUMP_IF_SMP_FRAME_ERR_RECEIVED
  0x160,  // 0x13e = 318 - 
  0x0ff,  // 0x13f = 319 - JUMP
  0x10d,  // 0x140 = 320 - 
  0x000,  // 0x141 = 321 - NO_OP
  0x000,  // 0x142 = 322 - NO_OP
  0x000,  // 0x143 = 323 - NO_OP
  0x000,  // 0x144 = 324 - NO_OP
  0x000,  // 0x145 = 325 - NO_OP
  0x09e,  // 0x146 = 326 - JUMP_IF_CLOSE_STATUS_EQUAL_NORMAL
  0x10d,  // 0x147 = 327 - 
  0x0c8,  // 0x148 = 328 - JUMP_IF_BREAK_RECEIVED
  0x14f,  // 0x149 = 329 - 
  0x0ca,  // 0x14a = 330 - JUMP_IF_PHY_READY
  0x141,  // 0x14b = 331 - 
  0x033,  // 0x14c = 332 - SOFT_RESET
  0x0ff,  // 0x14d = 333 - JUMP
  0x001,  // 0x14e = 334 - 
  0x009,  // 0x14f = 335 - CLOSE_BREAK
  0x0c8,  // 0x150 = 336 - JUMP_IF_BREAK_RECEIVED
  0x10d,  // 0x151 = 337 - 
  0x0ca,  // 0x152 = 338 - JUMP_IF_PHY_READY
  0x150,  // 0x153 = 339 - 
  0x033,  // 0x154 = 340 - SOFT_RESET
  0x0ff,  // 0x155 = 341 - JUMP
  0x001,  // 0x156 = 342 - 
  0x0c8,  // 0x157 = 343 - JUMP_IF_BREAK_RECEIVED
  0x160,  // 0x158 = 344 - 
  0x0c9,  // 0x159 = 345 - JUMP_IF_DONE_NORMAL_RECEIVED
  0x168,  // 0x15a = 346 - 
  0x0ca,  // 0x15b = 347 - JUMP_IF_PHY_READY
  0x10d,  // 0x15c = 348 - 
  0x033,  // 0x15d = 349 - SOFT_RESET
  0x0ff,  // 0x15e = 350 - JUMP
  0x10d,  // 0x15f = 351 - 
  0x009,  // 0x160 = 352 - CLOSE_BREAK
  0x0c8,  // 0x161 = 353 - JUMP_IF_BREAK_RECEIVED
  0x10d,  // 0x162 = 354 - 
  0x0ca,  // 0x163 = 355 - JUMP_IF_PHY_READY
  0x161,  // 0x164 = 356 - 
  0x033,  // 0x165 = 357 - SOFT_RESET
  0x0ff,  // 0x166 = 358 - JUMP
  0x001,  // 0x167 = 359 - 
  0x006,  // 0x168 = 360 - CLOSE_NORMAL
  0x000,  // 0x169 = 361 - NO_OP
  0x000,  // 0x16a = 362 - NO_OP
  0x000,  // 0x16b = 363 - NO_OP
  0x000,  // 0x16c = 364 - NO_OP
  0x000,  // 0x16d = 365 - NO_OP
  0x09e,  // 0x16e = 366 - JUMP_IF_CLOSE_STATUS_EQUAL_NORMAL
  0x10d,  // 0x16f = 367 - 
  0x0ca,  // 0x170 = 368 - JUMP_IF_PHY_READY
  0x16e,  // 0x171 = 369 - 
  0x033,  // 0x172 = 370 - SOFT_RESET
  0x0ff,  // 0x173 = 371 - JUMP
  0x001,  // 0x174 = 372 - 
  0x000,  // 0x175 = 373 - NO_OP
  0x000,  // 0x176 = 374 - NO_OP
  0x000,  // 0x177 = 375 - NO_OP
  0x000,  // 0x178 = 376 - NO_OP
  0x000,  // 0x179 = 377 - NO_OP
  0x000,  // 0x17a = 378 - NO_OP
  0x000,  // 0x17b = 379 - NO_OP
  0x000,  // 0x17c = 380 - NO_OP
  0x000,  // 0x17d = 381 - NO_OP
  0x000,  // 0x17e = 382 - NO_OP
  0x000,  // 0x17f = 383 - NO_OP
  0x000,  // 0x180 = 384 - NO_OP
  0x000,  // 0x181 = 385 - NO_OP
  0x000,  // 0x182 = 386 - NO_OP
  0x000,  // 0x183 = 387 - NO_OP
  0x000,  // 0x184 = 388 - NO_OP
  0x000,  // 0x185 = 389 - NO_OP
  0x000,  // 0x186 = 390 - NO_OP
  0x000,  // 0x187 = 391 - NO_OP
  0x000,  // 0x188 = 392 - NO_OP
  0x000,  // 0x189 = 393 - NO_OP
  0x000,  // 0x18a = 394 - NO_OP
  0x000,  // 0x18b = 395 - NO_OP
  0x000,  // 0x18c = 396 - NO_OP
  0x000,  // 0x18d = 397 - NO_OP
  0x000,  // 0x18e = 398 - NO_OP
  0x000,  // 0x18f = 399 - NO_OP
  0x000,  // 0x190 = 400 - NO_OP
  0x000,  // 0x191 = 401 - NO_OP
  0x000,  // 0x192 = 402 - NO_OP
  0x000,  // 0x193 = 403 - NO_OP
  0x000,  // 0x194 = 404 - NO_OP
  0x000,  // 0x195 = 405 - NO_OP
  0x000,  // 0x196 = 406 - NO_OP
  0x000,  // 0x197 = 407 - NO_OP
  0x000,  // 0x198 = 408 - NO_OP
  0x000,  // 0x199 = 409 - NO_OP
  0x000,  // 0x19a = 410 - NO_OP
  0x000,  // 0x19b = 411 - NO_OP
  0x000,  // 0x19c = 412 - NO_OP
  0x000,  // 0x19d = 413 - NO_OP
  0x000,  // 0x19e = 414 - NO_OP
  0x000,  // 0x19f = 415 - NO_OP
  0x000,  // 0x1a0 = 416 - NO_OP
  0x000,  // 0x1a1 = 417 - NO_OP
  0x000,  // 0x1a2 = 418 - NO_OP
  0x000,  // 0x1a3 = 419 - NO_OP
  0x000,  // 0x1a4 = 420 - NO_OP
  0x000,  // 0x1a5 = 421 - NO_OP
  0x000,  // 0x1a6 = 422 - NO_OP
  0x000,  // 0x1a7 = 423 - NO_OP
  0x000,  // 0x1a8 = 424 - NO_OP
  0x000,  // 0x1a9 = 425 - NO_OP
  0x000,  // 0x1aa = 426 - NO_OP
  0x000,  // 0x1ab = 427 - NO_OP
  0x000,  // 0x1ac = 428 - NO_OP
  0x000,  // 0x1ad = 429 - NO_OP
  0x000,  // 0x1ae = 430 - NO_OP
  0x000,  // 0x1af = 431 - NO_OP
  0x000,  // 0x1b0 = 432 - NO_OP
  0x000,  // 0x1b1 = 433 - NO_OP
  0x000,  // 0x1b2 = 434 - NO_OP
  0x000,  // 0x1b3 = 435 - NO_OP
  0x000,  // 0x1b4 = 436 - NO_OP
  0x000,  // 0x1b5 = 437 - NO_OP
  0x000,  // 0x1b6 = 438 - NO_OP
  0x000,  // 0x1b7 = 439 - NO_OP
  0x000,  // 0x1b8 = 440 - NO_OP
  0x000,  // 0x1b9 = 441 - NO_OP
  0x000,  // 0x1ba = 442 - NO_OP
  0x000,  // 0x1bb = 443 - NO_OP
  0x000,  // 0x1bc = 444 - NO_OP
  0x000,  // 0x1bd = 445 - NO_OP
  0x000,  // 0x1be = 446 - NO_OP
  0x000,  // 0x1bf = 447 - NO_OP
  0x000,  // 0x1c0 = 448 - NO_OP
  0x000,  // 0x1c1 = 449 - NO_OP
  0x000,  // 0x1c2 = 450 - NO_OP
  0x000,  // 0x1c3 = 451 - NO_OP
  0x000,  // 0x1c4 = 452 - NO_OP
  0x000,  // 0x1c5 = 453 - NO_OP
  0x000,  // 0x1c6 = 454 - NO_OP
  0x000,  // 0x1c7 = 455 - NO_OP
  0x000,  // 0x1c8 = 456 - NO_OP
  0x000,  // 0x1c9 = 457 - NO_OP
  0x000,  // 0x1ca = 458 - NO_OP
  0x000,  // 0x1cb = 459 - NO_OP
  0x000,  // 0x1cc = 460 - NO_OP
  0x000,  // 0x1cd = 461 - NO_OP
  0x000,  // 0x1ce = 462 - NO_OP
  0x000,  // 0x1cf = 463 - NO_OP
  0x000,  // 0x1d0 = 464 - NO_OP
  0x000,  // 0x1d1 = 465 - NO_OP
  0x000,  // 0x1d2 = 466 - NO_OP
  0x000,  // 0x1d3 = 467 - NO_OP
  0x000,  // 0x1d4 = 468 - NO_OP
  0x000,  // 0x1d5 = 469 - NO_OP
  0x000,  // 0x1d6 = 470 - NO_OP
  0x000,  // 0x1d7 = 471 - NO_OP
  0x000,  // 0x1d8 = 472 - NO_OP
  0x000,  // 0x1d9 = 473 - NO_OP
  0x000,  // 0x1da = 474 - NO_OP
  0x000,  // 0x1db = 475 - NO_OP
  0x000,  // 0x1dc = 476 - NO_OP
  0x000,  // 0x1dd = 477 - NO_OP
  0x000,  // 0x1de = 478 - NO_OP
  0x000,  // 0x1df = 479 - NO_OP
  0x000,  // 0x1e0 = 480 - NO_OP
  0x000,  // 0x1e1 = 481 - NO_OP
  0x000,  // 0x1e2 = 482 - NO_OP
  0x000,  // 0x1e3 = 483 - NO_OP
  0x000,  // 0x1e4 = 484 - NO_OP
  0x000,  // 0x1e5 = 485 - NO_OP
  0x000,  // 0x1e6 = 486 - NO_OP
  0x000,  // 0x1e7 = 487 - NO_OP
  0x000,  // 0x1e8 = 488 - NO_OP
  0x000,  // 0x1e9 = 489 - NO_OP
  0x000,  // 0x1ea = 490 - NO_OP
  0x000,  // 0x1eb = 491 - NO_OP
  0x000,  // 0x1ec = 492 - NO_OP
  0x000,  // 0x1ed = 493 - NO_OP
  0x000,  // 0x1ee = 494 - NO_OP
  0x000,  // 0x1ef = 495 - NO_OP
  0x000,  // 0x1f0 = 496 - NO_OP
  0x000,  // 0x1f1 = 497 - NO_OP
  0x000,  // 0x1f2 = 498 - NO_OP
  0x000,  // 0x1f3 = 499 - NO_OP
  0x000,  // 0x1f4 = 500 - NO_OP
  0x000,  // 0x1f5 = 501 - NO_OP
  0x000,  // 0x1f6 = 502 - NO_OP
  0x000,  // 0x1f7 = 503 - NO_OP
  0x000,  // 0x1f8 = 504 - NO_OP
  0x000,  // 0x1f9 = 505 - NO_OP
  0x000,  // 0x1fa = 506 - NO_OP
  0x000,  // 0x1fb = 507 - NO_OP
  0x000,  // 0x1fc = 508 - NO_OP
  0x000,  // 0x1fd = 509 - NO_OP
  0x000,  // 0x1fe = 510 - NO_OP
  0x000,  // 0x1ff = 511 - NO_OP
};

/* as of 8/18/2005 */
bit32 wcsImage0818[] = 
{
  0x011, // 00000 = 0 - PHY_RESET_START
  0x0ca, // 0x001 = 1 - JUMP_IF_PHY_READY
  0x009, // 0x002 = 2 - 
  0x0ba, // 0x003 = 3 - JUMP_IF_HARD_RESET_PRIMITIVE
  0x010, // 0x004 = 4 - 
  0x0bb, // 0x005 = 5 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
  0x01e, // 0x006 = 6 - 
  0x0ff, // 0x007 = 7 - JUMP
  0x001, // 0x008 = 8 - 
  0x010, // 0x009 = 9 - SEND_ID_FRAME
  0x0ba, // 0x00a = 10 - JUMP_IF_HARD_RESET_PRIMITIVE
  0x010, // 0x00b = 11 - 
  0x0bb, // 0x00c = 12 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
  0x023, // 0x00d = 13 - 
  0x0ff, // 0x00e = 14 - JUMP
  0x00a, // 0x00f = 15 - 
  0x033, // 0x010 = 16 - SOFT_RESET
  0x011, // 0x011 = 17 - PHY_RESET_START
  0x0ca, // 0x012 = 18 - JUMP_IF_PHY_READY
  0x016, // 0x013 = 19 - 
  0x0bb, // 0x014 = 20 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
  0x01b, // 0x015 = 21 - 
  0x010, // 0x016 = 22 - SEND_ID_FRAME
  0x0bb, // 0x017 = 23 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
  0x023, // 0x018 = 24 - 
  0x0ff, // 0x019 = 25 - JUMP
  0x017, // 0x01a = 26 - 
  0x010, // 0x01b = 27 - SEND_ID_FRAME
  0x0ff, // 0x01c = 28 - JUMP
  0x023, // 0x01d = 29 - 
  0x0ca, // 0x01e = 30 - JUMP_IF_PHY_READY
  0x022, // 0x01f = 31 - 
  0x0ff, // 0x020 = 32 - JUMP
  0x01e, // 0x021 = 33 - 
  0x010, // 0x022 = 34 - SEND_ID_FRAME
  0x000, // 0x023 = 35 - NO_OP
  0x000, // 0x024 = 36 - NO_OP
  0x000, // 0x025 = 37 - NO_OP
  0x000, // 0x026 = 38 - NO_OP
  0x000, // 0x027 = 39 - NO_OP
  0x000, // 0x028 = 40 - NO_OP
  0x0ff, // 0x029 = 41 - JUMP
  0x10d, // 0x02a = 42 - 
  0x01b, // 0x02b = 43 - START_IT_NEXUS_LOSS_TIMER_SFO
  0x017, // 0x02c = 44 - PATHWAY_BLOCKED_CNT_SFO_RESET
  0x013, // 0x02d = 45 - START_ARB_WAIT_TIMER_SFO
  0x001, // 0x02e = 46 - OPEN_REQUEST_SFO
  0x000, // 0x02f = 47 - NO_OP
  0x000, // 0x030 = 48 - NO_OP
  0x000, // 0x031 = 49 - NO_OP
  0x000, // 0x032 = 50 - NO_OP
  0x000, // 0x033 = 51 - NO_OP
  0x091, // 0x034 = 52 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_ACCEPT
  0x056, // 0x035 = 53 - 
  0x097, // 0x036 = 54 - JUMP_IF_OPEN_STATUS_EQUAL_RATE_NOT_SUPPORTED
  0x059, // 0x037 = 55 - 
  0x09b, // 0x038 = 56 - JUMP_IF_OPEN_STATUS_EQUAL_PROTOCOL_NOT_SUPPORTED
  0x05c, // 0x039 = 57 - 
  0x09d, // 0x03a = 58 - JUMP_IF_OPEN_STATUS_EQUAL_WRONG_DESTINATION
  0x05f, // 0x03b = 59 - 
  0x096, // 0x03c = 60 - JUMP_IF_OPEN_STATUS_EQUAL_BREAK_RECEIVED
  0x062, // 0x03d = 61 - 
  0x095, // 0x03e = 62 - JUMP_IF_OPEN_STATUS_EQUAL_BAD_DESTINATION
  0x065, // 0x03f = 63 - 
  0x0a1, // 0x040 = 64 - JUMP_IF_IT_NEXUS_LOSS_TIMEOUT_SFO
  0x068, // 0x041 = 65 - 
  0x09c, // 0x042 = 66 - JUMP_IF_OPEN_STATUS_EQUAL_STP_RESOURCE_BUSY
  0x02b, // 0x043 = 67 - 
  0x098, // 0x044 = 68 - JUMP_IF_OPEN_STATUS_EQUAL_NO_DESTINATION
  0x10d, // 0x045 = 69 - 
  0x099, // 0x046 = 70 - JUMP_IF_OPEN_STATUS_EQUAL_PATHWAY_BLOCKED
  0x06b, // 0x047 = 71 - 
  0x09a, // 0x048 = 72 - JUMP_IF_OPEN_STATUS_EQUAL_RETRY
  0x02e, // 0x049 = 73 - 
  0x094, // 0x04a = 74 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_TIMEOUT
  0x02e, // 0x04b = 75 - 
  0x0a7, // 0x04c = 76 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
  0x122, // 0x04d = 77 - 
  0x092, // 0x04e = 78 - JUMP_IF_OPEN_STATUS_EQUAL_OCSM_BUSY
  0x02e, // 0x04f = 79 - 
  0x0ca, // 0x050 = 80 - JUMP_IF_PHY_READY
  0x034, // 0x051 = 81 - 
  0x031, // 0x052 = 82 - SET_OPEN_STATUS_PHY_NOT_RDY_SFO
  0x033, // 0x053 = 83 - SOFT_RESET
  0x0ff, // 0x054 = 84 - JUMP
  0x001, // 0x055 = 85 - 
  0x021, // 0x056 = 86 - SET_OPEN_STATUS_NORMAL_SFO
  0x0ff, // 0x057 = 87 - JUMP
  0x06e, // 0x058 = 88 - 
  0x025, // 0x059 = 89 - SET_OPEN_STATUS_BAD_RATE_SFO
  0x0ff, // 0x05a = 90 - JUMP
  0x10d, // 0x05b = 91 - 
  0x026, // 0x05c = 92 - SET_OPEN_STATUS_BAD_PROTOCOL_SFO
  0x0ff, // 0x05d = 93 - JUMP
  0x10d, // 0x05e = 94 - 
  0x028, // 0x05f = 95 - SET_OPEN_STATUS_WRONG_DEST_SFO
  0x0ff, // 0x060 = 96 - JUMP
  0x10d, // 0x061 = 97 - 
  0x024, // 0x062 = 98 - SET_OPEN_STATUS_BREAK_SFO
  0x0ff, // 0x063 = 99 - JUMP
  0x10d, // 0x064 = 100 - 
  0x023, // 0x065 = 101 - SET_OPEN_STATUS_BAD_DEST_SFO
  0x0ff, // 0x066 = 102 - JUMP
  0x10d, // 0x067 = 103 - 
  0x022, // 0x068 = 104 - SET_OPEN_STATUS_IT_NEXUS_LOSS_SFO
  0x0ff, // 0x069 = 105 - JUMP
  0x10d, // 0x06a = 106 - 
  0x019, // 0x06b = 107 - PATHWAY_BLOCKED_CNT_SFO_INC
  0x0ff, // 0x06c = 108 - JUMP
  0x02e, // 0x06d = 109 - 
  0x000, // 0x06e = 110 - NO_OP
  0x0aa, // 0x06f = 111 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_GOOD
  0x082, // 0x070 = 112 - 
  0x0ab, // 0x071 = 113 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_NAK
  0x086, // 0x072 = 114 - 
  0x0ac, // 0x073 = 115 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_ACK_NAK_TIMEOUT
  0x089, // 0x074 = 116 - 
  0x0ad, // 0x075 = 117 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_BREAK
  0x08f, // 0x076 = 118 - 
  0x0af, // 0x077 = 119 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_CREDIT_TIMEOUT
  0x08c, // 0x078 = 120 - 
  0x0ae, // 0x079 = 121 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_UNEXPECTED_CLOSE
  0x086, // 0x07a = 122 - 
  0x0d2, // 0x07b = 123 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_SMP_ERR
  0x095, // 0x07c = 124 - 
  0x0ca, // 0x07d = 125 - JUMP_IF_PHY_READY
  0x06f, // 0x07e = 126 - 
  0x033, // 0x07f = 127 - SOFT_RESET
  0x0ff, // 0x080 = 128 - JUMP
  0x001, // 0x081 = 129 - 
  0x0d0, // 0x082 = 130 - JUMP_IF_SMP_PROTOCOL
  0x086, // 0x083 = 131 - 
  0x0ff, // 0x084 = 132 - JUMP
  0x092, // 0x085 = 133 - 
  0x006, // 0x086 = 134 - CLOSE_NORMAL
  0x0ff, // 0x087 = 135 - JUMP
  0x08f, // 0x088 = 136 - 
  0x007, // 0x089 = 137 - CLOSE_ACK_NAK_TIMEOUT
  0x0ff, // 0x08a = 138 - JUMP
  0x08f, // 0x08b = 139 - 
  0x008, // 0x08c = 140 - CLOSE_CREDIT_TIMEOUT
  0x0ff, // 0x08d = 141 - JUMP
  0x08f, // 0x08e = 142 - 
  0x034, // 0x08f = 143 - ADVANCE_SFO
  0x0ff, // 0x090 = 144 - JUMP
  0x14c, // 0x091 = 145 - 
  0x034, // 0x092 = 146 - ADVANCE_SFO
  0x0ff, // 0x093 = 147 - JUMP
  0x10d, // 0x094 = 148 - 
  0x034, // 0x095 = 149 - ADVANCE_SFO
  0x0ff, // 0x096 = 150 - JUMP
  0x15a, // 0x097 = 151 - 
  0x01c, // 0x098 = 152 - START_IT_NEXUS_LOSS_TIMER_DOC
  0x018, // 0x099 = 153 - PATHWAY_BLOCKED_CNT_DOC_RESET
  0x014, // 0x09a = 154 - START_ARB_WAIT_TIMER_DOC
  0x002, // 0x09b = 155 - OPEN_REQUEST_DOC
  0x000, // 0x09c = 156 - NO_OP
  0x000, // 0x09d = 157 - NO_OP
  0x000, // 0x09e = 158 - NO_OP
  0x000, // 0x09f = 159 - NO_OP
  0x000, // 0x0a0 = 160 - NO_OP
  0x091, // 0x0a1 = 161 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_ACCEPT
  0x0c3, // 0x0a2 = 162 - 
  0x097, // 0x0a3 = 163 - JUMP_IF_OPEN_STATUS_EQUAL_RATE_NOT_SUPPORTED
  0x0c6, // 0x0a4 = 164 - 
  0x09b, // 0x0a5 = 165 - JUMP_IF_OPEN_STATUS_EQUAL_PROTOCOL_NOT_SUPPORTED
  0x0c9, // 0x0a6 = 166 - 
  0x09d, // 0x0a7 = 167 - JUMP_IF_OPEN_STATUS_EQUAL_WRONG_DESTINATION
  0x0cc, // 0x0a8 = 168 - 
  0x096, // 0x0a9 = 169 - JUMP_IF_OPEN_STATUS_EQUAL_BREAK_RECEIVED
  0x0cf, // 0x0aa = 170 - 
  0x095, // 0x0ab = 171 - JUMP_IF_OPEN_STATUS_EQUAL_BAD_DESTINATION
  0x0d2, // 0x0ac = 172 - 
  0x0a2, // 0x0ad = 173 - JUMP_IF_IT_NEXUS_LOSS_TIMEOUT_DOC
  0x0d5, // 0x0ae = 174 - 
  0x09c, // 0x0af = 175 - JUMP_IF_OPEN_STATUS_EQUAL_STP_RESOURCE_BUSY
  0x098, // 0x0b0 = 176 - 
  0x098, // 0x0b1 = 177 - JUMP_IF_OPEN_STATUS_EQUAL_NO_DESTINATION
  0x10d, // 0x0b2 = 178 - 
  0x099, // 0x0b3 = 179 - JUMP_IF_OPEN_STATUS_EQUAL_PATHWAY_BLOCKED
  0x0d8, // 0x0b4 = 180 - 
  0x09a, // 0x0b5 = 181 - JUMP_IF_OPEN_STATUS_EQUAL_RETRY
  0x09b, // 0x0b6 = 182 - 
  0x094, // 0x0b7 = 183 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_TIMEOUT
  0x09b, // 0x0b8 = 184 - 
  0x0a7, // 0x0b9 = 185 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
  0x134, // 0x0ba = 186 - 
  0x092, // 0x0bb = 187 - JUMP_IF_OPEN_STATUS_EQUAL_OCSM_BUSY
  0x09b, // 0x0bc = 188 - 
  0x0ca, // 0x0bd = 189 - JUMP_IF_PHY_READY
  0x0a1, // 0x0be = 190 - 
  0x032, // 0x0bf = 191 - SET_OPEN_STATUS_PHY_NOT_RDY_DOC
  0x033, // 0x0c0 = 192 - SOFT_RESET
  0x0ff, // 0x0c1 = 193 - JUMP
  0x001, // 0x0c2 = 194 - 
  0x029, // 0x0c3 = 195 - SET_OPEN_STATUS_NORMAL_DOC
  0x0ff, // 0x0c4 = 196 - JUMP
  0x0db, // 0x0c5 = 197 - 
  0x02d, // 0x0c6 = 198 - SET_OPEN_STATUS_BAD_RATE_DOC
  0x0ff, // 0x0c7 = 199 - JUMP
  0x10d, // 0x0c8 = 200 - 
  0x02e, // 0x0c9 = 201 - SET_OPEN_STATUS_BAD_PROTOCOL_DOC
  0x0ff, // 0x0ca = 202 - JUMP
  0x10d, // 0x0cb = 203 - 
  0x030, // 0x0cc = 204 - SET_OPEN_STATUS_WRONG_DEST_DOC
  0x0ff, // 0x0cd = 205 - JUMP
  0x10d, // 0x0ce = 206 - 
  0x02c, // 0x0cf = 207 - SET_OPEN_STATUS_BREAK_DOC
  0x0ff, // 0x0d0 = 208 - JUMP
  0x10d, // 0x0d1 = 209 - 
  0x02b, // 0x0d2 = 210 - SET_OPEN_STATUS_BAD_DEST_DOC
  0x0ff, // 0x0d3 = 211 - JUMP
  0x10d, // 0x0d4 = 212 - 
  0x02a, // 0x0d5 = 213 - SET_OPEN_STATUS_IT_NEXUS_LOSS_DOC
  0x0ff, // 0x0d6 = 214 - JUMP
  0x10d, // 0x0d7 = 215 - 
  0x01a, // 0x0d8 = 216 - PATHWAY_BLOCKED_CNT_DOC_INC
  0x0ff, // 0x0d9 = 217 - JUMP
  0x09b, // 0x0da = 218 - 
  0x000, // 0x0db = 219 - NO_OP
  0x0b1, // 0x0dc = 220 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_GOOD
  0x0ef, // 0x0dd = 221 - 
  0x0b2, // 0x0de = 222 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_NAK
  0x0fb, // 0x0df = 223 - 
  0x0b3, // 0x0e0 = 224 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_ACK_NAK_TIMEOUT
  0x0fe, // 0x0e1 = 225 - 
  0x0b4, // 0x0e2 = 226 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_BREAK
  0x104, // 0x0e3 = 227 - 
  0x0b6, // 0x0e4 = 228 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_CREDIT_TIMEOUT
  0x101, // 0x0e5 = 229 - 
  0x0b5, // 0x0e6 = 230 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_UNEXPECTED_CLOSE
  0x0fb, // 0x0e7 = 231 - 
  0x0d3, // 0x0e8 = 232 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_SMP_ERR
  0x10a, // 0x0e9 = 233 - 
  0x0ca, // 0x0ea = 234 - JUMP_IF_PHY_READY
  0x0f3, // 0x0eb = 235 - 
  0x033, // 0x0ec = 236 - SOFT_RESET
  0x0ff, // 0x0ed = 237 - JUMP
  0x001, // 0x0ee = 238 - 
  0x0d0, // 0x0ef = 239 - JUMP_IF_SMP_PROTOCOL
  0x0fb, // 0x0f0 = 240 - 
  0x0ff, // 0x0f1 = 241 - JUMP
  0x107, // 0x0f2 = 242 - 
  0x0b7, // 0x0f3 = 243 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_CREDIT_BLOCKED
  0x0fb, // 0x0f4 = 244 - 
  0x0b8, // 0x0f5 = 245 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_MAX_BURST_SIZE
  0x0fb, // 0x0f6 = 246 - 
  0x0b9, // 0x0f7 = 247 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_MAX_CONNECTION_TIME
  0x0fb, // 0x0f8 = 248 - 
  0x0ff, // 0x0f9 = 249 - JUMP
  0x0dc, // 0x0fa = 250 - 
  0x006, // 0x0fb = 251 - CLOSE_NORMAL
  0x0ff, // 0x0fc = 252 - JUMP
  0x104, // 0x0fd = 253 - 
  0x007, // 0x0fe = 254 - CLOSE_ACK_NAK_TIMEOUT
  0x0ff, // 0x0ff = 255 - JUMP
  0x104, // 0x100 = 256 - 
  0x008, // 0x101 = 257 - CLOSE_CREDIT_TIMEOUT
  0x0ff, // 0x102 = 258 - JUMP
  0x104, // 0x103 = 259 - 
  0x035, // 0x104 = 260 - ADVANCE_DOC
  0x0ff, // 0x105 = 261 - JUMP
  0x14c, // 0x106 = 262 - 
  0x035, // 0x107 = 263 - ADVANCE_DOC
  0x0ff, // 0x108 = 264 - JUMP
  0x10d, // 0x109 = 265 - 
  0x035, // 0x10a = 266 - ADVANCE_DOC
  0x0ff, // 0x10b = 267 - JUMP
  0x15a, // 0x10c = 268 - 
  0x0a9, // 0x10d = 269 - JUMP_IF_SFO_REQ
  0x118, // 0x10e = 270 - 
  0x0b0, // 0x10f = 271 - JUMP_IF_DOC_REQ
  0x12a, // 0x110 = 272 - 
  0x0a8, // 0x111 = 273 - JUMP_IF_CONNECTION_ACTIVE_SET
  0x13c, // 0x112 = 274 - 
  0x0ca, // 0x113 = 275 - JUMP_IF_PHY_READY
  0x10d, // 0x114 = 276 - 
  0x033, // 0x115 = 277 - SOFT_RESET
  0x0ff, // 0x116 = 278 - JUMP
  0x001, // 0x117 = 279 - 
  0x0ca, // 0x118 = 280 - JUMP_IF_PHY_READY
  0x11e, // 0x119 = 281 - 
  0x031, // 0x11a = 282 - SET_OPEN_STATUS_PHY_NOT_RDY_SFO
  0x033, // 0x11b = 283 - SOFT_RESET
  0x0ff, // 0x11c = 284 - JUMP
  0x001, // 0x11d = 285 - 
  0x0a8, // 0x11e = 286 - JUMP_IF_CONNECTION_ACTIVE_SET
  0x122, // 0x11f = 287 - 
  0x0ff, // 0x120 = 288 - JUMP
  0x02b, // 0x121 = 289 - 
  0x0a3, // 0x122 = 290 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL_SFO
  0x126, // 0x123 = 291 - 
  0x0ff, // 0x124 = 292 - JUMP
  0x10f, // 0x125 = 293 - 
  0x0c8, // 0x126 = 294 - JUMP_IF_BREAK_RECEIVED
  0x15a, // 0x127 = 295 - 
  0x0ff, // 0x128 = 296 - JUMP
  0x056, // 0x129 = 297 - 
  0x0ca, // 0x12a = 298 - JUMP_IF_PHY_READY
  0x130, // 0x12b = 299 - 
  0x032, // 0x12c = 300 - SET_OPEN_STATUS_PHY_NOT_RDY_DOC
  0x033, // 0x12d = 301 - SOFT_RESET
  0x0ff, // 0x12e = 302 - JUMP
  0x001, // 0x12f = 303 - 
  0x0a8, // 0x130 = 304 - JUMP_IF_CONNECTION_ACTIVE_SET
  0x134, // 0x131 = 305 - 
  0x0ff, // 0x132 = 306 - JUMP
  0x098, // 0x133 = 307 - 
  0x0a4, // 0x134 = 308 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL_DOC
  0x138, // 0x135 = 309 - 
  0x0ff, // 0x136 = 310 - JUMP
  0x111, // 0x137 = 311 - 
  0x0c8, // 0x138 = 312 - JUMP_IF_BREAK_RECEIVED
  0x15a, // 0x139 = 313 - 
  0x0ff, // 0x13a = 314 - JUMP
  0x0c3, // 0x13b = 315 - 
  0x0d0, // 0x13c = 316 - JUMP_IF_SMP_PROTOCOL
  0x145, // 0x13d = 317 - 
  0x0a6, // 0x13e = 318 - JUMP_IF_CONNECTION_OPEN_MASTER_FLAG_SET
  0x142, // 0x13f = 319 - 
  0x0ff, // 0x140 = 320 - JUMP
  0x15f, // 0x141 = 321 - 
  0x006, // 0x142 = 322 - CLOSE_NORMAL
  0x0ff, // 0x143 = 323 - JUMP
  0x14c, // 0x144 = 324 - 
  0x0d1, // 0x145 = 325 - JUMP_IF_SMP_FRAME_ERR_RECEIVED
  0x168, // 0x146 = 326 - 
  0x0ff, // 0x147 = 327 - JUMP
  0x10d, // 0x148 = 328 - 
  0x0c8, // 0x149 = 329 - JUMP_IF_BREAK_RECEIVED
  0x15a, // 0x14a = 330 - 
  0x006, // 0x14b = 331 - CLOSE_NORMAL
  0x000, // 0x14c = 332 - NO_OP
  0x000, // 0x14d = 333 - NO_OP
  0x000, // 0x14e = 334 - NO_OP
  0x000, // 0x14f = 335 - NO_OP
  0x000, // 0x150 = 336 - NO_OP
  0x0cd, // 0x151 = 337 - JUMP_IF_CLOSE_STATUS_EQUAL_ANY
  0x10d, // 0x152 = 338 - 
  0x0c8, // 0x153 = 339 - JUMP_IF_BREAK_RECEIVED
  0x15a, // 0x154 = 340 - 
  0x0ca, // 0x155 = 341 - JUMP_IF_PHY_READY
  0x14c, // 0x156 = 342 - 
  0x033, // 0x157 = 343 - SOFT_RESET
  0x0ff, // 0x158 = 344 - JUMP
  0x001, // 0x159 = 345 - 
  0x009, // 0x15a = 346 - CLOSE_BREAK
  0x0a8, // 0x15b = 347 - JUMP_IF_CONNECTION_ACTIVE_SET
  0x15b, // 0x15c = 348 - 
  0x0ff, // 0x15d = 349 - JUMP
  0x10d, // 0x15e = 350 - 
  0x0c8, // 0x15f = 351 - JUMP_IF_BREAK_RECEIVED
  0x168, // 0x160 = 352 - 
  0x0ce, // 0x161 = 353 - JUMP_IF_ANY_DONE_RECEIVED
  0x16d, // 0x162 = 354 - 
  0x0ca, // 0x163 = 355 - JUMP_IF_PHY_READY
  0x10d, // 0x164 = 356 - 
  0x033, // 0x165 = 357 - SOFT_RESET
  0x0ff, // 0x166 = 358 - JUMP
  0x10d, // 0x167 = 359 - 
  0x009, // 0x168 = 360 - CLOSE_BREAK
  0x0a8, // 0x169 = 361 - JUMP_IF_CONNECTION_ACTIVE_SET
  0x169, // 0x16a = 362 - 
  0x0ff, // 0x16b = 363 - JUMP
  0x10d, // 0x16c = 364 - 
  0x006, // 0x16d = 365 - CLOSE_NORMAL
  0x000, // 0x16e = 366 - NO_OP
  0x000, // 0x16f = 367 - NO_OP
  0x000, // 0x170 = 368 - NO_OP
  0x000, // 0x171 = 369 - NO_OP
  0x000, // 0x172 = 370 - NO_OP
  0x0cd, // 0x173 = 371 - JUMP_IF_CLOSE_STATUS_EQUAL_ANY
  0x10d, // 0x174 = 372 - 
  0x0c8, // 0x175 = 373 - JUMP_IF_BREAK_RECEIVED
  0x168, // 0x176 = 374 - 
  0x0ca, // 0x177 = 375 - JUMP_IF_PHY_READY
  0x173, // 0x178 = 376 - 
  0x033, // 0x179 = 377 - SOFT_RESET
  0x0ff, // 0x17a = 378 - JUMP
  0x001, // 0x17b = 379 - 
  0x000, // 0x17c = 380 - NO_OP
  0x000, // 0x17d = 381 - NO_OP
  0x000, // 0x17e = 382 - NO_OP
  0x000, // 0x17f = 383 - NO_OP
  0x000, // 0x180 = 384 - NO_OP
  0x000, // 0x181 = 385 - NO_OP
  0x000, // 0x182 = 386 - NO_OP
  0x000, // 0x183 = 387 - NO_OP
  0x000, // 0x184 = 388 - NO_OP
  0x000, // 0x185 = 389 - NO_OP
  0x000, // 0x186 = 390 - NO_OP
  0x000, // 0x187 = 391 - NO_OP
  0x000, // 0x188 = 392 - NO_OP
  0x000, // 0x189 = 393 - NO_OP
  0x000, // 0x18a = 394 - NO_OP
  0x000, // 0x18b = 395 - NO_OP
  0x000, // 0x18c = 396 - NO_OP
  0x000, // 0x18d = 397 - NO_OP
  0x000, // 0x18e = 398 - NO_OP
  0x000, // 0x18f = 399 - NO_OP
  0x000, // 0x190 = 400 - NO_OP
  0x000, // 0x191 = 401 - NO_OP
  0x000, // 0x192 = 402 - NO_OP
  0x000, // 0x193 = 403 - NO_OP
  0x000, // 0x194 = 404 - NO_OP
  0x000, // 0x195 = 405 - NO_OP
  0x000, // 0x196 = 406 - NO_OP
  0x000, // 0x197 = 407 - NO_OP
  0x000, // 0x198 = 408 - NO_OP
  0x000, // 0x199 = 409 - NO_OP
  0x000, // 0x19a = 410 - NO_OP
  0x000, // 0x19b = 411 - NO_OP
  0x000, // 0x19c = 412 - NO_OP
  0x000, // 0x19d = 413 - NO_OP
  0x000, // 0x19e = 414 - NO_OP
  0x000, // 0x19f = 415 - NO_OP
  0x000, // 0x1a0 = 416 - NO_OP
  0x000, // 0x1a1 = 417 - NO_OP
  0x000, // 0x1a2 = 418 - NO_OP
  0x000, // 0x1a3 = 419 - NO_OP
  0x000, // 0x1a4 = 420 - NO_OP
  0x000, // 0x1a5 = 421 - NO_OP
  0x000, // 0x1a6 = 422 - NO_OP
  0x000, // 0x1a7 = 423 - NO_OP
  0x000, // 0x1a8 = 424 - NO_OP
  0x000, // 0x1a9 = 425 - NO_OP
  0x000, // 0x1aa = 426 - NO_OP
  0x000, // 0x1ab = 427 - NO_OP
  0x000, // 0x1ac = 428 - NO_OP
  0x000, // 0x1ad = 429 - NO_OP
  0x000, // 0x1ae = 430 - NO_OP
  0x000, // 0x1af = 431 - NO_OP
  0x000, // 0x1b0 = 432 - NO_OP
  0x000, // 0x1b1 = 433 - NO_OP
  0x000, // 0x1b2 = 434 - NO_OP
  0x000, // 0x1b3 = 435 - NO_OP
  0x000, // 0x1b4 = 436 - NO_OP
  0x000, // 0x1b5 = 437 - NO_OP
  0x000, // 0x1b6 = 438 - NO_OP
  0x000, // 0x1b7 = 439 - NO_OP
  0x000, // 0x1b8 = 440 - NO_OP
  0x000, // 0x1b9 = 441 - NO_OP
  0x000, // 0x1ba = 442 - NO_OP
  0x000, // 0x1bb = 443 - NO_OP
  0x000, // 0x1bc = 444 - NO_OP
  0x000, // 0x1bd = 445 - NO_OP
  0x000, // 0x1be = 446 - NO_OP
  0x000, // 0x1bf = 447 - NO_OP
  0x000, // 0x1c0 = 448 - NO_OP
  0x000, // 0x1c1 = 449 - NO_OP
  0x000, // 0x1c2 = 450 - NO_OP
  0x000, // 0x1c3 = 451 - NO_OP
  0x000, // 0x1c4 = 452 - NO_OP
  0x000, // 0x1c5 = 453 - NO_OP
  0x000, // 0x1c6 = 454 - NO_OP
  0x000, // 0x1c7 = 455 - NO_OP
  0x000, // 0x1c8 = 456 - NO_OP
  0x000, // 0x1c9 = 457 - NO_OP
  0x000, // 0x1ca = 458 - NO_OP
  0x000, // 0x1cb = 459 - NO_OP
  0x000, // 0x1cc = 460 - NO_OP
  0x000, // 0x1cd = 461 - NO_OP
  0x000, // 0x1ce = 462 - NO_OP
  0x000, // 0x1cf = 463 - NO_OP
  0x000, // 0x1d0 = 464 - NO_OP
  0x000, // 0x1d1 = 465 - NO_OP
  0x000, // 0x1d2 = 466 - NO_OP
  0x000, // 0x1d3 = 467 - NO_OP
  0x000, // 0x1d4 = 468 - NO_OP
  0x000, // 0x1d5 = 469 - NO_OP
  0x000, // 0x1d6 = 470 - NO_OP
  0x000, // 0x1d7 = 471 - NO_OP
  0x000, // 0x1d8 = 472 - NO_OP
  0x000, // 0x1d9 = 473 - NO_OP
  0x000, // 0x1da = 474 - NO_OP
  0x000, // 0x1db = 475 - NO_OP
  0x000, // 0x1dc = 476 - NO_OP
  0x000, // 0x1dd = 477 - NO_OP
  0x000, // 0x1de = 478 - NO_OP
  0x000, // 0x1df = 479 - NO_OP
  0x000, // 0x1e0 = 480 - NO_OP
  0x000, // 0x1e1 = 481 - NO_OP
  0x000, // 0x1e2 = 482 - NO_OP
  0x000, // 0x1e3 = 483 - NO_OP
  0x000, // 0x1e4 = 484 - NO_OP
  0x000, // 0x1e5 = 485 - NO_OP
  0x000, // 0x1e6 = 486 - NO_OP
  0x000, // 0x1e7 = 487 - NO_OP
  0x000, // 0x1e8 = 488 - NO_OP
  0x000, // 0x1e9 = 489 - NO_OP
  0x000, // 0x1ea = 490 - NO_OP
  0x000, // 0x1eb = 491 - NO_OP
  0x000, // 0x1ec = 492 - NO_OP
  0x000, // 0x1ed = 493 - NO_OP
  0x000, // 0x1ee = 494 - NO_OP
  0x000, // 0x1ef = 495 - NO_OP
  0x000, // 0x1f0 = 496 - NO_OP
  0x000, // 0x1f1 = 497 - NO_OP
  0x000, // 0x1f2 = 498 - NO_OP
  0x000, // 0x1f3 = 499 - NO_OP
  0x000, // 0x1f4 = 500 - NO_OP
  0x000, // 0x1f5 = 501 - NO_OP
  0x000, // 0x1f6 = 502 - NO_OP
  0x000, // 0x1f7 = 503 - NO_OP
  0x000, // 0x1f8 = 504 - NO_OP
  0x000, // 0x1f9 = 505 - NO_OP
  0x000, // 0x1fa = 506 - NO_OP
  0x000, // 0x1fb = 507 - NO_OP
  0x000, // 0x1fc = 508 - NO_OP
  0x000, // 0x1fd = 509 - NO_OP
  0x000, // 0x1fe = 510 - NO_OP
  0x000, // 0x1ff = 511 - NO_OP
};
/* 8/24/05 not worked */
bit32 wcsImage0824[] = 
{
0x011, // 00000 = 0 - PHY_RESET_START
0x0ca, // 0x001 = 1 - JUMP_IF_PHY_READY
0x009, // 0x002 = 2 - 
0x0ba, // 0x003 = 3 - JUMP_IF_HARD_RESET_PRIMITIVE
0x010, // 0x004 = 4 - 
0x0bb, // 0x005 = 5 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x01e, // 0x006 = 6 - 
0x0ff, // 0x007 = 7 - JUMP
0x001, // 0x008 = 8 - 
0x010, // 0x009 = 9 - SEND_ID_FRAME
0x0ba, // 0x00a = 10 - JUMP_IF_HARD_RESET_PRIMITIVE
0x010, // 0x00b = 11 - 
0x0bb, // 0x00c = 12 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x023, // 0x00d = 13 - 
0x0ff, // 0x00e = 14 - JUMP
0x00a, // 0x00f = 15 - 
0x033, // 0x010 = 16 - SOFT_RESET
0x011, // 0x011 = 17 - PHY_RESET_START
0x0ca, // 0x012 = 18 - JUMP_IF_PHY_READY
0x016, // 0x013 = 19 - 
0x0bb, // 0x014 = 20 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x01b, // 0x015 = 21 - 
0x010, // 0x016 = 22 - SEND_ID_FRAME
0x0bb, // 0x017 = 23 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x023, // 0x018 = 24 - 
0x0ff, // 0x019 = 25 - JUMP
0x017, // 0x01a = 26 - 
0x010, // 0x01b = 27 - SEND_ID_FRAME
0x0ff, // 0x01c = 28 - JUMP
0x023, // 0x01d = 29 - 
0x0ca, // 0x01e = 30 - JUMP_IF_PHY_READY
0x022, // 0x01f = 31 - 
0x0ff, // 0x020 = 32 - JUMP
0x01e, // 0x021 = 33 - 
0x010, // 0x022 = 34 - SEND_ID_FRAME
0x000, // 0x023 = 35 - NO_OP
0x000, // 0x024 = 36 - NO_OP
0x000, // 0x025 = 37 - NO_OP
0x000, // 0x026 = 38 - NO_OP
0x000, // 0x027 = 39 - NO_OP
0x000, // 0x028 = 40 - NO_OP
0x0ff, // 0x029 = 41 - JUMP
0x11b, // 0x02a = 42 - 
0x01b, // 0x02b = 43 - START_IT_NEXUS_LOSS_TIMER_SFO
0x017, // 0x02c = 44 - PATHWAY_BLOCKED_CNT_SFO_RESET
0x015, // 0x02d = 45 - NO_OP
0x07f, // 0x02e = 46 - NO_OP
0x001, // 0x02f = 47 - OPEN_REQUEST_SFO
0x000, // 0x030 = 48 - NO_OP
0x000, // 0x031 = 49 - NO_OP
0x000, // 0x032 = 50 - NO_OP
0x000, // 0x033 = 51 - NO_OP
0x000, // 0x034 = 52 - NO_OP
0x091, // 0x035 = 53 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_ACCEPT
0x057, // 0x036 = 54 - 
0x097, // 0x037 = 55 - JUMP_IF_OPEN_STATUS_EQUAL_RATE_NOT_SUPPORTED
0x05a, // 0x038 = 56 - 
0x09b, // 0x039 = 57 - JUMP_IF_OPEN_STATUS_EQUAL_PROTOCOL_NOT_SUPPORTED
0x05d, // 0x03a = 58 - 
0x09d, // 0x03b = 59 - JUMP_IF_OPEN_STATUS_EQUAL_WRONG_DESTINATION
0x060, // 0x03c = 60 - 
0x096, // 0x03d = 61 - JUMP_IF_OPEN_STATUS_EQUAL_BREAK_RECEIVED
0x063, // 0x03e = 62 - 
0x095, // 0x03f = 63 - JUMP_IF_OPEN_STATUS_EQUAL_BAD_DESTINATION
0x066, // 0x040 = 64 - 
0x0a1, // 0x041 = 65 - JUMP_IF_IT_NEXUS_LOSS_TIMEOUT_SFO
0x069, // 0x042 = 66 - 
0x09c, // 0x043 = 67 - JUMP_IF_OPEN_STATUS_EQUAL_STP_RESOURCE_BUSY
0x02b, // 0x044 = 68 - 
0x098, // 0x045 = 69 - JUMP_IF_OPEN_STATUS_EQUAL_NO_DESTINATION
0x11b, // 0x046 = 70 - 
0x099, // 0x047 = 71 - JUMP_IF_OPEN_STATUS_EQUAL_PATHWAY_BLOCKED
0x06c, // 0x048 = 72 - 
0x09a, // 0x049 = 73 - JUMP_IF_OPEN_STATUS_EQUAL_RETRY
0x02f, // 0x04a = 74 - 
0x094, // 0x04b = 75 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_TIMEOUT
0x02f, // 0x04c = 76 - 
0x0a7, // 0x04d = 77 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
0x130, // 0x04e = 78 - 
0x092, // 0x04f = 79 - JUMP_IF_OPEN_STATUS_EQUAL_OCSM_BUSY
0x02f, // 0x050 = 80 - 
0x0ca, // 0x051 = 81 - JUMP_IF_PHY_READY
0x035, // 0x052 = 82 - 
0x031, // 0x053 = 83 - SET_OPEN_STATUS_PHY_NOT_RDY_SFO
0x033, // 0x054 = 84 - SOFT_RESET
0x0ff, // 0x055 = 85 - JUMP
0x001, // 0x056 = 86 - 
0x021, // 0x057 = 87 - SET_OPEN_STATUS_NORMAL_SFO
0x0ff, // 0x058 = 88 - JUMP
0x06f, // 0x059 = 89 - 
0x025, // 0x05a = 90 - SET_OPEN_STATUS_BAD_RATE_SFO
0x0ff, // 0x05b = 91 - JUMP
0x11b, // 0x05c = 92 - 
0x026, // 0x05d = 93 - SET_OPEN_STATUS_BAD_PROTOCOL_SFO
0x0ff, // 0x05e = 94 - JUMP
0x11b, // 0x05f = 95 - 
0x028, // 0x060 = 96 - SET_OPEN_STATUS_WRONG_DEST_SFO
0x0ff, // 0x061 = 97 - JUMP
0x11b, // 0x062 = 98 - 
0x024, // 0x063 = 99 - SET_OPEN_STATUS_BREAK_SFO
0x0ff, // 0x064 = 100 - JUMP
0x11b, // 0x065 = 101 - 
0x023, // 0x066 = 102 - SET_OPEN_STATUS_BAD_DEST_SFO
0x0ff, // 0x067 = 103 - JUMP
0x11b, // 0x068 = 104 - 
0x022, // 0x069 = 105 - SET_OPEN_STATUS_IT_NEXUS_LOSS_SFO
0x0ff, // 0x06a = 106 - JUMP
0x11b, // 0x06b = 107 - 
0x019, // 0x06c = 108 - PATHWAY_BLOCKED_CNT_SFO_INC
0x0ff, // 0x06d = 109 - JUMP
0x02f, // 0x06e = 110 - 
0x000, // 0x06f = 111 - NO_OP
0x0d4, // 0x070 = 112 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x09b, // 0x071 = 113 - 
0x0aa, // 0x072 = 114 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_GOOD
0x085, // 0x073 = 115 - 
0x0ab, // 0x074 = 116 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_NAK
0x089, // 0x075 = 117 - 
0x0ac, // 0x076 = 118 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_ACK_NAK_TIMEOUT
0x08c, // 0x077 = 119 - 
0x0ad, // 0x078 = 120 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_BREAK
0x092, // 0x079 = 121 - 
0x0af, // 0x07a = 122 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_CREDIT_TIMEOUT
0x08f, // 0x07b = 123 - 
0x0ae, // 0x07c = 124 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_UNEXPECTED_CLOSE
0x089, // 0x07d = 125 - 
0x0d2, // 0x07e = 126 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_SMP_ERR
0x098, // 0x07f = 127 - 
0x0ca, // 0x080 = 128 - JUMP_IF_PHY_READY
0x070, // 0x081 = 129 - 
0x033, // 0x082 = 130 - SOFT_RESET
0x0ff, // 0x083 = 131 - JUMP
0x001, // 0x084 = 132 - 
0x0d0, // 0x085 = 133 - JUMP_IF_SMP_PROTOCOL
0x089, // 0x086 = 134 - 
0x0ff, // 0x087 = 135 - JUMP
0x095, // 0x088 = 136 - 
0x006, // 0x089 = 137 - CLOSE_NORMAL
0x0ff, // 0x08a = 138 - JUMP
0x092, // 0x08b = 139 - 
0x007, // 0x08c = 140 - CLOSE_ACK_NAK_TIMEOUT
0x0ff, // 0x08d = 141 - JUMP
0x092, // 0x08e = 142 - 
0x008, // 0x08f = 143 - CLOSE_CREDIT_TIMEOUT
0x0ff, // 0x090 = 144 - JUMP
0x092, // 0x091 = 145 - 
0x034, // 0x092 = 146 - ADVANCE_SFO
0x0ff, // 0x093 = 147 - JUMP
0x15f, // 0x094 = 148 - 
0x034, // 0x095 = 149 - ADVANCE_SFO
0x0ff, // 0x096 = 150 - JUMP
0x11b, // 0x097 = 151 - 
0x034, // 0x098 = 152 - ADVANCE_SFO
0x0ff, // 0x099 = 153 - JUMP
0x16f, // 0x09a = 154 - 
0x037, // 0x09b = 155 - SEND_CREDIT_BLOCK
0x0ff, // 0x09c = 156 - JUMP
0x072, // 0x09d = 157 - 
0x01c, // 0x09e = 158 - START_IT_NEXUS_LOSS_TIMER_DOC
0x018, // 0x09f = 159 - PATHWAY_BLOCKED_CNT_DOC_RESET
0x016, // 0x0a0 = 160 - NO_OP
0x07f, // 0x0a1 = 161 - NO_OP
0x002, // 0x0a2 = 162 - OPEN_REQUEST_DOC
0x000, // 0x0a3 = 163 - NO_OP
0x000, // 0x0a4 = 164 - NO_OP
0x000, // 0x0a5 = 165 - NO_OP
0x000, // 0x0a6 = 166 - NO_OP
0x000, // 0x0a7 = 167 - NO_OP
0x091, // 0x0a8 = 168 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_ACCEPT
0x0ca, // 0x0a9 = 169 - 
0x097, // 0x0aa = 170 - JUMP_IF_OPEN_STATUS_EQUAL_RATE_NOT_SUPPORTED
0x0cd, // 0x0ab = 171 - 
0x09b, // 0x0ac = 172 - JUMP_IF_OPEN_STATUS_EQUAL_PROTOCOL_NOT_SUPPORTED
0x0d0, // 0x0ad = 173 - 
0x09d, // 0x0ae = 174 - JUMP_IF_OPEN_STATUS_EQUAL_WRONG_DESTINATION
0x0d3, // 0x0af = 175 - 
0x096, // 0x0b0 = 176 - JUMP_IF_OPEN_STATUS_EQUAL_BREAK_RECEIVED
0x0d6, // 0x0b1 = 177 - 
0x095, // 0x0b2 = 178 - JUMP_IF_OPEN_STATUS_EQUAL_BAD_DESTINATION
0x0d9, // 0x0b3 = 179 - 
0x0a2, // 0x0b4 = 180 - JUMP_IF_IT_NEXUS_LOSS_TIMEOUT_DOC
0x0dc, // 0x0b5 = 181 - 
0x09c, // 0x0b6 = 182 - JUMP_IF_OPEN_STATUS_EQUAL_STP_RESOURCE_BUSY
0x09e, // 0x0b7 = 183 - 
0x098, // 0x0b8 = 184 - JUMP_IF_OPEN_STATUS_EQUAL_NO_DESTINATION
0x11b, // 0x0b9 = 185 - 
0x099, // 0x0ba = 186 - JUMP_IF_OPEN_STATUS_EQUAL_PATHWAY_BLOCKED
0x0df, // 0x0bb = 187 - 
0x09a, // 0x0bc = 188 - JUMP_IF_OPEN_STATUS_EQUAL_RETRY
0x0a2, // 0x0bd = 189 - 
0x094, // 0x0be = 190 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_TIMEOUT
0x0a2, // 0x0bf = 191 - 
0x0a7, // 0x0c0 = 192 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
0x142, // 0x0c1 = 193 - 
0x092, // 0x0c2 = 194 - JUMP_IF_OPEN_STATUS_EQUAL_OCSM_BUSY
0x0a2, // 0x0c3 = 195 - 
0x0ca, // 0x0c4 = 196 - JUMP_IF_PHY_READY
0x0a8, // 0x0c5 = 197 - 
0x032, // 0x0c6 = 198 - SET_OPEN_STATUS_PHY_NOT_RDY_DOC
0x033, // 0x0c7 = 199 - SOFT_RESET
0x0ff, // 0x0c8 = 200 - JUMP
0x001, // 0x0c9 = 201 - 
0x029, // 0x0ca = 202 - SET_OPEN_STATUS_NORMAL_DOC
0x0ff, // 0x0cb = 203 - JUMP
0x0e2, // 0x0cc = 204 - 
0x02d, // 0x0cd = 205 - SET_OPEN_STATUS_BAD_RATE_DOC
0x0ff, // 0x0ce = 206 - JUMP
0x11b, // 0x0cf = 207 - 
0x02e, // 0x0d0 = 208 - SET_OPEN_STATUS_BAD_PROTOCOL_DOC
0x0ff, // 0x0d1 = 209 - JUMP
0x11b, // 0x0d2 = 210 - 
0x030, // 0x0d3 = 211 - SET_OPEN_STATUS_WRONG_DEST_DOC
0x0ff, // 0x0d4 = 212 - JUMP
0x11b, // 0x0d5 = 213 - 
0x02c, // 0x0d6 = 214 - SET_OPEN_STATUS_BREAK_DOC
0x0ff, // 0x0d7 = 215 - JUMP
0x11b, // 0x0d8 = 216 - 
0x02b, // 0x0d9 = 217 - SET_OPEN_STATUS_BAD_DEST_DOC
0x0ff, // 0x0da = 218 - JUMP
0x11b, // 0x0db = 219 - 
0x02a, // 0x0dc = 220 - SET_OPEN_STATUS_IT_NEXUS_LOSS_DOC
0x0ff, // 0x0dd = 221 - JUMP
0x11b, // 0x0de = 222 - 
0x01a, // 0x0df = 223 - PATHWAY_BLOCKED_CNT_DOC_INC
0x0ff, // 0x0e0 = 224 - JUMP
0x0a2, // 0x0e1 = 225 - 
0x000, // 0x0e2 = 226 - NO_OP
0x0d4, // 0x0e3 = 227 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x118, // 0x0e4 = 228 - 
0x0b1, // 0x0e5 = 229 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_GOOD
0x0fa, // 0x0e6 = 230 - 
0x0b2, // 0x0e7 = 231 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_NAK
0x106, // 0x0e8 = 232 - 
0x0b3, // 0x0e9 = 233 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_ACK_NAK_TIMEOUT
0x109, // 0x0ea = 234 - 
0x0b4, // 0x0eb = 235 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_BREAK
0x10f, // 0x0ec = 236 - 
0x0b6, // 0x0ed = 237 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_CREDIT_TIMEOUT
0x10c, // 0x0ee = 238 - 
0x0b5, // 0x0ef = 239 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_UNEXPECTED_CLOSE
0x106, // 0x0f0 = 240 - 
0x0d3, // 0x0f1 = 241 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_SMP_ERR
0x115, // 0x0f2 = 242 - 
0x0d5, // 0x0f3 = 243 - JUMP_IF_DOC_CLOSE_REQ
0x15c, // 0x0f4 = 244 - 
0x0ca, // 0x0f5 = 245 - JUMP_IF_PHY_READY
0x0fe, // 0x0f6 = 246 - 
0x033, // 0x0f7 = 247 - SOFT_RESET
0x0ff, // 0x0f8 = 248 - JUMP
0x001, // 0x0f9 = 249 - 
0x0d0, // 0x0fa = 250 - JUMP_IF_SMP_PROTOCOL
0x106, // 0x0fb = 251 - 
0x0ff, // 0x0fc = 252 - JUMP
0x112, // 0x0fd = 253 - 
0x0b7, // 0x0fe = 254 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_CREDIT_BLOCKED
0x106, // 0x0ff = 255 - 
0x0b8, // 0x100 = 256 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_MAX_BURST_SIZE
0x106, // 0x101 = 257 - 
0x0b9, // 0x102 = 258 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_MAX_CONNECTION_TIME
0x106, // 0x103 = 259 - 
0x0ff, // 0x104 = 260 - JUMP
0x0e3, // 0x105 = 261 - 
0x006, // 0x106 = 262 - CLOSE_NORMAL
0x0ff, // 0x107 = 263 - JUMP
0x10f, // 0x108 = 264 - 
0x007, // 0x109 = 265 - CLOSE_ACK_NAK_TIMEOUT
0x0ff, // 0x10a = 266 - JUMP
0x10f, // 0x10b = 267 - 
0x008, // 0x10c = 268 - CLOSE_CREDIT_TIMEOUT
0x0ff, // 0x10d = 269 - JUMP
0x10f, // 0x10e = 270 - 
0x035, // 0x10f = 271 - ADVANCE_DOC
0x0ff, // 0x110 = 272 - JUMP
0x15f, // 0x111 = 273 - 
0x035, // 0x112 = 274 - ADVANCE_DOC
0x0ff, // 0x113 = 275 - JUMP
0x11b, // 0x114 = 276 - 
0x035, // 0x115 = 277 - ADVANCE_DOC
0x0ff, // 0x116 = 278 - JUMP
0x16f, // 0x117 = 279 - 
0x037, // 0x118 = 280 - SEND_CREDIT_BLOCK
0x0ff, // 0x119 = 281 - JUMP
0x0e5, // 0x11a = 282 - 
0x0a9, // 0x11b = 283 - JUMP_IF_SFO_REQ
0x126, // 0x11c = 284 - 
0x0b0, // 0x11d = 285 - JUMP_IF_DOC_REQ
0x138, // 0x11e = 286 - 
0x0a8, // 0x11f = 287 - JUMP_IF_CONNECTION_ACTIVE_SET
0x14a, // 0x120 = 288 - 
0x0ca, // 0x121 = 289 - JUMP_IF_PHY_READY
0x11b, // 0x122 = 290 - 
0x033, // 0x123 = 291 - SOFT_RESET
0x0ff, // 0x124 = 292 - JUMP
0x001, // 0x125 = 293 - 
0x0ca, // 0x126 = 294 - JUMP_IF_PHY_READY
0x12c, // 0x127 = 295 - 
0x031, // 0x128 = 296 - SET_OPEN_STATUS_PHY_NOT_RDY_SFO
0x033, // 0x129 = 297 - SOFT_RESET
0x0ff, // 0x12a = 298 - JUMP
0x001, // 0x12b = 299 - 
0x0a8, // 0x12c = 300 - JUMP_IF_CONNECTION_ACTIVE_SET
0x130, // 0x12d = 301 - 
0x0ff, // 0x12e = 302 - JUMP
0x02b, // 0x12f = 303 - 
0x0a3, // 0x130 = 304 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL_SFO
0x134, // 0x131 = 305 - 
0x0ff, // 0x132 = 306 - JUMP
0x11d, // 0x133 = 307 - 
0x0c8, // 0x134 = 308 - JUMP_IF_BREAK_RECEIVED
0x16f, // 0x135 = 309 - 
0x0ff, // 0x136 = 310 - JUMP
0x057, // 0x137 = 311 - 
0x0ca, // 0x138 = 312 - JUMP_IF_PHY_READY
0x13e, // 0x139 = 313 - 
0x032, // 0x13a = 314 - SET_OPEN_STATUS_PHY_NOT_RDY_DOC
0x033, // 0x13b = 315 - SOFT_RESET
0x0ff, // 0x13c = 316 - JUMP
0x001, // 0x13d = 317 - 
0x0a8, // 0x13e = 318 - JUMP_IF_CONNECTION_ACTIVE_SET
0x142, // 0x13f = 319 - 
0x0ff, // 0x140 = 320 - JUMP
0x09e, // 0x141 = 321 - 
0x0a4, // 0x142 = 322 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL_DOC
0x146, // 0x143 = 323 - 
0x0ff, // 0x144 = 324 - JUMP
0x11f, // 0x145 = 325 - 
0x0c8, // 0x146 = 326 - JUMP_IF_BREAK_RECEIVED
0x16f, // 0x147 = 327 - 
0x0ff, // 0x148 = 328 - JUMP
0x0ca, // 0x149 = 329 - 
0x0d0, // 0x14a = 330 - JUMP_IF_SMP_PROTOCOL
0x155, // 0x14b = 331 - 
0x0d4, // 0x14c = 332 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x159, // 0x14d = 333 - 
0x0a6, // 0x14e = 334 - JUMP_IF_CONNECTION_OPEN_MASTER_FLAG_SET
0x152, // 0x14f = 335 - 
0x0ff, // 0x150 = 336 - JUMP
0x177, // 0x151 = 337 - 
0x006, // 0x152 = 338 - CLOSE_NORMAL
0x0ff, // 0x153 = 339 - JUMP
0x15f, // 0x154 = 340 - 
0x0d1, // 0x155 = 341 - JUMP_IF_SMP_FRAME_ERR_RECEIVED
0x180, // 0x156 = 342 - 
0x0ff, // 0x157 = 343 - JUMP
0x11b, // 0x158 = 344 - 
0x037, // 0x159 = 345 - SEND_CREDIT_BLOCK
0x0ff, // 0x15a = 346 - JUMP
0x14e, // 0x15b = 347 - 
0x0c8, // 0x15c = 348 - JUMP_IF_BREAK_RECEIVED
0x16f, // 0x15d = 349 - 
0x006, // 0x15e = 350 - CLOSE_NORMAL
0x000, // 0x15f = 351 - NO_OP
0x000, // 0x160 = 352 - NO_OP
0x000, // 0x161 = 353 - NO_OP
0x000, // 0x162 = 354 - NO_OP
0x000, // 0x163 = 355 - NO_OP
0x0d4, // 0x164 = 356 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x174, // 0x165 = 357 - 
0x0cd, // 0x166 = 358 - JUMP_IF_CLOSE_STATUS_EQUAL_ANY
0x11b, // 0x167 = 359 - 
0x0c8, // 0x168 = 360 - JUMP_IF_BREAK_RECEIVED
0x16f, // 0x169 = 361 - 
0x0ca, // 0x16a = 362 - JUMP_IF_PHY_READY
0x15f, // 0x16b = 363 - 
0x033, // 0x16c = 364 - SOFT_RESET
0x0ff, // 0x16d = 365 - JUMP
0x001, // 0x16e = 366 - 
0x009, // 0x16f = 367 - CLOSE_BREAK
0x0a8, // 0x170 = 368 - JUMP_IF_CONNECTION_ACTIVE_SET
0x170, // 0x171 = 369 - 
0x0ff, // 0x172 = 370 - JUMP
0x11b, // 0x173 = 371 - 
0x037, // 0x174 = 372 - SEND_CREDIT_BLOCK
0x0ff, // 0x175 = 373 - JUMP
0x166, // 0x176 = 374 - 
0x0c8, // 0x177 = 375 - JUMP_IF_BREAK_RECEIVED
0x180, // 0x178 = 376 - 
0x0ce, // 0x179 = 377 - JUMP_IF_ANY_DONE_RECEIVED
0x185, // 0x17a = 378 - 
0x0ca, // 0x17b = 379 - JUMP_IF_PHY_READY
0x11b, // 0x17c = 380 - 
0x033, // 0x17d = 381 - SOFT_RESET
0x0ff, // 0x17e = 382 - JUMP
0x11b, // 0x17f = 383 - 
0x009, // 0x180 = 384 - CLOSE_BREAK
0x0a8, // 0x181 = 385 - JUMP_IF_CONNECTION_ACTIVE_SET
0x181, // 0x182 = 386 - 
0x0ff, // 0x183 = 387 - JUMP
0x11b, // 0x184 = 388 - 
0x006, // 0x185 = 389 - CLOSE_NORMAL
0x000, // 0x186 = 390 - NO_OP
0x000, // 0x187 = 391 - NO_OP
0x000, // 0x188 = 392 - NO_OP
0x000, // 0x189 = 393 - NO_OP
0x000, // 0x18a = 394 - NO_OP
0x0cd, // 0x18b = 395 - JUMP_IF_CLOSE_STATUS_EQUAL_ANY
0x11b, // 0x18c = 396 - 
0x0d4, // 0x18d = 397 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x196, // 0x18e = 398 - 
0x0c8, // 0x18f = 399 - JUMP_IF_BREAK_RECEIVED
0x180, // 0x190 = 400 - 
0x0ca, // 0x191 = 401 - JUMP_IF_PHY_READY
0x18b, // 0x192 = 402 - 
0x033, // 0x193 = 403 - SOFT_RESET
0x0ff, // 0x194 = 404 - JUMP
0x001, // 0x195 = 405 - 
0x037, // 0x196 = 406 - SEND_CREDIT_BLOCK
0x0ff, // 0x197 = 407 - JUMP
0x18f, // 0x198 = 408 - 
0x000, // 0x199 = 409 - NO_OP
0x000, // 0x19a = 410 - NO_OP
0x000, // 0x19b = 411 - NO_OP
0x000, // 0x19c = 412 - NO_OP
0x000, // 0x19d = 413 - NO_OP
0x000, // 0x19e = 414 - NO_OP
0x000, // 0x19f = 415 - NO_OP
0x000, // 0x1a0 = 416 - NO_OP
0x000, // 0x1a1 = 417 - NO_OP
0x000, // 0x1a2 = 418 - NO_OP
0x000, // 0x1a3 = 419 - NO_OP
0x000, // 0x1a4 = 420 - NO_OP
0x000, // 0x1a5 = 421 - NO_OP
0x000, // 0x1a6 = 422 - NO_OP
0x000, // 0x1a7 = 423 - NO_OP
0x000, // 0x1a8 = 424 - NO_OP
0x000, // 0x1a9 = 425 - NO_OP
0x000, // 0x1aa = 426 - NO_OP
0x000, // 0x1ab = 427 - NO_OP
0x000, // 0x1ac = 428 - NO_OP
0x000, // 0x1ad = 429 - NO_OP
0x000, // 0x1ae = 430 - NO_OP
0x000, // 0x1af = 431 - NO_OP
0x000, // 0x1b0 = 432 - NO_OP
0x000, // 0x1b1 = 433 - NO_OP
0x000, // 0x1b2 = 434 - NO_OP
0x000, // 0x1b3 = 435 - NO_OP
0x000, // 0x1b4 = 436 - NO_OP
0x000, // 0x1b5 = 437 - NO_OP
0x000, // 0x1b6 = 438 - NO_OP
0x000, // 0x1b7 = 439 - NO_OP
0x000, // 0x1b8 = 440 - NO_OP
0x000, // 0x1b9 = 441 - NO_OP
0x000, // 0x1ba = 442 - NO_OP
0x000, // 0x1bb = 443 - NO_OP
0x000, // 0x1bc = 444 - NO_OP
0x000, // 0x1bd = 445 - NO_OP
0x000, // 0x1be = 446 - NO_OP
0x000, // 0x1bf = 447 - NO_OP
0x000, // 0x1c0 = 448 - NO_OP
0x000, // 0x1c1 = 449 - NO_OP
0x000, // 0x1c2 = 450 - NO_OP
0x000, // 0x1c3 = 451 - NO_OP
0x000, // 0x1c4 = 452 - NO_OP
0x000, // 0x1c5 = 453 - NO_OP
0x000, // 0x1c6 = 454 - NO_OP
0x000, // 0x1c7 = 455 - NO_OP
0x000, // 0x1c8 = 456 - NO_OP
0x000, // 0x1c9 = 457 - NO_OP
0x000, // 0x1ca = 458 - NO_OP
0x000, // 0x1cb = 459 - NO_OP
0x000, // 0x1cc = 460 - NO_OP
0x000, // 0x1cd = 461 - NO_OP
0x000, // 0x1ce = 462 - NO_OP
0x000, // 0x1cf = 463 - NO_OP
0x000, // 0x1d0 = 464 - NO_OP
0x000, // 0x1d1 = 465 - NO_OP
0x000, // 0x1d2 = 466 - NO_OP
0x000, // 0x1d3 = 467 - NO_OP
0x000, // 0x1d4 = 468 - NO_OP
0x000, // 0x1d5 = 469 - NO_OP
0x000, // 0x1d6 = 470 - NO_OP
0x000, // 0x1d7 = 471 - NO_OP
0x000, // 0x1d8 = 472 - NO_OP
0x000, // 0x1d9 = 473 - NO_OP
0x000, // 0x1da = 474 - NO_OP
0x000, // 0x1db = 475 - NO_OP
0x000, // 0x1dc = 476 - NO_OP
0x000, // 0x1dd = 477 - NO_OP
0x000, // 0x1de = 478 - NO_OP
0x000, // 0x1df = 479 - NO_OP
0x000, // 0x1e0 = 480 - NO_OP
0x000, // 0x1e1 = 481 - NO_OP
0x000, // 0x1e2 = 482 - NO_OP
0x000, // 0x1e3 = 483 - NO_OP
0x000, // 0x1e4 = 484 - NO_OP
0x000, // 0x1e5 = 485 - NO_OP
0x000, // 0x1e6 = 486 - NO_OP
0x000, // 0x1e7 = 487 - NO_OP
0x000, // 0x1e8 = 488 - NO_OP
0x000, // 0x1e9 = 489 - NO_OP
0x000, // 0x1ea = 490 - NO_OP
0x000, // 0x1eb = 491 - NO_OP
0x000, // 0x1ec = 492 - NO_OP
0x000, // 0x1ed = 493 - NO_OP
0x000, // 0x1ee = 494 - NO_OP
0x000, // 0x1ef = 495 - NO_OP
0x000, // 0x1f0 = 496 - NO_OP
0x000, // 0x1f1 = 497 - NO_OP
0x000, // 0x1f2 = 498 - NO_OP
0x000, // 0x1f3 = 499 - NO_OP
0x000, // 0x1f4 = 500 - NO_OP
0x000, // 0x1f5 = 501 - NO_OP
0x000, // 0x1f6 = 502 - NO_OP
0x000, // 0x1f7 = 503 - NO_OP
0x000, // 0x1f8 = 504 - NO_OP
0x000, // 0x1f9 = 505 - NO_OP
0x000, // 0x1fa = 506 - NO_OP
0x000, // 0x1fb = 507 - NO_OP
0x000, // 0x1fc = 508 - NO_OP
0x000, // 0x1fd = 509 - NO_OP
0x000, // 0x1fe = 510 - NO_OP
0x000, // 0x1ff = 511 - NO_OP
};


/* as of 8/23/05 and worked, used for Houston demo, bitmap0822 */
bit32 wcsImage0822[] = 
{
0x011, // 00000 = 0 - PHY_RESET_START
0x0ca, // 0x001 = 1 - JUMP_IF_PHY_READY
0x009, // 0x002 = 2 - 
0x0ba, // 0x003 = 3 - JUMP_IF_HARD_RESET_PRIMITIVE
0x010, // 0x004 = 4 - 
0x0bb, // 0x005 = 5 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x01e, // 0x006 = 6 - 
0x0ff, // 0x007 = 7 - JUMP
0x001, // 0x008 = 8 - 
0x010, // 0x009 = 9 - SEND_ID_FRAME
0x0ba, // 0x00a = 10 - JUMP_IF_HARD_RESET_PRIMITIVE
0x010, // 0x00b = 11 - 
0x0bb, // 0x00c = 12 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x023, // 0x00d = 13 - 
0x0ff, // 0x00e = 14 - JUMP
0x00a, // 0x00f = 15 - 
0x033, // 0x010 = 16 - SOFT_RESET
0x011, // 0x011 = 17 - PHY_RESET_START
0x0ca, // 0x012 = 18 - JUMP_IF_PHY_READY
0x016, // 0x013 = 19 - 
0x0bb, // 0x014 = 20 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x01b, // 0x015 = 21 - 
0x010, // 0x016 = 22 - SEND_ID_FRAME
0x0bb, // 0x017 = 23 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x023, // 0x018 = 24 - 
0x0ff, // 0x019 = 25 - JUMP
0x017, // 0x01a = 26 - 
0x010, // 0x01b = 27 - SEND_ID_FRAME
0x0ff, // 0x01c = 28 - JUMP
0x023, // 0x01d = 29 - 
0x0ca, // 0x01e = 30 - JUMP_IF_PHY_READY
0x022, // 0x01f = 31 - 
0x0ff, // 0x020 = 32 - JUMP
0x01e, // 0x021 = 33 - 
0x010, // 0x022 = 34 - SEND_ID_FRAME
0x000, // 0x023 = 35 - NO_OP
0x000, // 0x024 = 36 - NO_OP
0x000, // 0x025 = 37 - NO_OP
0x000, // 0x026 = 38 - NO_OP
0x000, // 0x027 = 39 - NO_OP
0x000, // 0x028 = 40 - NO_OP
0x0ff, // 0x029 = 41 - JUMP
0x112, // 0x02a = 42 - 
0x01b, // 0x02b = 43 - START_IT_NEXUS_LOSS_TIMER_SFO
0x017, // 0x02c = 44 - PATHWAY_BLOCKED_CNT_SFO_RESET
0x013, // 0x02d = 45 - START_ARB_WAIT_TIMER_SFO
0x001, // 0x02e = 46 - OPEN_REQUEST_SFO
0x000, // 0x02f = 47 - NO_OP
0x000, // 0x030 = 48 - NO_OP
0x000, // 0x031 = 49 - NO_OP
0x000, // 0x032 = 50 - NO_OP
0x000, // 0x033 = 51 - NO_OP
0x091, // 0x034 = 52 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_ACCEPT
0x056, // 0x035 = 53 - 
0x097, // 0x036 = 54 - JUMP_IF_OPEN_STATUS_EQUAL_RATE_NOT_SUPPORTED
0x059, // 0x037 = 55 - 
0x09b, // 0x038 = 56 - JUMP_IF_OPEN_STATUS_EQUAL_PROTOCOL_NOT_SUPPORTED
0x05c, // 0x039 = 57 - 
0x09d, // 0x03a = 58 - JUMP_IF_OPEN_STATUS_EQUAL_WRONG_DESTINATION
0x05f, // 0x03b = 59 - 
0x096, // 0x03c = 60 - JUMP_IF_OPEN_STATUS_EQUAL_BREAK_RECEIVED
0x062, // 0x03d = 61 - 
0x095, // 0x03e = 62 - JUMP_IF_OPEN_STATUS_EQUAL_BAD_DESTINATION
0x065, // 0x03f = 63 - 
0x0a1, // 0x040 = 64 - JUMP_IF_IT_NEXUS_LOSS_TIMEOUT_SFO
0x068, // 0x041 = 65 - 
0x09c, // 0x042 = 66 - JUMP_IF_OPEN_STATUS_EQUAL_STP_RESOURCE_BUSY
0x02b, // 0x043 = 67 - 
0x098, // 0x044 = 68 - JUMP_IF_OPEN_STATUS_EQUAL_NO_DESTINATION
0x112, // 0x045 = 69 - 
0x099, // 0x046 = 70 - JUMP_IF_OPEN_STATUS_EQUAL_PATHWAY_BLOCKED
0x06b, // 0x047 = 71 - 
0x09a, // 0x048 = 72 - JUMP_IF_OPEN_STATUS_EQUAL_RETRY
0x02e, // 0x049 = 73 - 
0x094, // 0x04a = 74 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_TIMEOUT
0x02e, // 0x04b = 75 - 
0x0a7, // 0x04c = 76 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
0x127, // 0x04d = 77 - 
0x092, // 0x04e = 78 - JUMP_IF_OPEN_STATUS_EQUAL_OCSM_BUSY
0x02e, // 0x04f = 79 - 
0x0ca, // 0x050 = 80 - JUMP_IF_PHY_READY
0x034, // 0x051 = 81 - 
0x031, // 0x052 = 82 - SET_OPEN_STATUS_PHY_NOT_RDY_SFO
0x033, // 0x053 = 83 - SOFT_RESET
0x0ff, // 0x054 = 84 - JUMP
0x001, // 0x055 = 85 - 
0x021, // 0x056 = 86 - SET_OPEN_STATUS_NORMAL_SFO
0x0ff, // 0x057 = 87 - JUMP
0x06e, // 0x058 = 88 - 
0x025, // 0x059 = 89 - SET_OPEN_STATUS_BAD_RATE_SFO
0x0ff, // 0x05a = 90 - JUMP
0x112, // 0x05b = 91 - 
0x026, // 0x05c = 92 - SET_OPEN_STATUS_BAD_PROTOCOL_SFO
0x0ff, // 0x05d = 93 - JUMP
0x112, // 0x05e = 94 - 
0x028, // 0x05f = 95 - SET_OPEN_STATUS_WRONG_DEST_SFO
0x0ff, // 0x060 = 96 - JUMP
0x112, // 0x061 = 97 - 
0x024, // 0x062 = 98 - SET_OPEN_STATUS_BREAK_SFO
0x0ff, // 0x063 = 99 - JUMP
0x112, // 0x064 = 100 - 
0x023, // 0x065 = 101 - SET_OPEN_STATUS_BAD_DEST_SFO
0x0ff, // 0x066 = 102 - JUMP
0x112, // 0x067 = 103 - 
0x022, // 0x068 = 104 - SET_OPEN_STATUS_IT_NEXUS_LOSS_SFO
0x0ff, // 0x069 = 105 - JUMP
0x112, // 0x06a = 106 - 
0x019, // 0x06b = 107 - PATHWAY_BLOCKED_CNT_SFO_INC
0x0ff, // 0x06c = 108 - JUMP
0x02e, // 0x06d = 109 - 
0x000, // 0x06e = 110 - NO_OP
0x0d4, // 0x06f = 111 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x093, // 0x070 = 112 - 
0x0aa, // 0x071 = 113 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_GOOD
0x084, // 0x072 = 114 - 
0x0ab, // 0x073 = 115 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_NAK
0x084, // 0x074 = 116 - 
0x0ac, // 0x075 = 117 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_ACK_NAK_TIMEOUT
0x087, // 0x076 = 118 - 
0x0ad, // 0x077 = 119 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_BREAK
0x08d, // 0x078 = 120 - 
0x0af, // 0x079 = 121 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_CREDIT_TIMEOUT
0x08a, // 0x07a = 122 - 
0x0ae, // 0x07b = 123 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_UNEXPECTED_CLOSE
0x084, // 0x07c = 124 - 
0x0d2, // 0x07d = 125 - JUMP_IF_SFO_TRANSMISSION_STATUS_EQUAL_SMP_ERR
0x090, // 0x07e = 126 - 
0x0ca, // 0x07f = 127 - JUMP_IF_PHY_READY
0x06f, // 0x080 = 128 - 
0x033, // 0x081 = 129 - SOFT_RESET
0x0ff, // 0x082 = 130 - JUMP
0x001, // 0x083 = 131 - 
0x006, // 0x084 = 132 - CLOSE_NORMAL
0x0ff, // 0x085 = 133 - JUMP
0x08d, // 0x086 = 134 - 
0x007, // 0x087 = 135 - CLOSE_ACK_NAK_TIMEOUT
0x0ff, // 0x088 = 136 - JUMP
0x08d, // 0x089 = 137 - 
0x008, // 0x08a = 138 - CLOSE_CREDIT_TIMEOUT
0x0ff, // 0x08b = 139 - JUMP
0x08d, // 0x08c = 140 - 
0x034, // 0x08d = 141 - ADVANCE_SFO
0x0ff, // 0x08e = 142 - JUMP
0x156, // 0x08f = 143 - 
0x034, // 0x090 = 144 - ADVANCE_SFO
0x0ff, // 0x091 = 145 - JUMP
0x166, // 0x092 = 146 - 
0x037, // 0x093 = 147 - SEND_CREDIT_BLOCK
0x0ff, // 0x094 = 148 - JUMP
0x071, // 0x095 = 149 - 
0x01c, // 0x096 = 150 - START_IT_NEXUS_LOSS_TIMER_DOC
0x018, // 0x097 = 151 - PATHWAY_BLOCKED_CNT_DOC_RESET
0x014, // 0x098 = 152 - START_ARB_WAIT_TIMER_DOC
0x002, // 0x099 = 153 - OPEN_REQUEST_DOC
0x000, // 0x09a = 154 - NO_OP
0x000, // 0x09b = 155 - NO_OP
0x000, // 0x09c = 156 - NO_OP
0x000, // 0x09d = 157 - NO_OP
0x000, // 0x09e = 158 - NO_OP
0x091, // 0x09f = 159 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_ACCEPT
0x0c1, // 0x0a0 = 160 - 
0x097, // 0x0a1 = 161 - JUMP_IF_OPEN_STATUS_EQUAL_RATE_NOT_SUPPORTED
0x0c4, // 0x0a2 = 162 - 
0x09b, // 0x0a3 = 163 - JUMP_IF_OPEN_STATUS_EQUAL_PROTOCOL_NOT_SUPPORTED
0x0c7, // 0x0a4 = 164 - 
0x09d, // 0x0a5 = 165 - JUMP_IF_OPEN_STATUS_EQUAL_WRONG_DESTINATION
0x0ca, // 0x0a6 = 166 - 
0x096, // 0x0a7 = 167 - JUMP_IF_OPEN_STATUS_EQUAL_BREAK_RECEIVED
0x0cd, // 0x0a8 = 168 - 
0x095, // 0x0a9 = 169 - JUMP_IF_OPEN_STATUS_EQUAL_BAD_DESTINATION
0x0d0, // 0x0aa = 170 - 
0x0a2, // 0x0ab = 171 - JUMP_IF_IT_NEXUS_LOSS_TIMEOUT_DOC
0x0d3, // 0x0ac = 172 - 
0x09c, // 0x0ad = 173 - JUMP_IF_OPEN_STATUS_EQUAL_STP_RESOURCE_BUSY
0x096, // 0x0ae = 174 - 
0x098, // 0x0af = 175 - JUMP_IF_OPEN_STATUS_EQUAL_NO_DESTINATION
0x112, // 0x0b0 = 176 - 
0x099, // 0x0b1 = 177 - JUMP_IF_OPEN_STATUS_EQUAL_PATHWAY_BLOCKED
0x0d6, // 0x0b2 = 178 - 
0x09a, // 0x0b3 = 179 - JUMP_IF_OPEN_STATUS_EQUAL_RETRY
0x099, // 0x0b4 = 180 - 
0x094, // 0x0b5 = 181 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_TIMEOUT
0x099, // 0x0b6 = 182 - 
0x0a7, // 0x0b7 = 183 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
0x139, // 0x0b8 = 184 - 
0x092, // 0x0b9 = 185 - JUMP_IF_OPEN_STATUS_EQUAL_OCSM_BUSY
0x099, // 0x0ba = 186 - 
0x0ca, // 0x0bb = 187 - JUMP_IF_PHY_READY
0x09f, // 0x0bc = 188 - 
0x032, // 0x0bd = 189 - SET_OPEN_STATUS_PHY_NOT_RDY_DOC
0x033, // 0x0be = 190 - SOFT_RESET
0x0ff, // 0x0bf = 191 - JUMP
0x001, // 0x0c0 = 192 - 
0x029, // 0x0c1 = 193 - SET_OPEN_STATUS_NORMAL_DOC
0x0ff, // 0x0c2 = 194 - JUMP
0x0d9, // 0x0c3 = 195 - 
0x02d, // 0x0c4 = 196 - SET_OPEN_STATUS_BAD_RATE_DOC
0x0ff, // 0x0c5 = 197 - JUMP
0x112, // 0x0c6 = 198 - 
0x02e, // 0x0c7 = 199 - SET_OPEN_STATUS_BAD_PROTOCOL_DOC
0x0ff, // 0x0c8 = 200 - JUMP
0x112, // 0x0c9 = 201 - 
0x030, // 0x0ca = 202 - SET_OPEN_STATUS_WRONG_DEST_DOC
0x0ff, // 0x0cb = 203 - JUMP
0x112, // 0x0cc = 204 - 
0x02c, // 0x0cd = 205 - SET_OPEN_STATUS_BREAK_DOC
0x0ff, // 0x0ce = 206 - JUMP
0x112, // 0x0cf = 207 - 
0x02b, // 0x0d0 = 208 - SET_OPEN_STATUS_BAD_DEST_DOC
0x0ff, // 0x0d1 = 209 - JUMP
0x112, // 0x0d2 = 210 - 
0x02a, // 0x0d3 = 211 - SET_OPEN_STATUS_IT_NEXUS_LOSS_DOC
0x0ff, // 0x0d4 = 212 - JUMP
0x112, // 0x0d5 = 213 - 
0x01a, // 0x0d6 = 214 - PATHWAY_BLOCKED_CNT_DOC_INC
0x0ff, // 0x0d7 = 215 - JUMP
0x099, // 0x0d8 = 216 - 
0x000, // 0x0d9 = 217 - NO_OP
0x0d4, // 0x0da = 218 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x10f, // 0x0db = 219 - 
0x0b1, // 0x0dc = 220 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_GOOD
0x0f1, // 0x0dd = 221 - 
0x0b2, // 0x0de = 222 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_NAK
0x0fd, // 0x0df = 223 - 
0x0b3, // 0x0e0 = 224 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_ACK_NAK_TIMEOUT
0x100, // 0x0e1 = 225 - 
0x0b4, // 0x0e2 = 226 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_BREAK
0x106, // 0x0e3 = 227 - 
0x0b6, // 0x0e4 = 228 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_CREDIT_TIMEOUT
0x103, // 0x0e5 = 229 - 
0x0b5, // 0x0e6 = 230 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_UNEXPECTED_CLOSE
0x0fd, // 0x0e7 = 231 - 
0x0d3, // 0x0e8 = 232 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_SMP_ERR
0x10c, // 0x0e9 = 233 - 
0x0d5, // 0x0ea = 234 - JUMP_IF_DOC_CLOSE_REQ
0x153, // 0x0eb = 235 - 
0x0ca, // 0x0ec = 236 - JUMP_IF_PHY_READY
0x0f5, // 0x0ed = 237 - 
0x033, // 0x0ee = 238 - SOFT_RESET
0x0ff, // 0x0ef = 239 - JUMP
0x001, // 0x0f0 = 240 - 
0x0d0, // 0x0f1 = 241 - JUMP_IF_SMP_PROTOCOL
0x0fd, // 0x0f2 = 242 - 
0x0ff, // 0x0f3 = 243 - JUMP
0x109, // 0x0f4 = 244 - 
0x0b7, // 0x0f5 = 245 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_CREDIT_BLOCKED
0x0fd, // 0x0f6 = 246 - 
0x0b8, // 0x0f7 = 247 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_MAX_BURST_SIZE
0x0fd, // 0x0f8 = 248 - 
0x0b9, // 0x0f9 = 249 - JUMP_IF_DOC_TRANSMISSION_STATUS_EQUAL_MAX_CONNECTION_TIME
0x0fd, // 0x0fa = 250 - 
0x0ff, // 0x0fb = 251 - JUMP
0x0da, // 0x0fc = 252 - 
0x006, // 0x0fd = 253 - CLOSE_NORMAL
0x0ff, // 0x0fe = 254 - JUMP
0x106, // 0x0ff = 255 - 
0x007, // 0x100 = 256 - CLOSE_ACK_NAK_TIMEOUT
0x0ff, // 0x101 = 257 - JUMP
0x106, // 0x102 = 258 - 
0x008, // 0x103 = 259 - CLOSE_CREDIT_TIMEOUT
0x0ff, // 0x104 = 260 - JUMP
0x106, // 0x105 = 261 - 
0x035, // 0x106 = 262 - ADVANCE_DOC
0x0ff, // 0x107 = 263 - JUMP
0x156, // 0x108 = 264 - 
0x035, // 0x109 = 265 - ADVANCE_DOC
0x0ff, // 0x10a = 266 - JUMP
0x112, // 0x10b = 267 - 
0x035, // 0x10c = 268 - ADVANCE_DOC
0x0ff, // 0x10d = 269 - JUMP
0x166, // 0x10e = 270 - 
0x037, // 0x10f = 271 - SEND_CREDIT_BLOCK
0x0ff, // 0x110 = 272 - JUMP
0x0dc, // 0x111 = 273 - 
0x0a9, // 0x112 = 274 - JUMP_IF_SFO_REQ
0x11d, // 0x113 = 275 - 
0x0b0, // 0x114 = 276 - JUMP_IF_DOC_REQ
0x12f, // 0x115 = 277 - 
0x0a8, // 0x116 = 278 - JUMP_IF_CONNECTION_ACTIVE_SET
0x141, // 0x117 = 279 - 
0x0ca, // 0x118 = 280 - JUMP_IF_PHY_READY
0x112, // 0x119 = 281 - 
0x033, // 0x11a = 282 - SOFT_RESET
0x0ff, // 0x11b = 283 - JUMP
0x001, // 0x11c = 284 - 
0x0ca, // 0x11d = 285 - JUMP_IF_PHY_READY
0x123, // 0x11e = 286 - 
0x031, // 0x11f = 287 - SET_OPEN_STATUS_PHY_NOT_RDY_SFO
0x033, // 0x120 = 288 - SOFT_RESET
0x0ff, // 0x121 = 289 - JUMP
0x001, // 0x122 = 290 - 
0x0a8, // 0x123 = 291 - JUMP_IF_CONNECTION_ACTIVE_SET
0x127, // 0x124 = 292 - 
0x0ff, // 0x125 = 293 - JUMP
0x02b, // 0x126 = 294 - 
0x0a3, // 0x127 = 295 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL_SFO
0x12b, // 0x128 = 296 - 
0x0ff, // 0x129 = 297 - JUMP
0x114, // 0x12a = 298 - 
0x0c8, // 0x12b = 299 - JUMP_IF_BREAK_RECEIVED
0x166, // 0x12c = 300 - 
0x0ff, // 0x12d = 301 - JUMP
0x056, // 0x12e = 302 - 
0x0ca, // 0x12f = 303 - JUMP_IF_PHY_READY
0x135, // 0x130 = 304 - 
0x032, // 0x131 = 305 - SET_OPEN_STATUS_PHY_NOT_RDY_DOC
0x033, // 0x132 = 306 - SOFT_RESET
0x0ff, // 0x133 = 307 - JUMP
0x001, // 0x134 = 308 - 
0x0a8, // 0x135 = 309 - JUMP_IF_CONNECTION_ACTIVE_SET
0x139, // 0x136 = 310 - 
0x0ff, // 0x137 = 311 - JUMP
0x096, // 0x138 = 312 - 
0x0a4, // 0x139 = 313 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL_DOC
0x13d, // 0x13a = 314 - 
0x0ff, // 0x13b = 315 - JUMP
0x116, // 0x13c = 316 - 
0x0c8, // 0x13d = 317 - JUMP_IF_BREAK_RECEIVED
0x166, // 0x13e = 318 - 
0x0ff, // 0x13f = 319 - JUMP
0x0c1, // 0x140 = 320 - 
0x0d0, // 0x141 = 321 - JUMP_IF_SMP_PROTOCOL
0x14c, // 0x142 = 322 - 
0x0d4, // 0x143 = 323 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x150, // 0x144 = 324 - 
0x0a6, // 0x145 = 325 - JUMP_IF_CONNECTION_OPEN_MASTER_FLAG_SET
0x149, // 0x146 = 326 - 
0x0ff, // 0x147 = 327 - JUMP
0x16e, // 0x148 = 328 - 
0x006, // 0x149 = 329 - CLOSE_NORMAL
0x0ff, // 0x14a = 330 - JUMP
0x156, // 0x14b = 331 - 
0x0d1, // 0x14c = 332 - JUMP_IF_SMP_FRAME_ERR_RECEIVED
0x177, // 0x14d = 333 - 
0x0ff, // 0x14e = 334 - JUMP
0x112, // 0x14f = 335 - 
0x037, // 0x150 = 336 - SEND_CREDIT_BLOCK
0x0ff, // 0x151 = 337 - JUMP
0x145, // 0x152 = 338 - 
0x0c8, // 0x153 = 339 - JUMP_IF_BREAK_RECEIVED
0x166, // 0x154 = 340 - 
0x006, // 0x155 = 341 - CLOSE_NORMAL
0x000, // 0x156 = 342 - NO_OP
0x000, // 0x157 = 343 - NO_OP
0x000, // 0x158 = 344 - NO_OP
0x000, // 0x159 = 345 - NO_OP
0x000, // 0x15a = 346 - NO_OP
0x0d4, // 0x15b = 347 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x16b, // 0x15c = 348 - 
0x0cd, // 0x15d = 349 - JUMP_IF_CLOSE_STATUS_EQUAL_ANY
0x112, // 0x15e = 350 - 
0x0c8, // 0x15f = 351 - JUMP_IF_BREAK_RECEIVED
0x166, // 0x160 = 352 - 
0x0ca, // 0x161 = 353 - JUMP_IF_PHY_READY
0x156, // 0x162 = 354 - 
0x033, // 0x163 = 355 - SOFT_RESET
0x0ff, // 0x164 = 356 - JUMP
0x001, // 0x165 = 357 - 
0x009, // 0x166 = 358 - CLOSE_BREAK
0x0a8, // 0x167 = 359 - JUMP_IF_CONNECTION_ACTIVE_SET
0x167, // 0x168 = 360 - 
0x0ff, // 0x169 = 361 - JUMP
0x112, // 0x16a = 362 - 
0x037, // 0x16b = 363 - SEND_CREDIT_BLOCK
0x0ff, // 0x16c = 364 - JUMP
0x15d, // 0x16d = 365 - 
0x0c8, // 0x16e = 366 - JUMP_IF_BREAK_RECEIVED
0x177, // 0x16f = 367 - 
0x0ce, // 0x170 = 368 - JUMP_IF_ANY_DONE_RECEIVED
0x17c, // 0x171 = 369 - 
0x0ca, // 0x172 = 370 - JUMP_IF_PHY_READY
0x112, // 0x173 = 371 - 
0x033, // 0x174 = 372 - SOFT_RESET
0x0ff, // 0x175 = 373 - JUMP
0x112, // 0x176 = 374 - 
0x009, // 0x177 = 375 - CLOSE_BREAK
0x0a8, // 0x178 = 376 - JUMP_IF_CONNECTION_ACTIVE_SET
0x178, // 0x179 = 377 - 
0x0ff, // 0x17a = 378 - JUMP
0x112, // 0x17b = 379 - 
0x006, // 0x17c = 380 - CLOSE_NORMAL
0x000, // 0x17d = 381 - NO_OP
0x000, // 0x17e = 382 - NO_OP
0x000, // 0x17f = 383 - NO_OP
0x000, // 0x180 = 384 - NO_OP
0x000, // 0x181 = 385 - NO_OP
0x0cd, // 0x182 = 386 - JUMP_IF_CLOSE_STATUS_EQUAL_ANY
0x112, // 0x183 = 387 - 
0x0d4, // 0x184 = 388 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x18d, // 0x185 = 389 - 
0x0c8, // 0x186 = 390 - JUMP_IF_BREAK_RECEIVED
0x177, // 0x187 = 391 - 
0x0ca, // 0x188 = 392 - JUMP_IF_PHY_READY
0x182, // 0x189 = 393 - 
0x033, // 0x18a = 394 - SOFT_RESET
0x0ff, // 0x18b = 395 - JUMP
0x001, // 0x18c = 396 - 
0x037, // 0x18d = 397 - SEND_CREDIT_BLOCK
0x0ff, // 0x18e = 398 - JUMP
0x186, // 0x18f = 399 - 
0x000, // 0x190 = 400 - NO_OP
0x000, // 0x191 = 401 - NO_OP
0x000, // 0x192 = 402 - NO_OP
0x000, // 0x193 = 403 - NO_OP
0x000, // 0x194 = 404 - NO_OP
0x000, // 0x195 = 405 - NO_OP
0x000, // 0x196 = 406 - NO_OP
0x000, // 0x197 = 407 - NO_OP
0x000, // 0x198 = 408 - NO_OP
0x000, // 0x199 = 409 - NO_OP
0x000, // 0x19a = 410 - NO_OP
0x000, // 0x19b = 411 - NO_OP
0x000, // 0x19c = 412 - NO_OP
0x000, // 0x19d = 413 - NO_OP
0x000, // 0x19e = 414 - NO_OP
0x000, // 0x19f = 415 - NO_OP
0x000, // 0x1a0 = 416 - NO_OP
0x000, // 0x1a1 = 417 - NO_OP
0x000, // 0x1a2 = 418 - NO_OP
0x000, // 0x1a3 = 419 - NO_OP
0x000, // 0x1a4 = 420 - NO_OP
0x000, // 0x1a5 = 421 - NO_OP
0x000, // 0x1a6 = 422 - NO_OP
0x000, // 0x1a7 = 423 - NO_OP
0x000, // 0x1a8 = 424 - NO_OP
0x000, // 0x1a9 = 425 - NO_OP
0x000, // 0x1aa = 426 - NO_OP
0x000, // 0x1ab = 427 - NO_OP
0x000, // 0x1ac = 428 - NO_OP
0x000, // 0x1ad = 429 - NO_OP
0x000, // 0x1ae = 430 - NO_OP
0x000, // 0x1af = 431 - NO_OP
0x000, // 0x1b0 = 432 - NO_OP
0x000, // 0x1b1 = 433 - NO_OP
0x000, // 0x1b2 = 434 - NO_OP
0x000, // 0x1b3 = 435 - NO_OP
0x000, // 0x1b4 = 436 - NO_OP
0x000, // 0x1b5 = 437 - NO_OP
0x000, // 0x1b6 = 438 - NO_OP
0x000, // 0x1b7 = 439 - NO_OP
0x000, // 0x1b8 = 440 - NO_OP
0x000, // 0x1b9 = 441 - NO_OP
0x000, // 0x1ba = 442 - NO_OP
0x000, // 0x1bb = 443 - NO_OP
0x000, // 0x1bc = 444 - NO_OP
0x000, // 0x1bd = 445 - NO_OP
0x000, // 0x1be = 446 - NO_OP
0x000, // 0x1bf = 447 - NO_OP
0x000, // 0x1c0 = 448 - NO_OP
0x000, // 0x1c1 = 449 - NO_OP
0x000, // 0x1c2 = 450 - NO_OP
0x000, // 0x1c3 = 451 - NO_OP
0x000, // 0x1c4 = 452 - NO_OP
0x000, // 0x1c5 = 453 - NO_OP
0x000, // 0x1c6 = 454 - NO_OP
0x000, // 0x1c7 = 455 - NO_OP
0x000, // 0x1c8 = 456 - NO_OP
0x000, // 0x1c9 = 457 - NO_OP
0x000, // 0x1ca = 458 - NO_OP
0x000, // 0x1cb = 459 - NO_OP
0x000, // 0x1cc = 460 - NO_OP
0x000, // 0x1cd = 461 - NO_OP
0x000, // 0x1ce = 462 - NO_OP
0x000, // 0x1cf = 463 - NO_OP
0x000, // 0x1d0 = 464 - NO_OP
0x000, // 0x1d1 = 465 - NO_OP
0x000, // 0x1d2 = 466 - NO_OP
0x000, // 0x1d3 = 467 - NO_OP
0x000, // 0x1d4 = 468 - NO_OP
0x000, // 0x1d5 = 469 - NO_OP
0x000, // 0x1d6 = 470 - NO_OP
0x000, // 0x1d7 = 471 - NO_OP
0x000, // 0x1d8 = 472 - NO_OP
0x000, // 0x1d9 = 473 - NO_OP
0x000, // 0x1da = 474 - NO_OP
0x000, // 0x1db = 475 - NO_OP
0x000, // 0x1dc = 476 - NO_OP
0x000, // 0x1dd = 477 - NO_OP
0x000, // 0x1de = 478 - NO_OP
0x000, // 0x1df = 479 - NO_OP
0x000, // 0x1e0 = 480 - NO_OP
0x000, // 0x1e1 = 481 - NO_OP
0x000, // 0x1e2 = 482 - NO_OP
0x000, // 0x1e3 = 483 - NO_OP
0x000, // 0x1e4 = 484 - NO_OP
0x000, // 0x1e5 = 485 - NO_OP
0x000, // 0x1e6 = 486 - NO_OP
0x000, // 0x1e7 = 487 - NO_OP
0x000, // 0x1e8 = 488 - NO_OP
0x000, // 0x1e9 = 489 - NO_OP
0x000, // 0x1ea = 490 - NO_OP
0x000, // 0x1eb = 491 - NO_OP
0x000, // 0x1ec = 492 - NO_OP
0x000, // 0x1ed = 493 - NO_OP
0x000, // 0x1ee = 494 - NO_OP
0x000, // 0x1ef = 495 - NO_OP
0x000, // 0x1f0 = 496 - NO_OP
0x000, // 0x1f1 = 497 - NO_OP
0x000, // 0x1f2 = 498 - NO_OP
0x000, // 0x1f3 = 499 - NO_OP
0x000, // 0x1f4 = 500 - NO_OP
0x000, // 0x1f5 = 501 - NO_OP
0x000, // 0x1f6 = 502 - NO_OP
0x000, // 0x1f7 = 503 - NO_OP
0x000, // 0x1f8 = 504 - NO_OP
0x000, // 0x1f9 = 505 - NO_OP
0x000, // 0x1fa = 506 - NO_OP
0x000, // 0x1fb = 507 - NO_OP
0x000, // 0x1fc = 508 - NO_OP
0x000, // 0x1fd = 509 - NO_OP
0x000, // 0x1fe = 510 - NO_OP
0x000, // 0x1ff = 511 - NO_OP
};

/* worked with the bitmap both pnr11020.bit(mainly this) and t091505d0.bit,
   this has been golden */
bit32 wcsImage11020[] = 
{
0x00d, // 00000 = 0 - PHY_RESET_START
0x0be, // 0x001 = 1 - JUMP_IF_PHY_READY
0x009, // 0x002 = 2 - 
0x0ae, // 0x003 = 3 - JUMP_IF_HARD_RESET_PRIMITIVE
0x010, // 0x004 = 4 - 
0x0af, // 0x005 = 5 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x01e, // 0x006 = 6 - 
0x0ff, // 0x007 = 7 - JUMP
0x001, // 0x008 = 8 - 
0x00c, // 0x009 = 9 - SEND_ID_FRAME
0x0ae, // 0x00a = 10 - JUMP_IF_HARD_RESET_PRIMITIVE
0x010, // 0x00b = 11 - 
0x0af, // 0x00c = 12 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x023, // 0x00d = 13 - 
0x0ff, // 0x00e = 14 - JUMP
0x00a, // 0x00f = 15 - 
0x01c, // 0x010 = 16 - SOFT_RESET
0x00d, // 0x011 = 17 - PHY_RESET_START
0x0be, // 0x012 = 18 - JUMP_IF_PHY_READY
0x016, // 0x013 = 19 - 
0x0af, // 0x014 = 20 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x01b, // 0x015 = 21 - 
0x00c, // 0x016 = 22 - SEND_ID_FRAME
0x0af, // 0x017 = 23 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x023, // 0x018 = 24 - 
0x0ff, // 0x019 = 25 - JUMP
0x017, // 0x01a = 26 - 
0x00c, // 0x01b = 27 - SEND_ID_FRAME
0x0ff, // 0x01c = 28 - JUMP
0x023, // 0x01d = 29 - 
0x0be, // 0x01e = 30 - JUMP_IF_PHY_READY
0x022, // 0x01f = 31 - 
0x0ff, // 0x020 = 32 - JUMP
0x01e, // 0x021 = 33 - 
0x00c, // 0x022 = 34 - SEND_ID_FRAME
0x000, // 0x023 = 35 - NO_OP
0x000, // 0x024 = 36 - NO_OP
0x000, // 0x025 = 37 - NO_OP
0x000, // 0x026 = 38 - NO_OP
0x000, // 0x027 = 39 - NO_OP
0x000, // 0x028 = 40 - NO_OP
0x0ff, // 0x029 = 41 - JUMP
0x061, // 0x02a = 42 - 
0x000, // 0x02b = 43 - NO_OP
0x0c9, // 0x02c = 44 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x05e, // 0x02d = 45 - 
0x0a5, // 0x02e = 46 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_GOOD
0x041, // 0x02f = 47 - 
0x0a6, // 0x030 = 48 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_NAK
0x052, // 0x031 = 49 - 
0x0a7, // 0x032 = 50 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_ACK_NAK_TIMEOUT
0x055, // 0x033 = 51 - 
0x0a8, // 0x034 = 52 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_BREAK
0x052, // 0x035 = 53 - 
0x0aa, // 0x036 = 54 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_CREDIT_TIMEOUT
0x058, // 0x037 = 55 - 
0x0c5, // 0x038 = 56 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_SMP_ERR
0x05b, // 0x039 = 57 - 
0x0ca, // 0x03a = 58 - JUMP_IF_DOC_CLOSE_REQ
0x0a5, // 0x03b = 59 - 
0x0be, // 0x03c = 60 - JUMP_IF_PHY_READY
0x04a, // 0x03d = 61 - 
0x01c, // 0x03e = 62 - SOFT_RESET
0x0ff, // 0x03f = 63 - JUMP
0x001, // 0x040 = 64 - 
0x01d, // 0x041 = 65 - ADVANCE
0x0c3, // 0x042 = 66 - JUMP_IF_SMP_PROTOCOL
0x046, // 0x043 = 67 - 
0x0ff, // 0x044 = 68 - JUMP
0x061, // 0x045 = 69 - 
0x0a2, // 0x046 = 70 - JUMP_IF_CONNECTION_OPEN_MASTER_FLAG_SET
0x0a5, // 0x047 = 71 - 
0x0ff, // 0x048 = 72 - JUMP
0x061, // 0x049 = 73 - 
0x0ab, // 0x04a = 74 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_CREDIT_BLOCKED
0x052, // 0x04b = 75 - 
0x0ac, // 0x04c = 76 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_MAX_BURST_SIZE
0x052, // 0x04d = 77 - 
0x0ad, // 0x04e = 78 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_MAX_CONNECTION_TIME
0x052, // 0x04f = 79 - 
0x0ff, // 0x050 = 80 - JUMP
0x02c, // 0x051 = 81 - 
0x01d, // 0x052 = 82 - ADVANCE
0x0ff, // 0x053 = 83 - JUMP
0x061, // 0x054 = 84 - 
0x01d, // 0x055 = 85 - ADVANCE
0x0ff, // 0x056 = 86 - JUMP
0x0c2, // 0x057 = 87 - 
0x01d, // 0x058 = 88 - ADVANCE
0x0ff, // 0x059 = 89 - JUMP
0x0c5, // 0x05a = 90 - 
0x01d, // 0x05b = 91 - ADVANCE
0x0ff, // 0x05c = 92 - JUMP
0x0b6, // 0x05d = 93 - 
0x022, // 0x05e = 94 - SEND_CREDIT_BLOCK
0x0ff, // 0x05f = 95 - JUMP
0x02e, // 0x060 = 96 - 
0x0c8, // 0x061 = 97 - JUMP_IF_HIP_REQ
0x06d, // 0x062 = 98 - 
0x0c6, // 0x063 = 99 - JUMP_IF_SFO_REQ
0x07d, // 0x064 = 100 - 
0x0c7, // 0x065 = 101 - JUMP_IF_DOC_REQ
0x08d, // 0x066 = 102 - 
0x0a3, // 0x067 = 103 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
0x09d, // 0x068 = 104 - 
0x0a2, // 0x069 = 105 - JUMP_IF_CONNECTION_OPEN_MASTER_FLAG_SET
0x0a5, // 0x06a = 106 - 
0x0ff, // 0x06b = 107 - JUMP
0x061, // 0x06c = 108 - 
0x020, // 0x06d = 109 - SELECT_HIP
0x000, // 0x06e = 110 - NO_OP
0x000, // 0x06f = 111 - NO_OP
0x0a4, // 0x070 = 112 - JUMP_IF_CONNECTION_ACTIVE_SET
0x074, // 0x071 = 113 - 
0x0ff, // 0x072 = 114 - JUMP
0x0c8, // 0x073 = 115 - 
0x0a0, // 0x074 = 116 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL
0x07a, // 0x075 = 117 - 
0x0a3, // 0x076 = 118 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
0x09d, // 0x077 = 119 - 
0x0ff, // 0x078 = 120 - JUMP
0x0a5, // 0x079 = 121 - 
0x013, // 0x07a = 122 - SET_OPEN_STATUS_NORMAL
0x0ff, // 0x07b = 123 - JUMP
0x02b, // 0x07c = 124 - 
0x01e, // 0x07d = 125 - SELECT_SFO
0x000, // 0x07e = 126 - NO_OP
0x000, // 0x07f = 127 - NO_OP
0x0a4, // 0x080 = 128 - JUMP_IF_CONNECTION_ACTIVE_SET
0x084, // 0x081 = 129 - 
0x0ff, // 0x082 = 130 - JUMP
0x0c8, // 0x083 = 131 - 
0x0a0, // 0x084 = 132 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL
0x08a, // 0x085 = 133 - 
0x0a3, // 0x086 = 134 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
0x09d, // 0x087 = 135 - 
0x0ff, // 0x088 = 136 - JUMP
0x0a5, // 0x089 = 137 - 
0x013, // 0x08a = 138 - SET_OPEN_STATUS_NORMAL
0x0ff, // 0x08b = 139 - JUMP
0x02b, // 0x08c = 140 - 
0x01f, // 0x08d = 141 - SELECT_DOC
0x000, // 0x08e = 142 - NO_OP
0x000, // 0x08f = 143 - NO_OP
0x0a4, // 0x090 = 144 - JUMP_IF_CONNECTION_ACTIVE_SET
0x094, // 0x091 = 145 - 
0x0ff, // 0x092 = 146 - JUMP
0x0c8, // 0x093 = 147 - 
0x0a0, // 0x094 = 148 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL
0x09a, // 0x095 = 149 - 
0x0a3, // 0x096 = 150 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
0x09d, // 0x097 = 151 - 
0x0ff, // 0x098 = 152 - JUMP
0x0a5, // 0x099 = 153 - 
0x013, // 0x09a = 154 - SET_OPEN_STATUS_NORMAL
0x0ff, // 0x09b = 155 - JUMP
0x02b, // 0x09c = 156 - 
0x0c3, // 0x09d = 157 - JUMP_IF_SMP_PROTOCOL
0x0a1, // 0x09e = 158 - 
0x0ff, // 0x09f = 159 - JUMP
0x0a5, // 0x0a0 = 160 - 
0x0c4, // 0x0a1 = 161 - JUMP_IF_SMP_FRAME_ERR_RECEIVED
0x0b6, // 0x0a2 = 162 - 
0x0ff, // 0x0a3 = 163 - JUMP
0x061, // 0x0a4 = 164 - 
0x004, // 0x0a5 = 165 - CLOSE_NORMAL
0x000, // 0x0a6 = 166 - NO_OP
0x000, // 0x0a7 = 167 - NO_OP
0x000, // 0x0a8 = 168 - NO_OP
0x000, // 0x0a9 = 169 - NO_OP
0x0c9, // 0x0aa = 170 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x0b3, // 0x0ab = 171 - 
0x0c0, // 0x0ac = 172 - JUMP_IF_CLOSE_STATUS_EQUAL_ANY
0x061, // 0x0ad = 173 - 
0x0be, // 0x0ae = 174 - JUMP_IF_PHY_READY
0x0a6, // 0x0af = 175 - 
0x01c, // 0x0b0 = 176 - SOFT_RESET
0x0ff, // 0x0b1 = 177 - JUMP
0x001, // 0x0b2 = 178 - 
0x022, // 0x0b3 = 179 - SEND_CREDIT_BLOCK
0x0ff, // 0x0b4 = 180 - JUMP
0x0a6, // 0x0b5 = 181 - 
0x007, // 0x0b6 = 182 - CLOSE_BREAK
0x000, // 0x0b7 = 183 - NO_OP
0x000, // 0x0b8 = 184 - NO_OP
0x000, // 0x0b9 = 185 - NO_OP
0x000, // 0x0ba = 186 - NO_OP
0x0c0, // 0x0bb = 187 - JUMP_IF_CLOSE_STATUS_EQUAL_ANY
0x061, // 0x0bc = 188 - 
0x0be, // 0x0bd = 189 - JUMP_IF_PHY_READY
0x0b7, // 0x0be = 190 - 
0x01c, // 0x0bf = 191 - SOFT_RESET
0x0ff, // 0x0c0 = 192 - JUMP
0x001, // 0x0c1 = 193 - 
0x005, // 0x0c2 = 194 - CLOSE_ACK_NAK_TIMEOUT
0x0ff, // 0x0c3 = 195 - JUMP
0x0a6, // 0x0c4 = 196 - 
0x006, // 0x0c5 = 197 - CLOSE_CREDIT_TIMEOUT
0x0ff, // 0x0c6 = 198 - JUMP
0x0a6, // 0x0c7 = 199 - 
0x0b0, // 0x0c8 = 200 - JUMP_IF_FLAG_0_SET
0x0cd, // 0x0c9 = 201 - 
0x011, // 0x0ca = 202 - START_IT_NEXUS_LOSS_TIMER
0x00f, // 0x0cb = 203 - PATHWAY_BLOCKED_CNT_RESET
0x00e, // 0x0cc = 204 - START_ARB_WAIT_TIMER
0x001, // 0x0cd = 205 - OPEN_REQUEST
0x000, // 0x0ce = 206 - NO_OP
0x000, // 0x0cf = 207 - NO_OP
0x000, // 0x0d0 = 208 - NO_OP
0x000, // 0x0d1 = 209 - NO_OP
0x090, // 0x0d2 = 210 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_ACCEPT
0x0f8, // 0x0d3 = 211 - 
0x095, // 0x0d4 = 212 - JUMP_IF_OPEN_STATUS_EQUAL_RATE_NOT_SUPPORTED
0x0fd, // 0x0d5 = 213 - 
0x099, // 0x0d6 = 214 - JUMP_IF_OPEN_STATUS_EQUAL_PROTOCOL_NOT_SUPPORTED
0x100, // 0x0d7 = 215 - 
0x09b, // 0x0d8 = 216 - JUMP_IF_OPEN_STATUS_EQUAL_WRONG_DESTINATION
0x103, // 0x0d9 = 217 - 
0x094, // 0x0da = 218 - JUMP_IF_OPEN_STATUS_EQUAL_BREAK_RECEIVED
0x0cd, // 0x0db = 219 - 
0x093, // 0x0dc = 220 - JUMP_IF_OPEN_STATUS_EQUAL_BAD_DESTINATION
0x106, // 0x0dd = 221 - 
0x09f, // 0x0de = 222 - JUMP_IF_IT_NEXUS_LOSS_TIMEOUT
0x109, // 0x0df = 223 - 
0x09a, // 0x0e0 = 224 - JUMP_IF_OPEN_STATUS_EQUAL_STP_RESOURCE_BUSY
0x0cd, // 0x0e1 = 225 - 
0x096, // 0x0e2 = 226 - JUMP_IF_OPEN_STATUS_EQUAL_NO_DESTINATION
0x106, // 0x0e3 = 227 - 
0x097, // 0x0e4 = 228 - JUMP_IF_OPEN_STATUS_EQUAL_PATHWAY_BLOCKED
0x10c, // 0x0e5 = 229 - 
0x098, // 0x0e6 = 230 - JUMP_IF_OPEN_STATUS_EQUAL_RETRY
0x0cd, // 0x0e7 = 231 - 
0x092, // 0x0e8 = 232 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_TIMEOUT
0x0cd, // 0x0e9 = 233 - 
0x0a4, // 0x0ea = 234 - JUMP_IF_CONNECTION_ACTIVE_SET
0x0f2, // 0x0eb = 235 - 
0x0be, // 0x0ec = 236 - JUMP_IF_PHY_READY
0x0d2, // 0x0ed = 237 - 
0x01b, // 0x0ee = 238 - SET_OPEN_STATUS_PHY_NOT_RDY
0x01c, // 0x0ef = 239 - SOFT_RESET
0x0ff, // 0x0f0 = 240 - JUMP
0x001, // 0x0f1 = 241 - 
0x0a0, // 0x0f2 = 242 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL
0x0f8, // 0x0f3 = 243 - 
0x000, // 0x0f4 = 244 - NO_OP
0x000, // 0x0f5 = 245 - NO_OP
0x0ff, // 0x0f6 = 246 - JUMP
0x09d, // 0x0f7 = 247 - 
0x013, // 0x0f8 = 248 - SET_OPEN_STATUS_NORMAL
0x000, // 0x0f9 = 249 - NO_OP
0x000, // 0x0fa = 250 - NO_OP
0x0ff, // 0x0fb = 251 - JUMP
0x02b, // 0x0fc = 252 - 
0x017, // 0x0fd = 253 - SET_OPEN_STATUS_BAD_RATE
0x0ff, // 0x0fe = 254 - JUMP
0x061, // 0x0ff = 255 - 
0x018, // 0x100 = 256 - SET_OPEN_STATUS_BAD_PROTOCOL
0x0ff, // 0x101 = 257 - JUMP
0x061, // 0x102 = 258 - 
0x01a, // 0x103 = 259 - SET_OPEN_STATUS_WRONG_DEST
0x0ff, // 0x104 = 260 - JUMP
0x061, // 0x105 = 261 - 
0x015, // 0x106 = 262 - SET_OPEN_STATUS_BAD_DEST
0x0ff, // 0x107 = 263 - JUMP
0x061, // 0x108 = 264 - 
0x014, // 0x109 = 265 - SET_OPEN_STATUS_IT_NEXUS_LOSS
0x0ff, // 0x10a = 266 - JUMP
0x061, // 0x10b = 267 - 
0x010, // 0x10c = 268 - PATHWAY_BLOCKED_CNT_INC
0x0ff, // 0x10d = 269 - JUMP
0x0cd, // 0x10e = 270 - 
0x000, // 0x10f = 271 - NO_OP
0x000, // 0x110 = 272 - NO_OP
0x000, // 0x111 = 273 - NO_OP
0x000, // 0x112 = 274 - NO_OP
0x000, // 0x113 = 275 - NO_OP
0x000, // 0x114 = 276 - NO_OP
0x000, // 0x115 = 277 - NO_OP
0x000, // 0x116 = 278 - NO_OP
0x000, // 0x117 = 279 - NO_OP
0x000, // 0x118 = 280 - NO_OP
0x000, // 0x119 = 281 - NO_OP
0x000, // 0x11a = 282 - NO_OP
0x000, // 0x11b = 283 - NO_OP
0x000, // 0x11c = 284 - NO_OP
0x000, // 0x11d = 285 - NO_OP
0x000, // 0x11e = 286 - NO_OP
0x000, // 0x11f = 287 - NO_OP
0x000, // 0x120 = 288 - NO_OP
0x000, // 0x121 = 289 - NO_OP
0x000, // 0x122 = 290 - NO_OP
0x000, // 0x123 = 291 - NO_OP
0x000, // 0x124 = 292 - NO_OP
0x000, // 0x125 = 293 - NO_OP
0x000, // 0x126 = 294 - NO_OP
0x000, // 0x127 = 295 - NO_OP
0x000, // 0x128 = 296 - NO_OP
0x000, // 0x129 = 297 - NO_OP
0x000, // 0x12a = 298 - NO_OP
0x000, // 0x12b = 299 - NO_OP
0x000, // 0x12c = 300 - NO_OP
0x000, // 0x12d = 301 - NO_OP
0x000, // 0x12e = 302 - NO_OP
0x000, // 0x12f = 303 - NO_OP
0x000, // 0x130 = 304 - NO_OP
0x000, // 0x131 = 305 - NO_OP
0x000, // 0x132 = 306 - NO_OP
0x000, // 0x133 = 307 - NO_OP
0x000, // 0x134 = 308 - NO_OP
0x000, // 0x135 = 309 - NO_OP
0x000, // 0x136 = 310 - NO_OP
0x000, // 0x137 = 311 - NO_OP
0x000, // 0x138 = 312 - NO_OP
0x000, // 0x139 = 313 - NO_OP
0x000, // 0x13a = 314 - NO_OP
0x000, // 0x13b = 315 - NO_OP
0x000, // 0x13c = 316 - NO_OP
0x000, // 0x13d = 317 - NO_OP
0x000, // 0x13e = 318 - NO_OP
0x000, // 0x13f = 319 - NO_OP
0x000, // 0x140 = 320 - NO_OP
0x000, // 0x141 = 321 - NO_OP
0x000, // 0x142 = 322 - NO_OP
0x000, // 0x143 = 323 - NO_OP
0x000, // 0x144 = 324 - NO_OP
0x000, // 0x145 = 325 - NO_OP
0x000, // 0x146 = 326 - NO_OP
0x000, // 0x147 = 327 - NO_OP
0x000, // 0x148 = 328 - NO_OP
0x000, // 0x149 = 329 - NO_OP
0x000, // 0x14a = 330 - NO_OP
0x000, // 0x14b = 331 - NO_OP
0x000, // 0x14c = 332 - NO_OP
0x000, // 0x14d = 333 - NO_OP
0x000, // 0x14e = 334 - NO_OP
0x000, // 0x14f = 335 - NO_OP
0x000, // 0x150 = 336 - NO_OP
0x000, // 0x151 = 337 - NO_OP
0x000, // 0x152 = 338 - NO_OP
0x000, // 0x153 = 339 - NO_OP
0x000, // 0x154 = 340 - NO_OP
0x000, // 0x155 = 341 - NO_OP
0x000, // 0x156 = 342 - NO_OP
0x000, // 0x157 = 343 - NO_OP
0x000, // 0x158 = 344 - NO_OP
0x000, // 0x159 = 345 - NO_OP
0x000, // 0x15a = 346 - NO_OP
0x000, // 0x15b = 347 - NO_OP
0x000, // 0x15c = 348 - NO_OP
0x000, // 0x15d = 349 - NO_OP
0x000, // 0x15e = 350 - NO_OP
0x000, // 0x15f = 351 - NO_OP
0x000, // 0x160 = 352 - NO_OP
0x000, // 0x161 = 353 - NO_OP
0x000, // 0x162 = 354 - NO_OP
0x000, // 0x163 = 355 - NO_OP
0x000, // 0x164 = 356 - NO_OP
0x000, // 0x165 = 357 - NO_OP
0x000, // 0x166 = 358 - NO_OP
0x000, // 0x167 = 359 - NO_OP
0x000, // 0x168 = 360 - NO_OP
0x000, // 0x169 = 361 - NO_OP
0x000, // 0x16a = 362 - NO_OP
0x000, // 0x16b = 363 - NO_OP
0x000, // 0x16c = 364 - NO_OP
0x000, // 0x16d = 365 - NO_OP
0x000, // 0x16e = 366 - NO_OP
0x000, // 0x16f = 367 - NO_OP
0x000, // 0x170 = 368 - NO_OP
0x000, // 0x171 = 369 - NO_OP
0x000, // 0x172 = 370 - NO_OP
0x000, // 0x173 = 371 - NO_OP
0x000, // 0x174 = 372 - NO_OP
0x000, // 0x175 = 373 - NO_OP
0x000, // 0x176 = 374 - NO_OP
0x000, // 0x177 = 375 - NO_OP
0x000, // 0x178 = 376 - NO_OP
0x000, // 0x179 = 377 - NO_OP
0x000, // 0x17a = 378 - NO_OP
0x000, // 0x17b = 379 - NO_OP
0x000, // 0x17c = 380 - NO_OP
0x000, // 0x17d = 381 - NO_OP
0x000, // 0x17e = 382 - NO_OP
0x000, // 0x17f = 383 - NO_OP
0x000, // 0x180 = 384 - NO_OP
0x000, // 0x181 = 385 - NO_OP
0x000, // 0x182 = 386 - NO_OP
0x000, // 0x183 = 387 - NO_OP
0x000, // 0x184 = 388 - NO_OP
0x000, // 0x185 = 389 - NO_OP
0x000, // 0x186 = 390 - NO_OP
0x000, // 0x187 = 391 - NO_OP
0x000, // 0x188 = 392 - NO_OP
0x000, // 0x189 = 393 - NO_OP
0x000, // 0x18a = 394 - NO_OP
0x000, // 0x18b = 395 - NO_OP
0x000, // 0x18c = 396 - NO_OP
0x000, // 0x18d = 397 - NO_OP
0x000, // 0x18e = 398 - NO_OP
0x000, // 0x18f = 399 - NO_OP
0x000, // 0x190 = 400 - NO_OP
0x000, // 0x191 = 401 - NO_OP
0x000, // 0x192 = 402 - NO_OP
0x000, // 0x193 = 403 - NO_OP
0x000, // 0x194 = 404 - NO_OP
0x000, // 0x195 = 405 - NO_OP
0x000, // 0x196 = 406 - NO_OP
0x000, // 0x197 = 407 - NO_OP
0x000, // 0x198 = 408 - NO_OP
0x000, // 0x199 = 409 - NO_OP
0x000, // 0x19a = 410 - NO_OP
0x000, // 0x19b = 411 - NO_OP
0x000, // 0x19c = 412 - NO_OP
0x000, // 0x19d = 413 - NO_OP
0x000, // 0x19e = 414 - NO_OP
0x000, // 0x19f = 415 - NO_OP
0x000, // 0x1a0 = 416 - NO_OP
0x000, // 0x1a1 = 417 - NO_OP
0x000, // 0x1a2 = 418 - NO_OP
0x000, // 0x1a3 = 419 - NO_OP
0x000, // 0x1a4 = 420 - NO_OP
0x000, // 0x1a5 = 421 - NO_OP
0x000, // 0x1a6 = 422 - NO_OP
0x000, // 0x1a7 = 423 - NO_OP
0x000, // 0x1a8 = 424 - NO_OP
0x000, // 0x1a9 = 425 - NO_OP
0x000, // 0x1aa = 426 - NO_OP
0x000, // 0x1ab = 427 - NO_OP
0x000, // 0x1ac = 428 - NO_OP
0x000, // 0x1ad = 429 - NO_OP
0x000, // 0x1ae = 430 - NO_OP
0x000, // 0x1af = 431 - NO_OP
0x000, // 0x1b0 = 432 - NO_OP
0x000, // 0x1b1 = 433 - NO_OP
0x000, // 0x1b2 = 434 - NO_OP
0x000, // 0x1b3 = 435 - NO_OP
0x000, // 0x1b4 = 436 - NO_OP
0x000, // 0x1b5 = 437 - NO_OP
0x000, // 0x1b6 = 438 - NO_OP
0x000, // 0x1b7 = 439 - NO_OP
0x000, // 0x1b8 = 440 - NO_OP
0x000, // 0x1b9 = 441 - NO_OP
0x000, // 0x1ba = 442 - NO_OP
0x000, // 0x1bb = 443 - NO_OP
0x000, // 0x1bc = 444 - NO_OP
0x000, // 0x1bd = 445 - NO_OP
0x000, // 0x1be = 446 - NO_OP
0x000, // 0x1bf = 447 - NO_OP
0x000, // 0x1c0 = 448 - NO_OP
0x000, // 0x1c1 = 449 - NO_OP
0x000, // 0x1c2 = 450 - NO_OP
0x000, // 0x1c3 = 451 - NO_OP
0x000, // 0x1c4 = 452 - NO_OP
0x000, // 0x1c5 = 453 - NO_OP
0x000, // 0x1c6 = 454 - NO_OP
0x000, // 0x1c7 = 455 - NO_OP
0x000, // 0x1c8 = 456 - NO_OP
0x000, // 0x1c9 = 457 - NO_OP
0x000, // 0x1ca = 458 - NO_OP
0x000, // 0x1cb = 459 - NO_OP
0x000, // 0x1cc = 460 - NO_OP
0x000, // 0x1cd = 461 - NO_OP
0x000, // 0x1ce = 462 - NO_OP
0x000, // 0x1cf = 463 - NO_OP
0x000, // 0x1d0 = 464 - NO_OP
0x000, // 0x1d1 = 465 - NO_OP
0x000, // 0x1d2 = 466 - NO_OP
0x000, // 0x1d3 = 467 - NO_OP
0x000, // 0x1d4 = 468 - NO_OP
0x000, // 0x1d5 = 469 - NO_OP
0x000, // 0x1d6 = 470 - NO_OP
0x000, // 0x1d7 = 471 - NO_OP
0x000, // 0x1d8 = 472 - NO_OP
0x000, // 0x1d9 = 473 - NO_OP
0x000, // 0x1da = 474 - NO_OP
0x000, // 0x1db = 475 - NO_OP
0x000, // 0x1dc = 476 - NO_OP
0x000, // 0x1dd = 477 - NO_OP
0x000, // 0x1de = 478 - NO_OP
0x000, // 0x1df = 479 - NO_OP
0x000, // 0x1e0 = 480 - NO_OP
0x000, // 0x1e1 = 481 - NO_OP
0x000, // 0x1e2 = 482 - NO_OP
0x000, // 0x1e3 = 483 - NO_OP
0x000, // 0x1e4 = 484 - NO_OP
0x000, // 0x1e5 = 485 - NO_OP
0x000, // 0x1e6 = 486 - NO_OP
0x000, // 0x1e7 = 487 - NO_OP
0x000, // 0x1e8 = 488 - NO_OP
0x000, // 0x1e9 = 489 - NO_OP
0x000, // 0x1ea = 490 - NO_OP
0x000, // 0x1eb = 491 - NO_OP
0x000, // 0x1ec = 492 - NO_OP
0x000, // 0x1ed = 493 - NO_OP
0x000, // 0x1ee = 494 - NO_OP
0x000, // 0x1ef = 495 - NO_OP
0x000, // 0x1f0 = 496 - NO_OP
0x000, // 0x1f1 = 497 - NO_OP
0x000, // 0x1f2 = 498 - NO_OP
0x000, // 0x1f3 = 499 - NO_OP
0x000, // 0x1f4 = 500 - NO_OP
0x000, // 0x1f5 = 501 - NO_OP
0x000, // 0x1f6 = 502 - NO_OP
0x000, // 0x1f7 = 503 - NO_OP
0x000, // 0x1f8 = 504 - NO_OP
0x000, // 0x1f9 = 505 - NO_OP
0x000, // 0x1fa = 506 - NO_OP
0x000, // 0x1fb = 507 - NO_OP
0x000, // 0x1fc = 508 - NO_OP
0x000, // 0x1fd = 509 - NO_OP
0x000, // 0x1fe = 510 - NO_OP
0x000, // 0x1ff = 511 - NO_OP
};

/* for pnr12220.bit  */
bit32 wcsImage12220[] = 
{
 0x00d, // 00000 = 0 - PHY_RESET_START  
 0x0be, // 0x001 = 1 - JUMP_IF_PHY_READY  
 0x009, // 0x002 = 2 -   
 0x0ae, // 0x003 = 3 - JUMP_IF_HARD_RESET_PRIMITIVE  
 0x010, // 0x004 = 4 -   
 0x0af, // 0x005 = 5 - JUMP_IF_IDENTIFY_FRAME_RECEIVED  
 0x01e, // 0x006 = 6 -   
 0x0ff, // 0x007 = 7 - JUMP  
 0x001, // 0x008 = 8 -   
 0x00c, // 0x009 = 9 - SEND_ID_FRAME  
 0x0ae, // 0x00a = 10 - JUMP_IF_HARD_RESET_PRIMITIVE  
 0x010, // 0x00b = 11 -   
 0x0af, // 0x00c = 12 - JUMP_IF_IDENTIFY_FRAME_RECEIVED  
 0x023, // 0x00d = 13 -   
 0x0ff, // 0x00e = 14 - JUMP  
 0x00a, // 0x00f = 15 -   
 0x01c, // 0x010 = 16 - SOFT_RESET  
 0x00d, // 0x011 = 17 - PHY_RESET_START  
 0x0be, // 0x012 = 18 - JUMP_IF_PHY_READY  
 0x016, // 0x013 = 19 -   
 0x0af, // 0x014 = 20 - JUMP_IF_IDENTIFY_FRAME_RECEIVED  
 0x01b, // 0x015 = 21 -   
 0x00c, // 0x016 = 22 - SEND_ID_FRAME  
 0x0af, // 0x017 = 23 - JUMP_IF_IDENTIFY_FRAME_RECEIVED  
 0x023, // 0x018 = 24 -   
 0x0ff, // 0x019 = 25 - JUMP  
 0x017, // 0x01a = 26 -   
 0x00c, // 0x01b = 27 - SEND_ID_FRAME  
 0x0ff, // 0x01c = 28 - JUMP  
 0x023, // 0x01d = 29 -   
 0x0be, // 0x01e = 30 - JUMP_IF_PHY_READY  
 0x022, // 0x01f = 31 -   
 0x0ff, // 0x020 = 32 - JUMP  
 0x01e, // 0x021 = 33 -   
 0x00c, // 0x022 = 34 - SEND_ID_FRAME  
 0x000, // 0x023 = 35 - NO_OP  
 0x000, // 0x024 = 36 - NO_OP  
 0x000, // 0x025 = 37 - NO_OP  
 0x000, // 0x026 = 38 - NO_OP  
 0x000, // 0x027 = 39 - NO_OP  
 0x000, // 0x028 = 40 - NO_OP  
 0x0ff, // 0x029 = 41 - JUMP  
 0x059, // 0x02a = 42 -   
 0x000, // 0x02b = 43 - NO_OP  
 0x0c9, // 0x02c = 44 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT  
 0x056, // 0x02d = 45 -   
 0x0a5, // 0x02e = 46 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_GOOD  
 0x041, // 0x02f = 47 -   
 0x0a6, // 0x030 = 48 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_NAK  
 0x04a, // 0x031 = 49 -   
 0x0a7, // 0x032 = 50 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_ACK_NAK_TIMEOUT  
 0x04d, // 0x033 = 51 -   
 0x0a8, // 0x034 = 52 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_BREAK  
 0x053, // 0x035 = 53 -   
 0x0aa, // 0x036 = 54 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_CREDIT_TIMEOUT  
 0x050, // 0x037 = 55 -   
 0x0c5, // 0x038 = 56 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_SMP_ERR  
 0x053, // 0x039 = 57 -   
 0x0ca, // 0x03a = 58 - JUMP_IF_CLOSE_REQ  
 0x08e, // 0x03b = 59 -   
 0x0be, // 0x03c = 60 - JUMP_IF_PHY_READY  
 0x02c, // 0x03d = 61 -   
 0x01c, // 0x03e = 62 - SOFT_RESET  
 0x0ff, // 0x03f = 63 - JUMP  
 0x001, // 0x040 = 64 -   
 0x01d, // 0x041 = 65 - ADVANCE  
 0x0c3, // 0x042 = 66 - JUMP_IF_SMP_PROTOCOL  
 0x046, // 0x043 = 67 -   
 0x0ff, // 0x044 = 68 - JUMP  
 0x059, // 0x045 = 69 -   
 0x0a2, // 0x046 = 70 - JUMP_IF_CONNECTION_OPEN_MASTER_FLAG_SET  
 0x08e, // 0x047 = 71 -   
 0x0ff, // 0x048 = 72 - JUMP  
 0x059, // 0x049 = 73 -   
 0x01d, // 0x04a = 74 - ADVANCE  
 0x0ff, // 0x04b = 75 - JUMP  
 0x059, // 0x04c = 76 -   
 0x01d, // 0x04d = 77 - ADVANCE  
 0x0ff, // 0x04e = 78 - JUMP  
 0x0ad, // 0x04f = 79 -   
 0x01d, // 0x050 = 80 - ADVANCE  
 0x0ff, // 0x051 = 81 - JUMP  
 0x0b0, // 0x052 = 82 -   
 0x01d, // 0x053 = 83 - ADVANCE  
 0x0ff, // 0x054 = 84 - JUMP  
 0x0a1, // 0x055 = 85 -   
 0x022, // 0x056 = 86 - SEND_CREDIT_BLOCK  
 0x0ff, // 0x057 = 87 - JUMP  
 0x02e, // 0x058 = 88 -   
 0x0c8, // 0x059 = 89 - JUMP_IF_HIP_REQ  
 0x065, // 0x05a = 90 -   
 0x0c6, // 0x05b = 91 - JUMP_IF_SFO_REQ  
 0x06a, // 0x05c = 92 -   
 0x0c7, // 0x05d = 93 - JUMP_IF_DOC_REQ  
 0x06f, // 0x05e = 94 -   
 0x0a3, // 0x05f = 95 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET  
 0x086, // 0x060 = 96 -   
 0x0a2, // 0x061 = 97 - JUMP_IF_CONNECTION_OPEN_MASTER_FLAG_SET  
 0x08e, // 0x062 = 98 -   
 0x0ff, // 0x063 = 99 - JUMP  
 0x059, // 0x064 = 100 -   
 0x020, // 0x065 = 101 - SELECT_HIP  
 0x000, // 0x066 = 102 - NO_OP  
 0x000, // 0x067 = 103 - NO_OP  
 0x0ff, // 0x068 = 104 - JUMP  
 0x072, // 0x069 = 105 -   
 0x01e, // 0x06a = 106 - SELECT_SFO  
 0x000, // 0x06b = 107 - NO_OP  
 0x000, // 0x06c = 108 - NO_OP  
 0x0ff, // 0x06d = 109 - JUMP  
 0x072, // 0x06e = 110 -   
 0x01f, // 0x06f = 111 - SELECT_DOC  
 0x000, // 0x070 = 112 - NO_OP  
 0x000, // 0x071 = 113 - NO_OP  
 0x0a4, // 0x072 = 114 - JUMP_IF_CONNECTION_ACTIVE_SET  
 0x076, // 0x073 = 115 -   
 0x0ff, // 0x074 = 116 - JUMP  
 0x0b3, // 0x075 = 117 -   
 0x0a0, // 0x076 = 118 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL  
 0x07c, // 0x077 = 119 -   
 0x0a3, // 0x078 = 120 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET  
 0x086, // 0x079 = 121 -   
 0x0ff, // 0x07a = 122 - JUMP  
 0x08e, // 0x07b = 123 -   
 0x0cb, // 0x07c = 124 - JUMP_IF_FREEZE_ACTIVE  
 0x081, // 0x07d = 125 -   
 0x013, // 0x07e = 126 - SET_OPEN_STATUS_NORMAL  
 0x0ff, // 0x07f = 127 - JUMP  
 0x02b, // 0x080 = 128 -   
 0x024, // 0x081 = 129 - SET_OPEN_STATUS_FREEZE  
 0x000, // 0x082 = 130 - NO_OP  
 0x000, // 0x083 = 131 - NO_OP  
 0x0ff, // 0x084 = 132 - JUMP  
 0x059, // 0x085 = 133 -   
 0x0c3, // 0x086 = 134 - JUMP_IF_SMP_PROTOCOL  
 0x08a, // 0x087 = 135 -   
 0x0ff, // 0x088 = 136 - JUMP  
 0x08e, // 0x089 = 137 -   
 0x0c4, // 0x08a = 138 - JUMP_IF_SMP_FRAME_ERR_RECEIVED  
 0x0a1, // 0x08b = 139 -   
 0x0ff, // 0x08c = 140 - JUMP  
 0x059, // 0x08d = 141 -   
 0x004, // 0x08e = 142 - CLOSE_NORMAL  
 0x000, // 0x08f = 143 - NO_OP  
 0x000, // 0x090 = 144 - NO_OP  
 0x000, // 0x091 = 145 - NO_OP  
 0x000, // 0x092 = 146 - NO_OP  
 0x0c9, // 0x093 = 147 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT  
 0x09e, // 0x094 = 148 -   
 0x0c0, // 0x095 = 149 - JUMP_IF_CLOSE_STATUS_EQUAL_ANY  
 0x059, // 0x096 = 150 -   
 0x0bc, // 0x097 = 151 - JUMP_IF_BREAK_RECEIVED  
 0x0a1, // 0x098 = 152 -   
 0x0be, // 0x099 = 153 - JUMP_IF_PHY_READY  
 0x08f, // 0x09a = 154 -   
 0x01c, // 0x09b = 155 - SOFT_RESET  
 0x0ff, // 0x09c = 156 - JUMP  
 0x001, // 0x09d = 157 -   
 0x022, // 0x09e = 158 - SEND_CREDIT_BLOCK  
 0x0ff, // 0x09f = 159 - JUMP  
 0x08f, // 0x0a0 = 160 -   
 0x007, // 0x0a1 = 161 - CLOSE_BREAK  
 0x000, // 0x0a2 = 162 - NO_OP  
 0x000, // 0x0a3 = 163 - NO_OP  
 0x000, // 0x0a4 = 164 - NO_OP  
 0x000, // 0x0a5 = 165 - NO_OP  
 0x0c0, // 0x0a6 = 166 - JUMP_IF_CLOSE_STATUS_EQUAL_ANY  
 0x059, // 0x0a7 = 167 -   
 0x0be, // 0x0a8 = 168 - JUMP_IF_PHY_READY  
 0x0a2, // 0x0a9 = 169 -   
 0x01c, // 0x0aa = 170 - SOFT_RESET  
 0x0ff, // 0x0ab = 171 - JUMP  
 0x001, // 0x0ac = 172 -   
 0x005, // 0x0ad = 173 - CLOSE_ACK_NAK_TIMEOUT  
 0x0ff, // 0x0ae = 174 - JUMP  
 0x08f, // 0x0af = 175 -   
 0x006, // 0x0b0 = 176 - CLOSE_CREDIT_TIMEOUT  
 0x0ff, // 0x0b1 = 177 - JUMP  
 0x08f, // 0x0b2 = 178 -   
 0x0cc, // 0x0b3 = 179 - JUMP_IF_RX_BUFFER_FULL  
 0x059, // 0x0b4 = 180 -   
 0x0b0, // 0x0b5 = 181 - JUMP_IF_FLAG_0_SET  
 0x0ba, // 0x0b6 = 182 -   
 0x011, // 0x0b7 = 183 - START_IT_NEXUS_LOSS_TIMER  
 0x00f, // 0x0b8 = 184 - PATHWAY_BLOCKED_CNT_RESET  
 0x00e, // 0x0b9 = 185 - START_ARB_WAIT_TIMER  
 0x0cb, // 0x0ba = 186 - JUMP_IF_FREEZE_ACTIVE  
 0x0fb, // 0x0bb = 187 -   
 0x001, // 0x0bc = 188 - OPEN_REQUEST  
 0x000, // 0x0bd = 189 - NO_OP  
 0x000, // 0x0be = 190 - NO_OP  
 0x000, // 0x0bf = 191 - NO_OP  
 0x000, // 0x0c0 = 192 - NO_OP  
 0x090, // 0x0c1 = 193 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_ACCEPT  
 0x0e7, // 0x0c2 = 194 -   
 0x095, // 0x0c3 = 195 - JUMP_IF_OPEN_STATUS_EQUAL_RATE_NOT_SUPPORTED  
 0x0ec, // 0x0c4 = 196 -   
 0x099, // 0x0c5 = 197 - JUMP_IF_OPEN_STATUS_EQUAL_PROTOCOL_NOT_SUPPORTED  
 0x0ef, // 0x0c6 = 198 -   
 0x09b, // 0x0c7 = 199 - JUMP_IF_OPEN_STATUS_EQUAL_WRONG_DESTINATION  
 0x0f2, // 0x0c8 = 200 -   
 0x094, // 0x0c9 = 201 - JUMP_IF_OPEN_STATUS_EQUAL_BREAK_RECEIVED  
 0x0ba, // 0x0ca = 202 -   
 0x093, // 0x0cb = 203 - JUMP_IF_OPEN_STATUS_EQUAL_BAD_DESTINATION  
 0x0f5, // 0x0cc = 204 -   
 0x09f, // 0x0cd = 205 - JUMP_IF_IT_NEXUS_LOSS_TIMEOUT  
 0x0f8, // 0x0ce = 206 -   
 0x09a, // 0x0cf = 207 - JUMP_IF_OPEN_STATUS_EQUAL_STP_RESOURCE_BUSY  
 0x0ba, // 0x0d0 = 208 -   
 0x096, // 0x0d1 = 209 - JUMP_IF_OPEN_STATUS_EQUAL_NO_DESTINATION  
 0x0f5, // 0x0d2 = 210 -   
 0x097, // 0x0d3 = 211 - JUMP_IF_OPEN_STATUS_EQUAL_PATHWAY_BLOCKED  
 0x100, // 0x0d4 = 212 -   
 0x098, // 0x0d5 = 213 - JUMP_IF_OPEN_STATUS_EQUAL_RETRY  
 0x0ba, // 0x0d6 = 214 -   
 0x092, // 0x0d7 = 215 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_TIMEOUT  
 0x0ba, // 0x0d8 = 216 -   
 0x0a4, // 0x0d9 = 217 - JUMP_IF_CONNECTION_ACTIVE_SET  
 0x0e1, // 0x0da = 218 -   
 0x0be, // 0x0db = 219 - JUMP_IF_PHY_READY  
 0x0c1, // 0x0dc = 220 -   
 0x01b, // 0x0dd = 221 - SET_OPEN_STATUS_PHY_NOT_RDY  
 0x01c, // 0x0de = 222 - SOFT_RESET  
 0x0ff, // 0x0df = 223 - JUMP  
 0x001, // 0x0e0 = 224 -   
 0x0a0, // 0x0e1 = 225 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL  
 0x0e7, // 0x0e2 = 226 -   
 0x000, // 0x0e3 = 227 - NO_OP  
 0x000, // 0x0e4 = 228 - NO_OP  
 0x0ff, // 0x0e5 = 229 - JUMP  
 0x086, // 0x0e6 = 230 -   
 0x013, // 0x0e7 = 231 - SET_OPEN_STATUS_NORMAL  
 0x000, // 0x0e8 = 232 - NO_OP  
 0x000, // 0x0e9 = 233 - NO_OP  
 0x0ff, // 0x0ea = 234 - JUMP  
 0x02b, // 0x0eb = 235 -   
 0x017, // 0x0ec = 236 - SET_OPEN_STATUS_BAD_RATE  
 0x0ff, // 0x0ed = 237 - JUMP  
 0x0fc, // 0x0ee = 238 -   
 0x018, // 0x0ef = 239 - SET_OPEN_STATUS_BAD_PROTOCOL  
 0x0ff, // 0x0f0 = 240 - JUMP  
 0x0fc, // 0x0f1 = 241 -   
 0x01a, // 0x0f2 = 242 - SET_OPEN_STATUS_WRONG_DEST  
 0x0ff, // 0x0f3 = 243 - JUMP  
 0x0fc, // 0x0f4 = 244 -   
 0x015, // 0x0f5 = 245 - SET_OPEN_STATUS_BAD_DEST  
 0x0ff, // 0x0f6 = 246 - JUMP  
 0x0fc, // 0x0f7 = 247 -   
 0x014, // 0x0f8 = 248 - SET_OPEN_STATUS_IT_NEXUS_LOSS  
 0x0ff, // 0x0f9 = 249 - JUMP  
 0x0fc, // 0x0fa = 250 -   
 0x024, // 0x0fb = 251 - SET_OPEN_STATUS_FREEZE  
 0x000, // 0x0fc = 252 - NO_OP  
 0x000, // 0x0fd = 253 - NO_OP  
 0x0ff, // 0x0fe = 254 - JUMP  
 0x059, // 0x0ff = 255 -   
 0x010, // 0x100 = 256 - PATHWAY_BLOCKED_CNT_INC  
 0x0ff, // 0x101 = 257 - JUMP  
 0x0ba, // 0x102 = 258 -   
 0x000, // 0x103 = 259 - NO_OP  
 0x000, // 0x104 = 260 - NO_OP  
 0x000, // 0x105 = 261 - NO_OP  
 0x000, // 0x106 = 262 - NO_OP  
 0x000, // 0x107 = 263 - NO_OP  
 0x000, // 0x108 = 264 - NO_OP  
 0x000, // 0x109 = 265 - NO_OP  
 0x000, // 0x10a = 266 - NO_OP  
 0x000, // 0x10b = 267 - NO_OP  
 0x000, // 0x10c = 268 - NO_OP  
 0x000, // 0x10d = 269 - NO_OP  
 0x000, // 0x10e = 270 - NO_OP  
 0x000, // 0x10f = 271 - NO_OP  
 0x000, // 0x110 = 272 - NO_OP  
 0x000, // 0x111 = 273 - NO_OP  
 0x000, // 0x112 = 274 - NO_OP  
 0x000, // 0x113 = 275 - NO_OP  
 0x000, // 0x114 = 276 - NO_OP  
 0x000, // 0x115 = 277 - NO_OP  
 0x000, // 0x116 = 278 - NO_OP  
 0x000, // 0x117 = 279 - NO_OP  
 0x000, // 0x118 = 280 - NO_OP  
 0x000, // 0x119 = 281 - NO_OP  
 0x000, // 0x11a = 282 - NO_OP  
 0x000, // 0x11b = 283 - NO_OP  
 0x000, // 0x11c = 284 - NO_OP  
 0x000, // 0x11d = 285 - NO_OP  
 0x000, // 0x11e = 286 - NO_OP  
 0x000, // 0x11f = 287 - NO_OP  
 0x000, // 0x120 = 288 - NO_OP  
 0x000, // 0x121 = 289 - NO_OP  
 0x000, // 0x122 = 290 - NO_OP  
 0x000, // 0x123 = 291 - NO_OP  
 0x000, // 0x124 = 292 - NO_OP  
 0x000, // 0x125 = 293 - NO_OP  
 0x000, // 0x126 = 294 - NO_OP  
 0x000, // 0x127 = 295 - NO_OP  
 0x000, // 0x128 = 296 - NO_OP  
 0x000, // 0x129 = 297 - NO_OP  
 0x000, // 0x12a = 298 - NO_OP  
 0x000, // 0x12b = 299 - NO_OP  
 0x000, // 0x12c = 300 - NO_OP  
 0x000, // 0x12d = 301 - NO_OP  
 0x000, // 0x12e = 302 - NO_OP  
 0x000, // 0x12f = 303 - NO_OP  
 0x000, // 0x130 = 304 - NO_OP  
 0x000, // 0x131 = 305 - NO_OP  
 0x000, // 0x132 = 306 - NO_OP  
 0x000, // 0x133 = 307 - NO_OP  
 0x000, // 0x134 = 308 - NO_OP  
 0x000, // 0x135 = 309 - NO_OP  
 0x000, // 0x136 = 310 - NO_OP  
 0x000, // 0x137 = 311 - NO_OP  
 0x000, // 0x138 = 312 - NO_OP  
 0x000, // 0x139 = 313 - NO_OP  
 0x000, // 0x13a = 314 - NO_OP  
 0x000, // 0x13b = 315 - NO_OP  
 0x000, // 0x13c = 316 - NO_OP  
 0x000, // 0x13d = 317 - NO_OP  
 0x000, // 0x13e = 318 - NO_OP  
 0x000, // 0x13f = 319 - NO_OP  
 0x000, // 0x140 = 320 - NO_OP  
 0x000, // 0x141 = 321 - NO_OP  
 0x000, // 0x142 = 322 - NO_OP  
 0x000, // 0x143 = 323 - NO_OP  
 0x000, // 0x144 = 324 - NO_OP  
 0x000, // 0x145 = 325 - NO_OP  
 0x000, // 0x146 = 326 - NO_OP  
 0x000, // 0x147 = 327 - NO_OP  
 0x000, // 0x148 = 328 - NO_OP  
 0x000, // 0x149 = 329 - NO_OP  
 0x000, // 0x14a = 330 - NO_OP  
 0x000, // 0x14b = 331 - NO_OP  
 0x000, // 0x14c = 332 - NO_OP  
 0x000, // 0x14d = 333 - NO_OP  
 0x000, // 0x14e = 334 - NO_OP  
 0x000, // 0x14f = 335 - NO_OP  
 0x000, // 0x150 = 336 - NO_OP  
 0x000, // 0x151 = 337 - NO_OP  
 0x000, // 0x152 = 338 - NO_OP  
 0x000, // 0x153 = 339 - NO_OP  
 0x000, // 0x154 = 340 - NO_OP  
 0x000, // 0x155 = 341 - NO_OP  
 0x000, // 0x156 = 342 - NO_OP  
 0x000, // 0x157 = 343 - NO_OP  
 0x000, // 0x158 = 344 - NO_OP  
 0x000, // 0x159 = 345 - NO_OP  
 0x000, // 0x15a = 346 - NO_OP  
 0x000, // 0x15b = 347 - NO_OP  
 0x000, // 0x15c = 348 - NO_OP  
 0x000, // 0x15d = 349 - NO_OP  
 0x000, // 0x15e = 350 - NO_OP  
 0x000, // 0x15f = 351 - NO_OP  
 0x000, // 0x160 = 352 - NO_OP  
 0x000, // 0x161 = 353 - NO_OP  
 0x000, // 0x162 = 354 - NO_OP  
 0x000, // 0x163 = 355 - NO_OP  
 0x000, // 0x164 = 356 - NO_OP  
 0x000, // 0x165 = 357 - NO_OP  
 0x000, // 0x166 = 358 - NO_OP  
 0x000, // 0x167 = 359 - NO_OP  
 0x000, // 0x168 = 360 - NO_OP  
 0x000, // 0x169 = 361 - NO_OP  
 0x000, // 0x16a = 362 - NO_OP  
 0x000, // 0x16b = 363 - NO_OP  
 0x000, // 0x16c = 364 - NO_OP  
 0x000, // 0x16d = 365 - NO_OP  
 0x000, // 0x16e = 366 - NO_OP  
 0x000, // 0x16f = 367 - NO_OP  
 0x000, // 0x170 = 368 - NO_OP  
 0x000, // 0x171 = 369 - NO_OP  
 0x000, // 0x172 = 370 - NO_OP  
 0x000, // 0x173 = 371 - NO_OP  
 0x000, // 0x174 = 372 - NO_OP  
 0x000, // 0x175 = 373 - NO_OP  
 0x000, // 0x176 = 374 - NO_OP  
 0x000, // 0x177 = 375 - NO_OP  
 0x000, // 0x178 = 376 - NO_OP  
 0x000, // 0x179 = 377 - NO_OP  
 0x000, // 0x17a = 378 - NO_OP  
 0x000, // 0x17b = 379 - NO_OP  
 0x000, // 0x17c = 380 - NO_OP  
 0x000, // 0x17d = 381 - NO_OP  
 0x000, // 0x17e = 382 - NO_OP  
 0x000, // 0x17f = 383 - NO_OP  
 0x000, // 0x180 = 384 - NO_OP  
 0x000, // 0x181 = 385 - NO_OP  
 0x000, // 0x182 = 386 - NO_OP  
 0x000, // 0x183 = 387 - NO_OP  
 0x000, // 0x184 = 388 - NO_OP  
 0x000, // 0x185 = 389 - NO_OP  
 0x000, // 0x186 = 390 - NO_OP  
 0x000, // 0x187 = 391 - NO_OP  
 0x000, // 0x188 = 392 - NO_OP  
 0x000, // 0x189 = 393 - NO_OP  
 0x000, // 0x18a = 394 - NO_OP  
 0x000, // 0x18b = 395 - NO_OP  
 0x000, // 0x18c = 396 - NO_OP  
 0x000, // 0x18d = 397 - NO_OP  
 0x000, // 0x18e = 398 - NO_OP  
 0x000, // 0x18f = 399 - NO_OP  
 0x000, // 0x190 = 400 - NO_OP  
 0x000, // 0x191 = 401 - NO_OP  
 0x000, // 0x192 = 402 - NO_OP  
 0x000, // 0x193 = 403 - NO_OP  
 0x000, // 0x194 = 404 - NO_OP  
 0x000, // 0x195 = 405 - NO_OP  
 0x000, // 0x196 = 406 - NO_OP  
 0x000, // 0x197 = 407 - NO_OP  
 0x000, // 0x198 = 408 - NO_OP  
 0x000, // 0x199 = 409 - NO_OP  
 0x000, // 0x19a = 410 - NO_OP  
 0x000, // 0x19b = 411 - NO_OP  
 0x000, // 0x19c = 412 - NO_OP  
 0x000, // 0x19d = 413 - NO_OP  
 0x000, // 0x19e = 414 - NO_OP  
 0x000, // 0x19f = 415 - NO_OP  
 0x000, // 0x1a0 = 416 - NO_OP  
 0x000, // 0x1a1 = 417 - NO_OP  
 0x000, // 0x1a2 = 418 - NO_OP  
 0x000, // 0x1a3 = 419 - NO_OP  
 0x000, // 0x1a4 = 420 - NO_OP  
 0x000, // 0x1a5 = 421 - NO_OP  
 0x000, // 0x1a6 = 422 - NO_OP  
 0x000, // 0x1a7 = 423 - NO_OP  
 0x000, // 0x1a8 = 424 - NO_OP  
 0x000, // 0x1a9 = 425 - NO_OP  
 0x000, // 0x1aa = 426 - NO_OP  
 0x000, // 0x1ab = 427 - NO_OP  
 0x000, // 0x1ac = 428 - NO_OP  
 0x000, // 0x1ad = 429 - NO_OP  
 0x000, // 0x1ae = 430 - NO_OP  
 0x000, // 0x1af = 431 - NO_OP  
 0x000, // 0x1b0 = 432 - NO_OP  
 0x000, // 0x1b1 = 433 - NO_OP  
 0x000, // 0x1b2 = 434 - NO_OP  
 0x000, // 0x1b3 = 435 - NO_OP  
 0x000, // 0x1b4 = 436 - NO_OP  
 0x000, // 0x1b5 = 437 - NO_OP  
 0x000, // 0x1b6 = 438 - NO_OP  
 0x000, // 0x1b7 = 439 - NO_OP  
 0x000, // 0x1b8 = 440 - NO_OP  
 0x000, // 0x1b9 = 441 - NO_OP  
 0x000, // 0x1ba = 442 - NO_OP  
 0x000, // 0x1bb = 443 - NO_OP  
 0x000, // 0x1bc = 444 - NO_OP  
 0x000, // 0x1bd = 445 - NO_OP  
 0x000, // 0x1be = 446 - NO_OP  
 0x000, // 0x1bf = 447 - NO_OP  
 0x000, // 0x1c0 = 448 - NO_OP  
 0x000, // 0x1c1 = 449 - NO_OP  
 0x000, // 0x1c2 = 450 - NO_OP  
 0x000, // 0x1c3 = 451 - NO_OP  
 0x000, // 0x1c4 = 452 - NO_OP  
 0x000, // 0x1c5 = 453 - NO_OP  
 0x000, // 0x1c6 = 454 - NO_OP  
 0x000, // 0x1c7 = 455 - NO_OP  
 0x000, // 0x1c8 = 456 - NO_OP  
 0x000, // 0x1c9 = 457 - NO_OP  
 0x000, // 0x1ca = 458 - NO_OP  
 0x000, // 0x1cb = 459 - NO_OP  
 0x000, // 0x1cc = 460 - NO_OP  
 0x000, // 0x1cd = 461 - NO_OP  
 0x000, // 0x1ce = 462 - NO_OP  
 0x000, // 0x1cf = 463 - NO_OP  
 0x000, // 0x1d0 = 464 - NO_OP  
 0x000, // 0x1d1 = 465 - NO_OP  
 0x000, // 0x1d2 = 466 - NO_OP  
 0x000, // 0x1d3 = 467 - NO_OP  
 0x000, // 0x1d4 = 468 - NO_OP  
 0x000, // 0x1d5 = 469 - NO_OP  
 0x000, // 0x1d6 = 470 - NO_OP  
 0x000, // 0x1d7 = 471 - NO_OP  
 0x000, // 0x1d8 = 472 - NO_OP  
 0x000, // 0x1d9 = 473 - NO_OP  
 0x000, // 0x1da = 474 - NO_OP  
 0x000, // 0x1db = 475 - NO_OP  
 0x000, // 0x1dc = 476 - NO_OP  
 0x000, // 0x1dd = 477 - NO_OP  
 0x000, // 0x1de = 478 - NO_OP  
 0x000, // 0x1df = 479 - NO_OP  
 0x000, // 0x1e0 = 480 - NO_OP  
 0x000, // 0x1e1 = 481 - NO_OP  
 0x000, // 0x1e2 = 482 - NO_OP  
 0x000, // 0x1e3 = 483 - NO_OP  
 0x000, // 0x1e4 = 484 - NO_OP  
 0x000, // 0x1e5 = 485 - NO_OP  
 0x000, // 0x1e6 = 486 - NO_OP  
 0x000, // 0x1e7 = 487 - NO_OP  
 0x000, // 0x1e8 = 488 - NO_OP  
 0x000, // 0x1e9 = 489 - NO_OP  
 0x000, // 0x1ea = 490 - NO_OP  
 0x000, // 0x1eb = 491 - NO_OP  
 0x000, // 0x1ec = 492 - NO_OP  
 0x000, // 0x1ed = 493 - NO_OP  
 0x000, // 0x1ee = 494 - NO_OP  
 0x000, // 0x1ef = 495 - NO_OP  
 0x000, // 0x1f0 = 496 - NO_OP  
 0x000, // 0x1f1 = 497 - NO_OP  
 0x000, // 0x1f2 = 498 - NO_OP  
 0x000, // 0x1f3 = 499 - NO_OP  
 0x000, // 0x1f4 = 500 - NO_OP  
 0x000, // 0x1f5 = 501 - NO_OP  
 0x000, // 0x1f6 = 502 - NO_OP  
 0x000, // 0x1f7 = 503 - NO_OP  
 0x000, // 0x1f8 = 504 - NO_OP  
 0x000, // 0x1f9 = 505 - NO_OP  
 0x000, // 0x1fa = 506 - NO_OP  
 0x000, // 0x1fb = 507 - NO_OP  
 0x000, // 0x1fc = 508 - NO_OP  
 0x000, // 0x1fd = 509 - NO_OP  
 0x000, // 0x1fe = 510 - NO_OP  
 0x000 // 0x1ff = 511 - NO_OP  
};

/* WCS 022406 */
bit32 wcsImage022406[] = 
{
0x00d, // 00000 = 0 - PHY_RESET_START
0x0be, // 0x001 = 1 - JUMP_IF_PHY_READY
0x009, // 0x002 = 2 - 
0x0ae, // 0x003 = 3 - JUMP_IF_HARD_RESET_PRIMITIVE
0x010, // 0x004 = 4 - 
0x0af, // 0x005 = 5 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x01e, // 0x006 = 6 - 
0x0ff, // 0x007 = 7 - JUMP
0x001, // 0x008 = 8 - 
0x00c, // 0x009 = 9 - SEND_ID_FRAME
0x0ae, // 0x00a = 10 - JUMP_IF_HARD_RESET_PRIMITIVE
0x010, // 0x00b = 11 - 
0x0af, // 0x00c = 12 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x023, // 0x00d = 13 - 
0x0ff, // 0x00e = 14 - JUMP
0x00a, // 0x00f = 15 - 
0x01c, // 0x010 = 16 - SOFT_RESET
0x00d, // 0x011 = 17 - PHY_RESET_START
0x0be, // 0x012 = 18 - JUMP_IF_PHY_READY
0x016, // 0x013 = 19 - 
0x0af, // 0x014 = 20 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x01b, // 0x015 = 21 - 
0x00c, // 0x016 = 22 - SEND_ID_FRAME
0x0af, // 0x017 = 23 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x023, // 0x018 = 24 - 
0x0ff, // 0x019 = 25 - JUMP
0x017, // 0x01a = 26 - 
0x00c, // 0x01b = 27 - SEND_ID_FRAME
0x0ff, // 0x01c = 28 - JUMP
0x023, // 0x01d = 29 - 
0x0be, // 0x01e = 30 - JUMP_IF_PHY_READY
0x022, // 0x01f = 31 - 
0x0ff, // 0x020 = 32 - JUMP
0x01e, // 0x021 = 33 - 
0x00c, // 0x022 = 34 - SEND_ID_FRAME
0x000, // 0x023 = 35 - NO_OP
0x000, // 0x024 = 36 - NO_OP
0x000, // 0x025 = 37 - NO_OP
0x000, // 0x026 = 38 - NO_OP
0x000, // 0x027 = 39 - NO_OP
0x000, // 0x028 = 40 - NO_OP
0x0ff, // 0x029 = 41 - JUMP
0x055, // 0x02a = 42 - 
0x000, // 0x02b = 43 - NO_OP
0x0c9, // 0x02c = 44 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x052, // 0x02d = 45 - 
0x0a5, // 0x02e = 46 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_GOOD
0x041, // 0x02f = 47 - 
0x0a6, // 0x030 = 48 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_NAK
0x046, // 0x031 = 49 - 
0x0a7, // 0x032 = 50 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_ACK_NAK_TIMEOUT
0x049, // 0x033 = 51 - 
0x0a8, // 0x034 = 52 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_BREAK
0x04f, // 0x035 = 53 - 
0x0aa, // 0x036 = 54 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_CREDIT_TIMEOUT
0x04c, // 0x037 = 55 - 
0x0c5, // 0x038 = 56 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_SMP_ERR
0x04f, // 0x039 = 57 - 
0x0ca, // 0x03a = 58 - JUMP_IF_CLOSE_REQ
0x08a, // 0x03b = 59 - 
0x0be, // 0x03c = 60 - JUMP_IF_PHY_READY
0x02c, // 0x03d = 61 - 
0x01c, // 0x03e = 62 - SOFT_RESET
0x0ff, // 0x03f = 63 - JUMP
0x001, // 0x040 = 64 - 
0x01d, // 0x041 = 65 - ADVANCE
0x0c3, // 0x042 = 66 - JUMP_IF_SMP_PROTOCOL
0x08a, // 0x043 = 67 - 
0x0ff, // 0x044 = 68 - JUMP
0x055, // 0x045 = 69 - 
0x01d, // 0x046 = 70 - ADVANCE
0x0ff, // 0x047 = 71 - JUMP
0x055, // 0x048 = 72 - 
0x01d, // 0x049 = 73 - ADVANCE
0x0ff, // 0x04a = 74 - JUMP
0x0a9, // 0x04b = 75 - 
0x01d, // 0x04c = 76 - ADVANCE
0x0ff, // 0x04d = 77 - JUMP
0x0ac, // 0x04e = 78 - 
0x01d, // 0x04f = 79 - ADVANCE
0x0ff, // 0x050 = 80 - JUMP
0x09d, // 0x051 = 81 - 
0x022, // 0x052 = 82 - SEND_CREDIT_BLOCK
0x0ff, // 0x053 = 83 - JUMP
0x02e, // 0x054 = 84 - 
0x0c8, // 0x055 = 85 - JUMP_IF_HIP_REQ
0x061, // 0x056 = 86 - 
0x0c6, // 0x057 = 87 - JUMP_IF_SFO_REQ
0x066, // 0x058 = 88 - 
0x0c7, // 0x059 = 89 - JUMP_IF_DOC_REQ
0x06b, // 0x05a = 90 - 
0x0a3, // 0x05b = 91 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
0x082, // 0x05c = 92 - 
0x0a2, // 0x05d = 93 - JUMP_IF_CONNECTION_OPEN_MASTER_FLAG_SET
0x08a, // 0x05e = 94 - 
0x0ff, // 0x05f = 95 - JUMP
0x055, // 0x060 = 96 - 
0x020, // 0x061 = 97 - SELECT_HIP
0x000, // 0x062 = 98 - NO_OP
0x000, // 0x063 = 99 - NO_OP
0x0ff, // 0x064 = 100 - JUMP
0x06e, // 0x065 = 101 - 
0x01e, // 0x066 = 102 - SELECT_SFO
0x000, // 0x067 = 103 - NO_OP
0x000, // 0x068 = 104 - NO_OP
0x0ff, // 0x069 = 105 - JUMP
0x06e, // 0x06a = 106 - 
0x01f, // 0x06b = 107 - SELECT_DOC
0x000, // 0x06c = 108 - NO_OP
0x000, // 0x06d = 109 - NO_OP
0x0a4, // 0x06e = 110 - JUMP_IF_CONNECTION_ACTIVE_SET
0x072, // 0x06f = 111 - 
0x0ff, // 0x070 = 112 - JUMP
0x0af, // 0x071 = 113 - 
0x0a0, // 0x072 = 114 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL
0x078, // 0x073 = 115 - 
0x0a3, // 0x074 = 116 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
0x082, // 0x075 = 117 - 
0x0ff, // 0x076 = 118 - JUMP
0x08a, // 0x077 = 119 - 
0x0cb, // 0x078 = 120 - JUMP_IF_FREEZE_ACTIVE
0x07d, // 0x079 = 121 - 
0x013, // 0x07a = 122 - SET_OPEN_STATUS_NORMAL
0x0ff, // 0x07b = 123 - JUMP
0x02b, // 0x07c = 124 - 
0x024, // 0x07d = 125 - SET_OPEN_STATUS_FREEZE
0x000, // 0x07e = 126 - NO_OP
0x000, // 0x07f = 127 - NO_OP
0x0ff, // 0x080 = 128 - JUMP
0x055, // 0x081 = 129 - 
0x0c3, // 0x082 = 130 - JUMP_IF_SMP_PROTOCOL
0x086, // 0x083 = 131 - 
0x0ff, // 0x084 = 132 - JUMP
0x08a, // 0x085 = 133 - 
0x0c4, // 0x086 = 134 - JUMP_IF_SMP_FRAME_ERR_RECEIVED
0x09d, // 0x087 = 135 - 
0x0ff, // 0x088 = 136 - JUMP
0x055, // 0x089 = 137 - 
0x004, // 0x08a = 138 - CLOSE_NORMAL
0x000, // 0x08b = 139 - NO_OP
0x000, // 0x08c = 140 - NO_OP
0x000, // 0x08d = 141 - NO_OP
0x000, // 0x08e = 142 - NO_OP
0x0c9, // 0x08f = 143 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x09a, // 0x090 = 144 - 
0x0c0, // 0x091 = 145 - JUMP_IF_CLOSE_STATUS_EQUAL_ANY
0x055, // 0x092 = 146 - 
0x0bc, // 0x093 = 147 - JUMP_IF_BREAK_RECEIVED
0x09d, // 0x094 = 148 - 
0x0be, // 0x095 = 149 - JUMP_IF_PHY_READY
0x08b, // 0x096 = 150 - 
0x01c, // 0x097 = 151 - SOFT_RESET
0x0ff, // 0x098 = 152 - JUMP
0x001, // 0x099 = 153 - 
0x022, // 0x09a = 154 - SEND_CREDIT_BLOCK
0x0ff, // 0x09b = 155 - JUMP
0x08b, // 0x09c = 156 - 
0x007, // 0x09d = 157 - CLOSE_BREAK
0x000, // 0x09e = 158 - NO_OP
0x000, // 0x09f = 159 - NO_OP
0x000, // 0x0a0 = 160 - NO_OP
0x000, // 0x0a1 = 161 - NO_OP
0x0c0, // 0x0a2 = 162 - JUMP_IF_CLOSE_STATUS_EQUAL_ANY
0x055, // 0x0a3 = 163 - 
0x0be, // 0x0a4 = 164 - JUMP_IF_PHY_READY
0x09e, // 0x0a5 = 165 - 
0x01c, // 0x0a6 = 166 - SOFT_RESET
0x0ff, // 0x0a7 = 167 - JUMP
0x001, // 0x0a8 = 168 - 
0x005, // 0x0a9 = 169 - CLOSE_ACK_NAK_TIMEOUT
0x0ff, // 0x0aa = 170 - JUMP
0x08b, // 0x0ab = 171 - 
0x006, // 0x0ac = 172 - CLOSE_CREDIT_TIMEOUT
0x0ff, // 0x0ad = 173 - JUMP
0x08b, // 0x0ae = 174 - 
0x0cc, // 0x0af = 175 - JUMP_IF_RX_BUFFER_FULL
0x055, // 0x0b0 = 176 - 
0x0b7, // 0x0b1 = 177 - JUMP_IF_FLAG_7_SET
0x0b6, // 0x0b2 = 178 - 
0x011, // 0x0b3 = 179 - START_IT_NEXUS_LOSS_TIMER
0x00f, // 0x0b4 = 180 - PATHWAY_BLOCKED_CNT_RESET
0x00e, // 0x0b5 = 181 - START_ARB_WAIT_TIMER
0x0cb, // 0x0b6 = 182 - JUMP_IF_FREEZE_ACTIVE
0x0f9, // 0x0b7 = 183 - 
0x001, // 0x0b8 = 184 - OPEN_REQUEST
0x080, // 0x0b9 = 185 - SET_FLAG
0x080, // 0x0ba = 186 - 
0x000, // 0x0bb = 187 - NO_OP
0x000, // 0x0bc = 188 - NO_OP
0x000, // 0x0bd = 189 - NO_OP
0x090, // 0x0be = 190 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_ACCEPT
0x0e4, // 0x0bf = 191 - 
0x095, // 0x0c0 = 192 - JUMP_IF_OPEN_STATUS_EQUAL_RATE_NOT_SUPPORTED
0x0ea, // 0x0c1 = 193 - 
0x099, // 0x0c2 = 194 - JUMP_IF_OPEN_STATUS_EQUAL_PROTOCOL_NOT_SUPPORTED
0x0ed, // 0x0c3 = 195 - 
0x09b, // 0x0c4 = 196 - JUMP_IF_OPEN_STATUS_EQUAL_WRONG_DESTINATION
0x0f0, // 0x0c5 = 197 - 
0x094, // 0x0c6 = 198 - JUMP_IF_OPEN_STATUS_EQUAL_BREAK_RECEIVED
0x0b6, // 0x0c7 = 199 - 
0x093, // 0x0c8 = 200 - JUMP_IF_OPEN_STATUS_EQUAL_BAD_DESTINATION
0x0f3, // 0x0c9 = 201 - 
0x09f, // 0x0ca = 202 - JUMP_IF_IT_NEXUS_LOSS_TIMEOUT
0x0f6, // 0x0cb = 203 - 
0x09a, // 0x0cc = 204 - JUMP_IF_OPEN_STATUS_EQUAL_STP_RESOURCE_BUSY
0x0b6, // 0x0cd = 205 - 
0x096, // 0x0ce = 206 - JUMP_IF_OPEN_STATUS_EQUAL_NO_DESTINATION
0x0f3, // 0x0cf = 207 - 
0x097, // 0x0d0 = 208 - JUMP_IF_OPEN_STATUS_EQUAL_PATHWAY_BLOCKED
0x0fe, // 0x0d1 = 209 - 
0x098, // 0x0d2 = 210 - JUMP_IF_OPEN_STATUS_EQUAL_RETRY
0x0b6, // 0x0d3 = 211 - 
0x092, // 0x0d4 = 212 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_TIMEOUT
0x0b6, // 0x0d5 = 213 - 
0x0a4, // 0x0d6 = 214 - JUMP_IF_CONNECTION_ACTIVE_SET
0x0de, // 0x0d7 = 215 - 
0x0be, // 0x0d8 = 216 - JUMP_IF_PHY_READY
0x0be, // 0x0d9 = 217 - 
0x01b, // 0x0da = 218 - SET_OPEN_STATUS_PHY_NOT_RDY
0x01c, // 0x0db = 219 - SOFT_RESET
0x0ff, // 0x0dc = 220 - JUMP
0x001, // 0x0dd = 221 - 
0x0a0, // 0x0de = 222 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL
0x0e4, // 0x0df = 223 - 
0x000, // 0x0e0 = 224 - NO_OP
0x000, // 0x0e1 = 225 - NO_OP
0x0ff, // 0x0e2 = 226 - JUMP
0x082, // 0x0e3 = 227 - 
0x013, // 0x0e4 = 228 - SET_OPEN_STATUS_NORMAL
0x081, // 0x0e5 = 229 - CLEAR_FLAG
0x080, // 0x0e6 = 230 - 
0x000, // 0x0e7 = 231 - NO_OP
0x0ff, // 0x0e8 = 232 - JUMP
0x02b, // 0x0e9 = 233 - 
0x017, // 0x0ea = 234 - SET_OPEN_STATUS_BAD_RATE
0x0ff, // 0x0eb = 235 - JUMP
0x0fa, // 0x0ec = 236 - 
0x018, // 0x0ed = 237 - SET_OPEN_STATUS_BAD_PROTOCOL
0x0ff, // 0x0ee = 238 - JUMP
0x0fa, // 0x0ef = 239 - 
0x01a, // 0x0f0 = 240 - SET_OPEN_STATUS_WRONG_DEST
0x0ff, // 0x0f1 = 241 - JUMP
0x0fa, // 0x0f2 = 242 - 
0x015, // 0x0f3 = 243 - SET_OPEN_STATUS_BAD_DEST
0x0ff, // 0x0f4 = 244 - JUMP
0x0fa, // 0x0f5 = 245 - 
0x014, // 0x0f6 = 246 - SET_OPEN_STATUS_IT_NEXUS_LOSS
0x0ff, // 0x0f7 = 247 - JUMP
0x0fa, // 0x0f8 = 248 - 
0x024, // 0x0f9 = 249 - SET_OPEN_STATUS_FREEZE
0x000, // 0x0fa = 250 - NO_OP
0x000, // 0x0fb = 251 - NO_OP
0x0ff, // 0x0fc = 252 - JUMP
0x055, // 0x0fd = 253 - 
0x010, // 0x0fe = 254 - PATHWAY_BLOCKED_CNT_INC
0x0ff, // 0x0ff = 255 - JUMP
0x0b6, // 0x100 = 256 - 
0x000, // 0x101 = 257 - NO_OP
0x000, // 0x102 = 258 - NO_OP
0x000, // 0x103 = 259 - NO_OP
0x000, // 0x104 = 260 - NO_OP
0x000, // 0x105 = 261 - NO_OP
0x000, // 0x106 = 262 - NO_OP
0x000, // 0x107 = 263 - NO_OP
0x000, // 0x108 = 264 - NO_OP
0x000, // 0x109 = 265 - NO_OP
0x000, // 0x10a = 266 - NO_OP
0x000, // 0x10b = 267 - NO_OP
0x000, // 0x10c = 268 - NO_OP
0x000, // 0x10d = 269 - NO_OP
0x000, // 0x10e = 270 - NO_OP
0x000, // 0x10f = 271 - NO_OP
0x000, // 0x110 = 272 - NO_OP
0x000, // 0x111 = 273 - NO_OP
0x000, // 0x112 = 274 - NO_OP
0x000, // 0x113 = 275 - NO_OP
0x000, // 0x114 = 276 - NO_OP
0x000, // 0x115 = 277 - NO_OP
0x000, // 0x116 = 278 - NO_OP
0x000, // 0x117 = 279 - NO_OP
0x000, // 0x118 = 280 - NO_OP
0x000, // 0x119 = 281 - NO_OP
0x000, // 0x11a = 282 - NO_OP
0x000, // 0x11b = 283 - NO_OP
0x000, // 0x11c = 284 - NO_OP
0x000, // 0x11d = 285 - NO_OP
0x000, // 0x11e = 286 - NO_OP
0x000, // 0x11f = 287 - NO_OP
0x000, // 0x120 = 288 - NO_OP
0x000, // 0x121 = 289 - NO_OP
0x000, // 0x122 = 290 - NO_OP
0x000, // 0x123 = 291 - NO_OP
0x000, // 0x124 = 292 - NO_OP
0x000, // 0x125 = 293 - NO_OP
0x000, // 0x126 = 294 - NO_OP
0x000, // 0x127 = 295 - NO_OP
0x000, // 0x128 = 296 - NO_OP
0x000, // 0x129 = 297 - NO_OP
0x000, // 0x12a = 298 - NO_OP
0x000, // 0x12b = 299 - NO_OP
0x000, // 0x12c = 300 - NO_OP
0x000, // 0x12d = 301 - NO_OP
0x000, // 0x12e = 302 - NO_OP
0x000, // 0x12f = 303 - NO_OP
0x000, // 0x130 = 304 - NO_OP
0x000, // 0x131 = 305 - NO_OP
0x000, // 0x132 = 306 - NO_OP
0x000, // 0x133 = 307 - NO_OP
0x000, // 0x134 = 308 - NO_OP
0x000, // 0x135 = 309 - NO_OP
0x000, // 0x136 = 310 - NO_OP
0x000, // 0x137 = 311 - NO_OP
0x000, // 0x138 = 312 - NO_OP
0x000, // 0x139 = 313 - NO_OP
0x000, // 0x13a = 314 - NO_OP
0x000, // 0x13b = 315 - NO_OP
0x000, // 0x13c = 316 - NO_OP
0x000, // 0x13d = 317 - NO_OP
0x000, // 0x13e = 318 - NO_OP
0x000, // 0x13f = 319 - NO_OP
0x000, // 0x140 = 320 - NO_OP
0x000, // 0x141 = 321 - NO_OP
0x000, // 0x142 = 322 - NO_OP
0x000, // 0x143 = 323 - NO_OP
0x000, // 0x144 = 324 - NO_OP
0x000, // 0x145 = 325 - NO_OP
0x000, // 0x146 = 326 - NO_OP
0x000, // 0x147 = 327 - NO_OP
0x000, // 0x148 = 328 - NO_OP
0x000, // 0x149 = 329 - NO_OP
0x000, // 0x14a = 330 - NO_OP
0x000, // 0x14b = 331 - NO_OP
0x000, // 0x14c = 332 - NO_OP
0x000, // 0x14d = 333 - NO_OP
0x000, // 0x14e = 334 - NO_OP
0x000, // 0x14f = 335 - NO_OP
0x000, // 0x150 = 336 - NO_OP
0x000, // 0x151 = 337 - NO_OP
0x000, // 0x152 = 338 - NO_OP
0x000, // 0x153 = 339 - NO_OP
0x000, // 0x154 = 340 - NO_OP
0x000, // 0x155 = 341 - NO_OP
0x000, // 0x156 = 342 - NO_OP
0x000, // 0x157 = 343 - NO_OP
0x000, // 0x158 = 344 - NO_OP
0x000, // 0x159 = 345 - NO_OP
0x000, // 0x15a = 346 - NO_OP
0x000, // 0x15b = 347 - NO_OP
0x000, // 0x15c = 348 - NO_OP
0x000, // 0x15d = 349 - NO_OP
0x000, // 0x15e = 350 - NO_OP
0x000, // 0x15f = 351 - NO_OP
0x000, // 0x160 = 352 - NO_OP
0x000, // 0x161 = 353 - NO_OP
0x000, // 0x162 = 354 - NO_OP
0x000, // 0x163 = 355 - NO_OP
0x000, // 0x164 = 356 - NO_OP
0x000, // 0x165 = 357 - NO_OP
0x000, // 0x166 = 358 - NO_OP
0x000, // 0x167 = 359 - NO_OP
0x000, // 0x168 = 360 - NO_OP
0x000, // 0x169 = 361 - NO_OP
0x000, // 0x16a = 362 - NO_OP
0x000, // 0x16b = 363 - NO_OP
0x000, // 0x16c = 364 - NO_OP
0x000, // 0x16d = 365 - NO_OP
0x000, // 0x16e = 366 - NO_OP
0x000, // 0x16f = 367 - NO_OP
0x000, // 0x170 = 368 - NO_OP
0x000, // 0x171 = 369 - NO_OP
0x000, // 0x172 = 370 - NO_OP
0x000, // 0x173 = 371 - NO_OP
0x000, // 0x174 = 372 - NO_OP
0x000, // 0x175 = 373 - NO_OP
0x000, // 0x176 = 374 - NO_OP
0x000, // 0x177 = 375 - NO_OP
0x000, // 0x178 = 376 - NO_OP
0x000, // 0x179 = 377 - NO_OP
0x000, // 0x17a = 378 - NO_OP
0x000, // 0x17b = 379 - NO_OP
0x000, // 0x17c = 380 - NO_OP
0x000, // 0x17d = 381 - NO_OP
0x000, // 0x17e = 382 - NO_OP
0x000, // 0x17f = 383 - NO_OP
0x000, // 0x180 = 384 - NO_OP
0x000, // 0x181 = 385 - NO_OP
0x000, // 0x182 = 386 - NO_OP
0x000, // 0x183 = 387 - NO_OP
0x000, // 0x184 = 388 - NO_OP
0x000, // 0x185 = 389 - NO_OP
0x000, // 0x186 = 390 - NO_OP
0x000, // 0x187 = 391 - NO_OP
0x000, // 0x188 = 392 - NO_OP
0x000, // 0x189 = 393 - NO_OP
0x000, // 0x18a = 394 - NO_OP
0x000, // 0x18b = 395 - NO_OP
0x000, // 0x18c = 396 - NO_OP
0x000, // 0x18d = 397 - NO_OP
0x000, // 0x18e = 398 - NO_OP
0x000, // 0x18f = 399 - NO_OP
0x000, // 0x190 = 400 - NO_OP
0x000, // 0x191 = 401 - NO_OP
0x000, // 0x192 = 402 - NO_OP
0x000, // 0x193 = 403 - NO_OP
0x000, // 0x194 = 404 - NO_OP
0x000, // 0x195 = 405 - NO_OP
0x000, // 0x196 = 406 - NO_OP
0x000, // 0x197 = 407 - NO_OP
0x000, // 0x198 = 408 - NO_OP
0x000, // 0x199 = 409 - NO_OP
0x000, // 0x19a = 410 - NO_OP
0x000, // 0x19b = 411 - NO_OP
0x000, // 0x19c = 412 - NO_OP
0x000, // 0x19d = 413 - NO_OP
0x000, // 0x19e = 414 - NO_OP
0x000, // 0x19f = 415 - NO_OP
0x000, // 0x1a0 = 416 - NO_OP
0x000, // 0x1a1 = 417 - NO_OP
0x000, // 0x1a2 = 418 - NO_OP
0x000, // 0x1a3 = 419 - NO_OP
0x000, // 0x1a4 = 420 - NO_OP
0x000, // 0x1a5 = 421 - NO_OP
0x000, // 0x1a6 = 422 - NO_OP
0x000, // 0x1a7 = 423 - NO_OP
0x000, // 0x1a8 = 424 - NO_OP
0x000, // 0x1a9 = 425 - NO_OP
0x000, // 0x1aa = 426 - NO_OP
0x000, // 0x1ab = 427 - NO_OP
0x000, // 0x1ac = 428 - NO_OP
0x000, // 0x1ad = 429 - NO_OP
0x000, // 0x1ae = 430 - NO_OP
0x000, // 0x1af = 431 - NO_OP
0x000, // 0x1b0 = 432 - NO_OP
0x000, // 0x1b1 = 433 - NO_OP
0x000, // 0x1b2 = 434 - NO_OP
0x000, // 0x1b3 = 435 - NO_OP
0x000, // 0x1b4 = 436 - NO_OP
0x000, // 0x1b5 = 437 - NO_OP
0x000, // 0x1b6 = 438 - NO_OP
0x000, // 0x1b7 = 439 - NO_OP
0x000, // 0x1b8 = 440 - NO_OP
0x000, // 0x1b9 = 441 - NO_OP
0x000, // 0x1ba = 442 - NO_OP
0x000, // 0x1bb = 443 - NO_OP
0x000, // 0x1bc = 444 - NO_OP
0x000, // 0x1bd = 445 - NO_OP
0x000, // 0x1be = 446 - NO_OP
0x000, // 0x1bf = 447 - NO_OP
0x000, // 0x1c0 = 448 - NO_OP
0x000, // 0x1c1 = 449 - NO_OP
0x000, // 0x1c2 = 450 - NO_OP
0x000, // 0x1c3 = 451 - NO_OP
0x000, // 0x1c4 = 452 - NO_OP
0x000, // 0x1c5 = 453 - NO_OP
0x000, // 0x1c6 = 454 - NO_OP
0x000, // 0x1c7 = 455 - NO_OP
0x000, // 0x1c8 = 456 - NO_OP
0x000, // 0x1c9 = 457 - NO_OP
0x000, // 0x1ca = 458 - NO_OP
0x000, // 0x1cb = 459 - NO_OP
0x000, // 0x1cc = 460 - NO_OP
0x000, // 0x1cd = 461 - NO_OP
0x000, // 0x1ce = 462 - NO_OP
0x000, // 0x1cf = 463 - NO_OP
0x000, // 0x1d0 = 464 - NO_OP
0x000, // 0x1d1 = 465 - NO_OP
0x000, // 0x1d2 = 466 - NO_OP
0x000, // 0x1d3 = 467 - NO_OP
0x000, // 0x1d4 = 468 - NO_OP
0x000, // 0x1d5 = 469 - NO_OP
0x000, // 0x1d6 = 470 - NO_OP
0x000, // 0x1d7 = 471 - NO_OP
0x000, // 0x1d8 = 472 - NO_OP
0x000, // 0x1d9 = 473 - NO_OP
0x000, // 0x1da = 474 - NO_OP
0x000, // 0x1db = 475 - NO_OP
0x000, // 0x1dc = 476 - NO_OP
0x000, // 0x1dd = 477 - NO_OP
0x000, // 0x1de = 478 - NO_OP
0x000, // 0x1df = 479 - NO_OP
0x000, // 0x1e0 = 480 - NO_OP
0x000, // 0x1e1 = 481 - NO_OP
0x000, // 0x1e2 = 482 - NO_OP
0x000, // 0x1e3 = 483 - NO_OP
0x000, // 0x1e4 = 484 - NO_OP
0x000, // 0x1e5 = 485 - NO_OP
0x000, // 0x1e6 = 486 - NO_OP
0x000, // 0x1e7 = 487 - NO_OP
0x000, // 0x1e8 = 488 - NO_OP
0x000, // 0x1e9 = 489 - NO_OP
0x000, // 0x1ea = 490 - NO_OP
0x000, // 0x1eb = 491 - NO_OP
0x000, // 0x1ec = 492 - NO_OP
0x000, // 0x1ed = 493 - NO_OP
0x000, // 0x1ee = 494 - NO_OP
0x000, // 0x1ef = 495 - NO_OP
0x000, // 0x1f0 = 496 - NO_OP
0x000, // 0x1f1 = 497 - NO_OP
0x000, // 0x1f2 = 498 - NO_OP
0x000, // 0x1f3 = 499 - NO_OP
0x000, // 0x1f4 = 500 - NO_OP
0x000, // 0x1f5 = 501 - NO_OP
0x000, // 0x1f6 = 502 - NO_OP
0x000, // 0x1f7 = 503 - NO_OP
0x000, // 0x1f8 = 504 - NO_OP
0x000, // 0x1f9 = 505 - NO_OP
0x000, // 0x1fa = 506 - NO_OP
0x000, // 0x1fb = 507 - NO_OP
0x000, // 0x1fc = 508 - NO_OP
0x000, // 0x1fd = 509 - NO_OP
0x000, // 0x1fe = 510 - NO_OP
0x000, // 0x1ff = 511 - NO_OP
};

/* WCS 031606 */
bit32 wcsImage031606[] = 
{
0x00d, // 00000 = 0 - PHY_RESET_START
0x0be, // 0x001 = 1 - JUMP_IF_PHY_READY
0x009, // 0x002 = 2 - 
0x0ae, // 0x003 = 3 - JUMP_IF_HARD_RESET_PRIMITIVE
0x010, // 0x004 = 4 - 
0x0af, // 0x005 = 5 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x01e, // 0x006 = 6 - 
0x0ff, // 0x007 = 7 - JUMP
0x001, // 0x008 = 8 - 
0x00c, // 0x009 = 9 - SEND_ID_FRAME
0x0ae, // 0x00a = 10 - JUMP_IF_HARD_RESET_PRIMITIVE
0x010, // 0x00b = 11 - 
0x0af, // 0x00c = 12 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x023, // 0x00d = 13 - 
0x0ff, // 0x00e = 14 - JUMP
0x00a, // 0x00f = 15 - 
0x01c, // 0x010 = 16 - SOFT_RESET
0x00d, // 0x011 = 17 - PHY_RESET_START
0x0be, // 0x012 = 18 - JUMP_IF_PHY_READY
0x016, // 0x013 = 19 - 
0x0af, // 0x014 = 20 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x01b, // 0x015 = 21 - 
0x00c, // 0x016 = 22 - SEND_ID_FRAME
0x0af, // 0x017 = 23 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x023, // 0x018 = 24 - 
0x0ff, // 0x019 = 25 - JUMP
0x017, // 0x01a = 26 - 
0x00c, // 0x01b = 27 - SEND_ID_FRAME
0x0ff, // 0x01c = 28 - JUMP
0x023, // 0x01d = 29 - 
0x0be, // 0x01e = 30 - JUMP_IF_PHY_READY
0x022, // 0x01f = 31 - 
0x0ff, // 0x020 = 32 - JUMP
0x01e, // 0x021 = 33 - 
0x00c, // 0x022 = 34 - SEND_ID_FRAME
0x000, // 0x023 = 35 - NO_OP
0x000, // 0x024 = 36 - NO_OP
0x000, // 0x025 = 37 - NO_OP
0x000, // 0x026 = 38 - NO_OP
0x000, // 0x027 = 39 - NO_OP
0x000, // 0x028 = 40 - NO_OP
0x0ff, // 0x029 = 41 - JUMP
0x05b, // 0x02a = 42 - 
0x000, // 0x02b = 43 - NO_OP
0x0c9, // 0x02c = 44 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x058, // 0x02d = 45 - 
0x0a5, // 0x02e = 46 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_GOOD
0x041, // 0x02f = 47 - 
0x0a6, // 0x030 = 48 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_NAK
0x048, // 0x031 = 49 - 
0x0a7, // 0x032 = 50 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_ACK_NAK_TIMEOUT
0x04b, // 0x033 = 51 - 
0x0a8, // 0x034 = 52 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_BREAK
0x055, // 0x035 = 53 - 
0x0aa, // 0x036 = 54 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_CREDIT_TIMEOUT
0x050, // 0x037 = 55 - 
0x0c5, // 0x038 = 56 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_SMP_ERR
0x055, // 0x039 = 57 - 
0x0ca, // 0x03a = 58 - JUMP_IF_CLOSE_REQ
0x09c, // 0x03b = 59 - 
0x0be, // 0x03c = 60 - JUMP_IF_PHY_READY
0x02c, // 0x03d = 61 - 
0x01c, // 0x03e = 62 - SOFT_RESET
0x0ff, // 0x03f = 63 - JUMP
0x001, // 0x040 = 64 - 
0x01d, // 0x041 = 65 - ADVANCE
0x0bc, // 0x042 = 66 - JUMP_IF_BREAK_RECEIVED
0x0af, // 0x043 = 67 - 
0x0c3, // 0x044 = 68 - JUMP_IF_SMP_PROTOCOL
0x09c, // 0x045 = 69 - 
0x0ff, // 0x046 = 70 - JUMP
0x05b, // 0x047 = 71 - 
0x01d, // 0x048 = 72 - ADVANCE
0x0ff, // 0x049 = 73 - JUMP
0x05b, // 0x04a = 74 - 
0x01d, // 0x04b = 75 - ADVANCE
0x0bc, // 0x04c = 76 - JUMP_IF_BREAK_RECEIVED
0x0af, // 0x04d = 77 - 
0x0ff, // 0x04e = 78 - JUMP
0x0bb, // 0x04f = 79 - 
0x01d, // 0x050 = 80 - ADVANCE
0x0bc, // 0x051 = 81 - JUMP_IF_BREAK_RECEIVED
0x0af, // 0x052 = 82 - 
0x0ff, // 0x053 = 83 - JUMP
0x0be, // 0x054 = 84 - 
0x01d, // 0x055 = 85 - ADVANCE
0x0ff, // 0x056 = 86 - JUMP
0x0af, // 0x057 = 87 - 
0x022, // 0x058 = 88 - SEND_CREDIT_BLOCK
0x0ff, // 0x059 = 89 - JUMP
0x02e, // 0x05a = 90 - 
0x0bc, // 0x05b = 91 - JUMP_IF_BREAK_RECEIVED
0x0af, // 0x05c = 92 - 
0x0c8, // 0x05d = 93 - JUMP_IF_HIP_REQ
0x069, // 0x05e = 94 - 
0x0c6, // 0x05f = 95 - JUMP_IF_SFO_REQ
0x06e, // 0x060 = 96 - 
0x0c7, // 0x061 = 97 - JUMP_IF_DOC_REQ
0x073, // 0x062 = 98 - 
0x0a3, // 0x063 = 99 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
0x08a, // 0x064 = 100 - 
0x0a2, // 0x065 = 101 - JUMP_IF_CONNECTION_OPEN_MASTER_FLAG_SET
0x09c, // 0x066 = 102 - 
0x0ff, // 0x067 = 103 - JUMP
0x05b, // 0x068 = 104 - 
0x020, // 0x069 = 105 - SELECT_HIP
0x000, // 0x06a = 106 - NO_OP
0x000, // 0x06b = 107 - NO_OP
0x0ff, // 0x06c = 108 - JUMP
0x076, // 0x06d = 109 - 
0x01e, // 0x06e = 110 - SELECT_SFO
0x000, // 0x06f = 111 - NO_OP
0x000, // 0x070 = 112 - NO_OP
0x0ff, // 0x071 = 113 - JUMP
0x076, // 0x072 = 114 - 
0x01f, // 0x073 = 115 - SELECT_DOC
0x000, // 0x074 = 116 - NO_OP
0x000, // 0x075 = 117 - NO_OP
0x0a4, // 0x076 = 118 - JUMP_IF_CONNECTION_ACTIVE_SET
0x07a, // 0x077 = 119 - 
0x0ff, // 0x078 = 120 - JUMP
0x0c1, // 0x079 = 121 - 
0x0a0, // 0x07a = 122 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL
0x080, // 0x07b = 123 - 
0x0a3, // 0x07c = 124 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
0x08a, // 0x07d = 125 - 
0x0ff, // 0x07e = 126 - JUMP
0x09c, // 0x07f = 127 - 
0x0cb, // 0x080 = 128 - JUMP_IF_FREEZE_ACTIVE
0x085, // 0x081 = 129 - 
0x013, // 0x082 = 130 - SET_OPEN_STATUS_NORMAL
0x0ff, // 0x083 = 131 - JUMP
0x02b, // 0x084 = 132 - 
0x024, // 0x085 = 133 - SET_OPEN_STATUS_FREEZE
0x000, // 0x086 = 134 - NO_OP
0x000, // 0x087 = 135 - NO_OP
0x0ff, // 0x088 = 136 - JUMP
0x05b, // 0x089 = 137 - 
0x0c3, // 0x08a = 138 - JUMP_IF_SMP_PROTOCOL
0x092, // 0x08b = 139 - 
0x0d2, // 0x08c = 140 - JUMP_IF_STP_CONNECTION_ACTIVE
0x096, // 0x08d = 141 - 
0x0d1, // 0x08e = 142 - JUMP_IF_IDLE_TIMER_TIMEOUT
0x09a, // 0x08f = 143 - 
0x0ff, // 0x090 = 144 - JUMP
0x05b, // 0x091 = 145 - 
0x0c4, // 0x092 = 146 - JUMP_IF_SMP_FRAME_ERR_RECEIVED
0x0af, // 0x093 = 147 - 
0x0ff, // 0x094 = 148 - JUMP
0x05b, // 0x095 = 149 - 
0x0d1, // 0x096 = 150 - JUMP_IF_IDLE_TIMER_TIMEOUT
0x09a, // 0x097 = 151 - 
0x0ff, // 0x098 = 152 - JUMP
0x05b, // 0x099 = 153 - 
0x0ff, // 0x09a = 154 - JUMP
0x09c, // 0x09b = 155 - 
0x004, // 0x09c = 156 - CLOSE_NORMAL
0x000, // 0x09d = 157 - NO_OP
0x000, // 0x09e = 158 - NO_OP
0x000, // 0x09f = 159 - NO_OP
0x000, // 0x0a0 = 160 - NO_OP
0x0c9, // 0x0a1 = 161 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x0ac, // 0x0a2 = 162 - 
0x0c0, // 0x0a3 = 163 - JUMP_IF_CLOSE_STATUS_EQUAL_ANY
0x05b, // 0x0a4 = 164 - 
0x0bc, // 0x0a5 = 165 - JUMP_IF_BREAK_RECEIVED
0x0af, // 0x0a6 = 166 - 
0x0be, // 0x0a7 = 167 - JUMP_IF_PHY_READY
0x09d, // 0x0a8 = 168 - 
0x01c, // 0x0a9 = 169 - SOFT_RESET
0x0ff, // 0x0aa = 170 - JUMP
0x001, // 0x0ab = 171 - 
0x022, // 0x0ac = 172 - SEND_CREDIT_BLOCK
0x0ff, // 0x0ad = 173 - JUMP
0x09d, // 0x0ae = 174 - 
0x007, // 0x0af = 175 - CLOSE_BREAK
0x000, // 0x0b0 = 176 - NO_OP
0x000, // 0x0b1 = 177 - NO_OP
0x000, // 0x0b2 = 178 - NO_OP
0x000, // 0x0b3 = 179 - NO_OP
0x0c0, // 0x0b4 = 180 - JUMP_IF_CLOSE_STATUS_EQUAL_ANY
0x05b, // 0x0b5 = 181 - 
0x0be, // 0x0b6 = 182 - JUMP_IF_PHY_READY
0x0b0, // 0x0b7 = 183 - 
0x01c, // 0x0b8 = 184 - SOFT_RESET
0x0ff, // 0x0b9 = 185 - JUMP
0x001, // 0x0ba = 186 - 
0x005, // 0x0bb = 187 - CLOSE_ACK_NAK_TIMEOUT
0x0ff, // 0x0bc = 188 - JUMP
0x09d, // 0x0bd = 189 - 
0x006, // 0x0be = 190 - CLOSE_CREDIT_TIMEOUT
0x0ff, // 0x0bf = 191 - JUMP
0x09d, // 0x0c0 = 192 - 
0x0cc, // 0x0c1 = 193 - JUMP_IF_RX_BUFFER_FULL
0x05b, // 0x0c2 = 194 - 
0x0b7, // 0x0c3 = 195 - JUMP_IF_FLAG_7_SET
0x0c8, // 0x0c4 = 196 - 
0x011, // 0x0c5 = 197 - START_IT_NEXUS_LOSS_TIMER
0x00f, // 0x0c6 = 198 - PATHWAY_BLOCKED_CNT_RESET
0x00e, // 0x0c7 = 199 - START_ARB_WAIT_TIMER
0x0cb, // 0x0c8 = 200 - JUMP_IF_FREEZE_ACTIVE
0x107, // 0x0c9 = 201 - 
0x001, // 0x0ca = 202 - OPEN_REQUEST
0x080, // 0x0cb = 203 - SET_FLAG
0x080, // 0x0cc = 204 - 
0x090, // 0x0cd = 205 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_ACCEPT
0x0f3, // 0x0ce = 206 - 
0x095, // 0x0cf = 207 - JUMP_IF_OPEN_STATUS_EQUAL_RATE_NOT_SUPPORTED
0x0f8, // 0x0d0 = 208 - 
0x099, // 0x0d1 = 209 - JUMP_IF_OPEN_STATUS_EQUAL_PROTOCOL_NOT_SUPPORTED
0x0fb, // 0x0d2 = 210 - 
0x09b, // 0x0d3 = 211 - JUMP_IF_OPEN_STATUS_EQUAL_WRONG_DESTINATION
0x0fe, // 0x0d4 = 212 - 
0x094, // 0x0d5 = 213 - JUMP_IF_OPEN_STATUS_EQUAL_BREAK_RECEIVED
0x0c8, // 0x0d6 = 214 - 
0x093, // 0x0d7 = 215 - JUMP_IF_OPEN_STATUS_EQUAL_BAD_DESTINATION
0x101, // 0x0d8 = 216 - 
0x09f, // 0x0d9 = 217 - JUMP_IF_IT_NEXUS_LOSS_TIMEOUT
0x104, // 0x0da = 218 - 
0x09a, // 0x0db = 219 - JUMP_IF_OPEN_STATUS_EQUAL_STP_RESOURCE_BUSY
0x0c8, // 0x0dc = 220 - 
0x096, // 0x0dd = 221 - JUMP_IF_OPEN_STATUS_EQUAL_NO_DESTINATION
0x101, // 0x0de = 222 - 
0x097, // 0x0df = 223 - JUMP_IF_OPEN_STATUS_EQUAL_PATHWAY_BLOCKED
0x10c, // 0x0e0 = 224 - 
0x098, // 0x0e1 = 225 - JUMP_IF_OPEN_STATUS_EQUAL_RETRY
0x0c8, // 0x0e2 = 226 - 
0x092, // 0x0e3 = 227 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_TIMEOUT
0x0c8, // 0x0e4 = 228 - 
0x0a4, // 0x0e5 = 229 - JUMP_IF_CONNECTION_ACTIVE_SET
0x0ed, // 0x0e6 = 230 - 
0x0be, // 0x0e7 = 231 - JUMP_IF_PHY_READY
0x0cd, // 0x0e8 = 232 - 
0x01b, // 0x0e9 = 233 - SET_OPEN_STATUS_PHY_NOT_RDY
0x01c, // 0x0ea = 234 - SOFT_RESET
0x0ff, // 0x0eb = 235 - JUMP
0x001, // 0x0ec = 236 - 
0x0a0, // 0x0ed = 237 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL
0x0f3, // 0x0ee = 238 - 
0x000, // 0x0ef = 239 - NO_OP
0x000, // 0x0f0 = 240 - NO_OP
0x0ff, // 0x0f1 = 241 - JUMP
0x05b, // 0x0f2 = 242 - 
0x013, // 0x0f3 = 243 - SET_OPEN_STATUS_NORMAL
0x081, // 0x0f4 = 244 - CLEAR_FLAG
0x080, // 0x0f5 = 245 - 
0x0ff, // 0x0f6 = 246 - JUMP
0x02b, // 0x0f7 = 247 - 
0x017, // 0x0f8 = 248 - SET_OPEN_STATUS_BAD_RATE
0x0ff, // 0x0f9 = 249 - JUMP
0x108, // 0x0fa = 250 - 
0x018, // 0x0fb = 251 - SET_OPEN_STATUS_BAD_PROTOCOL
0x0ff, // 0x0fc = 252 - JUMP
0x108, // 0x0fd = 253 - 
0x01a, // 0x0fe = 254 - SET_OPEN_STATUS_WRONG_DEST
0x0ff, // 0x0ff = 255 - JUMP
0x108, // 0x100 = 256 - 
0x015, // 0x101 = 257 - SET_OPEN_STATUS_BAD_DEST
0x0ff, // 0x102 = 258 - JUMP
0x108, // 0x103 = 259 - 
0x014, // 0x104 = 260 - SET_OPEN_STATUS_IT_NEXUS_LOSS
0x0ff, // 0x105 = 261 - JUMP
0x108, // 0x106 = 262 - 
0x024, // 0x107 = 263 - SET_OPEN_STATUS_FREEZE
0x000, // 0x108 = 264 - NO_OP
0x000, // 0x109 = 265 - NO_OP
0x0ff, // 0x10a = 266 - JUMP
0x05b, // 0x10b = 267 - 
0x010, // 0x10c = 268 - PATHWAY_BLOCKED_CNT_INC
0x0ff, // 0x10d = 269 - JUMP
0x0c8, // 0x10e = 270 - 
0x000, // 0x10f = 271 - NO_OP
0x000, // 0x110 = 272 - NO_OP
0x000, // 0x111 = 273 - NO_OP
0x000, // 0x112 = 274 - NO_OP
0x000, // 0x113 = 275 - NO_OP
0x000, // 0x114 = 276 - NO_OP
0x000, // 0x115 = 277 - NO_OP
0x000, // 0x116 = 278 - NO_OP
0x000, // 0x117 = 279 - NO_OP
0x000, // 0x118 = 280 - NO_OP
0x000, // 0x119 = 281 - NO_OP
0x000, // 0x11a = 282 - NO_OP
0x000, // 0x11b = 283 - NO_OP
0x000, // 0x11c = 284 - NO_OP
0x000, // 0x11d = 285 - NO_OP
0x000, // 0x11e = 286 - NO_OP
0x000, // 0x11f = 287 - NO_OP
0x000, // 0x120 = 288 - NO_OP
0x000, // 0x121 = 289 - NO_OP
0x000, // 0x122 = 290 - NO_OP
0x000, // 0x123 = 291 - NO_OP
0x000, // 0x124 = 292 - NO_OP
0x000, // 0x125 = 293 - NO_OP
0x000, // 0x126 = 294 - NO_OP
0x000, // 0x127 = 295 - NO_OP
0x000, // 0x128 = 296 - NO_OP
0x000, // 0x129 = 297 - NO_OP
0x000, // 0x12a = 298 - NO_OP
0x000, // 0x12b = 299 - NO_OP
0x000, // 0x12c = 300 - NO_OP
0x000, // 0x12d = 301 - NO_OP
0x000, // 0x12e = 302 - NO_OP
0x000, // 0x12f = 303 - NO_OP
0x000, // 0x130 = 304 - NO_OP
0x000, // 0x131 = 305 - NO_OP
0x000, // 0x132 = 306 - NO_OP
0x000, // 0x133 = 307 - NO_OP
0x000, // 0x134 = 308 - NO_OP
0x000, // 0x135 = 309 - NO_OP
0x000, // 0x136 = 310 - NO_OP
0x000, // 0x137 = 311 - NO_OP
0x000, // 0x138 = 312 - NO_OP
0x000, // 0x139 = 313 - NO_OP
0x000, // 0x13a = 314 - NO_OP
0x000, // 0x13b = 315 - NO_OP
0x000, // 0x13c = 316 - NO_OP
0x000, // 0x13d = 317 - NO_OP
0x000, // 0x13e = 318 - NO_OP
0x000, // 0x13f = 319 - NO_OP
0x000, // 0x140 = 320 - NO_OP
0x000, // 0x141 = 321 - NO_OP
0x000, // 0x142 = 322 - NO_OP
0x000, // 0x143 = 323 - NO_OP
0x000, // 0x144 = 324 - NO_OP
0x000, // 0x145 = 325 - NO_OP
0x000, // 0x146 = 326 - NO_OP
0x000, // 0x147 = 327 - NO_OP
0x000, // 0x148 = 328 - NO_OP
0x000, // 0x149 = 329 - NO_OP
0x000, // 0x14a = 330 - NO_OP
0x000, // 0x14b = 331 - NO_OP
0x000, // 0x14c = 332 - NO_OP
0x000, // 0x14d = 333 - NO_OP
0x000, // 0x14e = 334 - NO_OP
0x000, // 0x14f = 335 - NO_OP
0x000, // 0x150 = 336 - NO_OP
0x000, // 0x151 = 337 - NO_OP
0x000, // 0x152 = 338 - NO_OP
0x000, // 0x153 = 339 - NO_OP
0x000, // 0x154 = 340 - NO_OP
0x000, // 0x155 = 341 - NO_OP
0x000, // 0x156 = 342 - NO_OP
0x000, // 0x157 = 343 - NO_OP
0x000, // 0x158 = 344 - NO_OP
0x000, // 0x159 = 345 - NO_OP
0x000, // 0x15a = 346 - NO_OP
0x000, // 0x15b = 347 - NO_OP
0x000, // 0x15c = 348 - NO_OP
0x000, // 0x15d = 349 - NO_OP
0x000, // 0x15e = 350 - NO_OP
0x000, // 0x15f = 351 - NO_OP
0x000, // 0x160 = 352 - NO_OP
0x000, // 0x161 = 353 - NO_OP
0x000, // 0x162 = 354 - NO_OP
0x000, // 0x163 = 355 - NO_OP
0x000, // 0x164 = 356 - NO_OP
0x000, // 0x165 = 357 - NO_OP
0x000, // 0x166 = 358 - NO_OP
0x000, // 0x167 = 359 - NO_OP
0x000, // 0x168 = 360 - NO_OP
0x000, // 0x169 = 361 - NO_OP
0x000, // 0x16a = 362 - NO_OP
0x000, // 0x16b = 363 - NO_OP
0x000, // 0x16c = 364 - NO_OP
0x000, // 0x16d = 365 - NO_OP
0x000, // 0x16e = 366 - NO_OP
0x000, // 0x16f = 367 - NO_OP
0x000, // 0x170 = 368 - NO_OP
0x000, // 0x171 = 369 - NO_OP
0x000, // 0x172 = 370 - NO_OP
0x000, // 0x173 = 371 - NO_OP
0x000, // 0x174 = 372 - NO_OP
0x000, // 0x175 = 373 - NO_OP
0x000, // 0x176 = 374 - NO_OP
0x000, // 0x177 = 375 - NO_OP
0x000, // 0x178 = 376 - NO_OP
0x000, // 0x179 = 377 - NO_OP
0x000, // 0x17a = 378 - NO_OP
0x000, // 0x17b = 379 - NO_OP
0x000, // 0x17c = 380 - NO_OP
0x000, // 0x17d = 381 - NO_OP
0x000, // 0x17e = 382 - NO_OP
0x000, // 0x17f = 383 - NO_OP
0x000, // 0x180 = 384 - NO_OP
0x000, // 0x181 = 385 - NO_OP
0x000, // 0x182 = 386 - NO_OP
0x000, // 0x183 = 387 - NO_OP
0x000, // 0x184 = 388 - NO_OP
0x000, // 0x185 = 389 - NO_OP
0x000, // 0x186 = 390 - NO_OP
0x000, // 0x187 = 391 - NO_OP
0x000, // 0x188 = 392 - NO_OP
0x000, // 0x189 = 393 - NO_OP
0x000, // 0x18a = 394 - NO_OP
0x000, // 0x18b = 395 - NO_OP
0x000, // 0x18c = 396 - NO_OP
0x000, // 0x18d = 397 - NO_OP
0x000, // 0x18e = 398 - NO_OP
0x000, // 0x18f = 399 - NO_OP
0x000, // 0x190 = 400 - NO_OP
0x000, // 0x191 = 401 - NO_OP
0x000, // 0x192 = 402 - NO_OP
0x000, // 0x193 = 403 - NO_OP
0x000, // 0x194 = 404 - NO_OP
0x000, // 0x195 = 405 - NO_OP
0x000, // 0x196 = 406 - NO_OP
0x000, // 0x197 = 407 - NO_OP
0x000, // 0x198 = 408 - NO_OP
0x000, // 0x199 = 409 - NO_OP
0x000, // 0x19a = 410 - NO_OP
0x000, // 0x19b = 411 - NO_OP
0x000, // 0x19c = 412 - NO_OP
0x000, // 0x19d = 413 - NO_OP
0x000, // 0x19e = 414 - NO_OP
0x000, // 0x19f = 415 - NO_OP
0x000, // 0x1a0 = 416 - NO_OP
0x000, // 0x1a1 = 417 - NO_OP
0x000, // 0x1a2 = 418 - NO_OP
0x000, // 0x1a3 = 419 - NO_OP
0x000, // 0x1a4 = 420 - NO_OP
0x000, // 0x1a5 = 421 - NO_OP
0x000, // 0x1a6 = 422 - NO_OP
0x000, // 0x1a7 = 423 - NO_OP
0x000, // 0x1a8 = 424 - NO_OP
0x000, // 0x1a9 = 425 - NO_OP
0x000, // 0x1aa = 426 - NO_OP
0x000, // 0x1ab = 427 - NO_OP
0x000, // 0x1ac = 428 - NO_OP
0x000, // 0x1ad = 429 - NO_OP
0x000, // 0x1ae = 430 - NO_OP
0x000, // 0x1af = 431 - NO_OP
0x000, // 0x1b0 = 432 - NO_OP
0x000, // 0x1b1 = 433 - NO_OP
0x000, // 0x1b2 = 434 - NO_OP
0x000, // 0x1b3 = 435 - NO_OP
0x000, // 0x1b4 = 436 - NO_OP
0x000, // 0x1b5 = 437 - NO_OP
0x000, // 0x1b6 = 438 - NO_OP
0x000, // 0x1b7 = 439 - NO_OP
0x000, // 0x1b8 = 440 - NO_OP
0x000, // 0x1b9 = 441 - NO_OP
0x000, // 0x1ba = 442 - NO_OP
0x000, // 0x1bb = 443 - NO_OP
0x000, // 0x1bc = 444 - NO_OP
0x000, // 0x1bd = 445 - NO_OP
0x000, // 0x1be = 446 - NO_OP
0x000, // 0x1bf = 447 - NO_OP
0x000, // 0x1c0 = 448 - NO_OP
0x000, // 0x1c1 = 449 - NO_OP
0x000, // 0x1c2 = 450 - NO_OP
0x000, // 0x1c3 = 451 - NO_OP
0x000, // 0x1c4 = 452 - NO_OP
0x000, // 0x1c5 = 453 - NO_OP
0x000, // 0x1c6 = 454 - NO_OP
0x000, // 0x1c7 = 455 - NO_OP
0x000, // 0x1c8 = 456 - NO_OP
0x000, // 0x1c9 = 457 - NO_OP
0x000, // 0x1ca = 458 - NO_OP
0x000, // 0x1cb = 459 - NO_OP
0x000, // 0x1cc = 460 - NO_OP
0x000, // 0x1cd = 461 - NO_OP
0x000, // 0x1ce = 462 - NO_OP
0x000, // 0x1cf = 463 - NO_OP
0x000, // 0x1d0 = 464 - NO_OP
0x000, // 0x1d1 = 465 - NO_OP
0x000, // 0x1d2 = 466 - NO_OP
0x000, // 0x1d3 = 467 - NO_OP
0x000, // 0x1d4 = 468 - NO_OP
0x000, // 0x1d5 = 469 - NO_OP
0x000, // 0x1d6 = 470 - NO_OP
0x000, // 0x1d7 = 471 - NO_OP
0x000, // 0x1d8 = 472 - NO_OP
0x000, // 0x1d9 = 473 - NO_OP
0x000, // 0x1da = 474 - NO_OP
0x000, // 0x1db = 475 - NO_OP
0x000, // 0x1dc = 476 - NO_OP
0x000, // 0x1dd = 477 - NO_OP
0x000, // 0x1de = 478 - NO_OP
0x000, // 0x1df = 479 - NO_OP
0x000, // 0x1e0 = 480 - NO_OP
0x000, // 0x1e1 = 481 - NO_OP
0x000, // 0x1e2 = 482 - NO_OP
0x000, // 0x1e3 = 483 - NO_OP
0x000, // 0x1e4 = 484 - NO_OP
0x000, // 0x1e5 = 485 - NO_OP
0x000, // 0x1e6 = 486 - NO_OP
0x000, // 0x1e7 = 487 - NO_OP
0x000, // 0x1e8 = 488 - NO_OP
0x000, // 0x1e9 = 489 - NO_OP
0x000, // 0x1ea = 490 - NO_OP
0x000, // 0x1eb = 491 - NO_OP
0x000, // 0x1ec = 492 - NO_OP
0x000, // 0x1ed = 493 - NO_OP
0x000, // 0x1ee = 494 - NO_OP
0x000, // 0x1ef = 495 - NO_OP
0x000, // 0x1f0 = 496 - NO_OP
0x000, // 0x1f1 = 497 - NO_OP
0x000, // 0x1f2 = 498 - NO_OP
0x000, // 0x1f3 = 499 - NO_OP
0x000, // 0x1f4 = 500 - NO_OP
0x000, // 0x1f5 = 501 - NO_OP
0x000, // 0x1f6 = 502 - NO_OP
0x000, // 0x1f7 = 503 - NO_OP
0x000, // 0x1f8 = 504 - NO_OP
0x000, // 0x1f9 = 505 - NO_OP
0x000, // 0x1fa = 506 - NO_OP
0x000, // 0x1fb = 507 - NO_OP
0x000, // 0x1fc = 508 - NO_OP
0x000, // 0x1fd = 509 - NO_OP
0x000, // 0x1fe = 510 - NO_OP
0x000 // 0x1ff = 511 - NO_OP
};

/* WCS 032006 */
bit32 wcsImage032006[] = 
{
0x00d, // 00000 = 0 - PHY_RESET_START
0x0be, // 0x001 = 1 - JUMP_IF_PHY_READY
0x009, // 0x002 = 2 - 
0x0ae, // 0x003 = 3 - JUMP_IF_HARD_RESET_PRIMITIVE
0x010, // 0x004 = 4 - 
0x0af, // 0x005 = 5 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x01e, // 0x006 = 6 - 
0x0ff, // 0x007 = 7 - JUMP
0x001, // 0x008 = 8 - 
0x00c, // 0x009 = 9 - SEND_ID_FRAME
0x0ae, // 0x00a = 10 - JUMP_IF_HARD_RESET_PRIMITIVE
0x010, // 0x00b = 11 - 
0x0af, // 0x00c = 12 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x023, // 0x00d = 13 - 
0x0ff, // 0x00e = 14 - JUMP
0x00a, // 0x00f = 15 - 
0x01c, // 0x010 = 16 - SOFT_RESET
0x00d, // 0x011 = 17 - PHY_RESET_START
0x0be, // 0x012 = 18 - JUMP_IF_PHY_READY
0x016, // 0x013 = 19 - 
0x0af, // 0x014 = 20 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x01b, // 0x015 = 21 - 
0x00c, // 0x016 = 22 - SEND_ID_FRAME
0x0af, // 0x017 = 23 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x023, // 0x018 = 24 - 
0x0ff, // 0x019 = 25 - JUMP
0x017, // 0x01a = 26 - 
0x00c, // 0x01b = 27 - SEND_ID_FRAME
0x0ff, // 0x01c = 28 - JUMP
0x023, // 0x01d = 29 - 
0x0be, // 0x01e = 30 - JUMP_IF_PHY_READY
0x022, // 0x01f = 31 - 
0x0ff, // 0x020 = 32 - JUMP
0x01e, // 0x021 = 33 - 
0x00c, // 0x022 = 34 - SEND_ID_FRAME
0x000, // 0x023 = 35 - NO_OP
0x000, // 0x024 = 36 - NO_OP
0x000, // 0x025 = 37 - NO_OP
0x000, // 0x026 = 38 - NO_OP
0x000, // 0x027 = 39 - NO_OP
0x000, // 0x028 = 40 - NO_OP
0x0ff, // 0x029 = 41 - JUMP
0x063, // 0x02a = 42 - 
0x000, // 0x02b = 43 - NO_OP
0x0c9, // 0x02c = 44 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x058, // 0x02d = 45 - 
0x0a5, // 0x02e = 46 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_GOOD
0x041, // 0x02f = 47 - 
0x0a6, // 0x030 = 48 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_NAK
0x048, // 0x031 = 49 - 
0x0a7, // 0x032 = 50 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_ACK_NAK_TIMEOUT
0x04b, // 0x033 = 51 - 
0x0a8, // 0x034 = 52 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_BREAK
0x055, // 0x035 = 53 - 
0x0aa, // 0x036 = 54 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_CREDIT_TIMEOUT
0x050, // 0x037 = 55 - 
0x0c5, // 0x038 = 56 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_SMP_ERR
0x055, // 0x039 = 57 - 
0x0ca, // 0x03a = 58 - JUMP_IF_CLOSE_REQ
0x0a4, // 0x03b = 59 - 
0x0be, // 0x03c = 60 - JUMP_IF_PHY_READY
0x02c, // 0x03d = 61 - 
0x01c, // 0x03e = 62 - SOFT_RESET
0x0ff, // 0x03f = 63 - JUMP
0x001, // 0x040 = 64 - 
0x01d, // 0x041 = 65 - ADVANCE
0x0bc, // 0x042 = 66 - JUMP_IF_BREAK_RECEIVED
0x0b7, // 0x043 = 67 - 
0x0c3, // 0x044 = 68 - JUMP_IF_SMP_PROTOCOL
0x0a4, // 0x045 = 69 - 
0x0ff, // 0x046 = 70 - JUMP
0x05b, // 0x047 = 71 - 
0x01d, // 0x048 = 72 - ADVANCE
0x0ff, // 0x049 = 73 - JUMP
0x05b, // 0x04a = 74 - 
0x01d, // 0x04b = 75 - ADVANCE
0x0bc, // 0x04c = 76 - JUMP_IF_BREAK_RECEIVED
0x0b7, // 0x04d = 77 - 
0x0ff, // 0x04e = 78 - JUMP
0x0c3, // 0x04f = 79 - 
0x01d, // 0x050 = 80 - ADVANCE
0x0bc, // 0x051 = 81 - JUMP_IF_BREAK_RECEIVED
0x0b7, // 0x052 = 82 - 
0x0ff, // 0x053 = 83 - JUMP
0x0c6, // 0x054 = 84 - 
0x01d, // 0x055 = 85 - ADVANCE
0x0ff, // 0x056 = 86 - JUMP
0x0b7, // 0x057 = 87 - 
0x022, // 0x058 = 88 - SEND_CREDIT_BLOCK
0x0ff, // 0x059 = 89 - JUMP
0x02e, // 0x05a = 90 - 
0x083, // 0x05b = 91 - TIMER_START
0x002, // 0x05c = 92 - 
0x000, // 0x05d = 93 - NO_OP
0x000, // 0x05e = 94 - NO_OP
0x0b8, // 0x05f = 95 - JUMP_IF_TIMER_EXPIRED
0x063, // 0x060 = 96 - 
0x0ff, // 0x061 = 97 - JUMP
0x05d, // 0x062 = 98 - 
0x0bc, // 0x063 = 99 - JUMP_IF_BREAK_RECEIVED
0x0b7, // 0x064 = 100 - 
0x0c8, // 0x065 = 101 - JUMP_IF_HIP_REQ
0x071, // 0x066 = 102 - 
0x0c6, // 0x067 = 103 - JUMP_IF_SFO_REQ
0x076, // 0x068 = 104 - 
0x0c7, // 0x069 = 105 - JUMP_IF_DOC_REQ
0x07b, // 0x06a = 106 - 
0x0a3, // 0x06b = 107 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
0x092, // 0x06c = 108 - 
0x0a2, // 0x06d = 109 - JUMP_IF_CONNECTION_OPEN_MASTER_FLAG_SET
0x0a4, // 0x06e = 110 - 
0x0ff, // 0x06f = 111 - JUMP
0x063, // 0x070 = 112 - 
0x020, // 0x071 = 113 - SELECT_HIP
0x000, // 0x072 = 114 - NO_OP
0x000, // 0x073 = 115 - NO_OP
0x0ff, // 0x074 = 116 - JUMP
0x07e, // 0x075 = 117 - 
0x01e, // 0x076 = 118 - SELECT_SFO
0x000, // 0x077 = 119 - NO_OP
0x000, // 0x078 = 120 - NO_OP
0x0ff, // 0x079 = 121 - JUMP
0x07e, // 0x07a = 122 - 
0x01f, // 0x07b = 123 - SELECT_DOC
0x000, // 0x07c = 124 - NO_OP
0x000, // 0x07d = 125 - NO_OP
0x0a4, // 0x07e = 126 - JUMP_IF_CONNECTION_ACTIVE_SET
0x082, // 0x07f = 127 - 
0x0ff, // 0x080 = 128 - JUMP
0x0c9, // 0x081 = 129 - 
0x0a0, // 0x082 = 130 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL
0x088, // 0x083 = 131 - 
0x0a3, // 0x084 = 132 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
0x092, // 0x085 = 133 - 
0x0ff, // 0x086 = 134 - JUMP
0x0a4, // 0x087 = 135 - 
0x0cb, // 0x088 = 136 - JUMP_IF_FREEZE_ACTIVE
0x08d, // 0x089 = 137 - 
0x013, // 0x08a = 138 - SET_OPEN_STATUS_NORMAL
0x0ff, // 0x08b = 139 - JUMP
0x02b, // 0x08c = 140 - 
0x024, // 0x08d = 141 - SET_OPEN_STATUS_FREEZE
0x000, // 0x08e = 142 - NO_OP
0x000, // 0x08f = 143 - NO_OP
0x0ff, // 0x090 = 144 - JUMP
0x063, // 0x091 = 145 - 
0x0c3, // 0x092 = 146 - JUMP_IF_SMP_PROTOCOL
0x09a, // 0x093 = 147 - 
0x0d2, // 0x094 = 148 - JUMP_IF_STP_CONNECTION_ACTIVE
0x09e, // 0x095 = 149 - 
0x0d1, // 0x096 = 150 - JUMP_IF_IDLE_TIMER_TIMEOUT
0x0a2, // 0x097 = 151 - 
0x0ff, // 0x098 = 152 - JUMP
0x063, // 0x099 = 153 - 
0x0c4, // 0x09a = 154 - JUMP_IF_SMP_FRAME_ERR_RECEIVED
0x0b7, // 0x09b = 155 - 
0x0ff, // 0x09c = 156 - JUMP
0x063, // 0x09d = 157 - 
0x0d1, // 0x09e = 158 - JUMP_IF_IDLE_TIMER_TIMEOUT
0x0a2, // 0x09f = 159 - 
0x0ff, // 0x0a0 = 160 - JUMP
0x063, // 0x0a1 = 161 - 
0x0ff, // 0x0a2 = 162 - JUMP
0x0a4, // 0x0a3 = 163 - 
0x004, // 0x0a4 = 164 - CLOSE_NORMAL
0x000, // 0x0a5 = 165 - NO_OP
0x000, // 0x0a6 = 166 - NO_OP
0x000, // 0x0a7 = 167 - NO_OP
0x000, // 0x0a8 = 168 - NO_OP
0x0c9, // 0x0a9 = 169 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x0b4, // 0x0aa = 170 - 
0x0c0, // 0x0ab = 171 - JUMP_IF_CLOSE_STATUS_EQUAL_ANY
0x063, // 0x0ac = 172 - 
0x0bc, // 0x0ad = 173 - JUMP_IF_BREAK_RECEIVED
0x0b7, // 0x0ae = 174 - 
0x0be, // 0x0af = 175 - JUMP_IF_PHY_READY
0x0a5, // 0x0b0 = 176 - 
0x01c, // 0x0b1 = 177 - SOFT_RESET
0x0ff, // 0x0b2 = 178 - JUMP
0x001, // 0x0b3 = 179 - 
0x022, // 0x0b4 = 180 - SEND_CREDIT_BLOCK
0x0ff, // 0x0b5 = 181 - JUMP
0x0a5, // 0x0b6 = 182 - 
0x007, // 0x0b7 = 183 - CLOSE_BREAK
0x000, // 0x0b8 = 184 - NO_OP
0x000, // 0x0b9 = 185 - NO_OP
0x000, // 0x0ba = 186 - NO_OP
0x000, // 0x0bb = 187 - NO_OP
0x0c0, // 0x0bc = 188 - JUMP_IF_CLOSE_STATUS_EQUAL_ANY
0x063, // 0x0bd = 189 - 
0x0be, // 0x0be = 190 - JUMP_IF_PHY_READY
0x0b8, // 0x0bf = 191 - 
0x01c, // 0x0c0 = 192 - SOFT_RESET
0x0ff, // 0x0c1 = 193 - JUMP
0x001, // 0x0c2 = 194 - 
0x005, // 0x0c3 = 195 - CLOSE_ACK_NAK_TIMEOUT
0x0ff, // 0x0c4 = 196 - JUMP
0x0a5, // 0x0c5 = 197 - 
0x006, // 0x0c6 = 198 - CLOSE_CREDIT_TIMEOUT
0x0ff, // 0x0c7 = 199 - JUMP
0x0a5, // 0x0c8 = 200 - 
0x0cc, // 0x0c9 = 201 - JUMP_IF_RX_BUFFER_FULL
0x063, // 0x0ca = 202 - 
0x0b7, // 0x0cb = 203 - JUMP_IF_FLAG_7_SET
0x0d0, // 0x0cc = 204 - 
0x011, // 0x0cd = 205 - START_IT_NEXUS_LOSS_TIMER
0x00f, // 0x0ce = 206 - PATHWAY_BLOCKED_CNT_RESET
0x00e, // 0x0cf = 207 - START_ARB_WAIT_TIMER
0x0cb, // 0x0d0 = 208 - JUMP_IF_FREEZE_ACTIVE
0x10f, // 0x0d1 = 209 - 
0x001, // 0x0d2 = 210 - OPEN_REQUEST
0x080, // 0x0d3 = 211 - SET_FLAG
0x080, // 0x0d4 = 212 - 
0x090, // 0x0d5 = 213 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_ACCEPT
0x0fb, // 0x0d6 = 214 - 
0x095, // 0x0d7 = 215 - JUMP_IF_OPEN_STATUS_EQUAL_RATE_NOT_SUPPORTED
0x100, // 0x0d8 = 216 - 
0x099, // 0x0d9 = 217 - JUMP_IF_OPEN_STATUS_EQUAL_PROTOCOL_NOT_SUPPORTED
0x103, // 0x0da = 218 - 
0x09b, // 0x0db = 219 - JUMP_IF_OPEN_STATUS_EQUAL_WRONG_DESTINATION
0x106, // 0x0dc = 220 - 
0x094, // 0x0dd = 221 - JUMP_IF_OPEN_STATUS_EQUAL_BREAK_RECEIVED
0x0d0, // 0x0de = 222 - 
0x093, // 0x0df = 223 - JUMP_IF_OPEN_STATUS_EQUAL_BAD_DESTINATION
0x109, // 0x0e0 = 224 - 
0x09f, // 0x0e1 = 225 - JUMP_IF_IT_NEXUS_LOSS_TIMEOUT
0x10c, // 0x0e2 = 226 - 
0x09a, // 0x0e3 = 227 - JUMP_IF_OPEN_STATUS_EQUAL_STP_RESOURCE_BUSY
0x0d0, // 0x0e4 = 228 - 
0x096, // 0x0e5 = 229 - JUMP_IF_OPEN_STATUS_EQUAL_NO_DESTINATION
0x109, // 0x0e6 = 230 - 
0x097, // 0x0e7 = 231 - JUMP_IF_OPEN_STATUS_EQUAL_PATHWAY_BLOCKED
0x114, // 0x0e8 = 232 - 
0x098, // 0x0e9 = 233 - JUMP_IF_OPEN_STATUS_EQUAL_RETRY
0x0d0, // 0x0ea = 234 - 
0x092, // 0x0eb = 235 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_TIMEOUT
0x0d0, // 0x0ec = 236 - 
0x0a4, // 0x0ed = 237 - JUMP_IF_CONNECTION_ACTIVE_SET
0x0f5, // 0x0ee = 238 - 
0x0be, // 0x0ef = 239 - JUMP_IF_PHY_READY
0x0d5, // 0x0f0 = 240 - 
0x01b, // 0x0f1 = 241 - SET_OPEN_STATUS_PHY_NOT_RDY
0x01c, // 0x0f2 = 242 - SOFT_RESET
0x0ff, // 0x0f3 = 243 - JUMP
0x001, // 0x0f4 = 244 - 
0x0a0, // 0x0f5 = 245 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL
0x0fb, // 0x0f6 = 246 - 
0x000, // 0x0f7 = 247 - NO_OP
0x000, // 0x0f8 = 248 - NO_OP
0x0ff, // 0x0f9 = 249 - JUMP
0x063, // 0x0fa = 250 - 
0x013, // 0x0fb = 251 - SET_OPEN_STATUS_NORMAL
0x081, // 0x0fc = 252 - CLEAR_FLAG
0x080, // 0x0fd = 253 - 
0x0ff, // 0x0fe = 254 - JUMP
0x02b, // 0x0ff = 255 - 
0x017, // 0x100 = 256 - SET_OPEN_STATUS_BAD_RATE
0x0ff, // 0x101 = 257 - JUMP
0x110, // 0x102 = 258 - 
0x018, // 0x103 = 259 - SET_OPEN_STATUS_BAD_PROTOCOL
0x0ff, // 0x104 = 260 - JUMP
0x110, // 0x105 = 261 - 
0x01a, // 0x106 = 262 - SET_OPEN_STATUS_WRONG_DEST
0x0ff, // 0x107 = 263 - JUMP
0x110, // 0x108 = 264 - 
0x015, // 0x109 = 265 - SET_OPEN_STATUS_BAD_DEST
0x0ff, // 0x10a = 266 - JUMP
0x110, // 0x10b = 267 - 
0x014, // 0x10c = 268 - SET_OPEN_STATUS_IT_NEXUS_LOSS
0x0ff, // 0x10d = 269 - JUMP
0x110, // 0x10e = 270 - 
0x024, // 0x10f = 271 - SET_OPEN_STATUS_FREEZE
0x000, // 0x110 = 272 - NO_OP
0x000, // 0x111 = 273 - NO_OP
0x0ff, // 0x112 = 274 - JUMP
0x063, // 0x113 = 275 - 
0x010, // 0x114 = 276 - PATHWAY_BLOCKED_CNT_INC
0x0ff, // 0x115 = 277 - JUMP
0x0d0, // 0x116 = 278 - 
0x000, // 0x117 = 279 - NO_OP
0x000, // 0x118 = 280 - NO_OP
0x000, // 0x119 = 281 - NO_OP
0x000, // 0x11a = 282 - NO_OP
0x000, // 0x11b = 283 - NO_OP
0x000, // 0x11c = 284 - NO_OP
0x000, // 0x11d = 285 - NO_OP
0x000, // 0x11e = 286 - NO_OP
0x000, // 0x11f = 287 - NO_OP
0x000, // 0x120 = 288 - NO_OP
0x000, // 0x121 = 289 - NO_OP
0x000, // 0x122 = 290 - NO_OP
0x000, // 0x123 = 291 - NO_OP
0x000, // 0x124 = 292 - NO_OP
0x000, // 0x125 = 293 - NO_OP
0x000, // 0x126 = 294 - NO_OP
0x000, // 0x127 = 295 - NO_OP
0x000, // 0x128 = 296 - NO_OP
0x000, // 0x129 = 297 - NO_OP
0x000, // 0x12a = 298 - NO_OP
0x000, // 0x12b = 299 - NO_OP
0x000, // 0x12c = 300 - NO_OP
0x000, // 0x12d = 301 - NO_OP
0x000, // 0x12e = 302 - NO_OP
0x000, // 0x12f = 303 - NO_OP
0x000, // 0x130 = 304 - NO_OP
0x000, // 0x131 = 305 - NO_OP
0x000, // 0x132 = 306 - NO_OP
0x000, // 0x133 = 307 - NO_OP
0x000, // 0x134 = 308 - NO_OP
0x000, // 0x135 = 309 - NO_OP
0x000, // 0x136 = 310 - NO_OP
0x000, // 0x137 = 311 - NO_OP
0x000, // 0x138 = 312 - NO_OP
0x000, // 0x139 = 313 - NO_OP
0x000, // 0x13a = 314 - NO_OP
0x000, // 0x13b = 315 - NO_OP
0x000, // 0x13c = 316 - NO_OP
0x000, // 0x13d = 317 - NO_OP
0x000, // 0x13e = 318 - NO_OP
0x000, // 0x13f = 319 - NO_OP
0x000, // 0x140 = 320 - NO_OP
0x000, // 0x141 = 321 - NO_OP
0x000, // 0x142 = 322 - NO_OP
0x000, // 0x143 = 323 - NO_OP
0x000, // 0x144 = 324 - NO_OP
0x000, // 0x145 = 325 - NO_OP
0x000, // 0x146 = 326 - NO_OP
0x000, // 0x147 = 327 - NO_OP
0x000, // 0x148 = 328 - NO_OP
0x000, // 0x149 = 329 - NO_OP
0x000, // 0x14a = 330 - NO_OP
0x000, // 0x14b = 331 - NO_OP
0x000, // 0x14c = 332 - NO_OP
0x000, // 0x14d = 333 - NO_OP
0x000, // 0x14e = 334 - NO_OP
0x000, // 0x14f = 335 - NO_OP
0x000, // 0x150 = 336 - NO_OP
0x000, // 0x151 = 337 - NO_OP
0x000, // 0x152 = 338 - NO_OP
0x000, // 0x153 = 339 - NO_OP
0x000, // 0x154 = 340 - NO_OP
0x000, // 0x155 = 341 - NO_OP
0x000, // 0x156 = 342 - NO_OP
0x000, // 0x157 = 343 - NO_OP
0x000, // 0x158 = 344 - NO_OP
0x000, // 0x159 = 345 - NO_OP
0x000, // 0x15a = 346 - NO_OP
0x000, // 0x15b = 347 - NO_OP
0x000, // 0x15c = 348 - NO_OP
0x000, // 0x15d = 349 - NO_OP
0x000, // 0x15e = 350 - NO_OP
0x000, // 0x15f = 351 - NO_OP
0x000, // 0x160 = 352 - NO_OP
0x000, // 0x161 = 353 - NO_OP
0x000, // 0x162 = 354 - NO_OP
0x000, // 0x163 = 355 - NO_OP
0x000, // 0x164 = 356 - NO_OP
0x000, // 0x165 = 357 - NO_OP
0x000, // 0x166 = 358 - NO_OP
0x000, // 0x167 = 359 - NO_OP
0x000, // 0x168 = 360 - NO_OP
0x000, // 0x169 = 361 - NO_OP
0x000, // 0x16a = 362 - NO_OP
0x000, // 0x16b = 363 - NO_OP
0x000, // 0x16c = 364 - NO_OP
0x000, // 0x16d = 365 - NO_OP
0x000, // 0x16e = 366 - NO_OP
0x000, // 0x16f = 367 - NO_OP
0x000, // 0x170 = 368 - NO_OP
0x000, // 0x171 = 369 - NO_OP
0x000, // 0x172 = 370 - NO_OP
0x000, // 0x173 = 371 - NO_OP
0x000, // 0x174 = 372 - NO_OP
0x000, // 0x175 = 373 - NO_OP
0x000, // 0x176 = 374 - NO_OP
0x000, // 0x177 = 375 - NO_OP
0x000, // 0x178 = 376 - NO_OP
0x000, // 0x179 = 377 - NO_OP
0x000, // 0x17a = 378 - NO_OP
0x000, // 0x17b = 379 - NO_OP
0x000, // 0x17c = 380 - NO_OP
0x000, // 0x17d = 381 - NO_OP
0x000, // 0x17e = 382 - NO_OP
0x000, // 0x17f = 383 - NO_OP
0x000, // 0x180 = 384 - NO_OP
0x000, // 0x181 = 385 - NO_OP
0x000, // 0x182 = 386 - NO_OP
0x000, // 0x183 = 387 - NO_OP
0x000, // 0x184 = 388 - NO_OP
0x000, // 0x185 = 389 - NO_OP
0x000, // 0x186 = 390 - NO_OP
0x000, // 0x187 = 391 - NO_OP
0x000, // 0x188 = 392 - NO_OP
0x000, // 0x189 = 393 - NO_OP
0x000, // 0x18a = 394 - NO_OP
0x000, // 0x18b = 395 - NO_OP
0x000, // 0x18c = 396 - NO_OP
0x000, // 0x18d = 397 - NO_OP
0x000, // 0x18e = 398 - NO_OP
0x000, // 0x18f = 399 - NO_OP
0x000, // 0x190 = 400 - NO_OP
0x000, // 0x191 = 401 - NO_OP
0x000, // 0x192 = 402 - NO_OP
0x000, // 0x193 = 403 - NO_OP
0x000, // 0x194 = 404 - NO_OP
0x000, // 0x195 = 405 - NO_OP
0x000, // 0x196 = 406 - NO_OP
0x000, // 0x197 = 407 - NO_OP
0x000, // 0x198 = 408 - NO_OP
0x000, // 0x199 = 409 - NO_OP
0x000, // 0x19a = 410 - NO_OP
0x000, // 0x19b = 411 - NO_OP
0x000, // 0x19c = 412 - NO_OP
0x000, // 0x19d = 413 - NO_OP
0x000, // 0x19e = 414 - NO_OP
0x000, // 0x19f = 415 - NO_OP
0x000, // 0x1a0 = 416 - NO_OP
0x000, // 0x1a1 = 417 - NO_OP
0x000, // 0x1a2 = 418 - NO_OP
0x000, // 0x1a3 = 419 - NO_OP
0x000, // 0x1a4 = 420 - NO_OP
0x000, // 0x1a5 = 421 - NO_OP
0x000, // 0x1a6 = 422 - NO_OP
0x000, // 0x1a7 = 423 - NO_OP
0x000, // 0x1a8 = 424 - NO_OP
0x000, // 0x1a9 = 425 - NO_OP
0x000, // 0x1aa = 426 - NO_OP
0x000, // 0x1ab = 427 - NO_OP
0x000, // 0x1ac = 428 - NO_OP
0x000, // 0x1ad = 429 - NO_OP
0x000, // 0x1ae = 430 - NO_OP
0x000, // 0x1af = 431 - NO_OP
0x000, // 0x1b0 = 432 - NO_OP
0x000, // 0x1b1 = 433 - NO_OP
0x000, // 0x1b2 = 434 - NO_OP
0x000, // 0x1b3 = 435 - NO_OP
0x000, // 0x1b4 = 436 - NO_OP
0x000, // 0x1b5 = 437 - NO_OP
0x000, // 0x1b6 = 438 - NO_OP
0x000, // 0x1b7 = 439 - NO_OP
0x000, // 0x1b8 = 440 - NO_OP
0x000, // 0x1b9 = 441 - NO_OP
0x000, // 0x1ba = 442 - NO_OP
0x000, // 0x1bb = 443 - NO_OP
0x000, // 0x1bc = 444 - NO_OP
0x000, // 0x1bd = 445 - NO_OP
0x000, // 0x1be = 446 - NO_OP
0x000, // 0x1bf = 447 - NO_OP
0x000, // 0x1c0 = 448 - NO_OP
0x000, // 0x1c1 = 449 - NO_OP
0x000, // 0x1c2 = 450 - NO_OP
0x000, // 0x1c3 = 451 - NO_OP
0x000, // 0x1c4 = 452 - NO_OP
0x000, // 0x1c5 = 453 - NO_OP
0x000, // 0x1c6 = 454 - NO_OP
0x000, // 0x1c7 = 455 - NO_OP
0x000, // 0x1c8 = 456 - NO_OP
0x000, // 0x1c9 = 457 - NO_OP
0x000, // 0x1ca = 458 - NO_OP
0x000, // 0x1cb = 459 - NO_OP
0x000, // 0x1cc = 460 - NO_OP
0x000, // 0x1cd = 461 - NO_OP
0x000, // 0x1ce = 462 - NO_OP
0x000, // 0x1cf = 463 - NO_OP
0x000, // 0x1d0 = 464 - NO_OP
0x000, // 0x1d1 = 465 - NO_OP
0x000, // 0x1d2 = 466 - NO_OP
0x000, // 0x1d3 = 467 - NO_OP
0x000, // 0x1d4 = 468 - NO_OP
0x000, // 0x1d5 = 469 - NO_OP
0x000, // 0x1d6 = 470 - NO_OP
0x000, // 0x1d7 = 471 - NO_OP
0x000, // 0x1d8 = 472 - NO_OP
0x000, // 0x1d9 = 473 - NO_OP
0x000, // 0x1da = 474 - NO_OP
0x000, // 0x1db = 475 - NO_OP
0x000, // 0x1dc = 476 - NO_OP
0x000, // 0x1dd = 477 - NO_OP
0x000, // 0x1de = 478 - NO_OP
0x000, // 0x1df = 479 - NO_OP
0x000, // 0x1e0 = 480 - NO_OP
0x000, // 0x1e1 = 481 - NO_OP
0x000, // 0x1e2 = 482 - NO_OP
0x000, // 0x1e3 = 483 - NO_OP
0x000, // 0x1e4 = 484 - NO_OP
0x000, // 0x1e5 = 485 - NO_OP
0x000, // 0x1e6 = 486 - NO_OP
0x000, // 0x1e7 = 487 - NO_OP
0x000, // 0x1e8 = 488 - NO_OP
0x000, // 0x1e9 = 489 - NO_OP
0x000, // 0x1ea = 490 - NO_OP
0x000, // 0x1eb = 491 - NO_OP
0x000, // 0x1ec = 492 - NO_OP
0x000, // 0x1ed = 493 - NO_OP
0x000, // 0x1ee = 494 - NO_OP
0x000, // 0x1ef = 495 - NO_OP
0x000, // 0x1f0 = 496 - NO_OP
0x000, // 0x1f1 = 497 - NO_OP
0x000, // 0x1f2 = 498 - NO_OP
0x000, // 0x1f3 = 499 - NO_OP
0x000, // 0x1f4 = 500 - NO_OP
0x000, // 0x1f5 = 501 - NO_OP
0x000, // 0x1f6 = 502 - NO_OP
0x000, // 0x1f7 = 503 - NO_OP
0x000, // 0x1f8 = 504 - NO_OP
0x000, // 0x1f9 = 505 - NO_OP
0x000, // 0x1fa = 506 - NO_OP
0x000, // 0x1fb = 507 - NO_OP
0x000, // 0x1fc = 508 - NO_OP
0x000, // 0x1fd = 509 - NO_OP
0x000, // 0x1fe = 510 - NO_OP
0x000 // 0x1ff = 511 - NO_OP
};



/* WCS 20060825 */
bit32 wcsImage_20060825[] = 
{
0x00d, // 00000 = 0 - PHY_RESET_START
0x00d, // 0x001 = 1 - PHY_RESET_START
0x0be, // 0x002 = 2 - JUMP_IF_PHY_READY
0x00c, // 0x003 = 3 - 
0x0ae, // 0x004 = 4 - JUMP_IF_HARD_RESET_PRIMITIVE
0x015, // 0x005 = 5 - 
0x0af, // 0x006 = 6 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x026, // 0x007 = 7 - 
0x0ce, // 0x008 = 8 - JUMP_IF_IDENTIFY_FRAME_TIMEOUT
0x000, // 0x009 = 9 - 
0x0ff, // 0x00a = 10 - JUMP
0x002, // 0x00b = 11 - 
0x00c, // 0x00c = 12 - SEND_ID_FRAME
0x0ae, // 0x00d = 13 - JUMP_IF_HARD_RESET_PRIMITIVE
0x015, // 0x00e = 14 - 
0x0af, // 0x00f = 15 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x02b, // 0x010 = 16 - 
0x0ce, // 0x011 = 17 - JUMP_IF_IDENTIFY_FRAME_TIMEOUT
0x000, // 0x012 = 18 - 
0x0ff, // 0x013 = 19 - JUMP
0x00d, // 0x014 = 20 - 
0x01c, // 0x015 = 21 - SOFT_RESET
0x00d, // 0x016 = 22 - PHY_RESET_START
0x00d, // 0x017 = 23 - PHY_RESET_START
0x0be, // 0x018 = 24 - JUMP_IF_PHY_READY
0x01c, // 0x019 = 25 - 
0x0af, // 0x01a = 26 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x023, // 0x01b = 27 - 
0x00c, // 0x01c = 28 - SEND_ID_FRAME
0x0af, // 0x01d = 29 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x02b, // 0x01e = 30 - 
0x0ce, // 0x01f = 31 - JUMP_IF_IDENTIFY_FRAME_TIMEOUT
0x000, // 0x020 = 32 - 
0x0ff, // 0x021 = 33 - JUMP
0x01d, // 0x022 = 34 - 
0x00c, // 0x023 = 35 - SEND_ID_FRAME
0x0ff, // 0x024 = 36 - JUMP
0x02b, // 0x025 = 37 - 
0x0be, // 0x026 = 38 - JUMP_IF_PHY_READY
0x02a, // 0x027 = 39 - 
0x0ff, // 0x028 = 40 - JUMP
0x026, // 0x029 = 41 - 
0x00c, // 0x02a = 42 - SEND_ID_FRAME
0x000, // 0x02b = 43 - NO_OP
0x000, // 0x02c = 44 - NO_OP
0x000, // 0x02d = 45 - NO_OP
0x000, // 0x02e = 46 - NO_OP
0x000, // 0x02f = 47 - NO_OP
0x000, // 0x030 = 48 - NO_OP
0x0ff, // 0x031 = 49 - JUMP
0x06d, // 0x032 = 50 - 
0x000, // 0x033 = 51 - NO_OP
0x0c9, // 0x034 = 52 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x062, // 0x035 = 53 - 
0x0a5, // 0x036 = 54 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_GOOD
0x04b, // 0x037 = 55 - 
0x0a6, // 0x038 = 56 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_NAK
0x052, // 0x039 = 57 - 
0x0a7, // 0x03a = 58 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_ACK_NAK_TIMEOUT
0x055, // 0x03b = 59 - 
0x0a8, // 0x03c = 60 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_BREAK
0x05f, // 0x03d = 61 - 
0x0aa, // 0x03e = 62 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_CREDIT_TIMEOUT
0x05a, // 0x03f = 63 - 
0x0c5, // 0x040 = 64 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_SMP_ERR
0x05f, // 0x041 = 65 - 
0x0ac, // 0x042 = 66 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_MAX_BURST_SIZE
0x052, // 0x043 = 67 - 
0x0ca, // 0x044 = 68 - JUMP_IF_CLOSE_REQ
0x0fc, // 0x045 = 69 - 
0x0be, // 0x046 = 70 - JUMP_IF_PHY_READY
0x034, // 0x047 = 71 - 
0x01c, // 0x048 = 72 - SOFT_RESET
0x0ff, // 0x049 = 73 - JUMP
0x002, // 0x04a = 74 - 
0x01d, // 0x04b = 75 - ADVANCE
0x0bc, // 0x04c = 76 - JUMP_IF_BREAK_RECEIVED
0x10f, // 0x04d = 77 - 
0x0c3, // 0x04e = 78 - JUMP_IF_SMP_PROTOCOL
0x0fc, // 0x04f = 79 - 
0x0ff, // 0x050 = 80 - JUMP
0x065, // 0x051 = 81 - 
0x01d, // 0x052 = 82 - ADVANCE
0x0ff, // 0x053 = 83 - JUMP
0x065, // 0x054 = 84 - 
0x01d, // 0x055 = 85 - ADVANCE
0x0bc, // 0x056 = 86 - JUMP_IF_BREAK_RECEIVED
0x10f, // 0x057 = 87 - 
0x0ff, // 0x058 = 88 - JUMP
0x11b, // 0x059 = 89 - 
0x01d, // 0x05a = 90 - ADVANCE
0x0bc, // 0x05b = 91 - JUMP_IF_BREAK_RECEIVED
0x10f, // 0x05c = 92 - 
0x0ff, // 0x05d = 93 - JUMP
0x11e, // 0x05e = 94 - 
0x01d, // 0x05f = 95 - ADVANCE
0x0ff, // 0x060 = 96 - JUMP
0x10f, // 0x061 = 97 - 
0x022, // 0x062 = 98 - SEND_CREDIT_BLOCK
0x0ff, // 0x063 = 99 - JUMP
0x036, // 0x064 = 100 - 
0x083, // 0x065 = 101 - TIMER_START
0x004, // 0x066 = 102 - 
0x000, // 0x067 = 103 - NO_OP
0x000, // 0x068 = 104 - NO_OP
0x0b8, // 0x069 = 105 - JUMP_IF_TIMER_EXPIRED
0x06d, // 0x06a = 106 - 
0x0ff, // 0x06b = 107 - JUMP
0x067, // 0x06c = 108 - 
0x0bc, // 0x06d = 109 - JUMP_IF_BREAK_RECEIVED
0x10f, // 0x06e = 110 - 
0x0be, // 0x06f = 111 - JUMP_IF_PHY_READY
0x074, // 0x070 = 112 - 
0x01c, // 0x071 = 113 - SOFT_RESET
0x0ff, // 0x072 = 114 - JUMP
0x002, // 0x073 = 115 - 
0x0c8, // 0x074 = 116 - JUMP_IF_HIP_REQ
0x086, // 0x075 = 117 - 
0x0c6, // 0x076 = 118 - JUMP_IF_SFO_REQ
0x08f, // 0x077 = 119 - 
0x0c7, // 0x078 = 120 - JUMP_IF_DOC_REQ
0x09a, // 0x079 = 121 - 
0x0a3, // 0x07a = 122 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
0x0db, // 0x07b = 123 - 
0x0a2, // 0x07c = 124 - JUMP_IF_CONNECTION_OPEN_MASTER_FLAG_SET
0x0c4, // 0x07d = 125 - 
0x0c8, // 0x07e = 126 - JUMP_IF_HIP_REQ
0x0a3, // 0x07f = 127 - 
0x0c6, // 0x080 = 128 - JUMP_IF_SFO_REQ
0x0a8, // 0x081 = 129 - 
0x0c7, // 0x082 = 130 - JUMP_IF_DOC_REQ
0x0ad, // 0x083 = 131 - 
0x0ff, // 0x084 = 132 - JUMP
0x06d, // 0x085 = 133 - 
0x028, // 0x086 = 134 - CHECK_HIP
0x000, // 0x087 = 135 - NO_OP
0x000, // 0x088 = 136 - NO_OP
0x000, // 0x089 = 137 - NO_OP
0x000, // 0x08a = 138 - NO_OP
0x0d8, // 0x08b = 139 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0a3, // 0x08c = 140 - 
0x0ff, // 0x08d = 141 - JUMP
0x07a, // 0x08e = 142 - 
0x029, // 0x08f = 143 - CHECK_SFO
0x000, // 0x090 = 144 - NO_OP
0x000, // 0x091 = 145 - NO_OP
0x000, // 0x092 = 146 - NO_OP
0x000, // 0x093 = 147 - NO_OP
0x0d8, // 0x094 = 148 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0a8, // 0x095 = 149 - 
0x0c7, // 0x096 = 150 - JUMP_IF_DOC_REQ
0x09a, // 0x097 = 151 - 
0x0ff, // 0x098 = 152 - JUMP
0x07a, // 0x099 = 153 - 
0x02a, // 0x09a = 154 - CHECK_DOC
0x000, // 0x09b = 155 - NO_OP
0x000, // 0x09c = 156 - NO_OP
0x000, // 0x09d = 157 - NO_OP
0x000, // 0x09e = 158 - NO_OP
0x0d8, // 0x09f = 159 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0ad, // 0x0a0 = 160 - 
0x0ff, // 0x0a1 = 161 - JUMP
0x07a, // 0x0a2 = 162 - 
0x020, // 0x0a3 = 163 - SELECT_HIP
0x000, // 0x0a4 = 164 - NO_OP
0x000, // 0x0a5 = 165 - NO_OP
0x0ff, // 0x0a6 = 166 - JUMP
0x0b0, // 0x0a7 = 167 - 
0x01e, // 0x0a8 = 168 - SELECT_SFO
0x000, // 0x0a9 = 169 - NO_OP
0x000, // 0x0aa = 170 - NO_OP
0x0ff, // 0x0ab = 171 - JUMP
0x0b0, // 0x0ac = 172 - 
0x01f, // 0x0ad = 173 - SELECT_DOC
0x000, // 0x0ae = 174 - NO_OP
0x000, // 0x0af = 175 - NO_OP
0x0a4, // 0x0b0 = 176 - JUMP_IF_CONNECTION_ACTIVE_SET
0x0b4, // 0x0b1 = 177 - 
0x0ff, // 0x0b2 = 178 - JUMP
0x121, // 0x0b3 = 179 - 
0x0a0, // 0x0b4 = 180 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL
0x0ba, // 0x0b5 = 181 - 
0x0a3, // 0x0b6 = 182 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
0x0db, // 0x0b7 = 183 - 
0x0ff, // 0x0b8 = 184 - JUMP
0x0fc, // 0x0b9 = 185 - 
0x0cb, // 0x0ba = 186 - JUMP_IF_FREEZE_ACTIVE
0x0bf, // 0x0bb = 187 - 
0x013, // 0x0bc = 188 - SET_OPEN_STATUS_NORMAL
0x0ff, // 0x0bd = 189 - JUMP
0x033, // 0x0be = 190 - 
0x024, // 0x0bf = 191 - SET_OPEN_STATUS_FREEZE
0x000, // 0x0c0 = 192 - NO_OP
0x000, // 0x0c1 = 193 - NO_OP
0x0ff, // 0x0c2 = 194 - JUMP
0x06d, // 0x0c3 = 195 - 
0x0d2, // 0x0c4 = 196 - JUMP_IF_STP_CONNECTION_ACTIVE
0x0c8, // 0x0c5 = 197 - 
0x0ff, // 0x0c6 = 198 - JUMP
0x0fc, // 0x0c7 = 199 - 
0x0d5, // 0x0c8 = 200 - JUMP_IF_CLOSE_RECEIVED
0x0fc, // 0x0c9 = 201 - 
0x0d6, // 0x0ca = 202 - JUMP_IF_SYNC_RECEIVED
0x0ce, // 0x0cb = 203 - 
0x0ff, // 0x0cc = 204 - JUMP
0x06d, // 0x0cd = 205 - 
0x027, // 0x0ce = 206 - SEND_STP_CLOSE_REQ
0x000, // 0x0cf = 207 - NO_OP
0x000, // 0x0d0 = 208 - NO_OP
0x000, // 0x0d1 = 209 - NO_OP
0x000, // 0x0d2 = 210 - NO_OP
0x0d5, // 0x0d3 = 211 - JUMP_IF_CLOSE_RECEIVED
0x0fc, // 0x0d4 = 212 - 
0x0bc, // 0x0d5 = 213 - JUMP_IF_BREAK_RECEIVED
0x10f, // 0x0d6 = 214 - 
0x0d7, // 0x0d7 = 215 - JUMP_IF_STP_CLOSE_ACK
0x0fc, // 0x0d8 = 216 - 
0x0ff, // 0x0d9 = 217 - JUMP
0x0cf, // 0x0da = 218 - 
0x0c3, // 0x0db = 219 - JUMP_IF_SMP_PROTOCOL
0x0e3, // 0x0dc = 220 - 
0x0d2, // 0x0dd = 221 - JUMP_IF_STP_CONNECTION_ACTIVE
0x0e7, // 0x0de = 222 - 
0x0d1, // 0x0df = 223 - JUMP_IF_IDLE_TIMER_TIMEOUT
0x0ed, // 0x0e0 = 224 - 
0x0ff, // 0x0e1 = 225 - JUMP
0x06d, // 0x0e2 = 226 - 
0x0c4, // 0x0e3 = 227 - JUMP_IF_SMP_FRAME_ERR_RECEIVED
0x10f, // 0x0e4 = 228 - 
0x0ff, // 0x0e5 = 229 - JUMP
0x07e, // 0x0e6 = 230 - 
0x0d5, // 0x0e7 = 231 - JUMP_IF_CLOSE_RECEIVED
0x0ed, // 0x0e8 = 232 - 
0x0d6, // 0x0e9 = 233 - JUMP_IF_SYNC_RECEIVED
0x0ef, // 0x0ea = 234 - 
0x0ff, // 0x0eb = 235 - JUMP
0x0e7, // 0x0ec = 236 - 
0x0ff, // 0x0ed = 237 - JUMP
0x0fc, // 0x0ee = 238 - 
0x027, // 0x0ef = 239 - SEND_STP_CLOSE_REQ
0x000, // 0x0f0 = 240 - NO_OP
0x000, // 0x0f1 = 241 - NO_OP
0x000, // 0x0f2 = 242 - NO_OP
0x000, // 0x0f3 = 243 - NO_OP
0x0d5, // 0x0f4 = 244 - JUMP_IF_CLOSE_RECEIVED
0x0fc, // 0x0f5 = 245 - 
0x0bc, // 0x0f6 = 246 - JUMP_IF_BREAK_RECEIVED
0x10f, // 0x0f7 = 247 - 
0x0d7, // 0x0f8 = 248 - JUMP_IF_STP_CLOSE_ACK
0x0fc, // 0x0f9 = 249 - 
0x0ff, // 0x0fa = 250 - JUMP
0x0f0, // 0x0fb = 251 - 
0x004, // 0x0fc = 252 - CLOSE_NORMAL
0x000, // 0x0fd = 253 - NO_OP
0x000, // 0x0fe = 254 - NO_OP
0x000, // 0x0ff = 255 - NO_OP
0x000, // 0x100 = 256 - NO_OP
0x0c9, // 0x101 = 257 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x10c, // 0x102 = 258 - 
0x0c0, // 0x103 = 259 - JUMP_IF_CLOSE_STATUS_EQUAL_ANY
0x06d, // 0x104 = 260 - 
0x0bc, // 0x105 = 261 - JUMP_IF_BREAK_RECEIVED
0x10f, // 0x106 = 262 - 
0x0be, // 0x107 = 263 - JUMP_IF_PHY_READY
0x0fd, // 0x108 = 264 - 
0x01c, // 0x109 = 265 - SOFT_RESET
0x0ff, // 0x10a = 266 - JUMP
0x002, // 0x10b = 267 - 
0x022, // 0x10c = 268 - SEND_CREDIT_BLOCK
0x0ff, // 0x10d = 269 - JUMP
0x0fd, // 0x10e = 270 - 
0x007, // 0x10f = 271 - CLOSE_BREAK
0x000, // 0x110 = 272 - NO_OP
0x000, // 0x111 = 273 - NO_OP
0x000, // 0x112 = 274 - NO_OP
0x000, // 0x113 = 275 - NO_OP
0x0c0, // 0x114 = 276 - JUMP_IF_CLOSE_STATUS_EQUAL_ANY
0x06d, // 0x115 = 277 - 
0x0be, // 0x116 = 278 - JUMP_IF_PHY_READY
0x110, // 0x117 = 279 - 
0x01c, // 0x118 = 280 - SOFT_RESET
0x0ff, // 0x119 = 281 - JUMP
0x002, // 0x11a = 282 - 
0x005, // 0x11b = 283 - CLOSE_ACK_NAK_TIMEOUT
0x0ff, // 0x11c = 284 - JUMP
0x0fd, // 0x11d = 285 - 
0x006, // 0x11e = 286 - CLOSE_CREDIT_TIMEOUT
0x0ff, // 0x11f = 287 - JUMP
0x0fd, // 0x120 = 288 - 
0x0cc, // 0x121 = 289 - JUMP_IF_RX_BUFFER_FULL
0x06d, // 0x122 = 290 - 
0x0b7, // 0x123 = 291 - JUMP_IF_FLAG_7_SET
0x128, // 0x124 = 292 - 
0x011, // 0x125 = 293 - START_IT_NEXUS_LOSS_TIMER
0x00f, // 0x126 = 294 - PATHWAY_BLOCKED_CNT_RESET
0x00e, // 0x127 = 295 - START_ARB_WAIT_TIMER
0x0cb, // 0x128 = 296 - JUMP_IF_FREEZE_ACTIVE
0x169, // 0x129 = 297 - 
0x001, // 0x12a = 298 - OPEN_REQUEST
0x080, // 0x12b = 299 - SET_FLAG
0x080, // 0x12c = 300 - 
0x090, // 0x12d = 301 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_ACCEPT
0x153, // 0x12e = 302 - 
0x095, // 0x12f = 303 - JUMP_IF_OPEN_STATUS_EQUAL_RATE_NOT_SUPPORTED
0x158, // 0x130 = 304 - 
0x099, // 0x131 = 305 - JUMP_IF_OPEN_STATUS_EQUAL_PROTOCOL_NOT_SUPPORTED
0x15b, // 0x132 = 306 - 
0x09b, // 0x133 = 307 - JUMP_IF_OPEN_STATUS_EQUAL_WRONG_DESTINATION
0x15e, // 0x134 = 308 - 
0x094, // 0x135 = 309 - JUMP_IF_OPEN_STATUS_EQUAL_BREAK_RECEIVED
0x128, // 0x136 = 310 - 
0x093, // 0x137 = 311 - JUMP_IF_OPEN_STATUS_EQUAL_BAD_DESTINATION
0x161, // 0x138 = 312 - 
0x09f, // 0x139 = 313 - JUMP_IF_IT_NEXUS_LOSS_TIMEOUT
0x164, // 0x13a = 314 - 
0x09a, // 0x13b = 315 - JUMP_IF_OPEN_STATUS_EQUAL_STP_RESOURCE_BUSY
0x128, // 0x13c = 316 - 
0x096, // 0x13d = 317 - JUMP_IF_OPEN_STATUS_EQUAL_NO_DESTINATION
0x128, // 0x13e = 318 - 
0x097, // 0x13f = 319 - JUMP_IF_OPEN_STATUS_EQUAL_PATHWAY_BLOCKED
0x16e, // 0x140 = 320 - 
0x098, // 0x141 = 321 - JUMP_IF_OPEN_STATUS_EQUAL_RETRY
0x128, // 0x142 = 322 - 
0x092, // 0x143 = 323 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_TIMEOUT
0x128, // 0x144 = 324 - 
0x0a4, // 0x145 = 325 - JUMP_IF_CONNECTION_ACTIVE_SET
0x14d, // 0x146 = 326 - 
0x0be, // 0x147 = 327 - JUMP_IF_PHY_READY
0x12d, // 0x148 = 328 - 
0x01b, // 0x149 = 329 - SET_OPEN_STATUS_PHY_NOT_RDY
0x01c, // 0x14a = 330 - SOFT_RESET
0x0ff, // 0x14b = 331 - JUMP
0x002, // 0x14c = 332 - 
0x0a0, // 0x14d = 333 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL
0x153, // 0x14e = 334 - 
0x000, // 0x14f = 335 - NO_OP
0x000, // 0x150 = 336 - NO_OP
0x0ff, // 0x151 = 337 - JUMP
0x06d, // 0x152 = 338 - 
0x013, // 0x153 = 339 - SET_OPEN_STATUS_NORMAL
0x081, // 0x154 = 340 - CLEAR_FLAG
0x080, // 0x155 = 341 - 
0x0ff, // 0x156 = 342 - JUMP
0x033, // 0x157 = 343 - 
0x017, // 0x158 = 344 - SET_OPEN_STATUS_BAD_RATE
0x0ff, // 0x159 = 345 - JUMP
0x16a, // 0x15a = 346 - 
0x018, // 0x15b = 347 - SET_OPEN_STATUS_BAD_PROTOCOL
0x0ff, // 0x15c = 348 - JUMP
0x16a, // 0x15d = 349 - 
0x01a, // 0x15e = 350 - SET_OPEN_STATUS_WRONG_DEST
0x0ff, // 0x15f = 351 - JUMP
0x16a, // 0x160 = 352 - 
0x015, // 0x161 = 353 - SET_OPEN_STATUS_BAD_DEST
0x0ff, // 0x162 = 354 - JUMP
0x16a, // 0x163 = 355 - 
0x014, // 0x164 = 356 - SET_OPEN_STATUS_IT_NEXUS_LOSS
0x081, // 0x165 = 357 - CLEAR_FLAG
0x080, // 0x166 = 358 - 
0x0ff, // 0x167 = 359 - JUMP
0x16a, // 0x168 = 360 - 
0x024, // 0x169 = 361 - SET_OPEN_STATUS_FREEZE
0x000, // 0x16a = 362 - NO_OP
0x000, // 0x16b = 363 - NO_OP
0x0ff, // 0x16c = 364 - JUMP
0x06d, // 0x16d = 365 - 
0x010, // 0x16e = 366 - PATHWAY_BLOCKED_CNT_INC
0x0ff, // 0x16f = 367 - JUMP
0x128, // 0x170 = 368 - 
0x000, // 0x171 = 369 - NO_OP
0x000, // 0x172 = 370 - NO_OP
0x000, // 0x173 = 371 - NO_OP
0x000, // 0x174 = 372 - NO_OP
0x000, // 0x175 = 373 - NO_OP
0x000, // 0x176 = 374 - NO_OP
0x000, // 0x177 = 375 - NO_OP
0x000, // 0x178 = 376 - NO_OP
0x000, // 0x179 = 377 - NO_OP
0x000, // 0x17a = 378 - NO_OP
0x000, // 0x17b = 379 - NO_OP
0x000, // 0x17c = 380 - NO_OP
0x000, // 0x17d = 381 - NO_OP
0x000, // 0x17e = 382 - NO_OP
0x000, // 0x17f = 383 - NO_OP
0x000, // 0x180 = 384 - NO_OP
0x000, // 0x181 = 385 - NO_OP
0x000, // 0x182 = 386 - NO_OP
0x000, // 0x183 = 387 - NO_OP
0x000, // 0x184 = 388 - NO_OP
0x000, // 0x185 = 389 - NO_OP
0x000, // 0x186 = 390 - NO_OP
0x000, // 0x187 = 391 - NO_OP
0x000, // 0x188 = 392 - NO_OP
0x000, // 0x189 = 393 - NO_OP
0x000, // 0x18a = 394 - NO_OP
0x000, // 0x18b = 395 - NO_OP
0x000, // 0x18c = 396 - NO_OP
0x000, // 0x18d = 397 - NO_OP
0x000, // 0x18e = 398 - NO_OP
0x000, // 0x18f = 399 - NO_OP
0x000, // 0x190 = 400 - NO_OP
0x000, // 0x191 = 401 - NO_OP
0x000, // 0x192 = 402 - NO_OP
0x000, // 0x193 = 403 - NO_OP
0x000, // 0x194 = 404 - NO_OP
0x000, // 0x195 = 405 - NO_OP
0x000, // 0x196 = 406 - NO_OP
0x000, // 0x197 = 407 - NO_OP
0x000, // 0x198 = 408 - NO_OP
0x000, // 0x199 = 409 - NO_OP
0x000, // 0x19a = 410 - NO_OP
0x000, // 0x19b = 411 - NO_OP
0x000, // 0x19c = 412 - NO_OP
0x000, // 0x19d = 413 - NO_OP
0x000, // 0x19e = 414 - NO_OP
0x000, // 0x19f = 415 - NO_OP
0x000, // 0x1a0 = 416 - NO_OP
0x000, // 0x1a1 = 417 - NO_OP
0x000, // 0x1a2 = 418 - NO_OP
0x000, // 0x1a3 = 419 - NO_OP
0x000, // 0x1a4 = 420 - NO_OP
0x000, // 0x1a5 = 421 - NO_OP
0x000, // 0x1a6 = 422 - NO_OP
0x000, // 0x1a7 = 423 - NO_OP
0x000, // 0x1a8 = 424 - NO_OP
0x000, // 0x1a9 = 425 - NO_OP
0x000, // 0x1aa = 426 - NO_OP
0x000, // 0x1ab = 427 - NO_OP
0x000, // 0x1ac = 428 - NO_OP
0x000, // 0x1ad = 429 - NO_OP
0x000, // 0x1ae = 430 - NO_OP
0x000, // 0x1af = 431 - NO_OP
0x000, // 0x1b0 = 432 - NO_OP
0x000, // 0x1b1 = 433 - NO_OP
0x000, // 0x1b2 = 434 - NO_OP
0x000, // 0x1b3 = 435 - NO_OP
0x000, // 0x1b4 = 436 - NO_OP
0x000, // 0x1b5 = 437 - NO_OP
0x000, // 0x1b6 = 438 - NO_OP
0x000, // 0x1b7 = 439 - NO_OP
0x000, // 0x1b8 = 440 - NO_OP
0x000, // 0x1b9 = 441 - NO_OP
0x000, // 0x1ba = 442 - NO_OP
0x000, // 0x1bb = 443 - NO_OP
0x000, // 0x1bc = 444 - NO_OP
0x000, // 0x1bd = 445 - NO_OP
0x000, // 0x1be = 446 - NO_OP
0x000, // 0x1bf = 447 - NO_OP
0x000, // 0x1c0 = 448 - NO_OP
0x000, // 0x1c1 = 449 - NO_OP
0x000, // 0x1c2 = 450 - NO_OP
0x000, // 0x1c3 = 451 - NO_OP
0x000, // 0x1c4 = 452 - NO_OP
0x000, // 0x1c5 = 453 - NO_OP
0x000, // 0x1c6 = 454 - NO_OP
0x000, // 0x1c7 = 455 - NO_OP
0x000, // 0x1c8 = 456 - NO_OP
0x000, // 0x1c9 = 457 - NO_OP
0x000, // 0x1ca = 458 - NO_OP
0x000, // 0x1cb = 459 - NO_OP
0x000, // 0x1cc = 460 - NO_OP
0x000, // 0x1cd = 461 - NO_OP
0x000, // 0x1ce = 462 - NO_OP
0x000, // 0x1cf = 463 - NO_OP
0x000, // 0x1d0 = 464 - NO_OP
0x000, // 0x1d1 = 465 - NO_OP
0x000, // 0x1d2 = 466 - NO_OP
0x000, // 0x1d3 = 467 - NO_OP
0x000, // 0x1d4 = 468 - NO_OP
0x000, // 0x1d5 = 469 - NO_OP
0x000, // 0x1d6 = 470 - NO_OP
0x000, // 0x1d7 = 471 - NO_OP
0x000, // 0x1d8 = 472 - NO_OP
0x000, // 0x1d9 = 473 - NO_OP
0x000, // 0x1da = 474 - NO_OP
0x000, // 0x1db = 475 - NO_OP
0x000, // 0x1dc = 476 - NO_OP
0x000, // 0x1dd = 477 - NO_OP
0x000, // 0x1de = 478 - NO_OP
0x000, // 0x1df = 479 - NO_OP
0x000, // 0x1e0 = 480 - NO_OP
0x000, // 0x1e1 = 481 - NO_OP
0x000, // 0x1e2 = 482 - NO_OP
0x000, // 0x1e3 = 483 - NO_OP
0x000, // 0x1e4 = 484 - NO_OP
0x000, // 0x1e5 = 485 - NO_OP
0x000, // 0x1e6 = 486 - NO_OP
0x000, // 0x1e7 = 487 - NO_OP
0x000, // 0x1e8 = 488 - NO_OP
0x000, // 0x1e9 = 489 - NO_OP
0x000, // 0x1ea = 490 - NO_OP
0x000, // 0x1eb = 491 - NO_OP
0x000, // 0x1ec = 492 - NO_OP
0x000, // 0x1ed = 493 - NO_OP
0x000, // 0x1ee = 494 - NO_OP
0x000, // 0x1ef = 495 - NO_OP
0x000, // 0x1f0 = 496 - NO_OP
0x000, // 0x1f1 = 497 - NO_OP
0x000, // 0x1f2 = 498 - NO_OP
0x000, // 0x1f3 = 499 - NO_OP
0x000, // 0x1f4 = 500 - NO_OP
0x000, // 0x1f5 = 501 - NO_OP
0x000, // 0x1f6 = 502 - NO_OP
0x000, // 0x1f7 = 503 - NO_OP
0x000, // 0x1f8 = 504 - NO_OP
0x000, // 0x1f9 = 505 - NO_OP
0x000, // 0x1fa = 506 - NO_OP
0x000, // 0x1fb = 507 - NO_OP
0x000, // 0x1fc = 508 - NO_OP
0x000, // 0x1fd = 509 - NO_OP
0x000, // 0x1fe = 510 - NO_OP
0x000, // 0x1ff = 511 - NO_OP
};

/* wcs with A1302_20 */
bit32 wcsImage_A1302_20[] = 
{
0x00d, // 00000 = 0 - PHY_RESET_START
0x00d, // 0x001 = 1 - PHY_RESET_START
0x0be, // 0x002 = 2 - JUMP_IF_PHY_READY
0x002, // 0x003 = 3 - 
0x0be, // 0x004 = 4 - JUMP_IF_PHY_READY
0x00e, // 0x005 = 5 - 
0x0ae, // 0x006 = 6 - JUMP_IF_HARD_RESET_PRIMITIVE
0x024, // 0x007 = 7 - 
0x0af, // 0x008 = 8 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x017, // 0x009 = 9 - 
0x0ce, // 0x00a = 10 - JUMP_IF_IDENTIFY_FRAME_TIMEOUT
0x000, // 0x00b = 11 - 
0x0ff, // 0x00c = 12 - JUMP
0x004, // 0x00d = 13 - 
0x00c, // 0x00e = 14 - SEND_ID_FRAME
0x0ae, // 0x00f = 15 - JUMP_IF_HARD_RESET_PRIMITIVE
0x024, // 0x010 = 16 - 
0x0af, // 0x011 = 17 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x01c, // 0x012 = 18 - 
0x0ce, // 0x013 = 19 - JUMP_IF_IDENTIFY_FRAME_TIMEOUT
0x000, // 0x014 = 20 - 
0x0ff, // 0x015 = 21 - JUMP
0x00f, // 0x016 = 22 - 
0x0be, // 0x017 = 23 - JUMP_IF_PHY_READY
0x01b, // 0x018 = 24 - 
0x0ff, // 0x019 = 25 - JUMP
0x017, // 0x01a = 26 - 
0x00c, // 0x01b = 27 - SEND_ID_FRAME
0x000, // 0x01c = 28 - NO_OP
0x000, // 0x01d = 29 - NO_OP
0x000, // 0x01e = 30 - NO_OP
0x000, // 0x01f = 31 - NO_OP
0x000, // 0x020 = 32 - NO_OP
0x000, // 0x021 = 33 - NO_OP
0x0ff, // 0x022 = 34 - JUMP
0x07e, // 0x023 = 35 - 
0x01c, // 0x024 = 36 - SOFT_RESET
0x00d, // 0x025 = 37 - PHY_RESET_START
0x00d, // 0x026 = 38 - PHY_RESET_START
0x0be, // 0x027 = 39 - JUMP_IF_PHY_READY
0x027, // 0x028 = 40 - 
0x0be, // 0x029 = 41 - JUMP_IF_PHY_READY
0x02f, // 0x02a = 42 - 
0x0af, // 0x02b = 43 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x036, // 0x02c = 44 - 
0x0ff, // 0x02d = 45 - JUMP
0x029, // 0x02e = 46 - 
0x00c, // 0x02f = 47 - SEND_ID_FRAME
0x0af, // 0x030 = 48 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x039, // 0x031 = 49 - 
0x0ce, // 0x032 = 50 - JUMP_IF_IDENTIFY_FRAME_TIMEOUT
0x024, // 0x033 = 51 - 
0x0ff, // 0x034 = 52 - JUMP
0x030, // 0x035 = 53 - 
0x00c, // 0x036 = 54 - SEND_ID_FRAME
0x0ff, // 0x037 = 55 - JUMP
0x039, // 0x038 = 56 - 
0x000, // 0x039 = 57 - NO_OP
0x0cb, // 0x03a = 58 - JUMP_IF_FREEZE_ACTIVE
0x03e, // 0x03b = 59 - 
0x0ff, // 0x03c = 60 - JUMP
0x03a, // 0x03d = 61 - 
0x0cb, // 0x03e = 62 - JUMP_IF_FREEZE_ACTIVE
0x03e, // 0x03f = 63 - 
0x0ff, // 0x040 = 64 - JUMP
0x07e, // 0x041 = 65 - 
0x000, // 0x042 = 66 - NO_OP
0x0c9, // 0x043 = 67 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x073, // 0x044 = 68 - 
0x0a5, // 0x045 = 69 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_GOOD
0x05c, // 0x046 = 70 - 
0x0a6, // 0x047 = 71 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_NAK
0x063, // 0x048 = 72 - 
0x0a7, // 0x049 = 73 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_ACK_NAK_TIMEOUT
0x066, // 0x04a = 74 - 
0x0a8, // 0x04b = 75 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_BREAK
0x070, // 0x04c = 76 - 
0x0aa, // 0x04d = 77 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_CREDIT_TIMEOUT
0x06b, // 0x04e = 78 - 
0x0c5, // 0x04f = 79 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_SMP_ERR
0x070, // 0x050 = 80 - 
0x0ac, // 0x051 = 81 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_MAX_BURST_SIZE
0x063, // 0x052 = 82 - 
0x0d9, // 0x053 = 83 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_FREEZE_TIMEOUT
0x070, // 0x054 = 84 - 
0x0ca, // 0x055 = 85 - JUMP_IF_CLOSE_REQ
0x10d, // 0x056 = 86 - 
0x0be, // 0x057 = 87 - JUMP_IF_PHY_READY
0x043, // 0x058 = 88 - 
0x01c, // 0x059 = 89 - SOFT_RESET
0x0ff, // 0x05a = 90 - JUMP
0x004, // 0x05b = 91 - 
0x01d, // 0x05c = 92 - ADVANCE
0x0bc, // 0x05d = 93 - JUMP_IF_BREAK_RECEIVED
0x120, // 0x05e = 94 - 
0x0c3, // 0x05f = 95 - JUMP_IF_SMP_PROTOCOL
0x10d, // 0x060 = 96 - 
0x0ff, // 0x061 = 97 - JUMP
0x076, // 0x062 = 98 - 
0x01d, // 0x063 = 99 - ADVANCE
0x0ff, // 0x064 = 100 - JUMP
0x076, // 0x065 = 101 - 
0x01d, // 0x066 = 102 - ADVANCE
0x0bc, // 0x067 = 103 - JUMP_IF_BREAK_RECEIVED
0x120, // 0x068 = 104 - 
0x0ff, // 0x069 = 105 - JUMP
0x12c, // 0x06a = 106 - 
0x01d, // 0x06b = 107 - ADVANCE
0x0bc, // 0x06c = 108 - JUMP_IF_BREAK_RECEIVED
0x120, // 0x06d = 109 - 
0x0ff, // 0x06e = 110 - JUMP
0x12f, // 0x06f = 111 - 
0x01d, // 0x070 = 112 - ADVANCE
0x0ff, // 0x071 = 113 - JUMP
0x120, // 0x072 = 114 - 
0x022, // 0x073 = 115 - SEND_CREDIT_BLOCK
0x0ff, // 0x074 = 116 - JUMP
0x045, // 0x075 = 117 - 
0x083, // 0x076 = 118 - TIMER_START
0x004, // 0x077 = 119 - 
0x000, // 0x078 = 120 - NO_OP
0x000, // 0x079 = 121 - NO_OP
0x0b8, // 0x07a = 122 - JUMP_IF_TIMER_EXPIRED
0x07e, // 0x07b = 123 - 
0x0ff, // 0x07c = 124 - JUMP
0x078, // 0x07d = 125 - 
0x0bc, // 0x07e = 126 - JUMP_IF_BREAK_RECEIVED
0x120, // 0x07f = 127 - 
0x0be, // 0x080 = 128 - JUMP_IF_PHY_READY
0x085, // 0x081 = 129 - 
0x01c, // 0x082 = 130 - SOFT_RESET
0x0ff, // 0x083 = 131 - JUMP
0x004, // 0x084 = 132 - 
0x0c8, // 0x085 = 133 - JUMP_IF_HIP_REQ
0x097, // 0x086 = 134 - 
0x0c6, // 0x087 = 135 - JUMP_IF_SFO_REQ
0x0a0, // 0x088 = 136 - 
0x0c7, // 0x089 = 137 - JUMP_IF_DOC_REQ
0x0ab, // 0x08a = 138 - 
0x0a3, // 0x08b = 139 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
0x0ec, // 0x08c = 140 - 
0x0a2, // 0x08d = 141 - JUMP_IF_CONNECTION_OPEN_MASTER_FLAG_SET
0x0d5, // 0x08e = 142 - 
0x0c8, // 0x08f = 143 - JUMP_IF_HIP_REQ
0x0b4, // 0x090 = 144 - 
0x0c6, // 0x091 = 145 - JUMP_IF_SFO_REQ
0x0b9, // 0x092 = 146 - 
0x0c7, // 0x093 = 147 - JUMP_IF_DOC_REQ
0x0be, // 0x094 = 148 - 
0x0ff, // 0x095 = 149 - JUMP
0x07e, // 0x096 = 150 - 
0x028, // 0x097 = 151 - CHECK_HIP
0x000, // 0x098 = 152 - NO_OP
0x000, // 0x099 = 153 - NO_OP
0x000, // 0x09a = 154 - NO_OP
0x000, // 0x09b = 155 - NO_OP
0x0d8, // 0x09c = 156 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0b4, // 0x09d = 157 - 
0x0ff, // 0x09e = 158 - JUMP
0x08b, // 0x09f = 159 - 
0x029, // 0x0a0 = 160 - CHECK_SFO
0x000, // 0x0a1 = 161 - NO_OP
0x000, // 0x0a2 = 162 - NO_OP
0x000, // 0x0a3 = 163 - NO_OP
0x000, // 0x0a4 = 164 - NO_OP
0x0d8, // 0x0a5 = 165 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0b9, // 0x0a6 = 166 - 
0x0c7, // 0x0a7 = 167 - JUMP_IF_DOC_REQ
0x0ab, // 0x0a8 = 168 - 
0x0ff, // 0x0a9 = 169 - JUMP
0x08b, // 0x0aa = 170 - 
0x02a, // 0x0ab = 171 - CHECK_DOC
0x000, // 0x0ac = 172 - NO_OP
0x000, // 0x0ad = 173 - NO_OP
0x000, // 0x0ae = 174 - NO_OP
0x000, // 0x0af = 175 - NO_OP
0x0d8, // 0x0b0 = 176 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0be, // 0x0b1 = 177 - 
0x0ff, // 0x0b2 = 178 - JUMP
0x08b, // 0x0b3 = 179 - 
0x020, // 0x0b4 = 180 - SELECT_HIP
0x000, // 0x0b5 = 181 - NO_OP
0x000, // 0x0b6 = 182 - NO_OP
0x0ff, // 0x0b7 = 183 - JUMP
0x0c1, // 0x0b8 = 184 - 
0x01e, // 0x0b9 = 185 - SELECT_SFO
0x000, // 0x0ba = 186 - NO_OP
0x000, // 0x0bb = 187 - NO_OP
0x0ff, // 0x0bc = 188 - JUMP
0x0c1, // 0x0bd = 189 - 
0x01f, // 0x0be = 190 - SELECT_DOC
0x000, // 0x0bf = 191 - NO_OP
0x000, // 0x0c0 = 192 - NO_OP
0x0a4, // 0x0c1 = 193 - JUMP_IF_CONNECTION_ACTIVE_SET
0x0c5, // 0x0c2 = 194 - 
0x0ff, // 0x0c3 = 195 - JUMP
0x132, // 0x0c4 = 196 - 
0x0a0, // 0x0c5 = 197 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL
0x0cb, // 0x0c6 = 198 - 
0x0a3, // 0x0c7 = 199 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
0x0ec, // 0x0c8 = 200 - 
0x0ff, // 0x0c9 = 201 - JUMP
0x10d, // 0x0ca = 202 - 
0x0cb, // 0x0cb = 203 - JUMP_IF_FREEZE_ACTIVE
0x0d0, // 0x0cc = 204 - 
0x013, // 0x0cd = 205 - SET_OPEN_STATUS_NORMAL
0x0ff, // 0x0ce = 206 - JUMP
0x042, // 0x0cf = 207 - 
0x024, // 0x0d0 = 208 - SET_OPEN_STATUS_FREEZE
0x000, // 0x0d1 = 209 - NO_OP
0x000, // 0x0d2 = 210 - NO_OP
0x0ff, // 0x0d3 = 211 - JUMP
0x07e, // 0x0d4 = 212 - 
0x0d2, // 0x0d5 = 213 - JUMP_IF_STP_CONNECTION_ACTIVE
0x0d9, // 0x0d6 = 214 - 
0x0ff, // 0x0d7 = 215 - JUMP
0x10d, // 0x0d8 = 216 - 
0x0d5, // 0x0d9 = 217 - JUMP_IF_CLOSE_RECEIVED
0x10d, // 0x0da = 218 - 
0x0d6, // 0x0db = 219 - JUMP_IF_SYNC_RECEIVED
0x0df, // 0x0dc = 220 - 
0x0ff, // 0x0dd = 221 - JUMP
0x07e, // 0x0de = 222 - 
0x027, // 0x0df = 223 - SEND_STP_CLOSE_REQ
0x000, // 0x0e0 = 224 - NO_OP
0x000, // 0x0e1 = 225 - NO_OP
0x000, // 0x0e2 = 226 - NO_OP
0x000, // 0x0e3 = 227 - NO_OP
0x0d5, // 0x0e4 = 228 - JUMP_IF_CLOSE_RECEIVED
0x10d, // 0x0e5 = 229 - 
0x0bc, // 0x0e6 = 230 - JUMP_IF_BREAK_RECEIVED
0x120, // 0x0e7 = 231 - 
0x0d7, // 0x0e8 = 232 - JUMP_IF_STP_CLOSE_ACK
0x10d, // 0x0e9 = 233 - 
0x0ff, // 0x0ea = 234 - JUMP
0x0e0, // 0x0eb = 235 - 
0x0c3, // 0x0ec = 236 - JUMP_IF_SMP_PROTOCOL
0x0f4, // 0x0ed = 237 - 
0x0d2, // 0x0ee = 238 - JUMP_IF_STP_CONNECTION_ACTIVE
0x0f8, // 0x0ef = 239 - 
0x0d1, // 0x0f0 = 240 - JUMP_IF_IDLE_TIMER_TIMEOUT
0x0fe, // 0x0f1 = 241 - 
0x0ff, // 0x0f2 = 242 - JUMP
0x07e, // 0x0f3 = 243 - 
0x0c4, // 0x0f4 = 244 - JUMP_IF_SMP_FRAME_ERR_RECEIVED
0x120, // 0x0f5 = 245 - 
0x0ff, // 0x0f6 = 246 - JUMP
0x08f, // 0x0f7 = 247 - 
0x0d5, // 0x0f8 = 248 - JUMP_IF_CLOSE_RECEIVED
0x0fe, // 0x0f9 = 249 - 
0x0d6, // 0x0fa = 250 - JUMP_IF_SYNC_RECEIVED
0x100, // 0x0fb = 251 - 
0x0ff, // 0x0fc = 252 - JUMP
0x0f8, // 0x0fd = 253 - 
0x0ff, // 0x0fe = 254 - JUMP
0x10d, // 0x0ff = 255 - 
0x027, // 0x100 = 256 - SEND_STP_CLOSE_REQ
0x000, // 0x101 = 257 - NO_OP
0x000, // 0x102 = 258 - NO_OP
0x000, // 0x103 = 259 - NO_OP
0x000, // 0x104 = 260 - NO_OP
0x0d5, // 0x105 = 261 - JUMP_IF_CLOSE_RECEIVED
0x10d, // 0x106 = 262 - 
0x0bc, // 0x107 = 263 - JUMP_IF_BREAK_RECEIVED
0x120, // 0x108 = 264 - 
0x0d7, // 0x109 = 265 - JUMP_IF_STP_CLOSE_ACK
0x10d, // 0x10a = 266 - 
0x0ff, // 0x10b = 267 - JUMP
0x101, // 0x10c = 268 - 
0x004, // 0x10d = 269 - CLOSE_NORMAL
0x000, // 0x10e = 270 - NO_OP
0x000, // 0x10f = 271 - NO_OP
0x000, // 0x110 = 272 - NO_OP
0x000, // 0x111 = 273 - NO_OP
0x0c9, // 0x112 = 274 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x11d, // 0x113 = 275 - 
0x0c0, // 0x114 = 276 - JUMP_IF_CLOSE_STATUS_EQUAL_ANY
0x07e, // 0x115 = 277 - 
0x0bc, // 0x116 = 278 - JUMP_IF_BREAK_RECEIVED
0x120, // 0x117 = 279 - 
0x0be, // 0x118 = 280 - JUMP_IF_PHY_READY
0x10e, // 0x119 = 281 - 
0x01c, // 0x11a = 282 - SOFT_RESET
0x0ff, // 0x11b = 283 - JUMP
0x004, // 0x11c = 284 - 
0x022, // 0x11d = 285 - SEND_CREDIT_BLOCK
0x0ff, // 0x11e = 286 - JUMP
0x10e, // 0x11f = 287 - 
0x007, // 0x120 = 288 - CLOSE_BREAK
0x000, // 0x121 = 289 - NO_OP
0x000, // 0x122 = 290 - NO_OP
0x000, // 0x123 = 291 - NO_OP
0x000, // 0x124 = 292 - NO_OP
0x0c0, // 0x125 = 293 - JUMP_IF_CLOSE_STATUS_EQUAL_ANY
0x07e, // 0x126 = 294 - 
0x0be, // 0x127 = 295 - JUMP_IF_PHY_READY
0x121, // 0x128 = 296 - 
0x01c, // 0x129 = 297 - SOFT_RESET
0x0ff, // 0x12a = 298 - JUMP
0x004, // 0x12b = 299 - 
0x005, // 0x12c = 300 - CLOSE_ACK_NAK_TIMEOUT
0x0ff, // 0x12d = 301 - JUMP
0x10e, // 0x12e = 302 - 
0x006, // 0x12f = 303 - CLOSE_CREDIT_TIMEOUT
0x0ff, // 0x130 = 304 - JUMP
0x10e, // 0x131 = 305 - 
0x0cc, // 0x132 = 306 - JUMP_IF_RX_BUFFER_FULL
0x07e, // 0x133 = 307 - 
0x0b7, // 0x134 = 308 - JUMP_IF_FLAG_7_SET
0x139, // 0x135 = 309 - 
0x011, // 0x136 = 310 - START_IT_NEXUS_LOSS_TIMER
0x00f, // 0x137 = 311 - PATHWAY_BLOCKED_CNT_RESET
0x00e, // 0x138 = 312 - START_ARB_WAIT_TIMER
0x0cb, // 0x139 = 313 - JUMP_IF_FREEZE_ACTIVE
0x17a, // 0x13a = 314 - 
0x001, // 0x13b = 315 - OPEN_REQUEST
0x080, // 0x13c = 316 - SET_FLAG
0x080, // 0x13d = 317 - 
0x090, // 0x13e = 318 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_ACCEPT
0x164, // 0x13f = 319 - 
0x095, // 0x140 = 320 - JUMP_IF_OPEN_STATUS_EQUAL_RATE_NOT_SUPPORTED
0x169, // 0x141 = 321 - 
0x099, // 0x142 = 322 - JUMP_IF_OPEN_STATUS_EQUAL_PROTOCOL_NOT_SUPPORTED
0x16c, // 0x143 = 323 - 
0x09b, // 0x144 = 324 - JUMP_IF_OPEN_STATUS_EQUAL_WRONG_DESTINATION
0x16f, // 0x145 = 325 - 
0x094, // 0x146 = 326 - JUMP_IF_OPEN_STATUS_EQUAL_BREAK_RECEIVED
0x139, // 0x147 = 327 - 
0x093, // 0x148 = 328 - JUMP_IF_OPEN_STATUS_EQUAL_BAD_DESTINATION
0x172, // 0x149 = 329 - 
0x09f, // 0x14a = 330 - JUMP_IF_IT_NEXUS_LOSS_TIMEOUT
0x175, // 0x14b = 331 - 
0x09a, // 0x14c = 332 - JUMP_IF_OPEN_STATUS_EQUAL_STP_RESOURCE_BUSY
0x139, // 0x14d = 333 - 
0x096, // 0x14e = 334 - JUMP_IF_OPEN_STATUS_EQUAL_NO_DESTINATION
0x139, // 0x14f = 335 - 
0x097, // 0x150 = 336 - JUMP_IF_OPEN_STATUS_EQUAL_PATHWAY_BLOCKED
0x17f, // 0x151 = 337 - 
0x098, // 0x152 = 338 - JUMP_IF_OPEN_STATUS_EQUAL_RETRY
0x139, // 0x153 = 339 - 
0x092, // 0x154 = 340 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_TIMEOUT
0x139, // 0x155 = 341 - 
0x0a4, // 0x156 = 342 - JUMP_IF_CONNECTION_ACTIVE_SET
0x15e, // 0x157 = 343 - 
0x0be, // 0x158 = 344 - JUMP_IF_PHY_READY
0x13e, // 0x159 = 345 - 
0x01b, // 0x15a = 346 - SET_OPEN_STATUS_PHY_NOT_RDY
0x01c, // 0x15b = 347 - SOFT_RESET
0x0ff, // 0x15c = 348 - JUMP
0x004, // 0x15d = 349 - 
0x0a0, // 0x15e = 350 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL
0x164, // 0x15f = 351 - 
0x000, // 0x160 = 352 - NO_OP
0x000, // 0x161 = 353 - NO_OP
0x0ff, // 0x162 = 354 - JUMP
0x07e, // 0x163 = 355 - 
0x013, // 0x164 = 356 - SET_OPEN_STATUS_NORMAL
0x081, // 0x165 = 357 - CLEAR_FLAG
0x080, // 0x166 = 358 - 
0x0ff, // 0x167 = 359 - JUMP
0x042, // 0x168 = 360 - 
0x017, // 0x169 = 361 - SET_OPEN_STATUS_BAD_RATE
0x0ff, // 0x16a = 362 - JUMP
0x17b, // 0x16b = 363 - 
0x018, // 0x16c = 364 - SET_OPEN_STATUS_BAD_PROTOCOL
0x0ff, // 0x16d = 365 - JUMP
0x17b, // 0x16e = 366 - 
0x01a, // 0x16f = 367 - SET_OPEN_STATUS_WRONG_DEST
0x0ff, // 0x170 = 368 - JUMP
0x17b, // 0x171 = 369 - 
0x015, // 0x172 = 370 - SET_OPEN_STATUS_BAD_DEST
0x0ff, // 0x173 = 371 - JUMP
0x17b, // 0x174 = 372 - 
0x014, // 0x175 = 373 - SET_OPEN_STATUS_IT_NEXUS_LOSS
0x081, // 0x176 = 374 - CLEAR_FLAG
0x080, // 0x177 = 375 - 
0x0ff, // 0x178 = 376 - JUMP
0x17b, // 0x179 = 377 - 
0x024, // 0x17a = 378 - SET_OPEN_STATUS_FREEZE
0x000, // 0x17b = 379 - NO_OP
0x000, // 0x17c = 380 - NO_OP
0x0ff, // 0x17d = 381 - JUMP
0x07e, // 0x17e = 382 - 
0x010, // 0x17f = 383 - PATHWAY_BLOCKED_CNT_INC
0x0ff, // 0x180 = 384 - JUMP
0x139, // 0x181 = 385 - 
0x000, // 0x182 = 386 - NO_OP
0x000, // 0x183 = 387 - NO_OP
0x000, // 0x184 = 388 - NO_OP
0x000, // 0x185 = 389 - NO_OP
0x000, // 0x186 = 390 - NO_OP
0x000, // 0x187 = 391 - NO_OP
0x000, // 0x188 = 392 - NO_OP
0x000, // 0x189 = 393 - NO_OP
0x000, // 0x18a = 394 - NO_OP
0x000, // 0x18b = 395 - NO_OP
0x000, // 0x18c = 396 - NO_OP
0x000, // 0x18d = 397 - NO_OP
0x000, // 0x18e = 398 - NO_OP
0x000, // 0x18f = 399 - NO_OP
0x000, // 0x190 = 400 - NO_OP
0x000, // 0x191 = 401 - NO_OP
0x000, // 0x192 = 402 - NO_OP
0x000, // 0x193 = 403 - NO_OP
0x000, // 0x194 = 404 - NO_OP
0x000, // 0x195 = 405 - NO_OP
0x000, // 0x196 = 406 - NO_OP
0x000, // 0x197 = 407 - NO_OP
0x000, // 0x198 = 408 - NO_OP
0x000, // 0x199 = 409 - NO_OP
0x000, // 0x19a = 410 - NO_OP
0x000, // 0x19b = 411 - NO_OP
0x000, // 0x19c = 412 - NO_OP
0x000, // 0x19d = 413 - NO_OP
0x000, // 0x19e = 414 - NO_OP
0x000, // 0x19f = 415 - NO_OP
0x000, // 0x1a0 = 416 - NO_OP
0x000, // 0x1a1 = 417 - NO_OP
0x000, // 0x1a2 = 418 - NO_OP
0x000, // 0x1a3 = 419 - NO_OP
0x000, // 0x1a4 = 420 - NO_OP
0x000, // 0x1a5 = 421 - NO_OP
0x000, // 0x1a6 = 422 - NO_OP
0x000, // 0x1a7 = 423 - NO_OP
0x000, // 0x1a8 = 424 - NO_OP
0x000, // 0x1a9 = 425 - NO_OP
0x000, // 0x1aa = 426 - NO_OP
0x000, // 0x1ab = 427 - NO_OP
0x000, // 0x1ac = 428 - NO_OP
0x000, // 0x1ad = 429 - NO_OP
0x000, // 0x1ae = 430 - NO_OP
0x000, // 0x1af = 431 - NO_OP
0x000, // 0x1b0 = 432 - NO_OP
0x000, // 0x1b1 = 433 - NO_OP
0x000, // 0x1b2 = 434 - NO_OP
0x000, // 0x1b3 = 435 - NO_OP
0x000, // 0x1b4 = 436 - NO_OP
0x000, // 0x1b5 = 437 - NO_OP
0x000, // 0x1b6 = 438 - NO_OP
0x000, // 0x1b7 = 439 - NO_OP
0x000, // 0x1b8 = 440 - NO_OP
0x000, // 0x1b9 = 441 - NO_OP
0x000, // 0x1ba = 442 - NO_OP
0x000, // 0x1bb = 443 - NO_OP
0x000, // 0x1bc = 444 - NO_OP
0x000, // 0x1bd = 445 - NO_OP
0x000, // 0x1be = 446 - NO_OP
0x000, // 0x1bf = 447 - NO_OP
0x000, // 0x1c0 = 448 - NO_OP
0x000, // 0x1c1 = 449 - NO_OP
0x000, // 0x1c2 = 450 - NO_OP
0x000, // 0x1c3 = 451 - NO_OP
0x000, // 0x1c4 = 452 - NO_OP
0x000, // 0x1c5 = 453 - NO_OP
0x000, // 0x1c6 = 454 - NO_OP
0x000, // 0x1c7 = 455 - NO_OP
0x000, // 0x1c8 = 456 - NO_OP
0x000, // 0x1c9 = 457 - NO_OP
0x000, // 0x1ca = 458 - NO_OP
0x000, // 0x1cb = 459 - NO_OP
0x000, // 0x1cc = 460 - NO_OP
0x000, // 0x1cd = 461 - NO_OP
0x000, // 0x1ce = 462 - NO_OP
0x000, // 0x1cf = 463 - NO_OP
0x000, // 0x1d0 = 464 - NO_OP
0x000, // 0x1d1 = 465 - NO_OP
0x000, // 0x1d2 = 466 - NO_OP
0x000, // 0x1d3 = 467 - NO_OP
0x000, // 0x1d4 = 468 - NO_OP
0x000, // 0x1d5 = 469 - NO_OP
0x000, // 0x1d6 = 470 - NO_OP
0x000, // 0x1d7 = 471 - NO_OP
0x000, // 0x1d8 = 472 - NO_OP
0x000, // 0x1d9 = 473 - NO_OP
0x000, // 0x1da = 474 - NO_OP
0x000, // 0x1db = 475 - NO_OP
0x000, // 0x1dc = 476 - NO_OP
0x000, // 0x1dd = 477 - NO_OP
0x000, // 0x1de = 478 - NO_OP
0x000, // 0x1df = 479 - NO_OP
0x000, // 0x1e0 = 480 - NO_OP
0x000, // 0x1e1 = 481 - NO_OP
0x000, // 0x1e2 = 482 - NO_OP
0x000, // 0x1e3 = 483 - NO_OP
0x000, // 0x1e4 = 484 - NO_OP
0x000, // 0x1e5 = 485 - NO_OP
0x000, // 0x1e6 = 486 - NO_OP
0x000, // 0x1e7 = 487 - NO_OP
0x000, // 0x1e8 = 488 - NO_OP
0x000, // 0x1e9 = 489 - NO_OP
0x000, // 0x1ea = 490 - NO_OP
0x000, // 0x1eb = 491 - NO_OP
0x000, // 0x1ec = 492 - NO_OP
0x000, // 0x1ed = 493 - NO_OP
0x000, // 0x1ee = 494 - NO_OP
0x000, // 0x1ef = 495 - NO_OP
0x000, // 0x1f0 = 496 - NO_OP
0x000, // 0x1f1 = 497 - NO_OP
0x000, // 0x1f2 = 498 - NO_OP
0x000, // 0x1f3 = 499 - NO_OP
0x000, // 0x1f4 = 500 - NO_OP
0x000, // 0x1f5 = 501 - NO_OP
0x000, // 0x1f6 = 502 - NO_OP
0x000, // 0x1f7 = 503 - NO_OP
0x000, // 0x1f8 = 504 - NO_OP
0x000, // 0x1f9 = 505 - NO_OP
0x000, // 0x1fa = 506 - NO_OP
0x000, // 0x1fb = 507 - NO_OP
0x000, // 0x1fc = 508 - NO_OP
0x000, // 0x1fd = 509 - NO_OP
0x000, // 0x1fe = 510 - NO_OP
0x000, // 0x1ff = 511 - NO_OP
};


/* wcs with A1304_24 and A1305_28 */
bit32 wcsImage1304_24[] = 
{
0x00d, // 00000 = 0 - PHY_RESET_START
0x00d, // 0x001 = 1 - PHY_RESET_START
0x0be, // 0x002 = 2 - JUMP_IF_PHY_READY
0x002, // 0x003 = 3 - 
0x0be, // 0x004 = 4 - JUMP_IF_PHY_READY
0x00e, // 0x005 = 5 - 
0x0ae, // 0x006 = 6 - JUMP_IF_HARD_RESET_PRIMITIVE
0x024, // 0x007 = 7 - 
0x0af, // 0x008 = 8 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x017, // 0x009 = 9 - 
0x0ce, // 0x00a = 10 - JUMP_IF_IDENTIFY_FRAME_TIMEOUT
0x000, // 0x00b = 11 - 
0x0ff, // 0x00c = 12 - JUMP
0x004, // 0x00d = 13 - 
0x00c, // 0x00e = 14 - SEND_ID_FRAME
0x0ae, // 0x00f = 15 - JUMP_IF_HARD_RESET_PRIMITIVE
0x024, // 0x010 = 16 - 
0x0af, // 0x011 = 17 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x01c, // 0x012 = 18 - 
0x0ce, // 0x013 = 19 - JUMP_IF_IDENTIFY_FRAME_TIMEOUT
0x000, // 0x014 = 20 - 
0x0ff, // 0x015 = 21 - JUMP
0x00f, // 0x016 = 22 - 
0x0be, // 0x017 = 23 - JUMP_IF_PHY_READY
0x01b, // 0x018 = 24 - 
0x0ff, // 0x019 = 25 - JUMP
0x017, // 0x01a = 26 - 
0x00c, // 0x01b = 27 - SEND_ID_FRAME
0x000, // 0x01c = 28 - NO_OP
0x000, // 0x01d = 29 - NO_OP
0x000, // 0x01e = 30 - NO_OP
0x000, // 0x01f = 31 - NO_OP
0x000, // 0x020 = 32 - NO_OP
0x000, // 0x021 = 33 - NO_OP
0x0ff, // 0x022 = 34 - JUMP
0x09c, // 0x023 = 35 - 
0x01c, // 0x024 = 36 - SOFT_RESET
0x00d, // 0x025 = 37 - PHY_RESET_START
0x00d, // 0x026 = 38 - PHY_RESET_START
0x0be, // 0x027 = 39 - JUMP_IF_PHY_READY
0x027, // 0x028 = 40 - 
0x0be, // 0x029 = 41 - JUMP_IF_PHY_READY
0x02f, // 0x02a = 42 - 
0x0af, // 0x02b = 43 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x036, // 0x02c = 44 - 
0x0ff, // 0x02d = 45 - JUMP
0x029, // 0x02e = 46 - 
0x00c, // 0x02f = 47 - SEND_ID_FRAME
0x0af, // 0x030 = 48 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x039, // 0x031 = 49 - 
0x0ce, // 0x032 = 50 - JUMP_IF_IDENTIFY_FRAME_TIMEOUT
0x024, // 0x033 = 51 - 
0x0ff, // 0x034 = 52 - JUMP
0x030, // 0x035 = 53 - 
0x00c, // 0x036 = 54 - SEND_ID_FRAME
0x0ff, // 0x037 = 55 - JUMP
0x039, // 0x038 = 56 - 
0x000, // 0x039 = 57 - NO_OP
0x0cb, // 0x03a = 58 - JUMP_IF_FREEZE_ACTIVE
0x03e, // 0x03b = 59 - 
0x0ff, // 0x03c = 60 - JUMP
0x03a, // 0x03d = 61 - 
0x0cb, // 0x03e = 62 - JUMP_IF_FREEZE_ACTIVE
0x03e, // 0x03f = 63 - 
0x0ff, // 0x040 = 64 - JUMP
0x09c, // 0x041 = 65 - 
0x000, // 0x042 = 66 - NO_OP
0x0c9, // 0x043 = 67 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x073, // 0x044 = 68 - 
0x0a5, // 0x045 = 69 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_GOOD
0x05c, // 0x046 = 70 - 
0x0a6, // 0x047 = 71 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_NAK
0x063, // 0x048 = 72 - 
0x0a7, // 0x049 = 73 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_ACK_NAK_TIMEOUT
0x066, // 0x04a = 74 - 
0x0a8, // 0x04b = 75 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_BREAK
0x070, // 0x04c = 76 - 
0x0aa, // 0x04d = 77 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_CREDIT_TIMEOUT
0x06b, // 0x04e = 78 - 
0x0c5, // 0x04f = 79 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_SMP_ERR
0x070, // 0x050 = 80 - 
0x0ac, // 0x051 = 81 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_MAX_BURST_SIZE
0x063, // 0x052 = 82 - 
0x0d9, // 0x053 = 83 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_FREEZE_TIMEOUT
0x070, // 0x054 = 84 - 
0x0ca, // 0x055 = 85 - JUMP_IF_CLOSE_REQ
0x0f0, // 0x056 = 86 - 
0x0be, // 0x057 = 87 - JUMP_IF_PHY_READY
0x043, // 0x058 = 88 - 
0x01c, // 0x059 = 89 - SOFT_RESET
0x0ff, // 0x05a = 90 - JUMP
0x004, // 0x05b = 91 - 
0x01d, // 0x05c = 92 - ADVANCE
0x0bc, // 0x05d = 93 - JUMP_IF_BREAK_RECEIVED
0x13b, // 0x05e = 94 - 
0x0c3, // 0x05f = 95 - JUMP_IF_SMP_PROTOCOL
0x128, // 0x060 = 96 - 
0x0ff, // 0x061 = 97 - JUMP
0x076, // 0x062 = 98 - 
0x01d, // 0x063 = 99 - ADVANCE
0x0ff, // 0x064 = 100 - JUMP
0x076, // 0x065 = 101 - 
0x01d, // 0x066 = 102 - ADVANCE
0x0bc, // 0x067 = 103 - JUMP_IF_BREAK_RECEIVED
0x13b, // 0x068 = 104 - 
0x0ff, // 0x069 = 105 - JUMP
0x147, // 0x06a = 106 - 
0x01d, // 0x06b = 107 - ADVANCE
0x0bc, // 0x06c = 108 - JUMP_IF_BREAK_RECEIVED
0x13b, // 0x06d = 109 - 
0x0ff, // 0x06e = 110 - JUMP
0x14a, // 0x06f = 111 - 
0x01d, // 0x070 = 112 - ADVANCE
0x0ff, // 0x071 = 113 - JUMP
0x13b, // 0x072 = 114 - 
0x022, // 0x073 = 115 - SEND_CREDIT_BLOCK
0x0ff, // 0x074 = 116 - JUMP
0x045, // 0x075 = 117 - 
0x083, // 0x076 = 118 - TIMER_START
0x004, // 0x077 = 119 - 
0x0c8, // 0x078 = 120 - JUMP_IF_HIP_REQ
0x082, // 0x079 = 121 - 
0x0c6, // 0x07a = 122 - JUMP_IF_SFO_REQ
0x08a, // 0x07b = 123 - 
0x0c7, // 0x07c = 124 - JUMP_IF_DOC_REQ
0x094, // 0x07d = 125 - 
0x0b8, // 0x07e = 126 - JUMP_IF_TIMER_EXPIRED
0x09c, // 0x07f = 127 - 
0x0ff, // 0x080 = 128 - JUMP
0x078, // 0x081 = 129 - 
0x028, // 0x082 = 130 - CHECK_HIP
0x000, // 0x083 = 131 - NO_OP
0x000, // 0x084 = 132 - NO_OP
0x000, // 0x085 = 133 - NO_OP
0x0d8, // 0x086 = 134 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0cf, // 0x087 = 135 - 
0x0ff, // 0x088 = 136 - JUMP
0x07e, // 0x089 = 137 - 
0x029, // 0x08a = 138 - CHECK_SFO
0x000, // 0x08b = 139 - NO_OP
0x000, // 0x08c = 140 - NO_OP
0x000, // 0x08d = 141 - NO_OP
0x0d8, // 0x08e = 142 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0d4, // 0x08f = 143 - 
0x0c7, // 0x090 = 144 - JUMP_IF_DOC_REQ
0x094, // 0x091 = 145 - 
0x0ff, // 0x092 = 146 - JUMP
0x07e, // 0x093 = 147 - 
0x02a, // 0x094 = 148 - CHECK_DOC
0x000, // 0x095 = 149 - NO_OP
0x000, // 0x096 = 150 - NO_OP
0x000, // 0x097 = 151 - NO_OP
0x0d8, // 0x098 = 152 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0d9, // 0x099 = 153 - 
0x0ff, // 0x09a = 154 - JUMP
0x07e, // 0x09b = 155 - 
0x0bc, // 0x09c = 156 - JUMP_IF_BREAK_RECEIVED
0x13b, // 0x09d = 157 - 
0x0be, // 0x09e = 158 - JUMP_IF_PHY_READY
0x0a3, // 0x09f = 159 - 
0x01c, // 0x0a0 = 160 - SOFT_RESET
0x0ff, // 0x0a1 = 161 - JUMP
0x004, // 0x0a2 = 162 - 
0x0c8, // 0x0a3 = 163 - JUMP_IF_HIP_REQ
0x0b5, // 0x0a4 = 164 - 
0x0c6, // 0x0a5 = 165 - JUMP_IF_SFO_REQ
0x0bd, // 0x0a6 = 166 - 
0x0c7, // 0x0a7 = 167 - JUMP_IF_DOC_REQ
0x0c7, // 0x0a8 = 168 - 
0x0a3, // 0x0a9 = 169 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
0x107, // 0x0aa = 170 - 
0x0a2, // 0x0ab = 171 - JUMP_IF_CONNECTION_OPEN_MASTER_FLAG_SET
0x0f0, // 0x0ac = 172 - 
0x0c8, // 0x0ad = 173 - JUMP_IF_HIP_REQ
0x0cf, // 0x0ae = 174 - 
0x0c6, // 0x0af = 175 - JUMP_IF_SFO_REQ
0x0d4, // 0x0b0 = 176 - 
0x0c7, // 0x0b1 = 177 - JUMP_IF_DOC_REQ
0x0d9, // 0x0b2 = 178 - 
0x0ff, // 0x0b3 = 179 - JUMP
0x09c, // 0x0b4 = 180 - 
0x028, // 0x0b5 = 181 - CHECK_HIP
0x000, // 0x0b6 = 182 - NO_OP
0x000, // 0x0b7 = 183 - NO_OP
0x000, // 0x0b8 = 184 - NO_OP
0x0d8, // 0x0b9 = 185 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0cf, // 0x0ba = 186 - 
0x0ff, // 0x0bb = 187 - JUMP
0x0a9, // 0x0bc = 188 - 
0x029, // 0x0bd = 189 - CHECK_SFO
0x000, // 0x0be = 190 - NO_OP
0x000, // 0x0bf = 191 - NO_OP
0x000, // 0x0c0 = 192 - NO_OP
0x0d8, // 0x0c1 = 193 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0d4, // 0x0c2 = 194 - 
0x0c7, // 0x0c3 = 195 - JUMP_IF_DOC_REQ
0x0c7, // 0x0c4 = 196 - 
0x0ff, // 0x0c5 = 197 - JUMP
0x0a9, // 0x0c6 = 198 - 
0x02a, // 0x0c7 = 199 - CHECK_DOC
0x000, // 0x0c8 = 200 - NO_OP
0x000, // 0x0c9 = 201 - NO_OP
0x000, // 0x0ca = 202 - NO_OP
0x0d8, // 0x0cb = 203 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0d9, // 0x0cc = 204 - 
0x0ff, // 0x0cd = 205 - JUMP
0x0a9, // 0x0ce = 206 - 
0x020, // 0x0cf = 207 - SELECT_HIP
0x000, // 0x0d0 = 208 - NO_OP
0x000, // 0x0d1 = 209 - NO_OP
0x0ff, // 0x0d2 = 210 - JUMP
0x0dc, // 0x0d3 = 211 - 
0x01e, // 0x0d4 = 212 - SELECT_SFO
0x000, // 0x0d5 = 213 - NO_OP
0x000, // 0x0d6 = 214 - NO_OP
0x0ff, // 0x0d7 = 215 - JUMP
0x0dc, // 0x0d8 = 216 - 
0x01f, // 0x0d9 = 217 - SELECT_DOC
0x000, // 0x0da = 218 - NO_OP
0x000, // 0x0db = 219 - NO_OP
0x0a4, // 0x0dc = 220 - JUMP_IF_CONNECTION_ACTIVE_SET
0x0e0, // 0x0dd = 221 - 
0x0ff, // 0x0de = 222 - JUMP
0x14d, // 0x0df = 223 - 
0x0a0, // 0x0e0 = 224 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL
0x0e6, // 0x0e1 = 225 - 
0x0a3, // 0x0e2 = 226 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
0x107, // 0x0e3 = 227 - 
0x0ff, // 0x0e4 = 228 - JUMP
0x128, // 0x0e5 = 229 - 
0x0cb, // 0x0e6 = 230 - JUMP_IF_FREEZE_ACTIVE
0x0eb, // 0x0e7 = 231 - 
0x013, // 0x0e8 = 232 - SET_OPEN_STATUS_NORMAL
0x0ff, // 0x0e9 = 233 - JUMP
0x042, // 0x0ea = 234 - 
0x024, // 0x0eb = 235 - SET_OPEN_STATUS_FREEZE
0x000, // 0x0ec = 236 - NO_OP
0x000, // 0x0ed = 237 - NO_OP
0x0ff, // 0x0ee = 238 - JUMP
0x09c, // 0x0ef = 239 - 
0x0d2, // 0x0f0 = 240 - JUMP_IF_STP_CONNECTION_ACTIVE
0x0f4, // 0x0f1 = 241 - 
0x0ff, // 0x0f2 = 242 - JUMP
0x128, // 0x0f3 = 243 - 
0x0d5, // 0x0f4 = 244 - JUMP_IF_CLOSE_RECEIVED
0x128, // 0x0f5 = 245 - 
0x0d6, // 0x0f6 = 246 - JUMP_IF_SYNC_RECEIVED
0x0fa, // 0x0f7 = 247 - 
0x0ff, // 0x0f8 = 248 - JUMP
0x09c, // 0x0f9 = 249 - 
0x027, // 0x0fa = 250 - SEND_STP_CLOSE_REQ
0x000, // 0x0fb = 251 - NO_OP
0x000, // 0x0fc = 252 - NO_OP
0x000, // 0x0fd = 253 - NO_OP
0x000, // 0x0fe = 254 - NO_OP
0x0d5, // 0x0ff = 255 - JUMP_IF_CLOSE_RECEIVED
0x128, // 0x100 = 256 - 
0x0bc, // 0x101 = 257 - JUMP_IF_BREAK_RECEIVED
0x13b, // 0x102 = 258 - 
0x0d7, // 0x103 = 259 - JUMP_IF_STP_CLOSE_ACK
0x128, // 0x104 = 260 - 
0x0ff, // 0x105 = 261 - JUMP
0x0fb, // 0x106 = 262 - 
0x0c3, // 0x107 = 263 - JUMP_IF_SMP_PROTOCOL
0x10f, // 0x108 = 264 - 
0x0d2, // 0x109 = 265 - JUMP_IF_STP_CONNECTION_ACTIVE
0x113, // 0x10a = 266 - 
0x0d1, // 0x10b = 267 - JUMP_IF_IDLE_TIMER_TIMEOUT
0x119, // 0x10c = 268 - 
0x0ff, // 0x10d = 269 - JUMP
0x09c, // 0x10e = 270 - 
0x0c4, // 0x10f = 271 - JUMP_IF_SMP_FRAME_ERR_RECEIVED
0x13b, // 0x110 = 272 - 
0x0ff, // 0x111 = 273 - JUMP
0x0ad, // 0x112 = 274 - 
0x0d5, // 0x113 = 275 - JUMP_IF_CLOSE_RECEIVED
0x119, // 0x114 = 276 - 
0x0d6, // 0x115 = 277 - JUMP_IF_SYNC_RECEIVED
0x11b, // 0x116 = 278 - 
0x0ff, // 0x117 = 279 - JUMP
0x113, // 0x118 = 280 - 
0x0ff, // 0x119 = 281 - JUMP
0x128, // 0x11a = 282 - 
0x027, // 0x11b = 283 - SEND_STP_CLOSE_REQ
0x000, // 0x11c = 284 - NO_OP
0x000, // 0x11d = 285 - NO_OP
0x000, // 0x11e = 286 - NO_OP
0x000, // 0x11f = 287 - NO_OP
0x0d5, // 0x120 = 288 - JUMP_IF_CLOSE_RECEIVED
0x128, // 0x121 = 289 - 
0x0bc, // 0x122 = 290 - JUMP_IF_BREAK_RECEIVED
0x13b, // 0x123 = 291 - 
0x0d7, // 0x124 = 292 - JUMP_IF_STP_CLOSE_ACK
0x128, // 0x125 = 293 - 
0x0ff, // 0x126 = 294 - JUMP
0x11c, // 0x127 = 295 - 
0x004, // 0x128 = 296 - CLOSE_NORMAL
0x000, // 0x129 = 297 - NO_OP
0x000, // 0x12a = 298 - NO_OP
0x000, // 0x12b = 299 - NO_OP
0x000, // 0x12c = 300 - NO_OP
0x0c9, // 0x12d = 301 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x138, // 0x12e = 302 - 
0x0c0, // 0x12f = 303 - JUMP_IF_CLOSE_STATUS_EQUAL_ANY
0x09c, // 0x130 = 304 - 
0x0bc, // 0x131 = 305 - JUMP_IF_BREAK_RECEIVED
0x13b, // 0x132 = 306 - 
0x0be, // 0x133 = 307 - JUMP_IF_PHY_READY
0x129, // 0x134 = 308 - 
0x01c, // 0x135 = 309 - SOFT_RESET
0x0ff, // 0x136 = 310 - JUMP
0x004, // 0x137 = 311 - 
0x022, // 0x138 = 312 - SEND_CREDIT_BLOCK
0x0ff, // 0x139 = 313 - JUMP
0x129, // 0x13a = 314 - 
0x007, // 0x13b = 315 - CLOSE_BREAK
0x000, // 0x13c = 316 - NO_OP
0x000, // 0x13d = 317 - NO_OP
0x000, // 0x13e = 318 - NO_OP
0x000, // 0x13f = 319 - NO_OP
0x0c0, // 0x140 = 320 - JUMP_IF_CLOSE_STATUS_EQUAL_ANY
0x09c, // 0x141 = 321 - 
0x0be, // 0x142 = 322 - JUMP_IF_PHY_READY
0x13c, // 0x143 = 323 - 
0x01c, // 0x144 = 324 - SOFT_RESET
0x0ff, // 0x145 = 325 - JUMP
0x004, // 0x146 = 326 - 
0x005, // 0x147 = 327 - CLOSE_ACK_NAK_TIMEOUT
0x0ff, // 0x148 = 328 - JUMP
0x129, // 0x149 = 329 - 
0x006, // 0x14a = 330 - CLOSE_CREDIT_TIMEOUT
0x0ff, // 0x14b = 331 - JUMP
0x129, // 0x14c = 332 - 
0x0cc, // 0x14d = 333 - JUMP_IF_RX_BUFFER_FULL
0x09c, // 0x14e = 334 - 
0x0b7, // 0x14f = 335 - JUMP_IF_FLAG_7_SET
0x154, // 0x150 = 336 - 
0x011, // 0x151 = 337 - START_IT_NEXUS_LOSS_TIMER
0x00f, // 0x152 = 338 - PATHWAY_BLOCKED_CNT_RESET
0x00e, // 0x153 = 339 - START_ARB_WAIT_TIMER
0x0cb, // 0x154 = 340 - JUMP_IF_FREEZE_ACTIVE
0x195, // 0x155 = 341 - 
0x001, // 0x156 = 342 - OPEN_REQUEST
0x080, // 0x157 = 343 - SET_FLAG
0x080, // 0x158 = 344 - 
0x090, // 0x159 = 345 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_ACCEPT
0x17f, // 0x15a = 346 - 
0x095, // 0x15b = 347 - JUMP_IF_OPEN_STATUS_EQUAL_RATE_NOT_SUPPORTED
0x184, // 0x15c = 348 - 
0x099, // 0x15d = 349 - JUMP_IF_OPEN_STATUS_EQUAL_PROTOCOL_NOT_SUPPORTED
0x187, // 0x15e = 350 - 
0x09b, // 0x15f = 351 - JUMP_IF_OPEN_STATUS_EQUAL_WRONG_DESTINATION
0x18a, // 0x160 = 352 - 
0x094, // 0x161 = 353 - JUMP_IF_OPEN_STATUS_EQUAL_BREAK_RECEIVED
0x154, // 0x162 = 354 - 
0x093, // 0x163 = 355 - JUMP_IF_OPEN_STATUS_EQUAL_BAD_DESTINATION
0x18d, // 0x164 = 356 - 
0x09f, // 0x165 = 357 - JUMP_IF_IT_NEXUS_LOSS_TIMEOUT
0x190, // 0x166 = 358 - 
0x09a, // 0x167 = 359 - JUMP_IF_OPEN_STATUS_EQUAL_STP_RESOURCE_BUSY
0x153, // 0x168 = 360 - 
0x096, // 0x169 = 361 - JUMP_IF_OPEN_STATUS_EQUAL_NO_DESTINATION
0x154, // 0x16a = 362 - 
0x097, // 0x16b = 363 - JUMP_IF_OPEN_STATUS_EQUAL_PATHWAY_BLOCKED
0x19a, // 0x16c = 364 - 
0x098, // 0x16d = 365 - JUMP_IF_OPEN_STATUS_EQUAL_RETRY
0x153, // 0x16e = 366 - 
0x092, // 0x16f = 367 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_TIMEOUT
0x154, // 0x170 = 368 - 
0x0a4, // 0x171 = 369 - JUMP_IF_CONNECTION_ACTIVE_SET
0x179, // 0x172 = 370 - 
0x0be, // 0x173 = 371 - JUMP_IF_PHY_READY
0x159, // 0x174 = 372 - 
0x01b, // 0x175 = 373 - SET_OPEN_STATUS_PHY_NOT_RDY
0x01c, // 0x176 = 374 - SOFT_RESET
0x0ff, // 0x177 = 375 - JUMP
0x004, // 0x178 = 376 - 
0x0a0, // 0x179 = 377 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL
0x17f, // 0x17a = 378 - 
0x000, // 0x17b = 379 - NO_OP
0x000, // 0x17c = 380 - NO_OP
0x0ff, // 0x17d = 381 - JUMP
0x09c, // 0x17e = 382 - 
0x013, // 0x17f = 383 - SET_OPEN_STATUS_NORMAL
0x081, // 0x180 = 384 - CLEAR_FLAG
0x080, // 0x181 = 385 - 
0x0ff, // 0x182 = 386 - JUMP
0x042, // 0x183 = 387 - 
0x017, // 0x184 = 388 - SET_OPEN_STATUS_BAD_RATE
0x0ff, // 0x185 = 389 - JUMP
0x196, // 0x186 = 390 - 
0x018, // 0x187 = 391 - SET_OPEN_STATUS_BAD_PROTOCOL
0x0ff, // 0x188 = 392 - JUMP
0x196, // 0x189 = 393 - 
0x01a, // 0x18a = 394 - SET_OPEN_STATUS_WRONG_DEST
0x0ff, // 0x18b = 395 - JUMP
0x196, // 0x18c = 396 - 
0x015, // 0x18d = 397 - SET_OPEN_STATUS_BAD_DEST
0x0ff, // 0x18e = 398 - JUMP
0x196, // 0x18f = 399 - 
0x014, // 0x190 = 400 - SET_OPEN_STATUS_IT_NEXUS_LOSS
0x081, // 0x191 = 401 - CLEAR_FLAG
0x080, // 0x192 = 402 - 
0x0ff, // 0x193 = 403 - JUMP
0x196, // 0x194 = 404 - 
0x024, // 0x195 = 405 - SET_OPEN_STATUS_FREEZE
0x000, // 0x196 = 406 - NO_OP
0x000, // 0x197 = 407 - NO_OP
0x0ff, // 0x198 = 408 - JUMP
0x09c, // 0x199 = 409 - 
0x010, // 0x19a = 410 - PATHWAY_BLOCKED_CNT_INC
0x0ff, // 0x19b = 411 - JUMP
0x154, // 0x19c = 412 - 
0x000, // 0x19d = 413 - NO_OP
0x000, // 0x19e = 414 - NO_OP
0x000, // 0x19f = 415 - NO_OP
0x000, // 0x1a0 = 416 - NO_OP
0x000, // 0x1a1 = 417 - NO_OP
0x000, // 0x1a2 = 418 - NO_OP
0x000, // 0x1a3 = 419 - NO_OP
0x000, // 0x1a4 = 420 - NO_OP
0x000, // 0x1a5 = 421 - NO_OP
0x000, // 0x1a6 = 422 - NO_OP
0x000, // 0x1a7 = 423 - NO_OP
0x000, // 0x1a8 = 424 - NO_OP
0x000, // 0x1a9 = 425 - NO_OP
0x000, // 0x1aa = 426 - NO_OP
0x000, // 0x1ab = 427 - NO_OP
0x000, // 0x1ac = 428 - NO_OP
0x000, // 0x1ad = 429 - NO_OP
0x000, // 0x1ae = 430 - NO_OP
0x000, // 0x1af = 431 - NO_OP
0x000, // 0x1b0 = 432 - NO_OP
0x000, // 0x1b1 = 433 - NO_OP
0x000, // 0x1b2 = 434 - NO_OP
0x000, // 0x1b3 = 435 - NO_OP
0x000, // 0x1b4 = 436 - NO_OP
0x000, // 0x1b5 = 437 - NO_OP
0x000, // 0x1b6 = 438 - NO_OP
0x000, // 0x1b7 = 439 - NO_OP
0x000, // 0x1b8 = 440 - NO_OP
0x000, // 0x1b9 = 441 - NO_OP
0x000, // 0x1ba = 442 - NO_OP
0x000, // 0x1bb = 443 - NO_OP
0x000, // 0x1bc = 444 - NO_OP
0x000, // 0x1bd = 445 - NO_OP
0x000, // 0x1be = 446 - NO_OP
0x000, // 0x1bf = 447 - NO_OP
0x000, // 0x1c0 = 448 - NO_OP
0x000, // 0x1c1 = 449 - NO_OP
0x000, // 0x1c2 = 450 - NO_OP
0x000, // 0x1c3 = 451 - NO_OP
0x000, // 0x1c4 = 452 - NO_OP
0x000, // 0x1c5 = 453 - NO_OP
0x000, // 0x1c6 = 454 - NO_OP
0x000, // 0x1c7 = 455 - NO_OP
0x000, // 0x1c8 = 456 - NO_OP
0x000, // 0x1c9 = 457 - NO_OP
0x000, // 0x1ca = 458 - NO_OP
0x000, // 0x1cb = 459 - NO_OP
0x000, // 0x1cc = 460 - NO_OP
0x000, // 0x1cd = 461 - NO_OP
0x000, // 0x1ce = 462 - NO_OP
0x000, // 0x1cf = 463 - NO_OP
0x000, // 0x1d0 = 464 - NO_OP
0x000, // 0x1d1 = 465 - NO_OP
0x000, // 0x1d2 = 466 - NO_OP
0x000, // 0x1d3 = 467 - NO_OP
0x000, // 0x1d4 = 468 - NO_OP
0x000, // 0x1d5 = 469 - NO_OP
0x000, // 0x1d6 = 470 - NO_OP
0x000, // 0x1d7 = 471 - NO_OP
0x000, // 0x1d8 = 472 - NO_OP
0x000, // 0x1d9 = 473 - NO_OP
0x000, // 0x1da = 474 - NO_OP
0x000, // 0x1db = 475 - NO_OP
0x000, // 0x1dc = 476 - NO_OP
0x000, // 0x1dd = 477 - NO_OP
0x000, // 0x1de = 478 - NO_OP
0x000, // 0x1df = 479 - NO_OP
0x000, // 0x1e0 = 480 - NO_OP
0x000, // 0x1e1 = 481 - NO_OP
0x000, // 0x1e2 = 482 - NO_OP
0x000, // 0x1e3 = 483 - NO_OP
0x000, // 0x1e4 = 484 - NO_OP
0x000, // 0x1e5 = 485 - NO_OP
0x000, // 0x1e6 = 486 - NO_OP
0x000, // 0x1e7 = 487 - NO_OP
0x000, // 0x1e8 = 488 - NO_OP
0x000, // 0x1e9 = 489 - NO_OP
0x000, // 0x1ea = 490 - NO_OP
0x000, // 0x1eb = 491 - NO_OP
0x000, // 0x1ec = 492 - NO_OP
0x000, // 0x1ed = 493 - NO_OP
0x000, // 0x1ee = 494 - NO_OP
0x000, // 0x1ef = 495 - NO_OP
0x000, // 0x1f0 = 496 - NO_OP
0x000, // 0x1f1 = 497 - NO_OP
0x000, // 0x1f2 = 498 - NO_OP
0x000, // 0x1f3 = 499 - NO_OP
0x000, // 0x1f4 = 500 - NO_OP
0x000, // 0x1f5 = 501 - NO_OP
0x000, // 0x1f6 = 502 - NO_OP
0x000, // 0x1f7 = 503 - NO_OP
0x000, // 0x1f8 = 504 - NO_OP
0x000, // 0x1f9 = 505 - NO_OP
0x000, // 0x1fa = 506 - NO_OP
0x000, // 0x1fb = 507 - NO_OP
0x000, // 0x1fc = 508 - NO_OP
0x000, // 0x1fd = 509 - NO_OP
0x000, // 0x1fe = 510 - NO_OP
0x000, // 0x1ff = 511 - NO_OP
};

/* wcs with A1306_02 and A1307_06 */
bit32 wcsImageA1306_02[] = 
{
0x00d, // 00000 = 0 - PHY_RESET_START
0x00d, // 0x001 = 1 - PHY_RESET_START
0x0be, // 0x002 = 2 - JUMP_IF_PHY_READY
0x002, // 0x003 = 3 - 
0x0be, // 0x004 = 4 - JUMP_IF_PHY_READY
0x00e, // 0x005 = 5 - 
0x0ae, // 0x006 = 6 - JUMP_IF_HARD_RESET_PRIMITIVE
0x024, // 0x007 = 7 - 
0x0af, // 0x008 = 8 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x017, // 0x009 = 9 - 
0x0ce, // 0x00a = 10 - JUMP_IF_IDENTIFY_FRAME_TIMEOUT
0x000, // 0x00b = 11 - 
0x0ff, // 0x00c = 12 - JUMP
0x004, // 0x00d = 13 - 
0x00c, // 0x00e = 14 - SEND_ID_FRAME
0x0ae, // 0x00f = 15 - JUMP_IF_HARD_RESET_PRIMITIVE
0x024, // 0x010 = 16 - 
0x0af, // 0x011 = 17 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x01c, // 0x012 = 18 - 
0x0ce, // 0x013 = 19 - JUMP_IF_IDENTIFY_FRAME_TIMEOUT
0x000, // 0x014 = 20 - 
0x0ff, // 0x015 = 21 - JUMP
0x00f, // 0x016 = 22 - 
0x0be, // 0x017 = 23 - JUMP_IF_PHY_READY
0x01b, // 0x018 = 24 - 
0x0ff, // 0x019 = 25 - JUMP
0x017, // 0x01a = 26 - 
0x00c, // 0x01b = 27 - SEND_ID_FRAME
0x000, // 0x01c = 28 - NO_OP
0x000, // 0x01d = 29 - NO_OP
0x000, // 0x01e = 30 - NO_OP
0x000, // 0x01f = 31 - NO_OP
0x000, // 0x020 = 32 - NO_OP
0x000, // 0x021 = 33 - NO_OP
0x0ff, // 0x022 = 34 - JUMP
0x09c, // 0x023 = 35 - 
0x01c, // 0x024 = 36 - SOFT_RESET
0x00d, // 0x025 = 37 - PHY_RESET_START
0x00d, // 0x026 = 38 - PHY_RESET_START
0x0be, // 0x027 = 39 - JUMP_IF_PHY_READY
0x027, // 0x028 = 40 - 
0x0be, // 0x029 = 41 - JUMP_IF_PHY_READY
0x02f, // 0x02a = 42 - 
0x0af, // 0x02b = 43 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x036, // 0x02c = 44 - 
0x0ff, // 0x02d = 45 - JUMP
0x029, // 0x02e = 46 - 
0x00c, // 0x02f = 47 - SEND_ID_FRAME
0x0af, // 0x030 = 48 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x039, // 0x031 = 49 - 
0x0ce, // 0x032 = 50 - JUMP_IF_IDENTIFY_FRAME_TIMEOUT
0x024, // 0x033 = 51 - 
0x0ff, // 0x034 = 52 - JUMP
0x030, // 0x035 = 53 - 
0x00c, // 0x036 = 54 - SEND_ID_FRAME
0x0ff, // 0x037 = 55 - JUMP
0x039, // 0x038 = 56 - 
0x000, // 0x039 = 57 - NO_OP
0x0cb, // 0x03a = 58 - JUMP_IF_FREEZE_ACTIVE
0x03e, // 0x03b = 59 - 
0x0ff, // 0x03c = 60 - JUMP
0x03a, // 0x03d = 61 - 
0x0cb, // 0x03e = 62 - JUMP_IF_FREEZE_ACTIVE
0x03e, // 0x03f = 63 - 
0x0ff, // 0x040 = 64 - JUMP
0x09c, // 0x041 = 65 - 
0x000, // 0x042 = 66 - NO_OP
0x0c9, // 0x043 = 67 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x073, // 0x044 = 68 - 
0x0a5, // 0x045 = 69 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_GOOD
0x05c, // 0x046 = 70 - 
0x0a6, // 0x047 = 71 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_NAK
0x063, // 0x048 = 72 - 
0x0a7, // 0x049 = 73 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_ACK_NAK_TIMEOUT
0x066, // 0x04a = 74 - 
0x0a8, // 0x04b = 75 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_BREAK
0x070, // 0x04c = 76 - 
0x0aa, // 0x04d = 77 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_CREDIT_TIMEOUT
0x06b, // 0x04e = 78 - 
0x0c5, // 0x04f = 79 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_SMP_ERR
0x070, // 0x050 = 80 - 
0x0ac, // 0x051 = 81 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_MAX_BURST_SIZE
0x063, // 0x052 = 82 - 
0x0d9, // 0x053 = 83 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_FREEZE_TIMEOUT
0x070, // 0x054 = 84 - 
0x0ca, // 0x055 = 85 - JUMP_IF_CLOSE_REQ
0x0f0, // 0x056 = 86 - 
0x0be, // 0x057 = 87 - JUMP_IF_PHY_READY
0x043, // 0x058 = 88 - 
0x01c, // 0x059 = 89 - SOFT_RESET
0x0ff, // 0x05a = 90 - JUMP
0x004, // 0x05b = 91 - 
0x01d, // 0x05c = 92 - ADVANCE
0x0bc, // 0x05d = 93 - JUMP_IF_BREAK_RECEIVED
0x13b, // 0x05e = 94 - 
0x0c3, // 0x05f = 95 - JUMP_IF_SMP_PROTOCOL
0x128, // 0x060 = 96 - 
0x0ff, // 0x061 = 97 - JUMP
0x076, // 0x062 = 98 - 
0x01d, // 0x063 = 99 - ADVANCE
0x0ff, // 0x064 = 100 - JUMP
0x076, // 0x065 = 101 - 
0x01d, // 0x066 = 102 - ADVANCE
0x0bc, // 0x067 = 103 - JUMP_IF_BREAK_RECEIVED
0x13b, // 0x068 = 104 - 
0x0ff, // 0x069 = 105 - JUMP
0x147, // 0x06a = 106 - 
0x01d, // 0x06b = 107 - ADVANCE
0x0bc, // 0x06c = 108 - JUMP_IF_BREAK_RECEIVED
0x13b, // 0x06d = 109 - 
0x0ff, // 0x06e = 110 - JUMP
0x14a, // 0x06f = 111 - 
0x01d, // 0x070 = 112 - ADVANCE
0x0ff, // 0x071 = 113 - JUMP
0x13b, // 0x072 = 114 - 
0x022, // 0x073 = 115 - SEND_CREDIT_BLOCK
0x0ff, // 0x074 = 116 - JUMP
0x045, // 0x075 = 117 - 
0x083, // 0x076 = 118 - TIMER_START
0x004, // 0x077 = 119 - 
0x0c8, // 0x078 = 120 - JUMP_IF_HIP_REQ
0x082, // 0x079 = 121 - 
0x0c6, // 0x07a = 122 - JUMP_IF_SFO_REQ
0x08a, // 0x07b = 123 - 
0x0c7, // 0x07c = 124 - JUMP_IF_DOC_REQ
0x094, // 0x07d = 125 - 
0x0b8, // 0x07e = 126 - JUMP_IF_TIMER_EXPIRED
0x09c, // 0x07f = 127 - 
0x0ff, // 0x080 = 128 - JUMP
0x078, // 0x081 = 129 - 
0x028, // 0x082 = 130 - CHECK_HIP
0x000, // 0x083 = 131 - NO_OP
0x000, // 0x084 = 132 - NO_OP
0x000, // 0x085 = 133 - NO_OP
0x0d8, // 0x086 = 134 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0cf, // 0x087 = 135 - 
0x0ff, // 0x088 = 136 - JUMP
0x07e, // 0x089 = 137 - 
0x029, // 0x08a = 138 - CHECK_SFO
0x000, // 0x08b = 139 - NO_OP
0x000, // 0x08c = 140 - NO_OP
0x000, // 0x08d = 141 - NO_OP
0x0d8, // 0x08e = 142 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0d4, // 0x08f = 143 - 
0x0c7, // 0x090 = 144 - JUMP_IF_DOC_REQ
0x094, // 0x091 = 145 - 
0x0ff, // 0x092 = 146 - JUMP
0x07e, // 0x093 = 147 - 
0x02a, // 0x094 = 148 - CHECK_DOC
0x000, // 0x095 = 149 - NO_OP
0x000, // 0x096 = 150 - NO_OP
0x000, // 0x097 = 151 - NO_OP
0x0d8, // 0x098 = 152 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0d9, // 0x099 = 153 - 
0x0ff, // 0x09a = 154 - JUMP
0x07e, // 0x09b = 155 - 
0x0bc, // 0x09c = 156 - JUMP_IF_BREAK_RECEIVED
0x13b, // 0x09d = 157 - 
0x0be, // 0x09e = 158 - JUMP_IF_PHY_READY
0x0a3, // 0x09f = 159 - 
0x01c, // 0x0a0 = 160 - SOFT_RESET
0x0ff, // 0x0a1 = 161 - JUMP
0x004, // 0x0a2 = 162 - 
0x0c8, // 0x0a3 = 163 - JUMP_IF_HIP_REQ
0x0b5, // 0x0a4 = 164 - 
0x0c6, // 0x0a5 = 165 - JUMP_IF_SFO_REQ
0x0bd, // 0x0a6 = 166 - 
0x0c7, // 0x0a7 = 167 - JUMP_IF_DOC_REQ
0x0c7, // 0x0a8 = 168 - 
0x0a3, // 0x0a9 = 169 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
0x107, // 0x0aa = 170 - 
0x0a2, // 0x0ab = 171 - JUMP_IF_CONNECTION_OPEN_MASTER_FLAG_SET
0x0f0, // 0x0ac = 172 - 
0x0c8, // 0x0ad = 173 - JUMP_IF_HIP_REQ
0x0cf, // 0x0ae = 174 - 
0x0c6, // 0x0af = 175 - JUMP_IF_SFO_REQ
0x0d4, // 0x0b0 = 176 - 
0x0c7, // 0x0b1 = 177 - JUMP_IF_DOC_REQ
0x0d9, // 0x0b2 = 178 - 
0x0ff, // 0x0b3 = 179 - JUMP
0x09c, // 0x0b4 = 180 - 
0x028, // 0x0b5 = 181 - CHECK_HIP
0x000, // 0x0b6 = 182 - NO_OP
0x000, // 0x0b7 = 183 - NO_OP
0x000, // 0x0b8 = 184 - NO_OP
0x0d8, // 0x0b9 = 185 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0cf, // 0x0ba = 186 - 
0x0ff, // 0x0bb = 187 - JUMP
0x0a9, // 0x0bc = 188 - 
0x029, // 0x0bd = 189 - CHECK_SFO
0x000, // 0x0be = 190 - NO_OP
0x000, // 0x0bf = 191 - NO_OP
0x000, // 0x0c0 = 192 - NO_OP
0x0d8, // 0x0c1 = 193 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0d4, // 0x0c2 = 194 - 
0x0c7, // 0x0c3 = 195 - JUMP_IF_DOC_REQ
0x0c7, // 0x0c4 = 196 - 
0x0ff, // 0x0c5 = 197 - JUMP
0x0a9, // 0x0c6 = 198 - 
0x02a, // 0x0c7 = 199 - CHECK_DOC
0x000, // 0x0c8 = 200 - NO_OP
0x000, // 0x0c9 = 201 - NO_OP
0x000, // 0x0ca = 202 - NO_OP
0x0d8, // 0x0cb = 203 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0d9, // 0x0cc = 204 - 
0x0ff, // 0x0cd = 205 - JUMP
0x0a9, // 0x0ce = 206 - 
0x020, // 0x0cf = 207 - SELECT_HIP
0x000, // 0x0d0 = 208 - NO_OP
0x000, // 0x0d1 = 209 - NO_OP
0x0ff, // 0x0d2 = 210 - JUMP
0x0dc, // 0x0d3 = 211 - 
0x01e, // 0x0d4 = 212 - SELECT_SFO
0x000, // 0x0d5 = 213 - NO_OP
0x000, // 0x0d6 = 214 - NO_OP
0x0ff, // 0x0d7 = 215 - JUMP
0x0dc, // 0x0d8 = 216 - 
0x01f, // 0x0d9 = 217 - SELECT_DOC
0x000, // 0x0da = 218 - NO_OP
0x000, // 0x0db = 219 - NO_OP
0x0a4, // 0x0dc = 220 - JUMP_IF_CONNECTION_ACTIVE_SET
0x0e0, // 0x0dd = 221 - 
0x0ff, // 0x0de = 222 - JUMP
0x14d, // 0x0df = 223 - 
0x0a0, // 0x0e0 = 224 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL
0x0e6, // 0x0e1 = 225 - 
0x0a3, // 0x0e2 = 226 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
0x107, // 0x0e3 = 227 - 
0x0ff, // 0x0e4 = 228 - JUMP
0x128, // 0x0e5 = 229 - 
0x0cb, // 0x0e6 = 230 - JUMP_IF_FREEZE_ACTIVE
0x0eb, // 0x0e7 = 231 - 
0x013, // 0x0e8 = 232 - SET_OPEN_STATUS_NORMAL
0x0ff, // 0x0e9 = 233 - JUMP
0x042, // 0x0ea = 234 - 
0x024, // 0x0eb = 235 - SET_OPEN_STATUS_FREEZE
0x000, // 0x0ec = 236 - NO_OP
0x000, // 0x0ed = 237 - NO_OP
0x0ff, // 0x0ee = 238 - JUMP
0x09c, // 0x0ef = 239 - 
0x0d2, // 0x0f0 = 240 - JUMP_IF_STP_CONNECTION_ACTIVE
0x0f4, // 0x0f1 = 241 - 
0x0ff, // 0x0f2 = 242 - JUMP
0x128, // 0x0f3 = 243 - 
0x0d5, // 0x0f4 = 244 - JUMP_IF_CLOSE_RECEIVED
0x128, // 0x0f5 = 245 - 
0x0d6, // 0x0f6 = 246 - JUMP_IF_SYNC_RECEIVED
0x0fa, // 0x0f7 = 247 - 
0x0ff, // 0x0f8 = 248 - JUMP
0x09c, // 0x0f9 = 249 - 
0x027, // 0x0fa = 250 - SEND_STP_CLOSE_REQ
0x000, // 0x0fb = 251 - NO_OP
0x000, // 0x0fc = 252 - NO_OP
0x000, // 0x0fd = 253 - NO_OP
0x000, // 0x0fe = 254 - NO_OP
0x0d5, // 0x0ff = 255 - JUMP_IF_CLOSE_RECEIVED
0x128, // 0x100 = 256 - 
0x0bc, // 0x101 = 257 - JUMP_IF_BREAK_RECEIVED
0x13b, // 0x102 = 258 - 
0x0d7, // 0x103 = 259 - JUMP_IF_STP_CLOSE_ACK
0x128, // 0x104 = 260 - 
0x0ff, // 0x105 = 261 - JUMP
0x0fb, // 0x106 = 262 - 
0x0c3, // 0x107 = 263 - JUMP_IF_SMP_PROTOCOL
0x10f, // 0x108 = 264 - 
0x0d2, // 0x109 = 265 - JUMP_IF_STP_CONNECTION_ACTIVE
0x113, // 0x10a = 266 - 
0x0d1, // 0x10b = 267 - JUMP_IF_IDLE_TIMER_TIMEOUT
0x119, // 0x10c = 268 - 
0x0ff, // 0x10d = 269 - JUMP
0x09c, // 0x10e = 270 - 
0x0c4, // 0x10f = 271 - JUMP_IF_SMP_FRAME_ERR_RECEIVED
0x13b, // 0x110 = 272 - 
0x0ff, // 0x111 = 273 - JUMP
0x0ad, // 0x112 = 274 - 
0x0d5, // 0x113 = 275 - JUMP_IF_CLOSE_RECEIVED
0x119, // 0x114 = 276 - 
0x0d6, // 0x115 = 277 - JUMP_IF_SYNC_RECEIVED
0x11b, // 0x116 = 278 - 
0x0ff, // 0x117 = 279 - JUMP
0x113, // 0x118 = 280 - 
0x0ff, // 0x119 = 281 - JUMP
0x128, // 0x11a = 282 - 
0x027, // 0x11b = 283 - SEND_STP_CLOSE_REQ
0x000, // 0x11c = 284 - NO_OP
0x000, // 0x11d = 285 - NO_OP
0x000, // 0x11e = 286 - NO_OP
0x000, // 0x11f = 287 - NO_OP
0x0d5, // 0x120 = 288 - JUMP_IF_CLOSE_RECEIVED
0x128, // 0x121 = 289 - 
0x0bc, // 0x122 = 290 - JUMP_IF_BREAK_RECEIVED
0x13b, // 0x123 = 291 - 
0x0d7, // 0x124 = 292 - JUMP_IF_STP_CLOSE_ACK
0x128, // 0x125 = 293 - 
0x0ff, // 0x126 = 294 - JUMP
0x11c, // 0x127 = 295 - 
0x004, // 0x128 = 296 - CLOSE_NORMAL
0x000, // 0x129 = 297 - NO_OP
0x000, // 0x12a = 298 - NO_OP
0x000, // 0x12b = 299 - NO_OP
0x000, // 0x12c = 300 - NO_OP
0x0c9, // 0x12d = 301 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x138, // 0x12e = 302 - 
0x0c0, // 0x12f = 303 - JUMP_IF_CLOSE_STATUS_EQUAL_ANY
0x09c, // 0x130 = 304 - 
0x0bc, // 0x131 = 305 - JUMP_IF_BREAK_RECEIVED
0x13b, // 0x132 = 306 - 
0x0be, // 0x133 = 307 - JUMP_IF_PHY_READY
0x129, // 0x134 = 308 - 
0x01c, // 0x135 = 309 - SOFT_RESET
0x0ff, // 0x136 = 310 - JUMP
0x004, // 0x137 = 311 - 
0x022, // 0x138 = 312 - SEND_CREDIT_BLOCK
0x0ff, // 0x139 = 313 - JUMP
0x129, // 0x13a = 314 - 
0x007, // 0x13b = 315 - CLOSE_BREAK
0x000, // 0x13c = 316 - NO_OP
0x000, // 0x13d = 317 - NO_OP
0x000, // 0x13e = 318 - NO_OP
0x000, // 0x13f = 319 - NO_OP
0x0c0, // 0x140 = 320 - JUMP_IF_CLOSE_STATUS_EQUAL_ANY
0x09c, // 0x141 = 321 - 
0x0be, // 0x142 = 322 - JUMP_IF_PHY_READY
0x13c, // 0x143 = 323 - 
0x01c, // 0x144 = 324 - SOFT_RESET
0x0ff, // 0x145 = 325 - JUMP
0x004, // 0x146 = 326 - 
0x005, // 0x147 = 327 - CLOSE_ACK_NAK_TIMEOUT
0x0ff, // 0x148 = 328 - JUMP
0x129, // 0x149 = 329 - 
0x006, // 0x14a = 330 - CLOSE_CREDIT_TIMEOUT
0x0ff, // 0x14b = 331 - JUMP
0x129, // 0x14c = 332 - 
0x0cc, // 0x14d = 333 - JUMP_IF_RX_BUFFER_FULL
0x09c, // 0x14e = 334 - 
0x0b7, // 0x14f = 335 - JUMP_IF_FLAG_7_SET
0x154, // 0x150 = 336 - 
0x011, // 0x151 = 337 - START_IT_NEXUS_LOSS_TIMER
0x00f, // 0x152 = 338 - PATHWAY_BLOCKED_CNT_RESET
0x00e, // 0x153 = 339 - START_ARB_WAIT_TIMER
0x0cb, // 0x154 = 340 - JUMP_IF_FREEZE_ACTIVE
0x193, // 0x155 = 341 - 
0x001, // 0x156 = 342 - OPEN_REQUEST
0x080, // 0x157 = 343 - SET_FLAG
0x080, // 0x158 = 344 - 
0x090, // 0x159 = 345 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_ACCEPT
0x17f, // 0x15a = 346 - 
0x095, // 0x15b = 347 - JUMP_IF_OPEN_STATUS_EQUAL_RATE_NOT_SUPPORTED
0x184, // 0x15c = 348 - 
0x099, // 0x15d = 349 - JUMP_IF_OPEN_STATUS_EQUAL_PROTOCOL_NOT_SUPPORTED
0x187, // 0x15e = 350 - 
0x09b, // 0x15f = 351 - JUMP_IF_OPEN_STATUS_EQUAL_WRONG_DESTINATION
0x18a, // 0x160 = 352 - 
0x094, // 0x161 = 353 - JUMP_IF_OPEN_STATUS_EQUAL_BREAK_RECEIVED
0x154, // 0x162 = 354 - 
0x093, // 0x163 = 355 - JUMP_IF_OPEN_STATUS_EQUAL_BAD_DESTINATION
0x18d, // 0x164 = 356 - 
0x09f, // 0x165 = 357 - JUMP_IF_IT_NEXUS_LOSS_TIMEOUT
0x190, // 0x166 = 358 - 
0x09a, // 0x167 = 359 - JUMP_IF_OPEN_STATUS_EQUAL_STP_RESOURCE_BUSY
0x153, // 0x168 = 360 - 
0x096, // 0x169 = 361 - JUMP_IF_OPEN_STATUS_EQUAL_NO_DESTINATION
0x154, // 0x16a = 362 - 
0x097, // 0x16b = 363 - JUMP_IF_OPEN_STATUS_EQUAL_PATHWAY_BLOCKED
0x19a, // 0x16c = 364 - 
0x098, // 0x16d = 365 - JUMP_IF_OPEN_STATUS_EQUAL_RETRY
0x153, // 0x16e = 366 - 
0x092, // 0x16f = 367 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_TIMEOUT
0x154, // 0x170 = 368 - 
0x0a4, // 0x171 = 369 - JUMP_IF_CONNECTION_ACTIVE_SET
0x179, // 0x172 = 370 - 
0x0be, // 0x173 = 371 - JUMP_IF_PHY_READY
0x159, // 0x174 = 372 - 
0x01b, // 0x175 = 373 - SET_OPEN_STATUS_PHY_NOT_RDY
0x01c, // 0x176 = 374 - SOFT_RESET
0x0ff, // 0x177 = 375 - JUMP
0x004, // 0x178 = 376 - 
0x0a0, // 0x179 = 377 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL
0x17f, // 0x17a = 378 - 
0x000, // 0x17b = 379 - NO_OP
0x000, // 0x17c = 380 - NO_OP
0x0ff, // 0x17d = 381 - JUMP
0x09c, // 0x17e = 382 - 
0x013, // 0x17f = 383 - SET_OPEN_STATUS_NORMAL
0x081, // 0x180 = 384 - CLEAR_FLAG
0x080, // 0x181 = 385 - 
0x0ff, // 0x182 = 386 - JUMP
0x042, // 0x183 = 387 - 
0x017, // 0x184 = 388 - SET_OPEN_STATUS_BAD_RATE
0x0ff, // 0x185 = 389 - JUMP
0x194, // 0x186 = 390 - 
0x018, // 0x187 = 391 - SET_OPEN_STATUS_BAD_PROTOCOL
0x0ff, // 0x188 = 392 - JUMP
0x194, // 0x189 = 393 - 
0x01a, // 0x18a = 394 - SET_OPEN_STATUS_WRONG_DEST
0x0ff, // 0x18b = 395 - JUMP
0x194, // 0x18c = 396 - 
0x015, // 0x18d = 397 - SET_OPEN_STATUS_BAD_DEST
0x0ff, // 0x18e = 398 - JUMP
0x194, // 0x18f = 399 - 
0x014, // 0x190 = 400 - SET_OPEN_STATUS_IT_NEXUS_LOSS
0x0ff, // 0x191 = 401 - JUMP
0x194, // 0x192 = 402 - 
0x024, // 0x193 = 403 - SET_OPEN_STATUS_FREEZE
0x000, // 0x194 = 404 - NO_OP
0x000, // 0x195 = 405 - NO_OP
0x081, // 0x196 = 406 - CLEAR_FLAG
0x080, // 0x197 = 407 - 
0x0ff, // 0x198 = 408 - JUMP
0x09c, // 0x199 = 409 - 
0x010, // 0x19a = 410 - PATHWAY_BLOCKED_CNT_INC
0x0ff, // 0x19b = 411 - JUMP
0x154, // 0x19c = 412 - 
0x000, // 0x19d = 413 - NO_OP
0x000, // 0x19e = 414 - NO_OP
0x000, // 0x19f = 415 - NO_OP
0x000, // 0x1a0 = 416 - NO_OP
0x000, // 0x1a1 = 417 - NO_OP
0x000, // 0x1a2 = 418 - NO_OP
0x000, // 0x1a3 = 419 - NO_OP
0x000, // 0x1a4 = 420 - NO_OP
0x000, // 0x1a5 = 421 - NO_OP
0x000, // 0x1a6 = 422 - NO_OP
0x000, // 0x1a7 = 423 - NO_OP
0x000, // 0x1a8 = 424 - NO_OP
0x000, // 0x1a9 = 425 - NO_OP
0x000, // 0x1aa = 426 - NO_OP
0x000, // 0x1ab = 427 - NO_OP
0x000, // 0x1ac = 428 - NO_OP
0x000, // 0x1ad = 429 - NO_OP
0x000, // 0x1ae = 430 - NO_OP
0x000, // 0x1af = 431 - NO_OP
0x000, // 0x1b0 = 432 - NO_OP
0x000, // 0x1b1 = 433 - NO_OP
0x000, // 0x1b2 = 434 - NO_OP
0x000, // 0x1b3 = 435 - NO_OP
0x000, // 0x1b4 = 436 - NO_OP
0x000, // 0x1b5 = 437 - NO_OP
0x000, // 0x1b6 = 438 - NO_OP
0x000, // 0x1b7 = 439 - NO_OP
0x000, // 0x1b8 = 440 - NO_OP
0x000, // 0x1b9 = 441 - NO_OP
0x000, // 0x1ba = 442 - NO_OP
0x000, // 0x1bb = 443 - NO_OP
0x000, // 0x1bc = 444 - NO_OP
0x000, // 0x1bd = 445 - NO_OP
0x000, // 0x1be = 446 - NO_OP
0x000, // 0x1bf = 447 - NO_OP
0x000, // 0x1c0 = 448 - NO_OP
0x000, // 0x1c1 = 449 - NO_OP
0x000, // 0x1c2 = 450 - NO_OP
0x000, // 0x1c3 = 451 - NO_OP
0x000, // 0x1c4 = 452 - NO_OP
0x000, // 0x1c5 = 453 - NO_OP
0x000, // 0x1c6 = 454 - NO_OP
0x000, // 0x1c7 = 455 - NO_OP
0x000, // 0x1c8 = 456 - NO_OP
0x000, // 0x1c9 = 457 - NO_OP
0x000, // 0x1ca = 458 - NO_OP
0x000, // 0x1cb = 459 - NO_OP
0x000, // 0x1cc = 460 - NO_OP
0x000, // 0x1cd = 461 - NO_OP
0x000, // 0x1ce = 462 - NO_OP
0x000, // 0x1cf = 463 - NO_OP
0x000, // 0x1d0 = 464 - NO_OP
0x000, // 0x1d1 = 465 - NO_OP
0x000, // 0x1d2 = 466 - NO_OP
0x000, // 0x1d3 = 467 - NO_OP
0x000, // 0x1d4 = 468 - NO_OP
0x000, // 0x1d5 = 469 - NO_OP
0x000, // 0x1d6 = 470 - NO_OP
0x000, // 0x1d7 = 471 - NO_OP
0x000, // 0x1d8 = 472 - NO_OP
0x000, // 0x1d9 = 473 - NO_OP
0x000, // 0x1da = 474 - NO_OP
0x000, // 0x1db = 475 - NO_OP
0x000, // 0x1dc = 476 - NO_OP
0x000, // 0x1dd = 477 - NO_OP
0x000, // 0x1de = 478 - NO_OP
0x000, // 0x1df = 479 - NO_OP
0x000, // 0x1e0 = 480 - NO_OP
0x000, // 0x1e1 = 481 - NO_OP
0x000, // 0x1e2 = 482 - NO_OP
0x000, // 0x1e3 = 483 - NO_OP
0x000, // 0x1e4 = 484 - NO_OP
0x000, // 0x1e5 = 485 - NO_OP
0x000, // 0x1e6 = 486 - NO_OP
0x000, // 0x1e7 = 487 - NO_OP
0x000, // 0x1e8 = 488 - NO_OP
0x000, // 0x1e9 = 489 - NO_OP
0x000, // 0x1ea = 490 - NO_OP
0x000, // 0x1eb = 491 - NO_OP
0x000, // 0x1ec = 492 - NO_OP
0x000, // 0x1ed = 493 - NO_OP
0x000, // 0x1ee = 494 - NO_OP
0x000, // 0x1ef = 495 - NO_OP
0x000, // 0x1f0 = 496 - NO_OP
0x000, // 0x1f1 = 497 - NO_OP
0x000, // 0x1f2 = 498 - NO_OP
0x000, // 0x1f3 = 499 - NO_OP
0x000, // 0x1f4 = 500 - NO_OP
0x000, // 0x1f5 = 501 - NO_OP
0x000, // 0x1f6 = 502 - NO_OP
0x000, // 0x1f7 = 503 - NO_OP
0x000, // 0x1f8 = 504 - NO_OP
0x000, // 0x1f9 = 505 - NO_OP
0x000, // 0x1fa = 506 - NO_OP
0x000, // 0x1fb = 507 - NO_OP
0x000, // 0x1fc = 508 - NO_OP
0x000, // 0x1fd = 509 - NO_OP
0x000, // 0x1fe = 510 - NO_OP
0x000, // 0x1ff = 511 - NO_OP
};  

/* for A1307_09 */
bit32 wcsImageA1307_09[] = 
{
0x00d, // 00000 = 0 - PHY_RESET_START
0x00d, // 0x001 = 1 - PHY_RESET_START
0x0be, // 0x002 = 2 - JUMP_IF_PHY_READY
0x002, // 0x003 = 3 - 
0x0be, // 0x004 = 4 - JUMP_IF_PHY_READY
0x00e, // 0x005 = 5 - 
0x0ae, // 0x006 = 6 - JUMP_IF_HARD_RESET_PRIMITIVE
0x024, // 0x007 = 7 - 
0x0af, // 0x008 = 8 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x017, // 0x009 = 9 - 
0x0ce, // 0x00a = 10 - JUMP_IF_IDENTIFY_FRAME_TIMEOUT
0x000, // 0x00b = 11 - 
0x0ff, // 0x00c = 12 - JUMP
0x004, // 0x00d = 13 - 
0x00c, // 0x00e = 14 - SEND_ID_FRAME
0x0ae, // 0x00f = 15 - JUMP_IF_HARD_RESET_PRIMITIVE
0x024, // 0x010 = 16 - 
0x0af, // 0x011 = 17 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x01c, // 0x012 = 18 - 
0x0ce, // 0x013 = 19 - JUMP_IF_IDENTIFY_FRAME_TIMEOUT
0x000, // 0x014 = 20 - 
0x0ff, // 0x015 = 21 - JUMP
0x00f, // 0x016 = 22 - 
0x0be, // 0x017 = 23 - JUMP_IF_PHY_READY
0x01b, // 0x018 = 24 - 
0x0ff, // 0x019 = 25 - JUMP
0x017, // 0x01a = 26 - 
0x00c, // 0x01b = 27 - SEND_ID_FRAME
0x000, // 0x01c = 28 - NO_OP
0x000, // 0x01d = 29 - NO_OP
0x000, // 0x01e = 30 - NO_OP
0x000, // 0x01f = 31 - NO_OP
0x000, // 0x020 = 32 - NO_OP
0x000, // 0x021 = 33 - NO_OP
0x0ff, // 0x022 = 34 - JUMP
0x09c, // 0x023 = 35 - 
0x01c, // 0x024 = 36 - SOFT_RESET
0x00d, // 0x025 = 37 - PHY_RESET_START
0x00d, // 0x026 = 38 - PHY_RESET_START
0x0be, // 0x027 = 39 - JUMP_IF_PHY_READY
0x027, // 0x028 = 40 - 
0x0be, // 0x029 = 41 - JUMP_IF_PHY_READY
0x02f, // 0x02a = 42 - 
0x0af, // 0x02b = 43 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x036, // 0x02c = 44 - 
0x0ff, // 0x02d = 45 - JUMP
0x029, // 0x02e = 46 - 
0x00c, // 0x02f = 47 - SEND_ID_FRAME
0x0af, // 0x030 = 48 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x039, // 0x031 = 49 - 
0x0ce, // 0x032 = 50 - JUMP_IF_IDENTIFY_FRAME_TIMEOUT
0x024, // 0x033 = 51 - 
0x0ff, // 0x034 = 52 - JUMP
0x030, // 0x035 = 53 - 
0x00c, // 0x036 = 54 - SEND_ID_FRAME
0x0ff, // 0x037 = 55 - JUMP
0x039, // 0x038 = 56 - 
0x000, // 0x039 = 57 - NO_OP
0x0cb, // 0x03a = 58 - JUMP_IF_FREEZE_ACTIVE
0x03e, // 0x03b = 59 - 
0x0ff, // 0x03c = 60 - JUMP
0x03a, // 0x03d = 61 - 
0x0cb, // 0x03e = 62 - JUMP_IF_FREEZE_ACTIVE
0x03e, // 0x03f = 63 - 
0x0ff, // 0x040 = 64 - JUMP
0x09c, // 0x041 = 65 - 
0x000, // 0x042 = 66 - NO_OP
0x0c9, // 0x043 = 67 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x073, // 0x044 = 68 - 
0x0a5, // 0x045 = 69 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_GOOD
0x05c, // 0x046 = 70 - 
0x0a6, // 0x047 = 71 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_NAK
0x063, // 0x048 = 72 - 
0x0a7, // 0x049 = 73 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_ACK_NAK_TIMEOUT
0x066, // 0x04a = 74 - 
0x0a8, // 0x04b = 75 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_BREAK
0x070, // 0x04c = 76 - 
0x0aa, // 0x04d = 77 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_CREDIT_TIMEOUT
0x06b, // 0x04e = 78 - 
0x0c5, // 0x04f = 79 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_SMP_ERR
0x070, // 0x050 = 80 - 
0x0ac, // 0x051 = 81 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_MAX_BURST_SIZE
0x063, // 0x052 = 82 - 
0x0d9, // 0x053 = 83 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_FREEZE_TIMEOUT
0x070, // 0x054 = 84 - 
0x0ca, // 0x055 = 85 - JUMP_IF_CLOSE_REQ
0x0f0, // 0x056 = 86 - 
0x0be, // 0x057 = 87 - JUMP_IF_PHY_READY
0x043, // 0x058 = 88 - 
0x01c, // 0x059 = 89 - SOFT_RESET
0x0ff, // 0x05a = 90 - JUMP
0x004, // 0x05b = 91 - 
0x01d, // 0x05c = 92 - ADVANCE
0x0bc, // 0x05d = 93 - JUMP_IF_BREAK_RECEIVED
0x13b, // 0x05e = 94 - 
0x0c3, // 0x05f = 95 - JUMP_IF_SMP_PROTOCOL
0x128, // 0x060 = 96 - 
0x0ff, // 0x061 = 97 - JUMP
0x076, // 0x062 = 98 - 
0x01d, // 0x063 = 99 - ADVANCE
0x0ff, // 0x064 = 100 - JUMP
0x076, // 0x065 = 101 - 
0x01d, // 0x066 = 102 - ADVANCE
0x0bc, // 0x067 = 103 - JUMP_IF_BREAK_RECEIVED
0x13b, // 0x068 = 104 - 
0x0ff, // 0x069 = 105 - JUMP
0x147, // 0x06a = 106 - 
0x01d, // 0x06b = 107 - ADVANCE
0x0bc, // 0x06c = 108 - JUMP_IF_BREAK_RECEIVED
0x13b, // 0x06d = 109 - 
0x0ff, // 0x06e = 110 - JUMP
0x14a, // 0x06f = 111 - 
0x01d, // 0x070 = 112 - ADVANCE
0x0ff, // 0x071 = 113 - JUMP
0x13b, // 0x072 = 114 - 
0x022, // 0x073 = 115 - SEND_CREDIT_BLOCK
0x0ff, // 0x074 = 116 - JUMP
0x045, // 0x075 = 117 - 
0x083, // 0x076 = 118 - TIMER_START
0x004, // 0x077 = 119 - 
0x0c8, // 0x078 = 120 - JUMP_IF_HIP_REQ
0x082, // 0x079 = 121 - 
0x0c6, // 0x07a = 122 - JUMP_IF_SFO_REQ
0x08a, // 0x07b = 123 - 
0x0c7, // 0x07c = 124 - JUMP_IF_DOC_REQ
0x094, // 0x07d = 125 - 
0x0b8, // 0x07e = 126 - JUMP_IF_TIMER_EXPIRED
0x09c, // 0x07f = 127 - 
0x0ff, // 0x080 = 128 - JUMP
0x078, // 0x081 = 129 - 
0x028, // 0x082 = 130 - CHECK_HIP
0x000, // 0x083 = 131 - NO_OP
0x000, // 0x084 = 132 - NO_OP
0x000, // 0x085 = 133 - NO_OP
0x0d8, // 0x086 = 134 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0cf, // 0x087 = 135 - 
0x0ff, // 0x088 = 136 - JUMP
0x07e, // 0x089 = 137 - 
0x029, // 0x08a = 138 - CHECK_SFO
0x000, // 0x08b = 139 - NO_OP
0x000, // 0x08c = 140 - NO_OP
0x000, // 0x08d = 141 - NO_OP
0x0d8, // 0x08e = 142 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0d4, // 0x08f = 143 - 
0x0c7, // 0x090 = 144 - JUMP_IF_DOC_REQ
0x094, // 0x091 = 145 - 
0x0ff, // 0x092 = 146 - JUMP
0x07e, // 0x093 = 147 - 
0x02a, // 0x094 = 148 - CHECK_DOC
0x000, // 0x095 = 149 - NO_OP
0x000, // 0x096 = 150 - NO_OP
0x000, // 0x097 = 151 - NO_OP
0x0d8, // 0x098 = 152 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0d9, // 0x099 = 153 - 
0x0ff, // 0x09a = 154 - JUMP
0x07e, // 0x09b = 155 - 
0x0bc, // 0x09c = 156 - JUMP_IF_BREAK_RECEIVED
0x13b, // 0x09d = 157 - 
0x0be, // 0x09e = 158 - JUMP_IF_PHY_READY
0x0a3, // 0x09f = 159 - 
0x01c, // 0x0a0 = 160 - SOFT_RESET
0x0ff, // 0x0a1 = 161 - JUMP
0x004, // 0x0a2 = 162 - 
0x0c8, // 0x0a3 = 163 - JUMP_IF_HIP_REQ
0x0b5, // 0x0a4 = 164 - 
0x0c6, // 0x0a5 = 165 - JUMP_IF_SFO_REQ
0x0bd, // 0x0a6 = 166 - 
0x0c7, // 0x0a7 = 167 - JUMP_IF_DOC_REQ
0x0c7, // 0x0a8 = 168 - 
0x0a3, // 0x0a9 = 169 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
0x107, // 0x0aa = 170 - 
0x0a2, // 0x0ab = 171 - JUMP_IF_CONNECTION_OPEN_MASTER_FLAG_SET
0x0f0, // 0x0ac = 172 - 
0x0c8, // 0x0ad = 173 - JUMP_IF_HIP_REQ
0x0cf, // 0x0ae = 174 - 
0x0c6, // 0x0af = 175 - JUMP_IF_SFO_REQ
0x0d4, // 0x0b0 = 176 - 
0x0c7, // 0x0b1 = 177 - JUMP_IF_DOC_REQ
0x0d9, // 0x0b2 = 178 - 
0x0ff, // 0x0b3 = 179 - JUMP
0x09c, // 0x0b4 = 180 - 
0x028, // 0x0b5 = 181 - CHECK_HIP
0x000, // 0x0b6 = 182 - NO_OP
0x000, // 0x0b7 = 183 - NO_OP
0x000, // 0x0b8 = 184 - NO_OP
0x0d8, // 0x0b9 = 185 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0cf, // 0x0ba = 186 - 
0x0ff, // 0x0bb = 187 - JUMP
0x0a9, // 0x0bc = 188 - 
0x029, // 0x0bd = 189 - CHECK_SFO
0x000, // 0x0be = 190 - NO_OP
0x000, // 0x0bf = 191 - NO_OP
0x000, // 0x0c0 = 192 - NO_OP
0x0d8, // 0x0c1 = 193 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0d4, // 0x0c2 = 194 - 
0x0c7, // 0x0c3 = 195 - JUMP_IF_DOC_REQ
0x0c7, // 0x0c4 = 196 - 
0x0ff, // 0x0c5 = 197 - JUMP
0x0a9, // 0x0c6 = 198 - 
0x02a, // 0x0c7 = 199 - CHECK_DOC
0x000, // 0x0c8 = 200 - NO_OP
0x000, // 0x0c9 = 201 - NO_OP
0x000, // 0x0ca = 202 - NO_OP
0x0d8, // 0x0cb = 203 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0d9, // 0x0cc = 204 - 
0x0ff, // 0x0cd = 205 - JUMP
0x0a9, // 0x0ce = 206 - 
0x020, // 0x0cf = 207 - SELECT_HIP
0x000, // 0x0d0 = 208 - NO_OP
0x000, // 0x0d1 = 209 - NO_OP
0x0ff, // 0x0d2 = 210 - JUMP
0x0dc, // 0x0d3 = 211 - 
0x01e, // 0x0d4 = 212 - SELECT_SFO
0x000, // 0x0d5 = 213 - NO_OP
0x000, // 0x0d6 = 214 - NO_OP
0x0ff, // 0x0d7 = 215 - JUMP
0x0dc, // 0x0d8 = 216 - 
0x01f, // 0x0d9 = 217 - SELECT_DOC
0x000, // 0x0da = 218 - NO_OP
0x000, // 0x0db = 219 - NO_OP
0x0a4, // 0x0dc = 220 - JUMP_IF_CONNECTION_ACTIVE_SET
0x0e0, // 0x0dd = 221 - 
0x0ff, // 0x0de = 222 - JUMP
0x14d, // 0x0df = 223 - 
0x0a0, // 0x0e0 = 224 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL
0x0e6, // 0x0e1 = 225 - 
0x0a3, // 0x0e2 = 226 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
0x107, // 0x0e3 = 227 - 
0x0ff, // 0x0e4 = 228 - JUMP
0x0f0, // 0x0e5 = 229 - 
0x0cb, // 0x0e6 = 230 - JUMP_IF_FREEZE_ACTIVE
0x0eb, // 0x0e7 = 231 - 
0x013, // 0x0e8 = 232 - SET_OPEN_STATUS_NORMAL
0x0ff, // 0x0e9 = 233 - JUMP
0x042, // 0x0ea = 234 - 
0x024, // 0x0eb = 235 - SET_OPEN_STATUS_FREEZE
0x000, // 0x0ec = 236 - NO_OP
0x000, // 0x0ed = 237 - NO_OP
0x0ff, // 0x0ee = 238 - JUMP
0x09c, // 0x0ef = 239 - 
0x0d2, // 0x0f0 = 240 - JUMP_IF_STP_CONNECTION_ACTIVE
0x0f4, // 0x0f1 = 241 - 
0x0ff, // 0x0f2 = 242 - JUMP
0x128, // 0x0f3 = 243 - 
0x0d5, // 0x0f4 = 244 - JUMP_IF_CLOSE_RECEIVED
0x128, // 0x0f5 = 245 - 
0x0d6, // 0x0f6 = 246 - JUMP_IF_SYNC_RECEIVED
0x0fa, // 0x0f7 = 247 - 
0x0ff, // 0x0f8 = 248 - JUMP
0x09c, // 0x0f9 = 249 - 
0x027, // 0x0fa = 250 - SEND_STP_CLOSE_REQ
0x000, // 0x0fb = 251 - NO_OP
0x000, // 0x0fc = 252 - NO_OP
0x000, // 0x0fd = 253 - NO_OP
0x000, // 0x0fe = 254 - NO_OP
0x0d5, // 0x0ff = 255 - JUMP_IF_CLOSE_RECEIVED
0x128, // 0x100 = 256 - 
0x0bc, // 0x101 = 257 - JUMP_IF_BREAK_RECEIVED
0x13b, // 0x102 = 258 - 
0x0d7, // 0x103 = 259 - JUMP_IF_STP_CLOSE_ACK
0x128, // 0x104 = 260 - 
0x0ff, // 0x105 = 261 - JUMP
0x0fb, // 0x106 = 262 - 
0x0c3, // 0x107 = 263 - JUMP_IF_SMP_PROTOCOL
0x10f, // 0x108 = 264 - 
0x0d2, // 0x109 = 265 - JUMP_IF_STP_CONNECTION_ACTIVE
0x113, // 0x10a = 266 - 
0x0d1, // 0x10b = 267 - JUMP_IF_IDLE_TIMER_TIMEOUT
0x119, // 0x10c = 268 - 
0x0ff, // 0x10d = 269 - JUMP
0x09c, // 0x10e = 270 - 
0x0c4, // 0x10f = 271 - JUMP_IF_SMP_FRAME_ERR_RECEIVED
0x13b, // 0x110 = 272 - 
0x0ff, // 0x111 = 273 - JUMP
0x0ad, // 0x112 = 274 - 
0x0d5, // 0x113 = 275 - JUMP_IF_CLOSE_RECEIVED
0x119, // 0x114 = 276 - 
0x0d6, // 0x115 = 277 - JUMP_IF_SYNC_RECEIVED
0x11b, // 0x116 = 278 - 
0x0ff, // 0x117 = 279 - JUMP
0x113, // 0x118 = 280 - 
0x0ff, // 0x119 = 281 - JUMP
0x128, // 0x11a = 282 - 
0x027, // 0x11b = 283 - SEND_STP_CLOSE_REQ
0x000, // 0x11c = 284 - NO_OP
0x000, // 0x11d = 285 - NO_OP
0x000, // 0x11e = 286 - NO_OP
0x000, // 0x11f = 287 - NO_OP
0x0d5, // 0x120 = 288 - JUMP_IF_CLOSE_RECEIVED
0x128, // 0x121 = 289 - 
0x0bc, // 0x122 = 290 - JUMP_IF_BREAK_RECEIVED
0x13b, // 0x123 = 291 - 
0x0d7, // 0x124 = 292 - JUMP_IF_STP_CLOSE_ACK
0x128, // 0x125 = 293 - 
0x0ff, // 0x126 = 294 - JUMP
0x11c, // 0x127 = 295 - 
0x004, // 0x128 = 296 - CLOSE_NORMAL
0x000, // 0x129 = 297 - NO_OP
0x000, // 0x12a = 298 - NO_OP
0x000, // 0x12b = 299 - NO_OP
0x000, // 0x12c = 300 - NO_OP
0x0c9, // 0x12d = 301 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x138, // 0x12e = 302 - 
0x0c0, // 0x12f = 303 - JUMP_IF_CLOSE_STATUS_EQUAL_ANY
0x09c, // 0x130 = 304 - 
0x0bc, // 0x131 = 305 - JUMP_IF_BREAK_RECEIVED
0x13b, // 0x132 = 306 - 
0x0be, // 0x133 = 307 - JUMP_IF_PHY_READY
0x129, // 0x134 = 308 - 
0x01c, // 0x135 = 309 - SOFT_RESET
0x0ff, // 0x136 = 310 - JUMP
0x004, // 0x137 = 311 - 
0x022, // 0x138 = 312 - SEND_CREDIT_BLOCK
0x0ff, // 0x139 = 313 - JUMP
0x129, // 0x13a = 314 - 
0x007, // 0x13b = 315 - CLOSE_BREAK
0x000, // 0x13c = 316 - NO_OP
0x000, // 0x13d = 317 - NO_OP
0x000, // 0x13e = 318 - NO_OP
0x000, // 0x13f = 319 - NO_OP
0x0c0, // 0x140 = 320 - JUMP_IF_CLOSE_STATUS_EQUAL_ANY
0x09c, // 0x141 = 321 - 
0x0be, // 0x142 = 322 - JUMP_IF_PHY_READY
0x13c, // 0x143 = 323 - 
0x01c, // 0x144 = 324 - SOFT_RESET
0x0ff, // 0x145 = 325 - JUMP
0x004, // 0x146 = 326 - 
0x005, // 0x147 = 327 - CLOSE_ACK_NAK_TIMEOUT
0x0ff, // 0x148 = 328 - JUMP
0x129, // 0x149 = 329 - 
0x006, // 0x14a = 330 - CLOSE_CREDIT_TIMEOUT
0x0ff, // 0x14b = 331 - JUMP
0x129, // 0x14c = 332 - 
0x0cc, // 0x14d = 333 - JUMP_IF_RX_BUFFER_FULL
0x09c, // 0x14e = 334 - 
0x0b7, // 0x14f = 335 - JUMP_IF_FLAG_7_SET
0x154, // 0x150 = 336 - 
0x011, // 0x151 = 337 - START_IT_NEXUS_LOSS_TIMER
0x00f, // 0x152 = 338 - PATHWAY_BLOCKED_CNT_RESET
0x00e, // 0x153 = 339 - START_ARB_WAIT_TIMER
0x0cb, // 0x154 = 340 - JUMP_IF_FREEZE_ACTIVE
0x193, // 0x155 = 341 - 
0x001, // 0x156 = 342 - OPEN_REQUEST
0x080, // 0x157 = 343 - SET_FLAG
0x080, // 0x158 = 344 - 
0x090, // 0x159 = 345 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_ACCEPT
0x17f, // 0x15a = 346 - 
0x095, // 0x15b = 347 - JUMP_IF_OPEN_STATUS_EQUAL_RATE_NOT_SUPPORTED
0x184, // 0x15c = 348 - 
0x099, // 0x15d = 349 - JUMP_IF_OPEN_STATUS_EQUAL_PROTOCOL_NOT_SUPPORTED
0x187, // 0x15e = 350 - 
0x09b, // 0x15f = 351 - JUMP_IF_OPEN_STATUS_EQUAL_WRONG_DESTINATION
0x18a, // 0x160 = 352 - 
0x094, // 0x161 = 353 - JUMP_IF_OPEN_STATUS_EQUAL_BREAK_RECEIVED
0x154, // 0x162 = 354 - 
0x093, // 0x163 = 355 - JUMP_IF_OPEN_STATUS_EQUAL_BAD_DESTINATION
0x18d, // 0x164 = 356 - 
0x09f, // 0x165 = 357 - JUMP_IF_IT_NEXUS_LOSS_TIMEOUT
0x190, // 0x166 = 358 - 
0x09a, // 0x167 = 359 - JUMP_IF_OPEN_STATUS_EQUAL_STP_RESOURCE_BUSY
0x153, // 0x168 = 360 - 
0x096, // 0x169 = 361 - JUMP_IF_OPEN_STATUS_EQUAL_NO_DESTINATION
0x154, // 0x16a = 362 - 
0x097, // 0x16b = 363 - JUMP_IF_OPEN_STATUS_EQUAL_PATHWAY_BLOCKED
0x19a, // 0x16c = 364 - 
0x098, // 0x16d = 365 - JUMP_IF_OPEN_STATUS_EQUAL_RETRY
0x153, // 0x16e = 366 - 
0x092, // 0x16f = 367 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_TIMEOUT
0x154, // 0x170 = 368 - 
0x0a4, // 0x171 = 369 - JUMP_IF_CONNECTION_ACTIVE_SET
0x179, // 0x172 = 370 - 
0x0be, // 0x173 = 371 - JUMP_IF_PHY_READY
0x159, // 0x174 = 372 - 
0x01b, // 0x175 = 373 - SET_OPEN_STATUS_PHY_NOT_RDY
0x01c, // 0x176 = 374 - SOFT_RESET
0x0ff, // 0x177 = 375 - JUMP
0x004, // 0x178 = 376 - 
0x0a0, // 0x179 = 377 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL
0x17f, // 0x17a = 378 - 
0x000, // 0x17b = 379 - NO_OP
0x000, // 0x17c = 380 - NO_OP
0x0ff, // 0x17d = 381 - JUMP
0x09c, // 0x17e = 382 - 
0x013, // 0x17f = 383 - SET_OPEN_STATUS_NORMAL
0x081, // 0x180 = 384 - CLEAR_FLAG
0x080, // 0x181 = 385 - 
0x0ff, // 0x182 = 386 - JUMP
0x042, // 0x183 = 387 - 
0x017, // 0x184 = 388 - SET_OPEN_STATUS_BAD_RATE
0x0ff, // 0x185 = 389 - JUMP
0x194, // 0x186 = 390 - 
0x018, // 0x187 = 391 - SET_OPEN_STATUS_BAD_PROTOCOL
0x0ff, // 0x188 = 392 - JUMP
0x194, // 0x189 = 393 - 
0x01a, // 0x18a = 394 - SET_OPEN_STATUS_WRONG_DEST
0x0ff, // 0x18b = 395 - JUMP
0x194, // 0x18c = 396 - 
0x015, // 0x18d = 397 - SET_OPEN_STATUS_BAD_DEST
0x0ff, // 0x18e = 398 - JUMP
0x194, // 0x18f = 399 - 
0x014, // 0x190 = 400 - SET_OPEN_STATUS_IT_NEXUS_LOSS
0x0ff, // 0x191 = 401 - JUMP
0x194, // 0x192 = 402 - 
0x024, // 0x193 = 403 - SET_OPEN_STATUS_FREEZE
0x000, // 0x194 = 404 - NO_OP
0x000, // 0x195 = 405 - NO_OP
0x081, // 0x196 = 406 - CLEAR_FLAG
0x080, // 0x197 = 407 - 
0x0ff, // 0x198 = 408 - JUMP
0x09c, // 0x199 = 409 - 
0x010, // 0x19a = 410 - PATHWAY_BLOCKED_CNT_INC
0x0ff, // 0x19b = 411 - JUMP
0x154, // 0x19c = 412 - 
0x000, // 0x19d = 413 - NO_OP
0x000, // 0x19e = 414 - NO_OP
0x000, // 0x19f = 415 - NO_OP
0x000, // 0x1a0 = 416 - NO_OP
0x000, // 0x1a1 = 417 - NO_OP
0x000, // 0x1a2 = 418 - NO_OP
0x000, // 0x1a3 = 419 - NO_OP
0x000, // 0x1a4 = 420 - NO_OP
0x000, // 0x1a5 = 421 - NO_OP
0x000, // 0x1a6 = 422 - NO_OP
0x000, // 0x1a7 = 423 - NO_OP
0x000, // 0x1a8 = 424 - NO_OP
0x000, // 0x1a9 = 425 - NO_OP
0x000, // 0x1aa = 426 - NO_OP
0x000, // 0x1ab = 427 - NO_OP
0x000, // 0x1ac = 428 - NO_OP
0x000, // 0x1ad = 429 - NO_OP
0x000, // 0x1ae = 430 - NO_OP
0x000, // 0x1af = 431 - NO_OP
0x000, // 0x1b0 = 432 - NO_OP
0x000, // 0x1b1 = 433 - NO_OP
0x000, // 0x1b2 = 434 - NO_OP
0x000, // 0x1b3 = 435 - NO_OP
0x000, // 0x1b4 = 436 - NO_OP
0x000, // 0x1b5 = 437 - NO_OP
0x000, // 0x1b6 = 438 - NO_OP
0x000, // 0x1b7 = 439 - NO_OP
0x000, // 0x1b8 = 440 - NO_OP
0x000, // 0x1b9 = 441 - NO_OP
0x000, // 0x1ba = 442 - NO_OP
0x000, // 0x1bb = 443 - NO_OP
0x000, // 0x1bc = 444 - NO_OP
0x000, // 0x1bd = 445 - NO_OP
0x000, // 0x1be = 446 - NO_OP
0x000, // 0x1bf = 447 - NO_OP
0x000, // 0x1c0 = 448 - NO_OP
0x000, // 0x1c1 = 449 - NO_OP
0x000, // 0x1c2 = 450 - NO_OP
0x000, // 0x1c3 = 451 - NO_OP
0x000, // 0x1c4 = 452 - NO_OP
0x000, // 0x1c5 = 453 - NO_OP
0x000, // 0x1c6 = 454 - NO_OP
0x000, // 0x1c7 = 455 - NO_OP
0x000, // 0x1c8 = 456 - NO_OP
0x000, // 0x1c9 = 457 - NO_OP
0x000, // 0x1ca = 458 - NO_OP
0x000, // 0x1cb = 459 - NO_OP
0x000, // 0x1cc = 460 - NO_OP
0x000, // 0x1cd = 461 - NO_OP
0x000, // 0x1ce = 462 - NO_OP
0x000, // 0x1cf = 463 - NO_OP
0x000, // 0x1d0 = 464 - NO_OP
0x000, // 0x1d1 = 465 - NO_OP
0x000, // 0x1d2 = 466 - NO_OP
0x000, // 0x1d3 = 467 - NO_OP
0x000, // 0x1d4 = 468 - NO_OP
0x000, // 0x1d5 = 469 - NO_OP
0x000, // 0x1d6 = 470 - NO_OP
0x000, // 0x1d7 = 471 - NO_OP
0x000, // 0x1d8 = 472 - NO_OP
0x000, // 0x1d9 = 473 - NO_OP
0x000, // 0x1da = 474 - NO_OP
0x000, // 0x1db = 475 - NO_OP
0x000, // 0x1dc = 476 - NO_OP
0x000, // 0x1dd = 477 - NO_OP
0x000, // 0x1de = 478 - NO_OP
0x000, // 0x1df = 479 - NO_OP
0x000, // 0x1e0 = 480 - NO_OP
0x000, // 0x1e1 = 481 - NO_OP
0x000, // 0x1e2 = 482 - NO_OP
0x000, // 0x1e3 = 483 - NO_OP
0x000, // 0x1e4 = 484 - NO_OP
0x000, // 0x1e5 = 485 - NO_OP
0x000, // 0x1e6 = 486 - NO_OP
0x000, // 0x1e7 = 487 - NO_OP
0x000, // 0x1e8 = 488 - NO_OP
0x000, // 0x1e9 = 489 - NO_OP
0x000, // 0x1ea = 490 - NO_OP
0x000, // 0x1eb = 491 - NO_OP
0x000, // 0x1ec = 492 - NO_OP
0x000, // 0x1ed = 493 - NO_OP
0x000, // 0x1ee = 494 - NO_OP
0x000, // 0x1ef = 495 - NO_OP
0x000, // 0x1f0 = 496 - NO_OP
0x000, // 0x1f1 = 497 - NO_OP
0x000, // 0x1f2 = 498 - NO_OP
0x000, // 0x1f3 = 499 - NO_OP
0x000, // 0x1f4 = 500 - NO_OP
0x000, // 0x1f5 = 501 - NO_OP
0x000, // 0x1f6 = 502 - NO_OP
0x000, // 0x1f7 = 503 - NO_OP
0x000, // 0x1f8 = 504 - NO_OP
0x000, // 0x1f9 = 505 - NO_OP
0x000, // 0x1fa = 506 - NO_OP
0x000, // 0x1fb = 507 - NO_OP
0x000, // 0x1fc = 508 - NO_OP
0x000, // 0x1fd = 509 - NO_OP
0x000, // 0x1fe = 510 - NO_OP
0x000, // 0x1ff = 511 - NO_OP
};

/* for A1407_10, A1410_15, A1412_19, A1415_19*/
bit32 wcsImage[] = 
{
0x00d, // 00000 = 0 - PHY_RESET_START
0x00d, // 0x001 = 1 - PHY_RESET_START
0x0be, // 0x002 = 2 - JUMP_IF_PHY_READY
0x002, // 0x003 = 3 - 
0x0be, // 0x004 = 4 - JUMP_IF_PHY_READY
0x00e, // 0x005 = 5 - 
0x0ae, // 0x006 = 6 - JUMP_IF_HARD_RESET_PRIMITIVE
0x024, // 0x007 = 7 - 
0x0af, // 0x008 = 8 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x017, // 0x009 = 9 - 
0x0ce, // 0x00a = 10 - JUMP_IF_IDENTIFY_FRAME_TIMEOUT
0x000, // 0x00b = 11 - 
0x0ff, // 0x00c = 12 - JUMP
0x004, // 0x00d = 13 - 
0x00c, // 0x00e = 14 - SEND_ID_FRAME
0x0ae, // 0x00f = 15 - JUMP_IF_HARD_RESET_PRIMITIVE
0x024, // 0x010 = 16 - 
0x0af, // 0x011 = 17 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x01c, // 0x012 = 18 - 
0x0ce, // 0x013 = 19 - JUMP_IF_IDENTIFY_FRAME_TIMEOUT
0x000, // 0x014 = 20 - 
0x0ff, // 0x015 = 21 - JUMP
0x00f, // 0x016 = 22 - 
0x0be, // 0x017 = 23 - JUMP_IF_PHY_READY
0x01b, // 0x018 = 24 - 
0x0ff, // 0x019 = 25 - JUMP
0x017, // 0x01a = 26 - 
0x00c, // 0x01b = 27 - SEND_ID_FRAME
0x000, // 0x01c = 28 - NO_OP
0x000, // 0x01d = 29 - NO_OP
0x000, // 0x01e = 30 - NO_OP
0x000, // 0x01f = 31 - NO_OP
0x000, // 0x020 = 32 - NO_OP
0x000, // 0x021 = 33 - NO_OP
0x0ff, // 0x022 = 34 - JUMP
0x09c, // 0x023 = 35 - 
0x01c, // 0x024 = 36 - SOFT_RESET
0x00d, // 0x025 = 37 - PHY_RESET_START
0x00d, // 0x026 = 38 - PHY_RESET_START
0x0be, // 0x027 = 39 - JUMP_IF_PHY_READY
0x027, // 0x028 = 40 - 
0x0be, // 0x029 = 41 - JUMP_IF_PHY_READY
0x02f, // 0x02a = 42 - 
0x0af, // 0x02b = 43 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x036, // 0x02c = 44 - 
0x0ff, // 0x02d = 45 - JUMP
0x029, // 0x02e = 46 - 
0x00c, // 0x02f = 47 - SEND_ID_FRAME
0x0af, // 0x030 = 48 - JUMP_IF_IDENTIFY_FRAME_RECEIVED
0x039, // 0x031 = 49 - 
0x0ce, // 0x032 = 50 - JUMP_IF_IDENTIFY_FRAME_TIMEOUT
0x024, // 0x033 = 51 - 
0x0ff, // 0x034 = 52 - JUMP
0x030, // 0x035 = 53 - 
0x00c, // 0x036 = 54 - SEND_ID_FRAME
0x0ff, // 0x037 = 55 - JUMP
0x039, // 0x038 = 56 - 
0x000, // 0x039 = 57 - NO_OP
0x0cb, // 0x03a = 58 - JUMP_IF_FREEZE_ACTIVE
0x03e, // 0x03b = 59 - 
0x0ff, // 0x03c = 60 - JUMP
0x03a, // 0x03d = 61 - 
0x0cb, // 0x03e = 62 - JUMP_IF_FREEZE_ACTIVE
0x03e, // 0x03f = 63 - 
0x0ff, // 0x040 = 64 - JUMP
0x09c, // 0x041 = 65 - 
0x000, // 0x042 = 66 - NO_OP
0x0c9, // 0x043 = 67 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x073, // 0x044 = 68 - 
0x0a5, // 0x045 = 69 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_GOOD
0x05c, // 0x046 = 70 - 
0x0a6, // 0x047 = 71 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_NAK
0x063, // 0x048 = 72 - 
0x0a7, // 0x049 = 73 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_ACK_NAK_TIMEOUT
0x066, // 0x04a = 74 - 
0x0a8, // 0x04b = 75 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_BREAK
0x070, // 0x04c = 76 - 
0x0aa, // 0x04d = 77 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_CREDIT_TIMEOUT
0x06b, // 0x04e = 78 - 
0x0c5, // 0x04f = 79 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_SMP_ERR
0x070, // 0x050 = 80 - 
0x0ac, // 0x051 = 81 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_MAX_BURST_SIZE
0x063, // 0x052 = 82 - 
0x0d9, // 0x053 = 83 - JUMP_IF_TRANSMISSION_STATUS_EQUAL_FREEZE_TIMEOUT
0x070, // 0x054 = 84 - 
0x0ca, // 0x055 = 85 - JUMP_IF_CLOSE_REQ
0x0f0, // 0x056 = 86 - 
0x0be, // 0x057 = 87 - JUMP_IF_PHY_READY
0x043, // 0x058 = 88 - 
0x01c, // 0x059 = 89 - SOFT_RESET
0x0ff, // 0x05a = 90 - JUMP
0x004, // 0x05b = 91 - 
0x01d, // 0x05c = 92 - ADVANCE
0x0bc, // 0x05d = 93 - JUMP_IF_BREAK_RECEIVED
0x13b, // 0x05e = 94 - 
0x0c3, // 0x05f = 95 - JUMP_IF_SMP_PROTOCOL
0x128, // 0x060 = 96 - 
0x0ff, // 0x061 = 97 - JUMP
0x076, // 0x062 = 98 - 
0x01d, // 0x063 = 99 - ADVANCE
0x0ff, // 0x064 = 100 - JUMP
0x076, // 0x065 = 101 - 
0x01d, // 0x066 = 102 - ADVANCE
0x0bc, // 0x067 = 103 - JUMP_IF_BREAK_RECEIVED
0x13b, // 0x068 = 104 - 
0x0ff, // 0x069 = 105 - JUMP
0x147, // 0x06a = 106 - 
0x01d, // 0x06b = 107 - ADVANCE
0x0bc, // 0x06c = 108 - JUMP_IF_BREAK_RECEIVED
0x13b, // 0x06d = 109 - 
0x0ff, // 0x06e = 110 - JUMP
0x14a, // 0x06f = 111 - 
0x01d, // 0x070 = 112 - ADVANCE
0x0ff, // 0x071 = 113 - JUMP
0x13b, // 0x072 = 114 - 
0x022, // 0x073 = 115 - SEND_CREDIT_BLOCK
0x0ff, // 0x074 = 116 - JUMP
0x045, // 0x075 = 117 - 
0x083, // 0x076 = 118 - TIMER_START
0x004, // 0x077 = 119 - 
0x0c8, // 0x078 = 120 - JUMP_IF_HIP_REQ
0x082, // 0x079 = 121 - 
0x0c6, // 0x07a = 122 - JUMP_IF_SFO_REQ
0x08a, // 0x07b = 123 - 
0x0c7, // 0x07c = 124 - JUMP_IF_DOC_REQ
0x094, // 0x07d = 125 - 
0x0b8, // 0x07e = 126 - JUMP_IF_TIMER_EXPIRED
0x09c, // 0x07f = 127 - 
0x0ff, // 0x080 = 128 - JUMP
0x078, // 0x081 = 129 - 
0x028, // 0x082 = 130 - CHECK_HIP
0x000, // 0x083 = 131 - NO_OP
0x000, // 0x084 = 132 - NO_OP
0x000, // 0x085 = 133 - NO_OP
0x0d8, // 0x086 = 134 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0cf, // 0x087 = 135 - 
0x0ff, // 0x088 = 136 - JUMP
0x07e, // 0x089 = 137 - 
0x029, // 0x08a = 138 - CHECK_SFO
0x000, // 0x08b = 139 - NO_OP
0x000, // 0x08c = 140 - NO_OP
0x000, // 0x08d = 141 - NO_OP
0x0d8, // 0x08e = 142 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0d4, // 0x08f = 143 - 
0x0c7, // 0x090 = 144 - JUMP_IF_DOC_REQ
0x094, // 0x091 = 145 - 
0x0ff, // 0x092 = 146 - JUMP
0x07e, // 0x093 = 147 - 
0x02a, // 0x094 = 148 - CHECK_DOC
0x000, // 0x095 = 149 - NO_OP
0x000, // 0x096 = 150 - NO_OP
0x000, // 0x097 = 151 - NO_OP
0x0d8, // 0x098 = 152 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0d9, // 0x099 = 153 - 
0x0ff, // 0x09a = 154 - JUMP
0x07e, // 0x09b = 155 - 
0x0bc, // 0x09c = 156 - JUMP_IF_BREAK_RECEIVED
0x13b, // 0x09d = 157 - 
0x0be, // 0x09e = 158 - JUMP_IF_PHY_READY
0x0a3, // 0x09f = 159 - 
0x01c, // 0x0a0 = 160 - SOFT_RESET
0x0ff, // 0x0a1 = 161 - JUMP
0x004, // 0x0a2 = 162 - 
0x0c8, // 0x0a3 = 163 - JUMP_IF_HIP_REQ
0x0b5, // 0x0a4 = 164 - 
0x0c6, // 0x0a5 = 165 - JUMP_IF_SFO_REQ
0x0bd, // 0x0a6 = 166 - 
0x0c7, // 0x0a7 = 167 - JUMP_IF_DOC_REQ
0x0c7, // 0x0a8 = 168 - 
0x0a3, // 0x0a9 = 169 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
0x107, // 0x0aa = 170 - 
0x0a2, // 0x0ab = 171 - JUMP_IF_CONNECTION_OPEN_MASTER_FLAG_SET
0x0f0, // 0x0ac = 172 - 
0x0c8, // 0x0ad = 173 - JUMP_IF_HIP_REQ
0x0cf, // 0x0ae = 174 - 
0x0c6, // 0x0af = 175 - JUMP_IF_SFO_REQ
0x0d4, // 0x0b0 = 176 - 
0x0c7, // 0x0b1 = 177 - JUMP_IF_DOC_REQ
0x0d9, // 0x0b2 = 178 - 
0x0ff, // 0x0b3 = 179 - JUMP
0x09c, // 0x0b4 = 180 - 
0x028, // 0x0b5 = 181 - CHECK_HIP
0x000, // 0x0b6 = 182 - NO_OP
0x000, // 0x0b7 = 183 - NO_OP
0x000, // 0x0b8 = 184 - NO_OP
0x0d8, // 0x0b9 = 185 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0cf, // 0x0ba = 186 - 
0x0ff, // 0x0bb = 187 - JUMP
0x0a9, // 0x0bc = 188 - 
0x029, // 0x0bd = 189 - CHECK_SFO
0x000, // 0x0be = 190 - NO_OP
0x000, // 0x0bf = 191 - NO_OP
0x000, // 0x0c0 = 192 - NO_OP
0x0d8, // 0x0c1 = 193 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0d4, // 0x0c2 = 194 - 
0x0c7, // 0x0c3 = 195 - JUMP_IF_DOC_REQ
0x0c7, // 0x0c4 = 196 - 
0x0ff, // 0x0c5 = 197 - JUMP
0x0a9, // 0x0c6 = 198 - 
0x02a, // 0x0c7 = 199 - CHECK_DOC
0x000, // 0x0c8 = 200 - NO_OP
0x000, // 0x0c9 = 201 - NO_OP
0x000, // 0x0ca = 202 - NO_OP
0x0d8, // 0x0cb = 203 - JUMP_IF_NXT_CONN_ACTIVE_PROF_EQ
0x0d9, // 0x0cc = 204 - 
0x0ff, // 0x0cd = 205 - JUMP
0x0a9, // 0x0ce = 206 - 
0x020, // 0x0cf = 207 - SELECT_HIP
0x000, // 0x0d0 = 208 - NO_OP
0x000, // 0x0d1 = 209 - NO_OP
0x0ff, // 0x0d2 = 210 - JUMP
0x0dc, // 0x0d3 = 211 - 
0x01e, // 0x0d4 = 212 - SELECT_SFO
0x000, // 0x0d5 = 213 - NO_OP
0x000, // 0x0d6 = 214 - NO_OP
0x0ff, // 0x0d7 = 215 - JUMP
0x0dc, // 0x0d8 = 216 - 
0x01f, // 0x0d9 = 217 - SELECT_DOC
0x000, // 0x0da = 218 - NO_OP
0x000, // 0x0db = 219 - NO_OP
0x0a4, // 0x0dc = 220 - JUMP_IF_CONNECTION_ACTIVE_SET
0x0e0, // 0x0dd = 221 - 
0x0ff, // 0x0de = 222 - JUMP
0x14d, // 0x0df = 223 - 
0x0a0, // 0x0e0 = 224 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL
0x0e6, // 0x0e1 = 225 - 
0x0a3, // 0x0e2 = 226 - JUMP_IF_CONNECTION_OPEN_SLAVE_FLAG_SET
0x107, // 0x0e3 = 227 - 
0x0ff, // 0x0e4 = 228 - JUMP
0x0f0, // 0x0e5 = 229 - 
0x0cb, // 0x0e6 = 230 - JUMP_IF_FREEZE_ACTIVE
0x0eb, // 0x0e7 = 231 - 
0x013, // 0x0e8 = 232 - SET_OPEN_STATUS_NORMAL
0x0ff, // 0x0e9 = 233 - JUMP
0x042, // 0x0ea = 234 - 
0x024, // 0x0eb = 235 - SET_OPEN_STATUS_FREEZE
0x000, // 0x0ec = 236 - NO_OP
0x000, // 0x0ed = 237 - NO_OP
0x0ff, // 0x0ee = 238 - JUMP
0x09c, // 0x0ef = 239 - 
0x0d2, // 0x0f0 = 240 - JUMP_IF_STP_CONNECTION_ACTIVE
0x0f4, // 0x0f1 = 241 - 
0x0ff, // 0x0f2 = 242 - JUMP
0x128, // 0x0f3 = 243 - 
0x0d5, // 0x0f4 = 244 - JUMP_IF_CLOSE_RECEIVED
0x128, // 0x0f5 = 245 - 
0x0d6, // 0x0f6 = 246 - JUMP_IF_SYNC_RECEIVED
0x0fa, // 0x0f7 = 247 - 
0x0ff, // 0x0f8 = 248 - JUMP
0x09c, // 0x0f9 = 249 - 
0x027, // 0x0fa = 250 - SEND_STP_CLOSE_REQ
0x000, // 0x0fb = 251 - NO_OP
0x000, // 0x0fc = 252 - NO_OP
0x000, // 0x0fd = 253 - NO_OP
0x000, // 0x0fe = 254 - NO_OP
0x0d5, // 0x0ff = 255 - JUMP_IF_CLOSE_RECEIVED
0x128, // 0x100 = 256 - 
0x0bc, // 0x101 = 257 - JUMP_IF_BREAK_RECEIVED
0x13b, // 0x102 = 258 - 
0x0d7, // 0x103 = 259 - JUMP_IF_STP_CLOSE_ACK
0x128, // 0x104 = 260 - 
0x0ff, // 0x105 = 261 - JUMP
0x0fb, // 0x106 = 262 - 
0x0c3, // 0x107 = 263 - JUMP_IF_SMP_PROTOCOL
0x10f, // 0x108 = 264 - 
0x0d2, // 0x109 = 265 - JUMP_IF_STP_CONNECTION_ACTIVE
0x113, // 0x10a = 266 - 
0x0d1, // 0x10b = 267 - JUMP_IF_IDLE_TIMER_TIMEOUT
0x119, // 0x10c = 268 - 
0x0ff, // 0x10d = 269 - JUMP
0x09c, // 0x10e = 270 - 
0x0c4, // 0x10f = 271 - JUMP_IF_SMP_FRAME_ERR_RECEIVED
0x13b, // 0x110 = 272 - 
0x0ff, // 0x111 = 273 - JUMP
0x0ad, // 0x112 = 274 - 
0x0d5, // 0x113 = 275 - JUMP_IF_CLOSE_RECEIVED
0x119, // 0x114 = 276 - 
0x0d6, // 0x115 = 277 - JUMP_IF_SYNC_RECEIVED
0x11b, // 0x116 = 278 - 
0x0ff, // 0x117 = 279 - JUMP
0x113, // 0x118 = 280 - 
0x0ff, // 0x119 = 281 - JUMP
0x128, // 0x11a = 282 - 
0x027, // 0x11b = 283 - SEND_STP_CLOSE_REQ
0x000, // 0x11c = 284 - NO_OP
0x000, // 0x11d = 285 - NO_OP
0x000, // 0x11e = 286 - NO_OP
0x000, // 0x11f = 287 - NO_OP
0x0d5, // 0x120 = 288 - JUMP_IF_CLOSE_RECEIVED
0x128, // 0x121 = 289 - 
0x0bc, // 0x122 = 290 - JUMP_IF_BREAK_RECEIVED
0x13b, // 0x123 = 291 - 
0x0d7, // 0x124 = 292 - JUMP_IF_STP_CLOSE_ACK
0x128, // 0x125 = 293 - 
0x0ff, // 0x126 = 294 - JUMP
0x11c, // 0x127 = 295 - 
0x004, // 0x128 = 296 - CLOSE_NORMAL
0x000, // 0x129 = 297 - NO_OP
0x000, // 0x12a = 298 - NO_OP
0x000, // 0x12b = 299 - NO_OP
0x000, // 0x12c = 300 - NO_OP
0x0c9, // 0x12d = 301 - JUMP_IF_RX_BUFFER_FULL_TIMEOUT
0x138, // 0x12e = 302 - 
0x0c0, // 0x12f = 303 - JUMP_IF_CLOSE_STATUS_EQUAL_ANY
0x09c, // 0x130 = 304 - 
0x0bc, // 0x131 = 305 - JUMP_IF_BREAK_RECEIVED
0x13b, // 0x132 = 306 - 
0x0be, // 0x133 = 307 - JUMP_IF_PHY_READY
0x129, // 0x134 = 308 - 
0x01c, // 0x135 = 309 - SOFT_RESET
0x0ff, // 0x136 = 310 - JUMP
0x004, // 0x137 = 311 - 
0x022, // 0x138 = 312 - SEND_CREDIT_BLOCK
0x0ff, // 0x139 = 313 - JUMP
0x129, // 0x13a = 314 - 
0x007, // 0x13b = 315 - CLOSE_BREAK
0x000, // 0x13c = 316 - NO_OP
0x000, // 0x13d = 317 - NO_OP
0x000, // 0x13e = 318 - NO_OP
0x000, // 0x13f = 319 - NO_OP
0x0c0, // 0x140 = 320 - JUMP_IF_CLOSE_STATUS_EQUAL_ANY
0x09c, // 0x141 = 321 - 
0x0be, // 0x142 = 322 - JUMP_IF_PHY_READY
0x13c, // 0x143 = 323 - 
0x01c, // 0x144 = 324 - SOFT_RESET
0x0ff, // 0x145 = 325 - JUMP
0x004, // 0x146 = 326 - 
0x005, // 0x147 = 327 - CLOSE_ACK_NAK_TIMEOUT
0x0ff, // 0x148 = 328 - JUMP
0x129, // 0x149 = 329 - 
0x006, // 0x14a = 330 - CLOSE_CREDIT_TIMEOUT
0x0ff, // 0x14b = 331 - JUMP
0x129, // 0x14c = 332 - 
0x0da, // 0x14d = 333 - JUMP_IF_SMP_TARGET
0x189, // 0x14e = 334 - 
0x0cc, // 0x14f = 335 - JUMP_IF_RX_BUFFER_FULL
0x09c, // 0x150 = 336 - 
0x0b7, // 0x151 = 337 - JUMP_IF_FLAG_7_SET
0x156, // 0x152 = 338 - 
0x011, // 0x153 = 339 - START_IT_NEXUS_LOSS_TIMER
0x00f, // 0x154 = 340 - PATHWAY_BLOCKED_CNT_RESET
0x00e, // 0x155 = 341 - START_ARB_WAIT_TIMER
0x0cb, // 0x156 = 342 - JUMP_IF_FREEZE_ACTIVE
0x195, // 0x157 = 343 - 
0x001, // 0x158 = 344 - OPEN_REQUEST
0x080, // 0x159 = 345 - SET_FLAG
0x080, // 0x15a = 346 - 
0x090, // 0x15b = 347 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_ACCEPT
0x181, // 0x15c = 348 - 
0x095, // 0x15d = 349 - JUMP_IF_OPEN_STATUS_EQUAL_RATE_NOT_SUPPORTED
0x186, // 0x15e = 350 - 
0x099, // 0x15f = 351 - JUMP_IF_OPEN_STATUS_EQUAL_PROTOCOL_NOT_SUPPORTED
0x189, // 0x160 = 352 - 
0x09b, // 0x161 = 353 - JUMP_IF_OPEN_STATUS_EQUAL_WRONG_DESTINATION
0x18c, // 0x162 = 354 - 
0x094, // 0x163 = 355 - JUMP_IF_OPEN_STATUS_EQUAL_BREAK_RECEIVED
0x156, // 0x164 = 356 - 
0x093, // 0x165 = 357 - JUMP_IF_OPEN_STATUS_EQUAL_BAD_DESTINATION
0x18f, // 0x166 = 358 - 
0x09f, // 0x167 = 359 - JUMP_IF_IT_NEXUS_LOSS_TIMEOUT
0x192, // 0x168 = 360 - 
0x09a, // 0x169 = 361 - JUMP_IF_OPEN_STATUS_EQUAL_STP_RESOURCE_BUSY
0x155, // 0x16a = 362 - 
0x096, // 0x16b = 363 - JUMP_IF_OPEN_STATUS_EQUAL_NO_DESTINATION
0x156, // 0x16c = 364 - 
0x097, // 0x16d = 365 - JUMP_IF_OPEN_STATUS_EQUAL_PATHWAY_BLOCKED
0x19c, // 0x16e = 366 - 
0x098, // 0x16f = 367 - JUMP_IF_OPEN_STATUS_EQUAL_RETRY
0x155, // 0x170 = 368 - 
0x092, // 0x171 = 369 - JUMP_IF_OPEN_STATUS_EQUAL_OPEN_TIMEOUT
0x156, // 0x172 = 370 - 
0x0a4, // 0x173 = 371 - JUMP_IF_CONNECTION_ACTIVE_SET
0x17b, // 0x174 = 372 - 
0x0be, // 0x175 = 373 - JUMP_IF_PHY_READY
0x15b, // 0x176 = 374 - 
0x01b, // 0x177 = 375 - SET_OPEN_STATUS_PHY_NOT_RDY
0x01c, // 0x178 = 376 - SOFT_RESET
0x0ff, // 0x179 = 377 - JUMP
0x004, // 0x17a = 378 - 
0x0a0, // 0x17b = 379 - JUMP_IF_CONNECTION_PROFILE_OPEN_EQUAL
0x181, // 0x17c = 380 - 
0x000, // 0x17d = 381 - NO_OP
0x000, // 0x17e = 382 - NO_OP
0x0ff, // 0x17f = 383 - JUMP
0x09c, // 0x180 = 384 - 
0x013, // 0x181 = 385 - SET_OPEN_STATUS_NORMAL
0x081, // 0x182 = 386 - CLEAR_FLAG
0x080, // 0x183 = 387 - 
0x0ff, // 0x184 = 388 - JUMP
0x042, // 0x185 = 389 - 
0x017, // 0x186 = 390 - SET_OPEN_STATUS_BAD_RATE
0x0ff, // 0x187 = 391 - JUMP
0x196, // 0x188 = 392 - 
0x018, // 0x189 = 393 - SET_OPEN_STATUS_BAD_PROTOCOL
0x0ff, // 0x18a = 394 - JUMP
0x196, // 0x18b = 395 - 
0x01a, // 0x18c = 396 - SET_OPEN_STATUS_WRONG_DEST
0x0ff, // 0x18d = 397 - JUMP
0x196, // 0x18e = 398 - 
0x015, // 0x18f = 399 - SET_OPEN_STATUS_BAD_DEST
0x0ff, // 0x190 = 400 - JUMP
0x196, // 0x191 = 401 - 
0x014, // 0x192 = 402 - SET_OPEN_STATUS_IT_NEXUS_LOSS
0x0ff, // 0x193 = 403 - JUMP
0x196, // 0x194 = 404 - 
0x024, // 0x195 = 405 - SET_OPEN_STATUS_FREEZE
0x000, // 0x196 = 406 - NO_OP
0x000, // 0x197 = 407 - NO_OP
0x081, // 0x198 = 408 - CLEAR_FLAG
0x080, // 0x199 = 409 - 
0x0ff, // 0x19a = 410 - JUMP
0x09c, // 0x19b = 411 - 
0x010, // 0x19c = 412 - PATHWAY_BLOCKED_CNT_INC
0x0ff, // 0x19d = 413 - JUMP
0x156, // 0x19e = 414 - 
0x000, // 0x19f = 415 - NO_OP
0x000, // 0x1a0 = 416 - NO_OP
0x000, // 0x1a1 = 417 - NO_OP
0x000, // 0x1a2 = 418 - NO_OP
0x000, // 0x1a3 = 419 - NO_OP
0x000, // 0x1a4 = 420 - NO_OP
0x000, // 0x1a5 = 421 - NO_OP
0x000, // 0x1a6 = 422 - NO_OP
0x000, // 0x1a7 = 423 - NO_OP
0x000, // 0x1a8 = 424 - NO_OP
0x000, // 0x1a9 = 425 - NO_OP
0x000, // 0x1aa = 426 - NO_OP
0x000, // 0x1ab = 427 - NO_OP
0x000, // 0x1ac = 428 - NO_OP
0x000, // 0x1ad = 429 - NO_OP
0x000, // 0x1ae = 430 - NO_OP
0x000, // 0x1af = 431 - NO_OP
0x000, // 0x1b0 = 432 - NO_OP
0x000, // 0x1b1 = 433 - NO_OP
0x000, // 0x1b2 = 434 - NO_OP
0x000, // 0x1b3 = 435 - NO_OP
0x000, // 0x1b4 = 436 - NO_OP
0x000, // 0x1b5 = 437 - NO_OP
0x000, // 0x1b6 = 438 - NO_OP
0x000, // 0x1b7 = 439 - NO_OP
0x000, // 0x1b8 = 440 - NO_OP
0x000, // 0x1b9 = 441 - NO_OP
0x000, // 0x1ba = 442 - NO_OP
0x000, // 0x1bb = 443 - NO_OP
0x000, // 0x1bc = 444 - NO_OP
0x000, // 0x1bd = 445 - NO_OP
0x000, // 0x1be = 446 - NO_OP
0x000, // 0x1bf = 447 - NO_OP
0x000, // 0x1c0 = 448 - NO_OP
0x000, // 0x1c1 = 449 - NO_OP
0x000, // 0x1c2 = 450 - NO_OP
0x000, // 0x1c3 = 451 - NO_OP
0x000, // 0x1c4 = 452 - NO_OP
0x000, // 0x1c5 = 453 - NO_OP
0x000, // 0x1c6 = 454 - NO_OP
0x000, // 0x1c7 = 455 - NO_OP
0x000, // 0x1c8 = 456 - NO_OP
0x000, // 0x1c9 = 457 - NO_OP
0x000, // 0x1ca = 458 - NO_OP
0x000, // 0x1cb = 459 - NO_OP
0x000, // 0x1cc = 460 - NO_OP
0x000, // 0x1cd = 461 - NO_OP
0x000, // 0x1ce = 462 - NO_OP
0x000, // 0x1cf = 463 - NO_OP
0x000, // 0x1d0 = 464 - NO_OP
0x000, // 0x1d1 = 465 - NO_OP
0x000, // 0x1d2 = 466 - NO_OP
0x000, // 0x1d3 = 467 - NO_OP
0x000, // 0x1d4 = 468 - NO_OP
0x000, // 0x1d5 = 469 - NO_OP
0x000, // 0x1d6 = 470 - NO_OP
0x000, // 0x1d7 = 471 - NO_OP
0x000, // 0x1d8 = 472 - NO_OP
0x000, // 0x1d9 = 473 - NO_OP
0x000, // 0x1da = 474 - NO_OP
0x000, // 0x1db = 475 - NO_OP
0x000, // 0x1dc = 476 - NO_OP
0x000, // 0x1dd = 477 - NO_OP
0x000, // 0x1de = 478 - NO_OP
0x000, // 0x1df = 479 - NO_OP
0x000, // 0x1e0 = 480 - NO_OP
0x000, // 0x1e1 = 481 - NO_OP
0x000, // 0x1e2 = 482 - NO_OP
0x000, // 0x1e3 = 483 - NO_OP
0x000, // 0x1e4 = 484 - NO_OP
0x000, // 0x1e5 = 485 - NO_OP
0x000, // 0x1e6 = 486 - NO_OP
0x000, // 0x1e7 = 487 - NO_OP
0x000, // 0x1e8 = 488 - NO_OP
0x000, // 0x1e9 = 489 - NO_OP
0x000, // 0x1ea = 490 - NO_OP
0x000, // 0x1eb = 491 - NO_OP
0x000, // 0x1ec = 492 - NO_OP
0x000, // 0x1ed = 493 - NO_OP
0x000, // 0x1ee = 494 - NO_OP
0x000, // 0x1ef = 495 - NO_OP
0x000, // 0x1f0 = 496 - NO_OP
0x000, // 0x1f1 = 497 - NO_OP
0x000, // 0x1f2 = 498 - NO_OP
0x000, // 0x1f3 = 499 - NO_OP
0x000, // 0x1f4 = 500 - NO_OP
0x000, // 0x1f5 = 501 - NO_OP
0x000, // 0x1f6 = 502 - NO_OP
0x000, // 0x1f7 = 503 - NO_OP
0x000, // 0x1f8 = 504 - NO_OP
0x000, // 0x1f9 = 505 - NO_OP
0x000, // 0x1fa = 506 - NO_OP
0x000, // 0x1fb = 507 - NO_OP
0x000, // 0x1fc = 508 - NO_OP
0x000, // 0x1fd = 509 - NO_OP
0x000, // 0x1fe = 510 - NO_OP
0x000, // 0x1ff = 511 - NO_OP
};
